# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################
import os, stat, sys
import Image

from mod_python import apache
import _Conf, Menus
import standard_html
import _Utils, _Person, _InitTypes
import base64
import cStringIO

BLOCK_SIZE = 8192

MY_MENU_ID = 0

def index(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_admin_menu(REQUEST, MY_MENU_ID))

    top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
    person = REQUEST.USER.get_person(REQUEST)
    if REQUEST.form.has_key('delpic') and REQUEST.form['delpic'].value=="1":
       person.set('picture', '')
       person.save()
    first_name = _Utils.html_quote_edit(person.get('first_name'))
    middle_name = _Utils.html_quote_edit(person.get('middle_name')) or ""
    phone_work = _Utils.html_quote_edit(person.get('phone_work')) or ""
    phone_home = _Utils.html_quote_edit(person.get('phone_home')) or ""
    phone_cell = _Utils.html_quote_edit(person.get('phone_cell')) or ""
    phone_fax = _Utils.html_quote_edit(person.get('phone_fax')) or ""
    e_mail = _Utils.html_quote_edit(person.get('e_mail')) or ""
    last_name = _Utils.html_quote_edit(person.get('last_name'))
    BASE_ADMIN_URL = _Conf.BASE_ADMIN_URL
    person_id = person.get_id()
    REQ_FIELD = _Conf.REQ_FIELD

    tls_myinfo = REQUEST.TLS('tls_myinfo')
    tls_first_name = REQUEST.TLS('tls_first_name')
    tls_middle = REQUEST.TLS('tls_middle_names')
    tls_last_name = REQUEST.TLS('tls_last_name')
    tls_email = REQUEST.TLS('tls_email')
    tls_work = REQUEST.TLS('tls_phone_work')
    tls_fax = REQUEST.TLS('tls_phone_fax')
    tls_home = REQUEST.TLS('tls_phone_home')
    tls_cell = REQUEST.TLS('tls_phone_cell')
    tls_save = REQUEST.TLS('tls_save')
    tls_password = REQUEST.TLS('tls_password')
    tls_passwordagain = REQUEST.TLS('tls_passwordagain')
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_short_del = REQUEST.TLS('email_short_del')
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_picture = REQUEST.TLS('admin_picture')
    tls_picture2 = REQUEST.TLS('admin_picture2')
    tls_upload = REQUEST.TLS('admin_upload')
    tls_choose_pic = REQUEST.TLS('admin_choose_pic')
    tls_choose_pic2 = REQUEST.TLS('admin_choose_pic2')

    pic = person.get('picture')
    if pic:
        pic_out = """\
<img src="%(BASE_ADMIN_URL)smyinfo.py/pic?id=%(person_id)s" border="0" alt="" hspace=10 vspace="5">
<br><a href="%(BASE_ADMIN_URL)smyinfo.py?delpic=1">%(tls_short_del)s</a>""" % locals()
    else:
        pic_out = "&nbsp;"
    output.append(u"""\
<SCRIPT language="javascript" type="text/javascript">
<!--
  function check_values()
  {
    if (!document.addform.first_name.value || !document.addform.last_name.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
// -->
</SCRIPT>
<BR>
<TABLE width="100%%" cellpadding=0 cellspacing=0 border=0>
<FORM method="POST" action="%(BASE_ADMIN_URL)smyinfo.py/save" name="addform" onsubmit="return check_values();">
 <TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD colspan=5 width="100%%">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD class="th_listing" align="center" nowrap>&nbsp;&nbsp;&nbsp;<b>%(tls_myinfo)s</b>&nbsp;&nbsp;&nbsp;</TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%" >&nbsp;</TD>
      </TR>
    </TABLE>
  </TD>
 </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_first_name)s%(REQ_FIELD)s</TD>
    <TD class="td_listing1" colspan="2" nowrap><INPUT size="25" class="textfield1" type="text" name="first_name" value="%(first_name)s">&nbsp;&nbsp;</TD>
    <TD class="td_listing0" rowspan="11" valign="top" align="center">%(pic_out)s</TD>
    <TD class="td_listing0" width="100%%" rowspan="11" valign="top">&nbsp;</TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0" nowrap>%(tls_middle)s</TD>
    <TD class="td_listing0" colspan="2"><INPUT class="textfield1" size="25" type="text" name="middle_name" value="%(middle_name)s"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_last_name)s%(REQ_FIELD)s</TD>
    <TD class="td_listing1" colspan="2"><INPUT class="textfield1" size="25" type="text" name="last_name" value="%(last_name)s"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0" nowrap>%(tls_password)s</TD>
    <TD class="td_listing0" colspan="2"><INPUT class="textfield1" size="25" type="password" name="password1"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_passwordagain)s</TD>
    <TD class="td_listing1" colspan="2"><INPUT class="textfield1" size="25" type="password" name="password2"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0" nowrap>%(tls_work)s</TD>
    <TD class="td_listing0" colspan="2"><INPUT class="textfield1" size="25" type="text" name="phone_work" value="%(phone_work)s"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_cell)s</TD>
    <TD class="td_listing1" colspan="2"><INPUT class="textfield1" size="25" type="text" name="phone_cell" value="%(phone_cell)s"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0" nowrap>%(tls_home)s</TD>
    <TD class="td_listing0" colspan="2"><INPUT class="textfield1" size="25" type="text" name="phone_home" value="%(phone_home)s"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_fax)s</TD>
    <TD class="td_listing1" colspan="2"><INPUT class="textfield1" size="25" type="text" name="phone_fax" value="%(phone_fax)s"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0" nowrap>%(tls_email)s</TD>
    <TD class="td_listing0" colspan="2"><INPUT class="textfield1" size="25" type="text" name="e_mail" value="%(e_mail)s"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1" colspan="3"><INPUT class="input2" type="submit" name="_save" value="%(tls_save)s"></TD>
  </TR>
</TABLE>
</FORM>
""" % locals())
    if not pic:
        output.append(u"""
<FORM method="POST" action="%(BASE_ADMIN_URL)smyinfo.py/save_pic" name="picform" ENCTYPE="multipart/form-data">
<TABLE width="100%%" cellpadding=0 cellspacing=0 border=0>
 <TR class="tr_listing0">
    <TD colspan=4><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=15 border=0 alt=""></TD>
 </TR>
 <TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD colspan=3 width="100%%">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD class="th_listing" align="center" nowrap>&nbsp;&nbsp;&nbsp;<b>%(tls_picture)s</b>&nbsp;&nbsp;&nbsp;</TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%" >&nbsp;</TD>
      </TR>
    </TABLE>
  </TD>
 </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_choose_pic)s:</TD>
    <TD class="td_listing1" width="100%%" colspan="2"><INPUT  type="file" class="textfield1" name="filepointer"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0" colspan="3"><INPUT class="input2" type="submit" name="_upload" value="%(tls_upload)s"></TD>
  </TR>
</TABLE>
</FORM>
"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def save(REQUEST):
    output = []
        
    per = REQUEST.USER.get_person(REQUEST)
    per.load_req()

    if REQUEST.form.has_key('password1') and REQUEST.form.has_key('password2') and REQUEST.form['password1'].value.decode('UTF8').strip():
        if REQUEST.form['password1'].value.decode('UTF8').strip() <> REQUEST.form['password2'].value.decode('UTF8').strip():
            raise RuntimeError, 'Passwords do not match.'
        per.set('password', _Utils.crypt(REQUEST.form['password1'].value.decode('UTF8').strip(), _Utils.get_salt()))
    for key in ['first_name', 'middle_name', 'last_name']:
        if REQUEST.form[key].value.decode('UTF8').find('<') <> -1 or \
           REQUEST.form[key].value.decode('UTF8').find('>') <> -1 or \
           REQUEST.form[key].value.decode('UTF8').find('"') <> -1:
            raise RuntimeError, REQUEST.TLS('name_invchars')
    per.save()
    REQUEST.mod_req.headers_out["Location"] = """%smyinfo.py""" % _Conf.BASE_ADMIN_URL
    return apache.HTTP_MOVED_TEMPORARILY

def save_pic(REQUEST):
    if not REQUEST.form.has_key('filepointer'):
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    temp_file = cStringIO.StringIO()

    size = 200, 200
    im = Image.open(REQUEST.form['filepointer'].file)
    im.thumbnail(size, Image.ANTIALIAS)
    im.save(temp_file, "PNG")
    temp_file.seek(0)
    
    per = REQUEST.USER.get_person(REQUEST)
    per.set('picture', base64.encodestring(temp_file.read()))
    per.save()

    REQUEST.mod_req.headers_out["Location"] = """%smyinfo.py""" % _Conf.BASE_ADMIN_URL
    return apache.HTTP_MOVED_TEMPORARILY


def pic(REQUEST):
    if REQUEST.form.has_key('id') and REQUEST.form['id'].value.strip():
        user_id = int(REQUEST.form['id'].value.strip())
        person = _Person.Person(REQUEST, _InitTypes.INIT_TYPE_ID, user_id)
    else:
        person = _Person.Person(REQUEST, _InitTypes.INIT_TYPE_ID, REQUEST.USER.get_id())
    return base64.decodestring(person.get('picture'))

def pic3(REQUEST):
    return base64.decodestring(REQUEST.get_setting('organization_logo_small'))
