# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################
import _Conf

from mod_python import apache

import mx.DateTime
from Menus import get_frontpage_menu
import standard_html, _Utils

MY_MENU_ID = 4

def index(REQUEST):
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        raise RuntimeError, REQUEST.TLS('admin_notsuper')

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_frontpage_menu(REQUEST, MY_MENU_ID))

    tls_date = REQUEST.TLS('tls_date')
    tls_add = REQUEST.TLS('tls_add')
    tls_news = REQUEST.TLS('compmenu_admin_news')
    tls_deletesel = REQUEST.TLS('tls_deletesel')
    tls_message = REQUEST.TLS('admin_newsmessage')

    SQL = "SELECT * FROM systemnotes"
    REQUEST.db.execute(SQL)
    dbresult = REQUEST.db.dictfetchall()

    BASE_ADMIN_URL = _Conf.BASE_ADMIN_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    output.append(u"""
<BR>
<TABLE border=0 cellpadding=0 cellspacing=0 width="100%%">
<FORM method="post" action="%(BASE_ADMIN_URL)snews.py/news">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD colspan=3 width="100%%">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD class="th_listing" align="center" nowrap>&nbsp;&nbsp;&nbsp;&nbsp;<b>%(tls_news)s</b>&nbsp;&nbsp;&nbsp;&nbsp;</TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%">&nbsp;</TD>
      </TR>
    </TABLE>
  </TD>
</TR>
<TR>
 <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
 <TD class="td_listing1b" nowrap>%(tls_date)s</TD>
 <TD class="td_listing1b" width="100%%">%(tls_message)s</TD>
 <TD class="td_listing1b" width="15">&nbsp;</TD>
</TR>""" % locals())
    index = 1
    for result in dbresult:
        if(index%2==0):
            td_class='td_listing1'
        else:
            td_class='td_listing0'
        index = index + 1
        message_date = REQUEST.iso2userdate(result['note_stamp'])
        message_id = result['note_id']
        message_self = _Utils.newline2br(result['note_message'].decode('UTF8'))
        output.append(u"""<TR>
 <TD class="%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
 <TD class="%(td_class)s" nowrap><A href="%(BASE_ADMIN_URL)snews.py/edit?news_id=%(message_id)d">%(message_date)s</A></TD>
 <TD class="%(td_class)s">%(message_self)s</TD>
 <TD class="%(td_class)s"><INPUT type="checkbox" name="sel_%(message_id)d"></TD>
</TR>""" % locals())

    if(index%2==0):
        td_class='td_listing1'
    else:
        td_class='td_listing0'
    output.append(u"""
<TR>
 <TD class="%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
 <TD class="%(td_class)s" colspan="3"><INPUT class="input2" type="submit" name="_add" value="%(tls_add)s">&nbsp;<INPUT class="input3" type="submit" name="_delete" value="%(tls_deletesel)s"></TD>
</TR>
</TABLE></FORM>""" % locals())

    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def news(REQUEST):
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        raise RuntimeError, REQUEST.TLS('admin_notsuper')

    BASE_ICON_URL = _Conf.BASE_ICON_URL
    if REQUEST.form.has_key('_add'):
        BASE_ADMIN_URL = _Conf.BASE_ADMIN_URL
        tls_message = REQUEST.TLS('admin_newsmessage')
        tls_add = REQUEST.TLS('tls_add')
        tls_date = REQUEST.TLS('tls_date')
        today = REQUEST.iso2userdate(_Utils.utc_now_mx())
        output = []
        tls_invdateformat = REQUEST.TLS('tls_invdateformat')
        datecheck_js = REQUEST.datecheck_js(REQUEST)
        output.append(standard_html.html_header(REQUEST))
        output.append(get_frontpage_menu(REQUEST, MY_MENU_ID))
        output.append(u"""
<SCRIPT  language="JavaScript" type="text/javascript">
%(datecheck_js)s
</SCRIPT>
<FORM method="post" action="%(BASE_ADMIN_URL)snews.py/news">
<TABLE border=0 cellpadding=0 cellspacing=0 width="100%%">
<TR>
  <TD colspan=2>&nbsp;</TD>
</TR>
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD width="100%%">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD class="th_listing" align="center" nowrap>&nbsp;&nbsp;%(tls_message)s&nbsp;&nbsp;</TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%">&nbsp;</TD>
      </TR>
    </TABLE>
  </TD>
</TR>
<TR>
 <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
 <TD class="td_listing1">%(tls_date)s: <INPUT size=10 class="textfield1" type="text" name="note_stamp" value="%(today)s" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }"></TD>
</TR>
<TR>
 <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
 <TD class="td_listing0"><TEXTAREA class="textarea1" name="note_message" cols=60 rows=10></TEXTAREA></TD>
</TR>
<TR>
 <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
 <TD class="td_listing1"><INPUT class="input2" type="submit" name="_save" value="%(tls_add)s"></TD>
</TR>
</TABLE>
</FORM>""" % locals())
        output.append(standard_html.html_footer(REQUEST))
        return "\n".join(output)
    elif REQUEST.form.has_key('_save'):
        if not REQUEST.form.has_key('note_message') or not REQUEST.form['note_message'].value.decode('UTF8').strip():
            raise RuntimeError, REQUEST.TLS('required_parameters_missing')

        if REQUEST.form.has_key('note_stamp') and REQUEST.form['note_stamp'].value.decode('UTF8').strip():
            SQL = u"""INSERT INTO systemnotes (note_message, note_stamp) VALUES (%s, %s)""" % (_Utils.sql_quote(REQUEST.form['note_message'].value.decode('UTF8').strip()), _Utils.sql_quote(REQUEST.user2isodate(REQUEST, REQUEST.form['note_stamp'].value.decode('UTF8').strip())))
        else:
            SQL = u"""INSERT INTO systemnotes (note_message) VALUES (%s)""" % _Utils.sql_quote(REQUEST.form['note_message'].value.decode('UTF8').strip())
        REQUEST.db.execute(SQL.encode('UTF8'))
        REQUEST.mod_req.headers_out["Location"] = """%snews.py""" % _Conf.BASE_ADMIN_URL
        return apache.HTTP_MOVED_TEMPORARILY  

    elif REQUEST.form.has_key('_delete'):
        del_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                del_ids.append(int(key[4:]))

        SQL = """DELETE FROM systemnotes WHERE note_id=%d"""
        for del_id in del_ids:
            REQUEST.db.execute(SQL % del_id)
        REQUEST.mod_req.headers_out["Location"] = """%snews.py""" % _Conf.BASE_ADMIN_URL
        return apache.HTTP_MOVED_TEMPORARILY  

    elif REQUEST.form.has_key('_edit'):
        if not REQUEST.form.has_key('note_message') or not REQUEST.form['note_message'].value.decode('UTF8').strip():
            raise RuntimeError, REQUEST.TLS('required_parameters_missing')
        if not REQUEST.form.has_key('news_id') or not REQUEST.form['news_id'].value.decode('UTF8').strip():
            raise RuntimeError, REQUEST.TLS('required_parameters_missing')

        if REQUEST.form.has_key('note_stamp') and REQUEST.form['note_stamp'].value.decode('UTF8').strip():
            SQL = u"""UPDATE systemnotes SET note_stamp=%s WHERE note_id=%d""" % (_Utils.sql_quote(REQUEST.user2isodate(REQUEST, REQUEST.form['note_stamp'].value.decode('UTF8').strip())), int(REQUEST.form['news_id'].value.decode('UTF8').strip()))
            REQUEST.db.execute(SQL.encode('UTF8'))
        REQUEST.db.execute(("""UPDATE systemnotes SET note_message=%s WHERE note_id=%d""" % (_Utils.sql_quote(REQUEST.form['note_message'].value.decode('UTF8').strip()), int(REQUEST.form['news_id'].value.decode('UTF8').strip()))).encode('UTF8'))
        REQUEST.mod_req.headers_out["Location"] = """%snews.py""" % _Conf.BASE_ADMIN_URL
        return apache.HTTP_MOVED_TEMPORARILY  

    REQUEST.mod_req.headers_out["Location"] = """%snews.py""" % _Conf.BASE_ADMIN_URL
    return apache.HTTP_MOVED_TEMPORARILY  


def edit(REQUEST):
    if not REQUEST.form.has_key('news_id') or not REQUEST.form['news_id'].value.decode('UTF8').strip():
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    REQUEST.db.execute("""SELECT * FROM systemnotes WHERE note_id=%d""" % int(REQUEST.form['news_id'].value.decode('UTF8').strip()))
    result = REQUEST.db.dictfetchone()
    if not result:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    today = REQUEST.iso2userdate(result['note_stamp'])
    message = result['note_message'].decode('UTF8')
    newsid = int(REQUEST.form['news_id'].value.decode('UTF8').strip())

    BASE_ADMIN_URL = _Conf.BASE_ADMIN_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_message = REQUEST.TLS('admin_newsmessage')
    tls_save = REQUEST.TLS('tls_save')
    tls_date = REQUEST.TLS('tls_date')
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_frontpage_menu(REQUEST, MY_MENU_ID))

    tls_invdateformat = REQUEST.TLS('tls_invdateformat')
    datecheck_js = REQUEST.datecheck_js(REQUEST)
    
    output.append(u"""<FORM method="post" action="%(BASE_ADMIN_URL)snews.py/news">
<SCRIPT  language="JavaScript" type="text/javascript">
%(datecheck_js)s
</SCRIPT>
<INPUT type="hidden" name="news_id" value="%(newsid)s">
<TABLE border=0 cellpadding=0 cellspacing=0 width="100%%">
<TR>
  <TD colspan=2>&nbsp;</TD>
</TR>
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD width="100%%">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD class="th_listing" align="center" nowrap>&nbsp;&nbsp;%(tls_message)s&nbsp;&nbsp;</TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%">&nbsp;</TD>
      </TR>
    </TABLE>
  </TD>
</TR>
<TR>
 <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
 <TD class="td_listing1">%(tls_date)s: <INPUT size=10 class="textfield1" type="text" name="note_stamp" value="%(today)s" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }"></TD>
</TR>
<TR>
 <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
 <TD class="td_listing0"><TEXTAREA class="textarea1" name="note_message" cols=60 rows=10>%(message)s</TEXTAREA></TD>
</TR>
<TR>
 <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
 <TD class="td_listing1"><INPUT class="input2" type="submit" name="_edit" value="%(tls_save)s"></TD>
</TR>
</TABLE>
</FORM>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)
