# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

import _Conf
from Menus import get_admin_menu
import standard_html

import _Access, _InitTypes, QueryGenerators, _Organization, _Exceptions, _Utils

MY_MENU_ID = 3

def index(REQUEST):
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
        if REQUEST.USER.get_id() <> top_parent.get('superuser_id'):
            raise RuntimeError, REQUEST.TLS('admin_notsuper')

    if not REQUEST.form.keys(): return org_list(REQUEST)

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_admin_menu(REQUEST, MY_MENU_ID))

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_ORGANIZATION])
    if right_param:
        right_param = " AND " + right_param
    QUERY = """SELECT o.organization_name, o.organization_id, i.parent_id FROM organizations o, items i WHERE o.organization_id=i.item_id AND i.item_id<>%d%s ORDER by i.treepos, o.organization_name""" % (_Conf.ROOTOBJECT, right_param)

    REQUEST.db.execute(QUERY.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()

    if REQUEST.form.has_key('do_search'):
        REQ_FIELD = ''
        select_l = [u"""<SELECT class="textfield3" name="parent_id">\n<OPTION value="">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"""]
        buttons = u"""<INPUT class="input2" type="submit" name="_search" value="%s">""" % REQUEST.TLS('tls_search')
        title = REQUEST.TLS('tls_search')
        for item in dbresult:
            item['organization_name'] = item['organization_name'].decode('UTF8')
            select_l.append(u"""<OPTION value="%(organization_id)d">%(organization_name)s""" % item)
        onsubm = ""
    else:
        REQ_FIELD = _Conf.REQ_FIELD
        select_l = [u"""<SELECT class="textfield3" name="parent_id">\n<OPTION value="%d">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;""" % _Conf.ROOTOBJECT]
        buttons = u"""<INPUT class="input2" type="submit" name="_save" value="%s">""" % REQUEST.TLS('tls_add')
        title = REQUEST.TLS('tls_add')
        onsubm = "return check_values()"
    select_l.append(u"""</SELECT>""")

    tls_orgname = REQUEST.TLS('admin_orgname')
    tls_parent = REQUEST.TLS('admin_parentorg')
    tls_address = REQUEST.TLS('contact_address')
    tls_homepage = REQUEST.TLS('contact_homepage')
    tls_email = REQUEST.TLS('tls_email')
    tls_phone = REQUEST.TLS('admin_phone')
    tls_fax = REQUEST.TLS('tls_phone_fax')
    tls_city = REQUEST.TLS('admin_city')
    tls_zipcode = REQUEST.TLS('admin_zipcode')
    tls_country = REQUEST.TLS('admin_country')
    tls_state = REQUEST.TLS('admin_state')
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    BASE_ADMIN_URL = _Conf.BASE_ADMIN_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    select_l = "\n".join(select_l)
    output.append(u"""\
<SCRIPT language="javascript" type="text/javascript">
<!--
  function check_values()
  {
    if (!document.addform.organization_name.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
// -->
</SCRIPT>
<BR>
<TABLE width="100%%" cellpadding=0 cellspacing=0 border=0>
<FORM method="POST" name="addform" action="%(BASE_ADMIN_URL)sorgs.py/org_list" onsubmit="%(onsubm)s">
  <TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD colspan=2 width="100%%">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD class="th_listing" align="center" nowrap>&nbsp;&nbsp;&nbsp;<b>%(title)s</b>&nbsp;&nbsp;&nbsp;</TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%">&nbsp;</TD>
      </TR>
    </TABLE>
  </TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_orgname)s%(REQ_FIELD)s</TD>
    <TD class="td_listing1"><INPUT class="textfield3" type="text" name="organization_name"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_parent)s%(REQ_FIELD)s</TD>
    <TD class="td_listing0">%(select_l)s</TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_address)s</TD>
    <TD class="td_listing1"><INPUT class="textfield3" type="text" name="address"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_city)s</TD>
    <TD class="td_listing0"><INPUT class="textfield3" type="text" name="city"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_state)s</TD>
    <TD class="td_listing1"><INPUT class="textfield3" type="text" name="state"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_zipcode)s</TD>
    <TD class="td_listing0"><INPUT class="textfield3" type="text" name="zipcode"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_country)s</TD>
    <TD class="td_listing1"><INPUT class="textfield3" type="text" name="country"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_homepage)s</TD>
    <TD class="td_listing0"><INPUT class="textfield3" type="text" name="website"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_email)s</TD>
    <TD class="td_listing1"><INPUT class="textfield3" type="text" name="email"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_phone)s</TD>
    <TD class="td_listing0"><INPUT class="textfield3" type="text" name="telephone"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_fax)s</TD>
    <TD class="td_listing1"><INPUT class="textfield3" type="text" name="fax"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0" colspan="2">%(buttons)s</TD>
  </TR>
</TABLE>
</FORM>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def org_list(REQUEST):
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
        if REQUEST.USER.get_id() <> top_parent.get('superuser_id'):
            raise RuntimeError, REQUEST.TLS('admin_notsuper')

    if REQUEST.form.has_key('_save'):
        return save_organization(REQUEST)

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_admin_menu(REQUEST, MY_MENU_ID))


    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_ORGANIZATION])
    if right_param:
        right_param = " AND " + right_param
    search_param = QueryGenerators.generate_search(REQUEST, _Organization.Organization, REQUEST.form)
    QUERY = """SELECT count(*) AS count_all FROM organizations o, items i WHERE o.organization_id=i.item_id AND i.item_id<>%d%s%s""" % (_Conf.ROOTOBJECT, search_param, right_param)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    count_all = REQUEST.db.dictfetchone()['count_all']

    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%sorgs.py/org_list%sqs=" % (_Conf.BASE_ADMIN_URL, REQUEST.get_formstring(['qs']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%sorgs.py/org_list%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_ADMIN_URL, REQUEST.get_formstring(['qs']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%sorgs.py/org_list%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_ADMIN_URL, REQUEST.get_formstring(['qs']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR2(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""

    QUERY = """SELECT o.*, i.treepos, i.parent_id FROM organizations o, items i WHERE o.organization_id=i.item_id AND i.item_id<>%d%s%s ORDER BY i.treepos, o.organization_name LIMIT %d OFFSET %d""" % (_Conf.ROOTOBJECT, search_param, right_param, REQUEST.batch_size, REQUEST.qs)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()



    tls_orgs = REQUEST.TLS('admin_organizations')
    tls_org = REQUEST.TLS('admin_organization')
    tls_address = REQUEST.TLS('contact_address')
    tls_phone = REQUEST.TLS('admin_phone')
    tls_fax = REQUEST.TLS('tls_phone_fax')
    tls_edit = REQUEST.TLS('admin_edit')
    tls_del = REQUEST.TLS('admin_delete')
    tls_search = REQUEST.TLS('tls_search')
    tls_add = REQUEST.TLS('tls_add')
    tls_email = REQUEST.TLS('tls_email')
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    output.append(u"""\
<BR>
<TABLE width="100%%" cellpadding=0 cellspacing=0 border=0>
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD colspan=5 width="100%%">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD class="th_listing" align="center" nowrap>&nbsp;&nbsp;&nbsp;<b>%(tls_orgs)s</b>&nbsp;&nbsp;&nbsp;</TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%">&nbsp;</TD>
      </TR>
    </TABLE>
  </TD>
</TR>
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1b" width="30%%" nowrap>%(tls_org)s</TD>
  <TD class="td_listing1b" width="40%%" nowrap>%(tls_address)s</TD>
  <TD class="td_listing1b" width="15%%" nowrap>%(tls_phone)s</TD>
  <TD class="td_listing1b" width="15%%" nowrap>%(tls_fax)s</TD>
  <TD class="td_listing1b" width="15%%" nowrap>%(tls_email)s</TD>
  <TD class="td_listing1b" width="25"   nowrap>%(tls_del)s</TD>
</TR>""" % locals())

    index = 0
    for item in dbresult:
        item['class_type'] = index % 2
        index += 1
        item['BASE_ADMIN_URL'] = _Conf.BASE_ADMIN_URL
        item['BASE_ICON_URL'] = _Conf.BASE_ICON_URL

        if item['address'] is None: item['address'] = ""
        if item['telephone'] is None: item['telephone'] = ""
        if item['fax'] is None: item['fax'] = ""
        if item['email'] is None: item['email'] = ""

        if item['address'] and item['zipcode'] and item['city']:
            item['address'] = "%s, %s, %s" % (item['address'], item['zipcode'], item['city'])
        elif item['address'] and item['zipcode']:
            item['address'] = "%s, %s" % (item['address'], item['zipcode'])
        elif item['address'] and item['city']:
            item['address'] = "%s, %s" % (item['address'], item['city'])
        elif item['zipcode'] and item['city']:
            item['address'] = "%s, %s" % (item['zipcode'], item['city'])
        elif item['city']:
            item['address'] = "%s" % (item['city'])
        elif item['address']:
            item['address'] = "%s" % (item['address'])
        else:
            item['address'] = '&nbsp;'

        if isinstance(item['organization_name'], str):
            item['organization_name'] = item['organization_name'].decode('UTF8')
        if isinstance(item['address'], str):
            item['address'] = item['address'].decode('UTF8')
        if isinstance(item['telephone'], str):
            item['telephone'] = item['telephone'].decode('UTF8')
        if isinstance(item['fax'], str):
            item['fax'] = item['fax'].decode('UTF8')
        item['e_mail'] = (item['email'] and item['email'].decode('UTF8')) or ''

        item['tls_edit'] = tls_edit
        item['tls_sureq'] = REQUEST.TLS('admin_sureq')
        item['tls_delete'] = REQUEST.TLS('tls_delete')
        item['spacing'] = (((len(item['treepos']) / 32) - 1) * 10) + 1
        output.append(u"""<TR>
  <TD class="td_listing%(class_type)d"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing%(class_type)d"><img src="%(BASE_ICON_URL)sspacer.gif" width="%(spacing)s" height="1" border="0" alt=""><A class="blacklink" href="%(BASE_ADMIN_URL)sorgs.py/org_edit_form?organization_id=%(organization_id)d">%(organization_name)s</A></TD>
  <TD class="td_listing%(class_type)d">%(address)s</TD>
  <TD class="td_listing%(class_type)d">%(telephone)s</TD>
  <TD class="td_listing%(class_type)d">%(fax)s</TD>
  <TD class="td_listing%(class_type)d">%(e_mail)s</TD>
  <TD class="td_listing%(class_type)d" style="text-align: center"><A onclick="return confirm('%(tls_sureq)s?');" href="%(BASE_ADMIN_URL)sorgs.py/org_delete?organization_id=%(organization_id)d"><IMG src="%(BASE_ICON_URL)sdelete.gif" alt="%(tls_delete)s"></A></TD>
</TR>""" % item)
    output.append(u"</TABLE>")
    if FULL_BAR:
        output.append(FULL_BAR)

    item = {}
    item['BASE_ADMIN_URL'] = _Conf.BASE_ADMIN_URL
    item['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
    item['tls_add'] = tls_add
    item['tls_search'] = tls_search
    if not REQUEST.form.keys() or REQUEST.form.keys() == ['qs']:
        output.append(u"""
    <BR>
    <TABLE width="100%%" cellpadding=0 cellspacing=0 border=0>
      <TR>
        <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
        <TD class="td_listing0" width="100%%"><FORM action="%(BASE_ADMIN_URL)sorgs.py" method="GET"><INPUT class="input2" type="submit" value="%(tls_search)s" name="do_search">&nbsp;<INPUT class="input2" type="submit" value="%(tls_add)s" name="do_add"></FORM></TD>
      </TR>
    </TABLE>""" % item)
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def save_organization(REQUEST):
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
        if REQUEST.USER.get_id() <> top_parent.get('superuser_id'):
            raise RuntimeError, REQUEST.TLS('admin_notsuper')

    organization = _Organization.Organization(REQUEST, _InitTypes.INIT_TYPE_REQ)

    if not REQUEST.form.has_key('parent_id') or not REQUEST.form['parent_id'].value:
        organization.set('parent_id', _Conf.ROOTOBJECT)

    for key in ['organization_name']:
        if REQUEST.form[key].value.decode('UTF8').find('<') <> -1 or \
           REQUEST.form[key].value.decode('UTF8').find('>') <> -1 or \
           REQUEST.form[key].value.decode('UTF8').find('"') <> -1:
            raise RuntimeError, REQUEST.TLS('name_orginvchars')

    SQL = u"""SELECT o.organization_id FROM organizations o, items i WHERE o.organization_id=i.item_id AND i.parent_id=%d and o.organization_name=%s""" % (organization.get_parent_id(), _Utils.sql_quote(organization.get('organization_name')))
    REQUEST.db.execute(SQL.encode('UTF8'))
    if REQUEST.db.dictfetchone():
        raise RuntimeError, REQUEST.TLS('admin_orgsamename')
    try:
        organization.save()
    except OSError:
        raise RuntimeError, REQUEST.TLS('admin_orgsamename')

    ns = {'BASE_ADMIN_URL': _Conf.BASE_ADMIN_URL, 'item_id': organization.get_id()}
    output = []
    output.append(standard_html.html_header(REQUEST))
    ref_url = REQUEST.SERVER_URL+_Conf.BASE_ADMIN_URL+"orgs.py/org_list"
    output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(get_admin_menu(REQUEST, MY_MENU_ID))
    output.append(REQUEST.TLS('admin_orgsaved'))
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)


def org_edit_form(REQUEST):
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
        if REQUEST.USER.get_id() <> top_parent.get('superuser_id'):
            raise RuntimeError, REQUEST.TLS('admin_notsuper')

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_admin_menu(REQUEST, MY_MENU_ID))


    ns = {}
    ns['tls_orgname'] = REQUEST.TLS('admin_orgname')
    ns['tls_parent'] = REQUEST.TLS('admin_parentorg')
    ns['tls_address'] = REQUEST.TLS('contact_address')
    ns['tls_homepage'] = REQUEST.TLS('contact_homepage')
    ns['tls_email'] = REQUEST.TLS('tls_email')
    ns['tls_phone'] = REQUEST.TLS('admin_phone')
    ns['tls_fax'] = REQUEST.TLS('tls_phone_fax')
    ns['tls_city'] = REQUEST.TLS('admin_city')
    ns['tls_zipcode'] = REQUEST.TLS('admin_zipcode')
    ns['tls_country'] = REQUEST.TLS('admin_country')
    ns['tls_state'] = REQUEST.TLS('admin_state')
    ns['tls_orgedit'] = REQUEST.TLS('admin_orgedit')
    ns['tls_save'] = REQUEST.TLS('tls_save')
    ns['REQ_FIELD'] = _Conf.REQ_FIELD

    if REQUEST.form.has_key('organization_id') and REQUEST.form['organization_id'].value:
        org = _Organization.Organization(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['organization_id'].value))
        ns['BASE_ADMIN_URL'] = _Conf.BASE_ADMIN_URL
        ns['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
        for (key, item) in org.get_itemdata().items():
            if isinstance(item, str):
                item = item.decode('UTF8')
            if item is None:
                ns[key] = ""
            else:
                ns[key] = item
        output.append(u"""\
<BR>
<TABLE width="100%%" cellpadding=0 cellspacing=0 border=0>
<FORM method="POST" action="%(BASE_ADMIN_URL)sorgs.py/org_edit">
<INPUT type="hidden" name="organization_id" value="%(organization_id)d">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD colspan=2 width="100%%">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD class="th_listing" align="center" nowrap>&nbsp;&nbsp;<b>%(tls_orgedit)s</b>&nbsp;&nbsp;</TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%">&nbsp;</TD>
      </TR>
    </TABLE>
  </TD>
</TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_orgname)s</TD>
    <TD class="td_listing1"><INPUT type="text" name="organization_name" value="%(organization_name)s"  class="textfield3"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_address)s</TD>
    <TD class="td_listing0"><INPUT class="textfield3" type="text" name="address" value="%(address)s" size="30"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_city)s</TD>
    <TD class="td_listing1"><INPUT class="textfield3" type="text" name="city" value="%(city)s" size="30"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_state)s</TD>
    <TD class="td_listing0"><INPUT class="textfield3" type="text" name="state" value="%(state)s" size="30"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_zipcode)s</TD>
    <TD class="td_listing1"><INPUT class="textfield3" type="text" name="zipcode" value="%(zipcode)s" size="30"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_country)s</TD>
    <TD class="td_listing0"><INPUT class="textfield3" type="text" name="country" value="%(country)s" size="30"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_homepage)s</TD>
    <TD class="td_listing1"><INPUT class="textfield3" type="text" name="website" value="%(website)s" size="30"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_email)s</TD>
    <TD class="td_listing0"><INPUT class="textfield3" type="text" name="email" value="%(email)s" size="30"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_phone)s</TD>
    <TD class="td_listing1"><INPUT class="textfield3" type="text" name="telephone" value="%(telephone)s" size="30"</TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_fax)s</TD>
    <TD class="td_listing0"><INPUT class="textfield3" type="text" name="fax" value="%(fax)s" size="30"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0" colspan="2"><INPUT type="submit" class="input2" name="_save" value="%(tls_save)s"></TD>
  </TR>
</TABLE>
</FORM>
""" % ns)
    else:
        output.append(u"Required parameters not provided.")
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def org_edit(REQUEST):
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
        if REQUEST.USER.get_id() <> top_parent.get('superuser_id'):
            raise RuntimeError, REQUEST.TLS('admin_notsuper')

    output = []

    if REQUEST.form.has_key('organization_id') and REQUEST.form['organization_id'].value:
        org = _Organization.Organization(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['organization_id'].value))
        org.load_req()
        for key in ['organization_name']:
            if REQUEST.form[key].value.decode('UTF8').find('<') <> -1 or \
               REQUEST.form[key].value.decode('UTF8').find('>') <> -1 or \
               REQUEST.form[key].value.decode('UTF8').find('"') <> -1:
                raise RuntimeError, REQUEST.TLS('name_orginvchars')
        org.save()
        ns = {'BASE_ADMIN_URL':_Conf.BASE_ADMIN_URL, 'organization_id': org.get_id()}
        output.append(standard_html.html_header(REQUEST))
        ref_url = REQUEST.SERVER_URL+_Conf.BASE_ADMIN_URL+"orgs.py/org_edit_form?organization_id=%d" % org.get_id()
        output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
        output.append(get_admin_menu(REQUEST, MY_MENU_ID))
        output.append(REQUEST.TLS('admin_orgsaved'))
    else:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def org_delete(REQUEST):
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
        if REQUEST.USER.get_id() <> top_parent.get('superuser_id'):
            raise RuntimeError, REQUEST.TLS('admin_notsuper')

    output = []

    if REQUEST.form.has_key('organization_id') and REQUEST.form['organization_id'].value:
        if int(REQUEST.form['organization_id'].value) <= 3:
            raise RuntimeError, REQUEST.TLS('rootobj_nodeleteaccess')
        org = _Organization.Organization(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['organization_id'].value))
        org.delete()
        ns = {'BASE_ADMIN_URL':_Conf.BASE_ADMIN_URL, 'organization_id': org.get_id()}
        output.append(standard_html.html_header(REQUEST))
        ref_url = REQUEST.SERVER_URL+_Conf.BASE_ADMIN_URL+"orgs.py/org_list"
        output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
        output.append(get_admin_menu(REQUEST, MY_MENU_ID))
        output.append(REQUEST.TLS('admin_orgdeleted'))
    else:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

