# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################
import _Conf

from Menus import get_admin_menu
import standard_html, _Person, _InitTypes

MY_MENU_ID = 1

def index(REQUEST):
    output = []

    BASE_ADMIN_URL = _Conf.BASE_ADMIN_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_settings = REQUEST.TLS('tls_settings')
    tls_lang = REQUEST.TLS('setting_language')
    tls_date = REQUEST.TLS('setting_dateformat')
    tls_batch = REQUEST.TLS('setting_batch')
    tls_batch_email = REQUEST.TLS('setting_batch_email')
    tls_save = REQUEST.TLS('tls_save')
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_timezone = REQUEST.TLS('tls_timezone')
    tls_notify = REQUEST.TLS('admin_notify')
    tls_prefclient = REQUEST.TLS('email_pref_client')
    tls_richtext = REQUEST.TLS('email_format_html')
    tls_plaintext = REQUEST.TLS('email_format_plain')
    tls_email_view_frames = REQUEST.TLS('email_view_frames')
    tls_email_view_single = REQUEST.TLS('email_view_single')
    tls_email_view_dual = REQUEST.TLS('email_view_dual')
    tls_framesize = REQUEST.TLS('email_framesize')
    tls_interface  = REQUEST.TLS('admin_interface')
    tls_interface1 = REQUEST.TLS('admin_interface_1')
    tls_interface2 = REQUEST.TLS('admin_interface_2')
    tls_contact_order = REQUEST.TLS('contact_order')
    tls_first_last = REQUEST.TLS('contact_first_last')
    tls_last_first = REQUEST.TLS('contact_last_first')
    tls_rightmenu_view = REQUEST.TLS('admin_rightmenu_view')
    tls_enabled = REQUEST.TLS('admin_enabled')
    tls_disabled = REQUEST.TLS('admin_disabled')

    try:
        cur_lang = REQUEST.get_setting('user_language')
    except:
        cur_lang = None
    try:
        cur_date = REQUEST.get_setting('user_dateformat')
    except:
        cur_date = None
    try:
        cur_tz = REQUEST.get_setting('user_timezone')
    except:
        cur_tz = None

    if cur_tz:
        output.append(standard_html.html_header(REQUEST, "", " onload=\"show(%s);\"" % cur_tz.split(":")[-1]))
    else:
        output.append(standard_html.html_header(REQUEST, ""))
    output.append(get_admin_menu(REQUEST, MY_MENU_ID))


    LANGS = []
    DATES = []
    for (key, item) in _Conf.LANGS.items():
        if cur_lang == key:
            LANGS.append(u"""<OPTION value="%s" SELECTED>%s""" % (key, item))
        else:
            LANGS.append(u"""<OPTION value="%s">%s""" % (key, item))
    for (key, item) in _Conf.DATES.items():
        if cur_date == key:
            DATES.append(u"""<OPTION value="%s" SELECTED>%s""" % (key, item))
        else:
            DATES.append(u"""<OPTION value="%s">%s""" % (key, item))
    LANGS = u"""<SELECT name="user_language">\n%s\n</SELECT>""" % "\n".join(LANGS)
    DATES = u"""<SELECT name="user_dateformat">\n%s\n</SELECT>""" % "\n".join(DATES)
    try:
        user_batch = REQUEST.get_setting('user_default_batch')
    except:
        user_batch = _Conf.DEFAULT_BATCH
    try:
        user_email_batch = REQUEST.get_setting('user_email_batch')
    except:
        user_email_batch = _Conf.DEFAULT_BATCH

    tzinfos = []
    for i in _Conf.TIMEZONES:
        st = "%02d:%s" % (i[0], i[1])
        if st == cur_tz:
            tzinfos.append("""<OPTION value="%s" selected>UTC%s %s</OPTION>""" % (st, i[2], i[3]))
        else:
            tzinfos.append("""<OPTION value="%s">UTC%s %s</OPTION>""" % (st, i[2], i[3]))
    tzinfos = "\n".join(tzinfos)

    person = _Person.Person(REQUEST, _InitTypes.INIT_TYPE_ID, REQUEST.USER.get_id())
    if person.get('email_notify'):
        notify_sel = " checked"
    else:
        notify_sel = ""

    try:
        email_format = REQUEST.get_setting('email_format')
    except:
        email_format =0
    if email_format and email_format=="2":
        ec1 = """<input type="radio" name="e_client" value="1" style="position: relative; top: 3px;">"""
        ec2 = """<input type="radio" name="e_client" value="2" style="position: relative; top: 3px;" checked>"""
    else:
        ec1 = """<input type="radio" name="e_client" value="1" style="position: relative; top: 3px;" checked>"""
        ec2 = """<input type="radio" name="e_client" value="2" style="position: relative; top: 3px;">"""

    try:
        contact_view = REQUEST.get_setting('contact_view')
    except:
        contact_view = "0"
    if contact_view and contact_view=="1":
        co1 = """<input type="radio" name="contact_view" value="0" style="position: relative; top: 3px;">"""
        co2 = """<input type="radio" name="contact_view" value="1" style="position: relative; top: 3px;" checked>"""
    else:
        co1 = """<input type="radio" name="contact_view" value="0" style="position: relative; top: 3px;" checked>"""
        co2 = """<input type="radio" name="contact_view" value="1" style="position: relative; top: 3px;">"""

    try:
        rightmenu_view = REQUEST.get_setting('rightmenu_view')
    except:
        rightmenu_view = "1"
    if rightmenu_view and rightmenu_view=="1":
        rm1 = """<input type="radio" name="rightmenu_view" value="1" style="position: relative; top: 3px;" checked>"""
        rm2 = """<input type="radio" name="rightmenu_view" value="0" style="position: relative; top: 3px;">"""
    else:
        rm1 = """<input type="radio" name="rightmenu_view" value="1" style="position: relative; top: 3px;">"""
        rm2 = """<input type="radio" name="rightmenu_view" value="0" style="position: relative; top: 3px;" checked>"""

    

    output.append("""
<SCRIPT language="javascript" type="text/javascript">
<!--
  function check_values()
  {
    if (!document.addform.user_default_batch.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
// -->
</SCRIPT>
<BR>
<TABLE width="100%%" cellpadding=0 cellspacing=0 border=0>
<FORM method="POST" action="%(BASE_ADMIN_URL)ssettings.py/save" name="addform" onsubmit="return check_values();">
 <TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD colspan=3 width="100%%">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD class="th_listing" align="center" nowrap>&nbsp;&nbsp;&nbsp;<b>%(tls_settings)s</b>&nbsp;&nbsp;&nbsp;</TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%">&nbsp;</TD>
      </TR>
    </TABLE>
  </TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1" nowrap>%(tls_lang)s:</TD>
  <TD class="td_listing1" width="80%%" colspan="2">%(LANGS)s</TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing0" nowrap>%(tls_date)s:</TD>
  <TD class="td_listing0" colspan="2">%(DATES)s</TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1">%(tls_prefclient)s:</TD>
  <TD class="td_listing1" colspan="2">%(ec1)s %(tls_richtext)s &nbsp; %(ec2)s %(tls_plaintext)s</TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing0">%(tls_contact_order)s:</TD>
  <TD class="td_listing0" colspan="2">%(co1)s %(tls_first_last)s &nbsp; %(co2)s %(tls_last_first)s</TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1">%(tls_rightmenu_view)s:</TD>
  <TD class="td_listing1" colspan="2">%(rm1)s %(tls_enabled)s &nbsp; %(rm2)s %(tls_disabled)s</TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing0" nowrap>%(tls_batch)s:</TD>
  <TD class="td_listing0" colspan="2"><INPUT class="textfield1" size=4 type="text" name="user_default_batch" value="%(user_batch)d"></TD>
</TR>
<TR class="tr_listing1" valign="top">
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1">%(tls_notify)s:</TD>
  <TD class="td_listing1" colspan="2"><INPUT type="checkbox" value="1" name="email_notify"%(notify_sel)s></TD>
</TR>
<TR class="tr_listing0">
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing0" width="20%%" nowrap>%(tls_timezone)s:</TD>
  <TD class="td_listing0" width="80%%" nowrap colspan="2"><SELECT name="zone" onchange="show(this.value.substring(3,999));">
%(tzinfos)s
</SELECT></TD>
 </TR>
 <TR class="tr_listing1">
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1" colspan="3" width="100%%"><INPUT class="input2" type=submit name="_save" value="%(tls_save)s"></TD>
 </TR>
</TABLE>
""" % locals())
    output.append("""
<br>
<table border=0 cellpadding=0 cellspacing=0 align="center" style="border: 1px solid black">
  <tr>
    <td><img name="i26" src="%(BASE_ICON_URL)stimezone/26.gif" width="14" height="181" border="0" alt=""></td>
    <td><img name="i2" src="%(BASE_ICON_URL)stimezone/2.gif" width="14" height="181" border="0" alt=""></td>
    <td><img name="i3" src="%(BASE_ICON_URL)stimezone/3.gif" width="14" height="181" border="0" alt=""></td>
    <td><img name="i4" src="%(BASE_ICON_URL)stimezone/4.gif" width="14" height="181" border="0" alt=""></td>
    <td><img name="i5" src="%(BASE_ICON_URL)stimezone/5.gif" width="14" height="181" border="0" alt=""></td>
    <td><img name="i6" src="%(BASE_ICON_URL)stimezone/6.gif" width="14" height="181" border="0" alt=""></td>
    <td><img name="i7" src="%(BASE_ICON_URL)stimezone/7.gif" width="14" height="181" border="0" alt=""></td>
    <td><img name="i8" src="%(BASE_ICON_URL)stimezone/8.gif" width="14" height="181" border="0" alt=""></td>
    <td><img name="i9" src="%(BASE_ICON_URL)stimezone/9.gif" width="14" height="181" border="0" alt=""></td>
    <td><img name="i10" src="%(BASE_ICON_URL)stimezone/10.gif" width="14" height="181" border="0" alt=""></td>
    <td><img name="i11" src="%(BASE_ICON_URL)stimezone/11.gif" width="14" height="181" border="0" alt=""></td>
    <td><img name="i12" src="%(BASE_ICON_URL)stimezone/12.gif" width="14" height="181" border="0" alt=""></td>
    <td><img name="i13" src="%(BASE_ICON_URL)stimezone/13.gif" width="14" height="181" border="0" alt=""></td>
    <td><img name="i14" src="%(BASE_ICON_URL)stimezone/14.gif" width="14" height="181" border="0" alt=""></td>
    <td><img name="i15" src="%(BASE_ICON_URL)stimezone/15.gif" width="14" height="181" border="0" alt=""></td>
    <td><img name="i16" src="%(BASE_ICON_URL)stimezone/16.gif" width="14" height="181" border="0" alt=""></td>
    <td><img name="i17" src="%(BASE_ICON_URL)stimezone/17.gif" width="14" height="181" border="0" alt=""></td>
    <td><img name="i18" src="%(BASE_ICON_URL)stimezone/18.gif" width="14" height="181" border="0" alt=""></td>
    <td><img name="i19" src="%(BASE_ICON_URL)stimezone/19.gif" width="14" height="181" border="0" alt=""></td>
    <td><img name="i20" src="%(BASE_ICON_URL)stimezone/20.gif" width="14" height="181" border="0" alt=""></td>
    <td><img name="i21" src="%(BASE_ICON_URL)stimezone/21.gif" width="14" height="181" border="0" alt=""></td>
    <td><img name="i22" src="%(BASE_ICON_URL)stimezone/22.gif" width="14" height="181" border="0" alt=""></td>
    <td><img name="i23" src="%(BASE_ICON_URL)stimezone/23.gif" width="14" height="181" border="0" alt=""></td>
    <td><img name="i24" src="%(BASE_ICON_URL)stimezone/24.gif" width="14" height="181" border="0" alt=""></td>
    <td><img name="i25" src="%(BASE_ICON_URL)stimezone/25.gif" width="14" height="181" border="0" alt=""></td>
  </tr>
</table>
</form>
<script type="text/javascript">
function show(numb)
 {
   if (document.images)
    {
      numb=parseInt(numb)-1;
      if(numb<2)
        numb=numb+25
      for(i=2;i<=26;i++)
      {
        if(i==numb)
        {
          document.images["i"+(parseInt(i))].src= "%(BASE_ICON_URL)stimezone/"+(parseInt(i))+"a.gif";
        }
        else
        {
          document.images["i"+(parseInt(i))].src= "%(BASE_ICON_URL)stimezone/"+(parseInt(i))+".gif";
        }
      }
    }
 }
</script>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def save(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    ref_url = REQUEST.SERVER_URL+_Conf.BASE_ADMIN_URL+"settings.py"
    output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(get_admin_menu(REQUEST, MY_MENU_ID))
    error_messages = []
    if REQUEST.form.has_key('user_language') and _Conf.LANGS.has_key(REQUEST.form['user_language'].value.decode('UTF8').strip()):
        REQUEST.set_setting('user_language', REQUEST.form['user_language'].value.decode('UTF8').strip())
        output.append("""\
<SCRIPT LANGUAGE="JavaScript">
<!--    
function change_url()
{   
   top.document.location.href=top.document.location.href;
}   
change_url();
// -->  
</script>""")
    else:
        error_messages.append(REQUEST.TLS('setting_nolang'))

    if REQUEST.form.has_key('user_dateformat') and _Conf.DATES.has_key(REQUEST.form['user_dateformat'].value.decode('UTF8').strip()):
        REQUEST.set_setting('user_dateformat', REQUEST.form['user_dateformat'].value.decode('UTF8').strip())
    else:
        error_messages.append(REQUEST.TLS('setting_nodate'))

    if REQUEST.form.has_key('zone') and REQUEST.form['zone'].value.decode('UTF8').strip():
        REQUEST.set_setting('user_timezone', REQUEST.form['zone'].value.decode('UTF8').strip())
    
    if REQUEST.form.has_key('contact_view') and REQUEST.form['contact_view'].value.decode('UTF8').strip():
        REQUEST.set_setting('contact_view', REQUEST.form['contact_view'].value.decode('UTF8').strip())

    if REQUEST.form.has_key('rightmenu_view') and REQUEST.form['rightmenu_view'].value.decode('UTF8').strip():
        REQUEST.set_setting('rightmenu_view', REQUEST.form['rightmenu_view'].value.decode('UTF8').strip())

    if REQUEST.form.has_key('user_default_batch') and REQUEST.form['user_default_batch'].value.decode('UTF8').strip():
        try:
            batch_size = int(REQUEST.form['user_default_batch'].value.decode('UTF8').strip())
            if batch_size >= 10 and batch_size <= 100:
                REQUEST.set_setting('user_default_batch', batch_size)
                REQUEST.set_setting('user_email_batch', batch_size)
            elif batch_size<10:
                REQUEST.set_setting('user_default_batch', 10)
                REQUEST.set_setting('user_email_batch', 10)
            else:
                REQUEST.set_setting('user_default_batch', 100)
                REQUEST.set_setting('user_email_batch', 100)
        except:
            error_messages.append(REQUEST.TLS('setting_nobatch'))
    else:
        error_messages.append(REQUEST.TLS('setting_nobatch'))

    person = _Person.Person(REQUEST, _InitTypes.INIT_TYPE_ID, REQUEST.USER.get_id())
    if REQUEST.form.has_key('email_notify'):
        person.set('email_notify', 1)
    else:
        person.set('email_notify', 0)
    person.save()
    

    output.append(REQUEST.TLS('setting_saved'))
    for errormsg in error_messages:
        output.append("<BR>%s" % errormsg)
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)
