# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################
import os, stat, mx.DateTime, mimetypes, popen2
import _Conf, _Utils, _Document, _RootObject, _InitTypes, cCore

from Menus import get_admin_menu
import standard_html
from mod_python import apache

MY_MENU_ID = 5

def index(REQUEST):
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        raise RuntimeError, REQUEST.TLS('admin_notsuper')

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_admin_menu(REQUEST, MY_MENU_ID))

    BASE_ADMIN_URL = _Conf.BASE_ADMIN_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_sys_status = REQUEST.TLS('admin_sys_status')
    tls_backups = REQUEST.TLS('admin_backups')
    tls_undelete = REQUEST.TLS('admin_undelete')
    tls_pit = REQUEST.TLS('admin_pit')


    if _Conf.PLATFORM_WIN:
        sysinfo = u''
    else:
        sysinfo = u"""<TR>
 <TD width="45%%"><IMG src="%(BASE_ICON_URL)sspacer.gif" width="15" height="132" border="0" alt=""></TD>
 <TD><A href="%(BASE_ADMIN_URL)ssystem.py/systemstatus"><IMG src="%(BASE_ICON_URL)ssys_small.gif" border="0" title="%(tls_sys_status)s"></a></TD>
 <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="10" height="40" border="0" alt=""></TD>
 <TD nowrap><A class="adm_syslink" href="%(BASE_ADMIN_URL)ssystem.py/systemstatus">%(tls_sys_status)s</a></TD>
 <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="150" height="1" border="0" alt=""></TD>
 <TD><A href="%(BASE_ADMIN_URL)ssystem.py/backups"><IMG src="%(BASE_ICON_URL)sbac_small.gif" border="0" title="%(tls_backups)s"></A></TD>
 <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="10" height="40" border="0" alt=""></TD>
 <TD nowrap><A class="adm_syslink" href="%(BASE_ADMIN_URL)ssystem.py/backups">%(tls_backups)s</a></TD>
 <TD width="55%%"><IMG src="%(BASE_ICON_URL)sspacer.gif" width="15" height="132" border="0" alt=""></TD>
</TR>
""" % locals()
    output.append(u"""\
<TABLE border=0 cellpadding="0" cellspacing="0" width="100%%">
<TR>
 <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="1" height="40" border="0" alt=""></TD>
 <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="10" height="40" border="0" alt=""></TD>
 <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="10" height="40" border="0" alt=""></TD>
 <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="10" height="40" border="0" alt=""></TD>
 <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="150" height="40" border="0" alt=""></TD>
 <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="10" height="40" border="0" alt=""></TD>
 <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="10" height="40" border="0" alt=""></TD>
 <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="10" height="40" border="0" alt=""></TD>
 <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="1" height="40" border="0" alt=""></TD>
</TR>
<TR>
 <TD colspan=3>&nbsp;</TD>
 <TD colspan=3 align=center><B>Conflux Lite</B>
</TD>
 <TD colspan=3>&nbsp;</TD>
</TR>
%(sysinfo)s
<TR>
 <TD colspan="9"><IMG src="%(BASE_ICON_URL)sspacer.gif" width="1" height="10" border="0" alt=""></TD>
</TR>
</TABLE>""" % locals())

    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def systemstatus(REQUEST):
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        raise RuntimeError, REQUEST.TLS('admin_notsuper')

    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_disc = REQUEST.TLS('admin_disc_space')
    tls_memory = REQUEST.TLS('admin_memory')
    tls_mountpoint = REQUEST.TLS('admin_mountpoint')
    tls_partition = REQUEST.TLS('admin_partition')
    tls_percentage = REQUEST.TLS('admin_percent_used')
    tls_free = REQUEST.TLS('tls_free')
    tls_used = REQUEST.TLS('tls_used')
    tls_size = REQUEST.TLS('tls_size')
    tls_type = REQUEST.TLS('tls_type')
    tls_phys = REQUEST.TLS('admin_mem_phys')
    tls_swap = REQUEST.TLS('admin_mem_swap')
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_admin_menu(REQUEST, MY_MENU_ID))
    res1 = _Utils.html_quote(popen2.popen4("/bin/df -kP")[0].read())
    list_1 = map(lambda x:filter(None, x.split(" ")),res1.split("\n")[1:-1])
    res1 = u"""
<TABLE border="0" cellpadding="0" cellspacing="0" style="border: 1px solid #596E33;" align="center" width="95%%">
<TR bgcolor="#596E33">
  <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="10" height="25" border="0" alt=""></TD>
  <TD class="td_hdr" nowrap colspan="6" nowrap><b>%(tls_disc)s</B></TD>
</TR>
<TR>
  <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="10" height="20" border="0" alt=""></TD>
  <TD class="td_listingd0" width="20%%"><b>%(tls_mountpoint)s</b></TD>
  <TD class="td_listingd0" width="15%%"><b>%(tls_partition)s</b></TD>
  <TD class="td_listingd0" width="35%%"><b>%(tls_percentage)s</b></TD>
  <TD class="td_listingd0" width="10%%" align="right"><b>%(tls_free)s</b></TD>
  <TD class="td_listingd0" width="10%%" align="right"><b>%(tls_used)s</b></TD>
  <TD class="td_listingd0" width="10%%" align="right"><b>%(tls_size)s</b></TD>
</TR>""" % locals()
    for row in list_1:
        mpt = row[5]
        prt = row[0]
        per = row[4][0:-1]
        use = _Utils.str_size(int(row[2])*1024)
        siz = _Utils.str_size(int(row[1])*1024)
        fre = _Utils.str_size(int(row[3])*1024)
        if(per == 0):
            img_out = """<IMG src="%(BASE_ICON_URL)slgreen.gif" width="50" height="4" border=0 alt="">""" % locals()
        elif(per == 100):
            img_out = """<IMG src="%(BASE_ICON_URL)sdgreen.gif" width="50" height="4" border=0 alt="">""" % locals()
        else:
            fp=int(per)*2
            sp=200 - fp
            img_out = """<IMG src="%(BASE_ICON_URL)sdgreen.gif" width="%(fp)d" height="10" border=0 alt=""><IMG src="%(BASE_ICON_URL)slgreen.gif" width="%(sp)d" height="10" border=0 alt="">""" % locals()
        res1 += u"""
<TR valign="top">
  <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="10" height="25" border="0" alt=""></TD>
  <TD nowrap class="td_listing7">%(mpt)s</TD>
  <TD nowrap class="td_listing7">%(prt)s</TD>
  <TD nowrap class="td_listing7">
    <TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
      <TR>
        <TD>
            <TABLE border=0 cellpadding=0 cellspacing=0 bgcolor="#FFFFFF" style="border: 1px solid black;">
              <TR>
                <TD bgcolor="#FFFFFF" width="100%%">%(img_out)s</TD>
              </TR>
            </TABLE>
        </TD>
        <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
      </TR>
      <TR>
        <TD style="font-size: 9px">%(per)s%% %(tls_used)s</TD>
      </TR>
    </TABLE>
  </TD>
  <TD nowrap class="td_listing7" align="right">%(fre)s</TD>
  <TD nowrap class="td_listing7" align="right">%(use)s</TD>
  <TD nowrap class="td_listing7" align="right">%(siz)s</TD>
</TR>
        """ % locals()
    res1 += """
</TABLE>""" % locals()
    
    try:
        res2 = _Utils.html_quote(popen2.popen4("/usr/bin/free -b")[0].read())
        list_2 = map(lambda x:filter(None, x.split(" ")),res2.split("\n")[1:4])
        ft = _Utils.str_size(int(list_2[0][1]))
        fu = _Utils.str_size(int(list_2[1][2]))
        ff = _Utils.str_size(int(list_2[1][3]))
        st = _Utils.str_size(int(list_2[2][1]))
        su = _Utils.str_size(int(list_2[2][2]))
        sf = _Utils.str_size(int(list_2[2][3]))
        per1 = int(list_2[1][2])*100/int(list_2[0][1])
        if(per1 == 0):
            img_out1 = """<IMG src="%(BASE_ICON_URL)slgreen.gif" width="200" height="10" border=0 alt="">""" % locals()
        elif(per1 == 100):
            img_out1 = """<IMG src="%(BASE_ICON_URL)sdgreen.gif" width="200" height="10" border=0 alt="">""" % locals()
        else:
            fp=int(per1)*2
            sp=200 - fp
            img_out1 = """<IMG src="%(BASE_ICON_URL)sdgreen.gif" width="%(fp)d" height="10" border=0 alt=""><IMG src="%(BASE_ICON_URL)slgreen.gif" width="%(sp)d" height="10" border=0 alt="">""" % locals()
        per2 = int(list_2[2][2])*100/int(list_2[2][1])
        if(per2 == 0):
            img_out2 = """<IMG src="%(BASE_ICON_URL)slgreen.gif" width="200" height="10" border=0 alt="">""" % locals()
        elif(per2 == 100):
            img_out2 = """<IMG src="%(BASE_ICON_URL)sdgreen.gif" width="200" height="10" border=0 alt="">""" % locals()
        else:
            fp=int(per2)*2
            sp=200 - fp
            img_out2 = """<IMG src="%(BASE_ICON_URL)sdgreen.gif" width="%(fp)d" height="10" border=0 alt=""><IMG src="%(BASE_ICON_URL)slgreen.gif" width="%(sp)d" height="10" border=0 alt="">""" % locals()
        res2 = u"""
    <TABLE border="0" cellpadding="0" cellspacing="0" style="border: 1px solid #596E33;" align="center" width="95%%">
    <TR bgcolor="#596E33">
      <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="10" height="25" border="0" alt=""></TD>
      <TD class="td_hdr" nowrap colspan="6" nowrap><b>%(tls_memory)s</B></TD>
    </TR>
    <TR>
      <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="10" height="20" border="0" alt=""></TD>
      <TD class="td_listing7" width="25%%"><b>%(tls_type)s</b></TD>
      <TD class="td_listing7" width="45%%"><b>%(tls_percentage)s</b></TD>
      <TD class="td_listing7" width="10%%" align="right"><b>%(tls_free)s</b></TD>
      <TD class="td_listing7" width="10%%" align="right"><b>%(tls_used)s</b></TD>
      <TD class="td_listing7" width="10%%" align="right"><b>%(tls_size)s</b></TD>
    </TR>
    <TR valign="top">
      <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="10" height="25" border="0" alt=""></TD>
      <TD nowrap class="td_listing7">%(tls_phys)s</TD>
      <TD nowrap class="td_listing7">
        <TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
          <TR>
            <TD>
                <TABLE border=0 cellpadding=0 cellspacing=0 bgcolor="#FFFFFF" style="border: 1px solid black;">
                  <TR>
                    <TD bgcolor="#FFFFFF" width="100%%">%(img_out1)s</TD>
                  </TR>
                </TABLE>
            </TD>
            <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
          </TR>
          <TR>
            <TD style="font-size: 9px">%(per1)s%% %(tls_used)s</TD>
          </TR>
        </TABLE>
      </TD>
      <TD nowrap class="td_listing7" align="right">%(ff)s</TD>
      <TD nowrap class="td_listing7" align="right">%(fu)s</TD>
      <TD nowrap class="td_listing7" align="right">%(ft)s</TD>
    </TR>
    <TR valign="top">
      <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="10" height="25" border="0" alt=""></TD>
      <TD nowrap class="td_listing7">%(tls_swap)s</TD>
      <TD nowrap class="td_listing7">
        <TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
          <TR>
            <TD>
                <TABLE border=0 cellpadding=0 cellspacing=0 bgcolor="#FFFFFF" style="border: 1px solid black;">
                  <TR>
                    <TD bgcolor="#FFFFFF" width="100%%">%(img_out2)s</TD>
                  </TR>
                </TABLE>
            </TD>
            <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
          </TR>
          <TR>
            <TD style="font-size: 9px">%(per2)s%% %(tls_used)s</TD>
          </TR>
        </TABLE>
      </TD>
      <TD nowrap class="td_listing7" align="right">%(sf)s</TD>
      <TD nowrap class="td_listing7" align="right">%(su)s</TD>
      <TD nowrap class="td_listing7" align="right">%(st)s</TD>
    </TR>
    </TABLE>""" % locals()
    except:
        res2 = u""

    output.append(u"""
<BR>
%(res1)s
<BR>
<BR>
%(res2)s
<BR>
<BR>""" % locals())

    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def backups(REQUEST):
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        raise RuntimeError, REQUEST.TLS('admin_notsuper')
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_admin_menu(REQUEST, MY_MENU_ID))
    
    
    BASE_ADMIN_URL = _Conf.BASE_ADMIN_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL

    if REQUEST.form.has_key('_delete'):
        delfiles = []
        for i in REQUEST.form.keys():
            if i[:4] == "del_":
                delfiles.append(i[4:])
        for i in delfiles:
            try:
                os.unlink(os.path.join(_Conf.BACKUP_PATH, i))
            except:
                pass
    
    tls_file_backups = REQUEST.TLS('admin_file_backups')
    tls_db_backups = REQUEST.TLS('admin_db_backups')
    tls_create_backup = REQUEST.TLS('admin_create_backup')
    tls_name = REQUEST.TLS('tls_name')
    tls_size = REQUEST.TLS('size')
    tls_date = REQUEST.TLS('date')
    tls_deletesel = REQUEST.TLS('tls_deletesel')
    
    backups = os.listdir(_Conf.BACKUP_PATH)
    file_backups = []
    db_backups = []
    map(lambda x: (x[:2] == 'db' and (db_backups.append(x) or 1)) or file_backups.append(x), backups)
    
    file_output = []
    file_output.append(u"""\
<SCRIPT type="text/javascript">
function check_1(id)
{
  id1 = "sel1_" + id;
  id2 = "sel2_" + id;
  i1 = document.getElementById(id1);
  i2 = document.getElementById(id2);
  if(i1.checked)
    i2.checked = true;
  else
    i2.checked = false;
}
function check_2(id)
{
  id1 = "sel2_" + id;
  id2 = "sel1_" + id;
  i1 = document.getElementById(id1);
  i2 = document.getElementById(id2);
  if(i1.checked)
    i2.checked = true;
  else
    i2.checked = false;
}
</SCRIPT>
<FORM method="POST" name="backups">
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
  <TR>
    <TD colspan="4">
      <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
        <TR>
          <TD>&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD class="th_listing" align=center nowrap>&nbsp;&nbsp;&nbsp;<b>%(tls_file_backups)s</b>&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD width="100%%">&nbsp;</TD>
        </TR>
      </TABLE>
    </TD>
  </TR>
  <TR>
    <TD class="td_listing1b">%(tls_name)s</TD>
    <TD class="td_listing1b">%(tls_size)s</TD>
    <TD class="td_listing1b">%(tls_date)s</TD>
    <TD class="td_listing1b">&nbsp;</TD>
  </TR>""" % locals())
    index = 0
    for i in file_backups:
        if(index%2==0):
            td_class="td_listing0"
        else:
            td_class="td_listing1"
        index = index + 1
        st = os.stat(os.path.join(_Conf.BACKUP_PATH, i))
        size = _Utils.str_size(st[stat.ST_SIZE])
        date = REQUEST.iso2userdatetime(REQUEST, mx.DateTime.localtime(st[stat.ST_MTIME]))
        file_output.append(u"""<TR><TD class="%(td_class)s"><A href="%(BASE_ADMIN_URL)ssystem.py/file_return?filename=%(i)s">%(i)s</A></TD><TD class="%(td_class)s">%(size)s</TD><TD class="%(td_class)s">%(date)s</TD><TD class="%(td_class)s"><INPUT type="checkbox" name="del_%(i)s" id="sel1_%(index)s" onclick="check_1(%(index)s)"></TD></TR>""" % locals())
    file_output.append(u"""</TABLE>""")
    file_output = "\n".join(file_output)
    
    db_output = []
    db_output.append(u"""\
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
  <TR>
    <TD colspan="4">
      <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
        <TR>
          <TD>&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD class="th_listing" align=center nowrap>&nbsp;&nbsp;&nbsp;<b>%(tls_db_backups)s</b>&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD width="100%%">&nbsp;</TD>
        </TR>
      </TABLE>
    </TD>
  </TR>
  <TR>
    <TD class="td_listing1b">%(tls_name)s</TD>
    <TD class="td_listing1b">%(tls_size)s</TD>
    <TD class="td_listing1b">%(tls_date)s</TD>
    <TD class="td_listing1b">&nbsp;</TD>
  </TR>""" % locals())
    index = 0
    for i in db_backups:
        if(index%2==0):
            td_class="td_listing0"
        else:
            td_class="td_listing1"
        index = index + 1
        st = os.stat(os.path.join(_Conf.BACKUP_PATH, i))
        size = _Utils.str_size(st[stat.ST_SIZE])
        date = REQUEST.iso2userdatetime(REQUEST, mx.DateTime.localtime(st[stat.ST_MTIME]))
        db_output.append(u"""<TR><TD class="%(td_class)s"><A href="%(BASE_ADMIN_URL)ssystem.py/file_return?filename=%(i)s">%(i)s</A></TD><TD class="%(td_class)s">%(size)s</TD><TD class="%(td_class)s">%(date)s</TD><TD class="%(td_class)s"><INPUT type="checkbox" name="del_%(i)s" id="sel2_%(index)s" onclick="check_2(%(index)s)"></TD></TR>""" % locals())
    db_output.append(u"""</TABLE>""")
    db_output = "\n".join(db_output)
    
    output.append(u"""\
<BR>
&nbsp;
<TABLE border=0 width="100%%">
  <TR>
    <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="15" height="20" border="0" alt=""></TD>
    <TD width="50%%" valign="top">%(file_output)s</TD>
    <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="15" height="20" border="0" alt=""></TD>
    <TD width="50%%" valign="top">%(db_output)s</TD>
    <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width="15" height="20" border="0" alt=""></TD>
  </TR>
</TABLE>""" % locals())


    output.append(u"""\
<TABLE border=0 width="100%%" cellpadding="0" cellspacing="0">
  <TR>
    <TD class="td_listing0"><IMG src="%(BASE_ICON_URL)sspacer.gif" width="15" height="20" border="0" alt=""></TD>
    <TD class="td_listing0" width="100%%">
<INPUT type="button" name="_create" class="input3" value="%(tls_create_backup)s" onclick="document.location.href='%(BASE_ADMIN_URL)ssystem.py/createbackup';">&nbsp;<INPUT type="submit" name="_delete" class="input3" value="%(tls_deletesel)s"></TD>
  </TR>
</TABLE></FORM>""" % locals())
    
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def createbackup(REQUEST):
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        raise RuntimeError, REQUEST.TLS('admin_notsuper')

    ok = 1
    admin_file_backup_failed = REQUEST.TLS('admin_file_backup_failed')
    admin_db_backup_failed = REQUEST.TLS('admin_db_backup_failed')
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_admin_menu(REQUEST, MY_MENU_ID))

    now = _Utils.utc_now_mx().strftime("%d%m%Y_%H%M")

    target_fname = os.path.join(_Conf.BACKUP_PATH, "file_%s.tar.gz" % now)
    res = popen2.Popen4("tar -cz %s > %s" % (_Conf.BASE_DOCUMENT_PATH, target_fname))
    if res.wait():
        ok = 0
        output.append(u"""<FONT color="red">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;%(admin_file_backup_failed)s</FONT><BR>""" %locals())
    target_fname = os.path.join(_Conf.BACKUP_PATH, "db_%s.dump" % now)
    res = popen2.Popen4("PGPASSWORD=%s %s -f %s -p %s -U %s %s" % (_Conf.DB_PASS, _Conf.PG_DUMP_PATH, target_fname, _Conf.DB_PORT, _Conf.DB_USER, _Conf.DB_NAME))
    if res.wait():
        ok = 0
        output.append(u"""<FONT color="red">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;%(admin_db_backup_failed)s</FONT><BR>""" %locals())

    output.append(standard_html.html_footer(REQUEST))
    if(ok):
        REQUEST.mod_req.headers_out["Location"] = "%ssystem.py/backups" % _Conf.BASE_ADMIN_URL
        return apache.HTTP_MOVED_TEMPORARILY
    else:
        return "\n".join(output)

def file_return(REQUEST):
    if not REQUEST.form.has_key('filename') or REQUEST.form['filename'].value.decode('UTF8').find('/') <> -1:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    filepath = os.path.join(_Conf.BACKUP_PATH, os.path.split(REQUEST.form['filename'].value.decode('UTF8'))[-1].encode('UTF8'))

    filesize = os.stat(filepath.encode('UTF8'))[stat.ST_SIZE]
    filefp = open(filepath.encode('UTF8'),'rb')
    REQUEST.mod_req.headers_out["Content-Length"] = str(filesize)
    REQUEST.mod_req.headers_out["Content-Disposition"] = "attachment; filename=\"%s\"" % os.path.split(filepath)[-1]
    mimetype, encoding = mimetypes.guess_type(os.path.split(filepath)[-1])
    REQUEST.mod_req.content_type = mimetype or "application/binary"

    if _Conf.IS_MP_27:
        REQUEST.mod_req.send_http_header()
    if REQUEST.mod_req.method == "HEAD":
        REQUEST.mod_req.write("")
        return apache.OK
    reqwrite = REQUEST.mod_req.write  
    fpread = filefp.read
    data = fpread(_Document.BLOCK_SIZE)
    while data:
        reqwrite(data)  
        data = fpread(_Document.BLOCK_SIZE)
    filefp.close()
    return apache.OK

def sanitycheck(REQUEST):
    tables = { 1: ('persons','person_id'),
               2: ('organizations','organization_id'),
               3: ('folders','folder_id'),
               4: ('documents','document_id'),
               5: ('events','event_id'),
               6: ('todos','todo_id'),
               7: ('contacts','contact_id'),
               8: ('efolders','efolder_id'),
               9: ('emails','email_id'),
              10: ('eaccounts','eaccount_id'),
              12: ('usernotes','note_id'),
              11: ('discussions','discussion_id'),
              13: ('disccategories','disccategory_id'),
              14: ('resources','resource_id'),
              15: ('bookmarks','bookmark_id'),
              16: ('workflows','workflow_id'),
              17: ('email_filters','filter_id'),
            }

    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        raise RuntimeError, REQUEST.TLS('admin_notsuper')

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_admin_menu(REQUEST, MY_MENU_ID))
    output.append("<PRE>")

    # Missing rows from object tables while item-row still exists
    for i in tables.keys():
        REQUEST.db.execute("""SELECT count(*) as missing FROM items WHERE item_type_id=%d AND item_id not in (select %s from %s)""" % (i, tables[i][1], tables[i][0]))
        res = REQUEST.db.dictfetchall()[0]['missing']
        output.append("""Table items has records with missing match in table %s: %s""" % (tables[i][0], res))
    output.append("<HR>")

    # Missing files and folders
    found = 0
    REQUEST.db.execute("""SELECT item_id FROM items WHERE item_type_id in (%d, %d, %d)""" % (_InitTypes.ITEM_TYPE_FOLDER, _InitTypes.ITEM_TYPE_DOCUMENT, _InitTypes.ITEM_TYPE_ORGANIZATION))
    res = REQUEST.db.fetchall()
    for i in res:
        try:
            obj = _RootObject.dispatch_item(REQUEST, i[0])
            path = obj.get_path()
            if not os.path.exists(path.encode('UTF8')):
                output.append("Object %d (%s) is missing filesystem data." % (obj.get_id(), obj.table_name))
                found = 1
        except:
            output.append("LOAD FAILED: %s\n" % i[0])
    if not found:
        output.append("No missing files/folders found.")
    output.append("<HR>")

    # Missing db-items with existing files/folders
    found = 0
    REQUEST.db.execute("""SELECT item_id FROM items WHERE item_type_id in (%d,%d)""" % (_InitTypes.ITEM_TYPE_FOLDER, _InitTypes.ITEM_TYPE_ORGANIZATION))
    res = REQUEST.db.fetchall()
    for folder in res:
        folder_id = folder[0]
        try:
            obj = _RootObject.dispatch_item(REQUEST, folder_id)
            path = obj.get_path().encode('UTF8')
            REQUEST.db.execute("""SELECT d.filename FROM documents d, items i where i.item_id=d.document_id and i.parent_id=%d""" % obj.get_id())
            files = map(lambda x: _Utils.make_path(x[0]), REQUEST.db.fetchall())
            REQUEST.db.execute("""SELECT f.folder_name FROM folders f, items i where i.item_id=f.folder_id and i.parent_id=%d""" % obj.get_id())
            folders = map(lambda x: _Utils.make_path(x[0]), REQUEST.db.fetchall())
            REQUEST.db.execute("""SELECT o.organization_name FROM organizations o, items i where i.item_id=o.organization_id and i.parent_id=%d""" % obj.get_id())
            orgs = map(lambda x: _Utils.make_path(x[0]), REQUEST.db.fetchall())
            localfiles = os.listdir(path)
            missing = []
            for i in localfiles:
                if i not in files and i not in folders and i not in orgs:
                    missing.append(i)
            if missing:
                found = 1
                output.append("""Following filesystem objects under folder %s (%d) are missing from DB: %s""" % (obj.get_path(), obj.get_id(), missing))
        except:
            output.append("LOAD FAILED: %s\n" % folder_id)
    if not found:
        output.append("No missing database records for existing files/folders found.")
    output.append("</PRE>")
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

