# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

import _Conf, cCore
from Menus import get_admin_menu
import standard_html

from mod_python import apache

import _Access, _InitTypes, QueryGenerators, _Person, _Exceptions, _Utils, _Organization, SQLTree

MY_MENU_ID = 2

def index(REQUEST):
    if not REQUEST.form.keys(): return user_list(REQUEST)
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
        if REQUEST.USER.get_id() <> top_parent.get('superuser_id'):
            raise RuntimeError, REQUEST.TLS('admin_notsuper')

    if REQUEST.form.has_key('_activate'):
        del_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                del_ids.append(int(key[4:]))

        for del_id in del_ids:
            if del_id <> _Conf.SUPERUSER and del_id <> REQUEST.USER.get_id():
                REQUEST.db.execute("""UPDATE persons SET is_disabled=0 WHERE person_id=%d""" % del_id)

        REQUEST.mod_req.headers_out["Location"] = """%susers.py""" % _Conf.BASE_ADMIN_URL
        return apache.HTTP_MOVED_TEMPORARILY
    elif REQUEST.form.has_key('_deactivate'):
        del_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                del_ids.append(int(key[4:]))

        for del_id in del_ids:
            if del_id <> _Conf.SUPERUSER and del_id <> REQUEST.USER.get_id():
                REQUEST.db.execute("""UPDATE persons SET is_disabled=1 WHERE person_id=%d""" % del_id)

        REQUEST.mod_req.headers_out["Location"] = """%susers.py""" % _Conf.BASE_ADMIN_URL
        return apache.HTTP_MOVED_TEMPORARILY

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_admin_menu(REQUEST, MY_MENU_ID))

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_ORGANIZATION])
    if right_param:
        right_param = " AND " + right_param
    QUERY = """SELECT o.organization_name, o.organization_id, i.parent_id FROM organizations o, items i WHERE o.organization_id=i.item_id AND i.item_id<>%d%s ORDER by i.treepos, o.organization_name""" % (_Conf.ROOTOBJECT, right_param)

    REQUEST.db.execute(QUERY.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()

    if REQUEST.form.has_key('do_search'):
        output.append("""\
<SCRIPT language="javascript" type="text/javascript">
<!--
  function check_values()
  {
    return true;
  }
// -->
</SCRIPT>""")
        REQ_FIELD = ''
        select_l = [u"""<SELECT class="textfield3" name="parent_id">\n<OPTION value="">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"""]
        buttons = u"""<INPUT class="input2" type="submit" name="_search" value="%s">""" % REQUEST.TLS('tls_search')
        title = REQUEST.TLS('tls_search')
    else:
        tls_missing_input = REQUEST.TLS('tls_missing_input')
        output.append("""\
<SCRIPT language="javascript" type="text/javascript">
<!--
  function check_values()
  {
    if (!document.addform.first_name.value || !document.addform.last_name.value || !document.addform.username.value || !document.addform.password1.value || !document.addform.password1.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
// -->
</SCRIPT>""" % locals())
        REQ_FIELD = _Conf.REQ_FIELD
        select_l = [u"""<SELECT class="textfield3" name="parent_id">"""]
        buttons = u"""<INPUT class="input2" type="submit" name="_save" value="%s">""" % REQUEST.TLS('tls_add')
        title = REQUEST.TLS('tls_add')
    for item in dbresult:
        item['organization_name'] = item['organization_name'].decode('UTF8')
        select_l.append(u"""<OPTION value="%(organization_id)d">%(organization_name)s""" % item)
    select_l.append(u"""</SELECT>""")

    tls_org = REQUEST.TLS('admin_organization')
    tls_first = REQUEST.TLS('tls_first_name')
    tls_last = REQUEST.TLS('tls_last_name')
    tls_middle = REQUEST.TLS('tls_middle_names')
    tls_user = REQUEST.TLS('admin_username')
    tls_pass = REQUEST.TLS('tls_password')
    tls_pass2 = REQUEST.TLS('tls_passwordagain')
    tls_work = REQUEST.TLS('tls_phone_work')
    tls_cell = REQUEST.TLS('tls_phone_cell')
    tls_home = REQUEST.TLS('tls_phone_home')
    tls_fax = REQUEST.TLS('tls_phone_fax')
    tls_email = REQUEST.TLS('tls_email')
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    BASE_ADMIN_URL = _Conf.BASE_ADMIN_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    select_l = "\n".join(select_l)
    output.append(u"""\
<br>
<TABLE width="100%%" cellpadding=0 cellspacing=0 border=0>
<FORM method="POST" action="%(BASE_ADMIN_URL)susers.py/user_list" name="addform" onsubmit="return check_values()">
  <TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD colspan=2 width="100%%">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD class="th_listing" align="center" nowrap>&nbsp;&nbsp;&nbsp;<b>%(title)s</b>&nbsp;&nbsp;&nbsp;</TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%">&nbsp;</TD>
      </TR>
    </TABLE>
  </TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_org)s%(REQ_FIELD)s</TD>
    <TD>%(select_l)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_first)s%(REQ_FIELD)s</TD>
    <TD class="td_listing0"><INPUT class="textfield3" type="text" name="first_name"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_middle)s</TD>
    <TD class="td_listing1"><INPUT class="textfield3" type="text" name="middle_name"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_last)s%(REQ_FIELD)s</TD>
    <TD class="td_listing0"><INPUT class="textfield3" type="text" name="last_name"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_user)s%(REQ_FIELD)s</TD>
    <TD class="td_listing1"><INPUT class="textfield3" type="text" name="username"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_pass)s%(REQ_FIELD)s</TD>
    <TD class="td_listing0"><INPUT class="textfield3" type="password" name="password1"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_pass2)s%(REQ_FIELD)s</TD>
    <TD class="td_listing1"><INPUT class="textfield3" type="password" name="password2"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_work)s</TD>
    <TD class="td_listing0"><INPUT class="textfield3" type="text" name="phone_work"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_cell)s</TD>
    <TD class="td_listing1"><INPUT class="textfield3" type="text" name="phone_cell"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_home)s</TD>
    <TD class="td_listing0"><INPUT class="textfield3" type="text" name="phone_home"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_fax)s</TD>
    <TD class="td_listing1"><INPUT class="textfield3" type="text" name="phone_fax"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_email)s</TD>
    <TD class="td_listing0"><INPUT class="textfield3" type="text" name="e_mail"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0" colspan="2">%(buttons)s</TD>
  </TR>
</TABLE>
</FORM>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def user_list(REQUEST):
#    regular users can see the list now too, only buttons are disabled.    #
#    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
#        top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
#        if REQUEST.USER.get_id() <> top_parent.get('superuser_id'):
#            raise RuntimeError, REQUEST.TLS('admin_notsuper')
    
    is_super = 0
    if REQUEST.USER.get_id() == _Conf.SUPERUSER:
        is_super = 1
    else:
        top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
        if REQUEST.USER.get_id() == top_parent.get('superuser_id'):
            is_super = 1

    if REQUEST.form.has_key('_save'):
        return save_user(REQUEST)

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_admin_menu(REQUEST, MY_MENU_ID))

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_PERSON])
    if right_param:
        right_param = " AND " + right_param
    search_param = QueryGenerators.generate_search(REQUEST, _Person.Person, REQUEST.form, banned_keys=['password'], tablename="p")

    QUERY = """SELECT count(*) AS count_all FROM persons p, items i, organizations o WHERE p.person_id=i.item_id AND o.organization_id=i.parent_id AND p.is_deleted=0%s%s""" % (search_param, right_param)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    count_all = REQUEST.db.dictfetchone()['count_all']

    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%susers.py/user_list%sqs=" % (_Conf.BASE_ADMIN_URL, REQUEST.get_formstring(['qs']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%susers.py/user_list%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_ADMIN_URL, REQUEST.get_formstring(['qs']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%susers.py/user_list%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_ADMIN_URL, REQUEST.get_formstring(['qs']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR2(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""

    tls_users = REQUEST.TLS('admin_users')
    tls_name = REQUEST.TLS('tls_name')
    tls_phone = REQUEST.TLS('tls_phone_work')
    tls_email = REQUEST.TLS('tls_email')
    tls_organization = REQUEST.TLS('admin_organization')
    tls_edit = REQUEST.TLS('admin_edit')
    if is_super:
        tls_delete = REQUEST.TLS('admin_delete')
    else:
        tls_delete = ""
    tls_username = REQUEST.TLS('admin_username')
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    BASE_ADMIN_URL = _Conf.BASE_ADMIN_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL

    sortby = [
'last_name ASC, first_name ASC', 'last_name DESC, first_name ASC',
'phone_work ASC', 'phone_work DESC',
'e_mail ASC', 'e_mail DESC',
'username ASC', 'username DESC',
'organization_name ASC, last_name ASC, first_name ASC', 'organization_name DESC, last_name ASC, first_name ASC']
    DEFAULT_SORTBY = 5
    sortby_id = -1
    if REQUEST.form.has_key('sort_by') and REQUEST.form['sort_by'].value.decode('UTF8').strip():
        sortby_id = int(REQUEST.form['sort_by'].value.decode('UTF8').strip())
    if sortby_id < 0 or sortby_id >= len(sortby):
        sortby_id  = DEFAULT_SORTBY

    formstring = REQUEST.get_formstring(['qs','sort_by','moveselected','deleteselected'])
    sortby_name = u"""<A class="email_contentsb" href="%susers.py/user_list%ssort_by=0">%s</A>""" % (_Conf.BASE_ADMIN_URL, formstring, tls_name)
    sortby_phone = u"""<A class="email_contentsb" href="%susers.py/user_list%ssort_by=2">%s</A>""" % (_Conf.BASE_ADMIN_URL, formstring, tls_phone)
    sortby_email = u"""<A class="email_contentsb" href="%susers.py/user_list%ssort_by=4">%s</A>""" % (_Conf.BASE_ADMIN_URL, formstring, tls_email)
    sortby_username = u"""<A class="email_contentsb" href="%susers.py/user_list%ssort_by=6">%s</A>""" % (_Conf.BASE_ADMIN_URL, formstring, tls_username)
    sortby_organization = u"""<A class="email_contentsb" href="%susers.py/user_list%ssort_by=8">%s</A>""" % (_Conf.BASE_ADMIN_URL, formstring, tls_organization)
    if sortby_id == 0:
        sortby_name = u"""<A class="email_contentsb" href="%susers.py/user_list%ssort_by=1">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_ADMIN_URL, formstring, tls_name)
    elif sortby_id == 1:
        sortby_name = u"""<A class="email_contentsb" href="%susers.py/user_list%ssort_by=0">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_ADMIN_URL, formstring, tls_name)
    elif sortby_id == 2:
        sortby_phone = u"""<A class="email_contentsb" href="%susers.py/user_list%ssort_by=3">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_ADMIN_URL, formstring, tls_phone)
    elif sortby_id == 3:
        sortby_phone = u"""<A class="email_contentsb" href="%susers.py/user_list%ssort_by=2">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_ADMIN_URL, formstring, tls_phone)
    elif sortby_id == 4:
        sortby_email = u"""<A class="email_contentsb" href="%susers.py/user_list%ssort_by=5">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_ADMIN_URL, formstring, tls_email)
    elif sortby_id == 5:
        sortby_email = u"""<A class="email_contentsb" href="%susers.py/user_list%ssort_by=4">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_ADMIN_URL, formstring, tls_email)
    elif sortby_id == 6:
        sortby_username = u"""<A class="email_contentsb" href="%susers.py/user_list%ssort_by=7">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_ADMIN_URL, formstring, tls_username)
    elif sortby_id == 7:
        sortby_username = u"""<A class="email_contentsb" href="%susers.py/user_list%ssort_by=6">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_ADMIN_URL, formstring, tls_username)
    elif sortby_id == 8:
        sortby_organization = u"""<A class="email_contentsb" href="%susers.py/user_list%ssort_by=9">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_ADMIN_URL, formstring, tls_organization)
    elif sortby_id == 9:
        sortby_organization = u"""<A class="email_contentsb" href="%susers.py/user_list%ssort_by=8">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_ADMIN_URL, formstring, tls_organization)
    del formstring


    QUERY = """SELECT p.*, i.parent_id, o.organization_name FROM persons p, items i, organizations o WHERE p.person_id=i.item_id AND o.organization_id=i.parent_id AND p.is_deleted=0%s%s ORDER BY %s LIMIT %d OFFSET %d""" % (search_param, right_param, sortby[sortby_id], REQUEST.batch_size, REQUEST.qs)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()

    output.append(u"""\
<BR>
<TABLE width="100%%" cellpadding=0 cellspacing=0 border=0>
<FORM action="%(BASE_ADMIN_URL)susers.py" method="POST">
  <TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD colspan=7 width="100%%">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD class="th_listing" align=center nowrap>&nbsp;&nbsp;&nbsp;<b>%(tls_users)s</b>&nbsp;&nbsp;&nbsp;</TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%">&nbsp;</TD>
      </TR>
    </TABLE>
  </TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1b" width="25%%">%(sortby_name)s</TD>
    <TD class="td_listing1b" width="15%%">%(sortby_phone)s</TD>
    <TD class="td_listing1b" width="20%%">%(sortby_email)s</TD>
    <TD class="td_listing1b" width="10%%">%(sortby_username)s</TD>
    <TD class="td_listing1b" width="30%%">%(sortby_organization)s</TD>
    <TD class="td_listing1b" width="25">&nbsp;</TD>
    <TD class="td_listing1b" width="25" nowrap>%(tls_delete)s</TD>
  </TR>""" % locals())

    index = 0
    for item in dbresult:
        item['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
        item['BASE_ADMIN_URL'] = _Conf.BASE_ADMIN_URL
        item['class_type'] = index % 2
        index += 1
        if item['phone_work'] is None: item['phone_work'] = ""
        else: item['phone_work'] = item['phone_work'].decode('UTF8')
        if item['e_mail'] is None: item['e_mail'] = ""
        else: item['e_mail'] = item['e_mail'].decode("UTF8")
        if item['username'] is None: item['username'] = ""

        item['first_name'] = item['first_name'].decode('UTF8')
        item['last_name'] = item['last_name'].decode('UTF8')
        item['organization_name'] = item['organization_name'].decode('UTF8')
        item['username'] = item['username'].decode('UTF8')
        if item['is_disabled']:
            item['username'] = u"""<FONT color="red"><b>%s</b></FONT>""" % item['username']
        item['tls_sureq'] = REQUEST.TLS('admin_sureq')
        item['tls_edit'] = tls_edit
        item['tls_delete'] = tls_delete
        if is_super:
            item['del_check'] = """<INPUT type="checkbox" name="sel_%d">""" % item['person_id']
        else:
            item['del_check'] = "&nbsp;"
        if is_super:
            item['del_out'] = """<A onclick="return confirm('%(tls_sureq)s');" href="%(BASE_ADMIN_URL)susers.py/user_delete?person_id=%(person_id)d"><IMG src="%(BASE_ICON_URL)sdelete.gif" alt="%(tls_delete)s"></A>""" % item
        else:
            item['del_out'] = "&nbsp;"
        
        output.append(u"""<TR class="tr_listing%(class_type)d">
  <TD class="td_listing%(class_type)d"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing%(class_type)d"><A class="blacklink" href="%(BASE_ADMIN_URL)susers.py/user_info?person_id=%(person_id)d" >%(first_name)s %(last_name)s</A></TD>
  <TD class="td_listing%(class_type)d">%(phone_work)s</TD>
  <TD class="td_listing%(class_type)d">%(e_mail)s</TD>
  <TD class="td_listing%(class_type)d">%(username)s</TD>
  <TD class="td_listing%(class_type)d">%(organization_name)s</TD>
  <TD class="td_listing%(class_type)d" style="text-align: center">%(del_check)s</TD>
  <TD class="td_listing%(class_type)d" style="text-align: center">%(del_out)s</TD>
</TR>""" % item)

    output.append("</TABLE>")
    if FULL_BAR:
        output.append(FULL_BAR)
    item = {'BASE_ADMIN_URL':_Conf.BASE_ADMIN_URL, 'tls_search':REQUEST.TLS('tls_search'), 'tls_add':REQUEST.TLS('tls_add'), 'tls_activate':REQUEST.TLS('email_activate'), 'tls_deactivate':REQUEST.TLS('email_deactivate'), 'BASE_ICON_URL':_Conf.BASE_ICON_URL}
    if is_super:
        output.append("""
    <BR>
    <TABLE width="100%%" cellpadding=0 cellspacing=0 border=0>
      <TR>
        <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>    
        <TD class="td_listing0" width="100%%"><INPUT class="input2" type="submit" value="%(tls_search)s" name="do_search">&nbsp;<INPUT class="input2" type="submit" value="%(tls_add)s" name="do_add">&nbsp;<INPUT class="input2" type="submit" value="%(tls_activate)s" name="_activate">&nbsp;<INPUT class="input2" type="submit" value="%(tls_deactivate)s" name="_deactivate"></TD>
      </TR>
    </TABLE>""" % item)
    output.append("</FORM>")
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def save_user(REQUEST):
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
        if REQUEST.USER.get_id() <> top_parent.get('superuser_id'):
            raise RuntimeError, REQUEST.TLS('admin_notsuper')

    person = _Person.Person(REQUEST, _InitTypes.INIT_TYPE_REQ)

    if not REQUEST.form.has_key('first_name') or not REQUEST.form['first_name'].value.decode('UTF8'):
        raise RuntimeError, REQUEST.TLS('admin_users_nofirst')
    if not REQUEST.form.has_key('last_name') or not REQUEST.form['last_name'].value.decode('UTF8'):
        raise RuntimeError, REQUEST.TLS('admin_users_nolast')
    if not REQUEST.form.has_key('username') or not REQUEST.form['username'].value.decode('UTF8'):
        raise RuntimeError, REQUEST.TLS('admin_users_nouser')

    for key in ['first_name', 'middle_name', 'last_name']:
        if REQUEST.form[key].value.decode('UTF8').find('<') <> -1 or \
           REQUEST.form[key].value.decode('UTF8').find('>') <> -1 or \
           REQUEST.form[key].value.decode('UTF8').find('"') <> -1:
            raise RuntimeError, REQUEST.TLS('name_invchars')

    if REQUEST.form.has_key('password1') and REQUEST.form.has_key('password2') and REQUEST.form['password1'].value: # Can't strip or decode to unicode here since crypt dies on unicode :(
        if REQUEST.form['password1'].value <> REQUEST.form['password2'].value:
            raise RuntimeError, REQUEST.TLS('admin_users_nomatch')
        person.set('password', _Utils.crypt(REQUEST.form['password1'].value, _Utils.get_salt()))
    else:
        raise RuntimeError, REQUEST.TLS('admin_users_nomatch')

    if not REQUEST.form.has_key('parent_id') or not REQUEST.form['parent_id'].value:
        raise RuntimeError
    SQL = u"""SELECT p.person_id FROM persons p, items i WHERE p.username=%s AND p.is_deleted=0""" % _Utils.sql_quote(person.get('username'))
    REQUEST.db.execute(SQL.encode('UTF8'))
    if REQUEST.db.dictfetchone():
        raise RuntimeError, REQUEST.TLS('admin_users_usertaken')

    person.save()

    ns = {'BASE_ADMIN_URL': _Conf.BASE_ADMIN_URL, 'item_id': person.get_id()}
    output = []
    output.append(standard_html.html_header(REQUEST))
    ref_url = REQUEST.SERVER_URL+_Conf.BASE_ADMIN_URL+"users.py/user_list"
    output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(get_admin_menu(REQUEST, MY_MENU_ID))
    output.append(REQUEST.TLS('admin_usersaved'))
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def user_info(REQUEST):
    is_super = 0
    if REQUEST.USER.get_id() == _Conf.SUPERUSER:
        is_super = 1
    else:
        top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
        if REQUEST.USER.get_id() == top_parent.get('superuser_id'):
            is_super = 1
    
    output = []
    output.append(standard_html.html_header(REQUEST))
    if REQUEST.form.has_key('person_id') and REQUEST.form['person_id'].value:
        person = _Person.Person(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['person_id'].value))
        org = _Organization.Organization(REQUEST, _InitTypes.INIT_TYPE_ID, person.get_parent_id())
    else:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    
    person_id = person.get_id()
    first_name = person.get('first_name')
    last_name = person.get('last_name')
    org_name = org.get_name()
    username = person.get('username')
    phone_work = person.get('phone_work') or '&nbsp;'
    phone_home = person.get('phone_home') or '&nbsp;'
    phone_cell = person.get('phone_cell') or '&nbsp;'
    phone_fax = person.get('phone_fax') or '&nbsp;'
    e_mail = person.get('e_mail') or ''
    if e_mail:
        e_mail = """<a href="%scompose.py?mail_to=%s%%20%s%%20<%s>">%s</a>""" % (_Conf.BASE_EMAIL_URL, person.get('first_name'), person.get('last_name'), e_mail, e_mail)
    else:
        e_mail = "&nbsp;"
    tls_title = REQUEST.TLS('admin_users_edit')
    tls_org = REQUEST.TLS('admin_organization')
    tls_first = REQUEST.TLS('tls_first_name')
    tls_last = REQUEST.TLS('tls_last_name')
    tls_user = REQUEST.TLS('admin_username')
    tls_workp = REQUEST.TLS('tls_phone_work')
    tls_cell = REQUEST.TLS('tls_phone_cell')
    tls_homep = REQUEST.TLS('tls_phone_home')
    tls_fax = REQUEST.TLS('tls_phone_fax')
    tls_email = REQUEST.TLS('tls_email')
    tls_userinfo = REQUEST.TLS('email_userinfo')
    tls_edit = REQUEST.TLS('tls_edit')
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_ADMIN_URL = _Conf.BASE_ADMIN_URL
    output.append(get_admin_menu(REQUEST, MY_MENU_ID))
    output.append(u"""
<br>
<TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
  <TR class="tr_listing0">
    <TD colspan=5>
      <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
        <TR>
          <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;&nbsp;<b>%(tls_userinfo)s</b>&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
        </TR>
      </TABLE>
    </TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD nowrap class="td_listing1b">%(tls_org)s:</TD>
    <TD nowrap class="td_listing1">%(org_name)s</TD>
    <TD width="50%%" colspan="3"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD nowrap class="td_listing0b">%(tls_first)s:</TD>
    <TD nowrap class="td_listing0">%(first_name)s</TD>
    <TD nowrap class="td_listing0b">%(tls_last)s:</TD>
    <TD nowrap class="td_listing0">%(last_name)s</TD>
    <TD width="50%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD nowrap class="td_listing1b">%(tls_workp)s:</TD>
    <TD nowrap class="td_listing1">%(phone_work)s</TD>
    <TD nowrap class="td_listing1b">%(tls_fax)s:</TD>
    <TD nowrap class="td_listing1">%(phone_fax)s</TD>
    <TD width="50%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD nowrap class="td_listing0b">%(tls_homep)s:</TD>
    <TD nowrap class="td_listing0">%(phone_home)s</TD>
    <TD nowrap class="td_listing0b">%(tls_cell)s:</TD>
    <TD nowrap class="td_listing0">%(phone_cell)s</TD>
    <TD width="50%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD nowrap class="td_listing1b">%(tls_email)s:</TD>
    <TD nowrap class="td_listing1">%(e_mail)s</TD>
    <TD width="50%%" colspan="3"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
  </TR>
</TABLE>
""" % locals())
    pic = person.get('picture')
    if pic:
        output.append(u"""
<BR>
<TABLE width="100%%" cellpadding=0 cellspacing=0 border=0>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0" width="100%%"><img src="%(BASE_ADMIN_URL)smyinfo.py/pic?id=%(person_id)s" border="0" alt="" style="border: 1px solid black"></TD>
  </TR>
</TABLE>
<BR>""" % locals())
    if is_super:
        output.append("""
    <TABLE width="100%%" cellpadding=0 cellspacing=0 border=0>
      <TR>
        <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>    
        <TD class="td_listing0" width="100%%"><INPUT class="input2" type="submit" value="%(tls_edit)s" onclick="document.location='%(BASE_ADMIN_URL)susers.py/user_edit_form?person_id=%(person_id)s';"></TD>
      </TR>
    </TABLE>""" % locals())


    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)


def user_edit_form(REQUEST):
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
        if REQUEST.USER.get_id() <> top_parent.get('superuser_id'):
            raise RuntimeError, REQUEST.TLS('admin_notsuper')

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_admin_menu(REQUEST, MY_MENU_ID))
    output.append(standard_html.window_script(height=300,width=300))
    if REQUEST.form.has_key('person_id') and REQUEST.form['person_id'].value:
        person = _Person.Person(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['person_id'].value))
        ns = {}
        ns['first_name'] = person.get('first_name')
        ns['middle_name'] = person.get('middle_name') or ""
        ns['last_name'] = person.get('last_name')
        ns['BASE_ADMIN_URL'] = _Conf.BASE_ADMIN_URL
        ns['person_id'] = person.get_id()
        ns['username'] = person.get('username') or ""
        ns['phone_work'] = person.get('phone_work') or ""
        ns['phone_cell'] = person.get('phone_cell') or ""
        ns['phone_home'] = person.get('phone_home') or ""
        ns['phone_fax'] = person.get('phone_fax') or ""
        ns['e_mail'] = person.get('e_mail') or ""

        ns['tls_orgname'] = REQUEST.TLS('admin_organization')
        ns['tls_title'] = REQUEST.TLS('admin_users_edit')
        ns['tls_org'] = REQUEST.TLS('admin_organization')
        ns['tls_first'] = REQUEST.TLS('tls_first_name')
        ns['tls_last'] = REQUEST.TLS('tls_last_name')
        ns['tls_middle'] = REQUEST.TLS('tls_middle_names')
        ns['tls_user'] = REQUEST.TLS('admin_username')
        ns['tls_pass'] = REQUEST.TLS('tls_password')
        ns['tls_pass2'] = REQUEST.TLS('tls_passwordagain')
        ns['tls_work'] = REQUEST.TLS('tls_phone_work')
        ns['tls_cell'] = REQUEST.TLS('tls_phone_cell')
        ns['tls_home'] = REQUEST.TLS('tls_phone_home')
        ns['tls_fax'] = REQUEST.TLS('tls_phone_fax')
        ns['tls_email'] = REQUEST.TLS('tls_email')
        ns['tls_save'] = REQUEST.TLS('tls_save')
        ns['tls_missing_input'] = REQUEST.TLS('tls_missing_input')
        ns['REQ_FIELD'] = _Conf.REQ_FIELD
        ns['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
        ns['my_parent_name'] = _Organization.Organization(REQUEST, _InitTypes.INIT_TYPE_ID, person.get('parent_id')).get('organization_name')
        ns['parent_id'] = person.get('parent_id')

        output.append(u"""\
<SCRIPT language="javascript" type="text/javascript">
<!--
  function check_values()
  {
    if (!document.editform.first_name.value || !document.editform.last_name.value || !document.editform.username.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
// -->
</SCRIPT>
<BR>
<TABLE width="100%%" cellpadding=0 cellspacing=0 border=0>
<FORM method="POST" action="%(BASE_ADMIN_URL)susers.py/user_edit" onsubmit="return check_values()" name="editform">
<INPUT type="hidden" name="person_id" value="%(person_id)d">
<INPUT type="hidden" name="my_parent_id" value="%(parent_id)d">
  <TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD colspan=2 width="100%%">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD class="th_listing" align="center" nowrap>&nbsp;&nbsp;&nbsp;&nbsp;<b>%(tls_title)s</b>&nbsp;&nbsp;&nbsp;&nbsp;</TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%">&nbsp;</TD>
      </TR>
    </TABLE>
  </TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_first)s%(REQ_FIELD)s</TD>
    <TD class="td_listing1"><INPUT class="textfield3" type="text" name="first_name" value="%(first_name)s"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_middle)s</TD>
    <TD class="td_listing0"><INPUT class="textfield3" type="text" name="middle_name" value="%(middle_name)s"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_last)s%(REQ_FIELD)s</TD>
    <TD class="td_listing1"><INPUT class="textfield3" type="text" name="last_name" value="%(last_name)s"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_user)s%(REQ_FIELD)s</TD>
    <TD class="td_listing0"><INPUT class="textfield3" type="text" name="username" value="%(username)s"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_pass)s</TD>
    <TD class="td_listing1"><INPUT class="textfield3" type="password" name="password1"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_pass2)s</TD>
    <TD class="td_listing0"><INPUT class="textfield3" type="password" name="password2"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_work)s</TD>
    <TD class="td_listing1"><INPUT class="textfield3" type="text" name="phone_work" value="%(phone_work)s"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_cell)s</TD>
    <TD class="td_listing0"><INPUT class="textfield3" type="text" name="phone_cell" value="%(phone_cell)s"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_home)s</TD>
    <TD class="td_listing1"><INPUT class="textfield3" type="text" name="phone_home" value="%(phone_home)s"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_fax)s</TD>
    <TD class="td_listing0"><INPUT class="textfield3" type="text" name="phone_fax" value="%(phone_fax)s"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_email)s</TD>
    <TD class="td_listing1"><INPUT class="textfield3" type="text" name="e_mail" value="%(e_mail)s"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_orgname)s</TD>
    <TD class="td_listing0" colspan=2><INPUT size=35 type="text"  class="textfield1" name="parent_name" value="%(my_parent_name)s" disabled>&nbsp;&nbsp;<A target="popup_window" href="%(BASE_ADMIN_URL)susers.py/orgtree" onClick="open_window('about:blank');"><IMG src="%(BASE_ICON_URL)sfld.gif" alt="" border="0"></A></TD>
  </TR>
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
    <TD class="td_listing0" colspan="2"><INPUT type="submit" class="input2" name="_save" value="%(tls_save)s"></TD>
  </TR>
</TABLE>
</FORM>"""%ns)
    else:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def user_edit(REQUEST):
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
        if REQUEST.USER.get_id() <> top_parent.get('superuser_id'):
            raise RuntimeError, REQUEST.TLS('admin_notsuper')

    output = []

    if REQUEST.form.has_key('person_id') and REQUEST.form['person_id'].value:
        per = _Person.Person(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['person_id'].value))
        per.load_req()

        if not REQUEST.form.has_key('first_name') or not REQUEST.form['first_name'].value.decode('UTF8'):
            raise RuntimeError, REQUEST.TLS('admin_users_nofirst')
        if not REQUEST.form.has_key('last_name') or not REQUEST.form['last_name'].value.decode('UTF8'):
            raise RuntimeError, REQUEST.TLS('admin_users_nolast')
        if not REQUEST.form.has_key('username') or not REQUEST.form['username'].value.decode('UTF8'):
            raise RuntimeError, REQUEST.TLS('admin_users_nouser')

        for key in ['first_name', 'middle_name', 'last_name']:
            if REQUEST.form[key].value.decode('UTF8').find('<') <> -1 or \
               REQUEST.form[key].value.decode('UTF8').find('>') <> -1 or \
               REQUEST.form[key].value.decode('UTF8').find('"') <> -1:
                raise RuntimeError, REQUEST.TLS('name_invchars')

        if REQUEST.form.has_key('password1') and REQUEST.form.has_key('password2') and REQUEST.form['password1'].value: # Can't decode to unicode here since crypt dies on unicode :(
            if REQUEST.form['password1'].value <> REQUEST.form['password2'].value:
                raise RuntimeError, REQUEST.TLS('admin_users_nomatch')
            per.set('password', _Utils.crypt(REQUEST.form['password1'].value, _Utils.get_salt()))

        if per.get_id() == _Conf.SUPERUSER and per.get('username') <> _Conf.SUPERUSER_NAME:
            raise RuntimeError, REQUEST.TLS('tls_supernamechange')

        if per.__olddata__['username'] <> per.__itemdata__['username']:
            SQL = u"""SELECT p.person_id FROM persons p, items i WHERE p.username=%s AND p.is_deleted=0""" % _Utils.sql_quote(per.get('username'))
            REQUEST.db.execute(SQL.encode('UTF8'))
            if REQUEST.db.dictfetchone():
                raise RuntimeError, REQUEST.TLS('admin_users_usertaken')
        if REQUEST.form.has_key('my_parent_id') and int(REQUEST.form['my_parent_id'].value) <> per.get('parent_id'):
            per.move_to_org(int(REQUEST.form['my_parent_id'].value))
        per.save()
        ns = {'BASE_ADMIN_URL':_Conf.BASE_ADMIN_URL, 'person_id': per.get_id()}
        output.append(standard_html.html_header(REQUEST))
        ref_url = REQUEST.SERVER_URL+_Conf.BASE_ADMIN_URL+"users.py/user_info?person_id="+str(per.get_id())
        output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
        output.append(get_admin_menu(REQUEST, MY_MENU_ID))
        output.append(REQUEST.TLS('admin_usersaved'))
    else:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def user_delete(REQUEST):
    if REQUEST.USER.get_id() <> _Conf.SUPERUSER:
        top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
        if REQUEST.USER.get_id() <> top_parent.get('superuser_id'):
            raise RuntimeError, REQUEST.TLS('admin_notsuper')

    output = []

    if REQUEST.form.has_key('person_id') and REQUEST.form['person_id'].value:
        if int(REQUEST.form['person_id'].value) <= 3:
            raise RuntimeError, REQUEST.TLS('rootobj_nodeleteaccess')

        per = _Person.Person(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['person_id'].value))
        if per.get_id() == REQUEST.USER.get_id() or per.get_id() == _Conf.SUPERUSER or not per.canDelete():
            raise _Exceptions.AccessError, self.REQUEST.TLS('rootobj_nodeleteaccess')
        REQUEST.db.execute("""UPDATE persons SET is_deleted=1 WHERE person_id=%d""" % per.get_id())

        ns = {'BASE_ADMIN_URL':_Conf.BASE_ADMIN_URL, 'person_id': per.get_id()}
        output.append(standard_html.html_header(REQUEST))
        ref_url = REQUEST.SERVER_URL+_Conf.BASE_ADMIN_URL+"users.py/user_list"
        output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
        output.append(get_admin_menu(REQUEST, MY_MENU_ID))
        output.append(REQUEST.TLS('admin_userdeleted'))
    else:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def orgtree(REQUEST):
    output = []
    output.append(standard_html.html_header_popup(REQUEST))
    a = SQLTree.SQLTree(REQUEST, "orgtreeadm")
    a.set_param('item_types', [_InitTypes.ITEM_TYPE_ORGANIZATION])
    a.set_param('tree_url', _Conf.BASE_ADMIN_URL + 'users.py/orgtree')
    a.set_param('target_url', _Conf.BASE_ADMIN_URL + 'users.py')
#    a.set_param('target', 'framecontents')

    a.set_param('js', """<A href="javascript:void(0);" onClick="window.opener.document.forms.editform.my_parent_id.value=%(item_id)d; window.opener.document.forms.editform.parent_name.value='%(item_name)s'; window.close();\">""")

    a.maketree()
    output.append(a.getTree())
    output.append(standard_html.html_footer2(REQUEST))
    return "\n".join(output)

