# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################
from mod_python import apache
import time, calendar

import mx.DateTime
import _Conf, _Exceptions, _Utils, _RootObject, _Access, _InitTypes, _Resource, _Event, relations
from Menus import get_calendar_menu
import standard_html
import _calendar
import urllib
import random


MY_MENU_ID = 0

class Colour(object):
    colours =  ["#C4AFE8","#C4AFE8","#C4AFE8"] # my events
    colours2 = ["#3F97E1","#3F97E1","#3F97E1"] # related
    colours3 = ["#70BF55","#70BF55","#70BF55"] # other
    colours4 = ["#EB6969","#EB6969","#EB6969"] # resources
    colours5 = ["#E2DA8D","#E2DA8D","#E2DA8D"] # groups
    num_colours = 3
    colour_index = 0
    colour_index2 = 0
    colour_index3 = 0
    colour_index4 = 0
    colour_index5 = 0
    def __init__(self, REQUEST):
        try:
            self.show_resources = REQUEST.get_setting('cal_show_resources')
        except:
            self.show_resources = None
        try:
            self.show_groups = REQUEST.get_setting('cal_show_groups')
        except:
            self.show_groups = None

    def get_colour(self, REQUEST, event):
        if event.has_key('related_groups') and event['related_groups'] <> '{}':
            return self.get_colour5()
        if self.show_resources and event.has_key('event_id'):
            sel_resources = _Resource.get_event_resource_ids(REQUEST, event['event_id'])
            for i in sel_resources:
                if i in self.show_resources:
                    return self.get_colour4()

        event_related = _Utils.sql_parse_array(REQUEST, event.get('related_persons'))
        if REQUEST.USER.get_id() != event.get('creator_id'):
            if REQUEST.USER.get_id() not in event_related:
                return self.get_colour3()
            else:
                return self.get_colour2()
        if self.colour_index >= self.num_colours:
            self.colour_index = 0
        colour = self.colours[self.colour_index]
        self.colour_index += 1
        return colour
    def get_colour2(self):
        if self.colour_index2 >= self.num_colours:
            self.colour_index2 = 0
        colour = self.colours2[self.colour_index2]
        self.colour_index2 += 1
        return colour
    def get_colour3(self):
        if self.colour_index3 >= self.num_colours:
            self.colour_index3 = 0
        colour = self.colours3[self.colour_index3]
        self.colour_index3 += 1
        return colour
    def get_colour4(self):
        if self.colour_index4 >= self.num_colours:
            self.colour_index4 = 0
        colour = self.colours4[self.colour_index4]
        self.colour_index4 += 1
        return colour
    def get_colour5(self):
        if self.colour_index5 >= self.num_colours:
            self.colour_index5 = 0
        colour = self.colours5[self.colour_index5]
        self.colour_index5 += 1
        return colour

def index(REQUEST):
    colour = Colour(REQUEST)
    output = []
    corners = {'#C4AFE8':'1','#3F97E1':'2','#70BF55':'3','#EB6969':'4','#E2DA8D':'5'}
    fontcols = {'#C4AFE8':'#5D3DC0','#3F97E1':'#CBFFFF','#70BF55':'#F0FFF0','#EB6969':'#FFE0E3','#E2DA8D':'#FFFFFF'}
    BASE_CALENDAR_URL = _Conf.BASE_CALENDAR_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    if REQUEST.form.has_key('show_users_list'):
        return users_list(REQUEST)
    formstring = REQUEST.get_formstring(['qs', 'show_users'])
    returl = urllib.quote("%sday.py%s" % (BASE_CALENDAR_URL, formstring))

    if REQUEST.form.has_key('show_users'):
        REQUEST.del_setting('cal_show_users')
        REQUEST.del_setting('cal_show_resources')
        REQUEST.del_setting('cal_show_groups')

    try:
        show_users = REQUEST.get_setting('cal_show_users')
    except:
        show_users = None
    try:
        show_resources = REQUEST.get_setting('cal_show_resources')
    except:
        show_resources = None
    try:
        show_groups = REQUEST.get_setting('cal_show_groups')
    except:
        show_groups = None

    if show_groups:
        dic = {}
        REQUEST.db.execute("""SELECT members from calendar_groups where group_id in (%s)""" % ",".join(map(str, show_groups)))
        group_members = map(lambda x:_Utils.sql_parse_array(REQUEST, x[0]), REQUEST.db.fetchall())
        for gr in group_members:
            for member in gr:
                dic[member]=1
        group_members = dic.keys()
        if show_users:
            show_users+=group_members
        else:
            show_users=group_members
    extra_headers = u"""
<SCRIPT LANGUAGE = JAVASCRIPT>
if (document.images) 
{
   img2 = new Image();
   img3 = new Image();
   img4 = new Image();
   img5 = new Image();
   img6 = new Image();
   img7 = new Image();
   img8 = new Image();
   img9 = new Image();
   img10 = new Image();
   img11 = new Image();
   img12 = new Image();
   img13 = new Image();
   img14 = new Image();
   img15 = new Image();
   img16 = new Image();
   img17 = new Image();
   img18 = new Image();
   img19 = new Image();
   img20 = new Image();
   img21 = new Image();
   img22 = new Image();
   img23 = new Image();
   img24 = new Image();
   img25 = new Image();
   img26 = new Image();
   img27 = new Image();
   img28 = new Image();
   img29 = new Image();
   img30 = new Image();
   img31 = new Image();
   img32 = new Image();
   img33 = new Image();
   img34 = new Image();
   img35 = new Image();
   img36 = new Image();
   img2.src = "%(BASE_ICON_URL)sn12.gif"
   img3.src = "%(BASE_ICON_URL)sn13.gif"
   img4.src = "%(BASE_ICON_URL)sn14.gif"
   img5.src = "%(BASE_ICON_URL)sn15.gif"
   img6.src = "%(BASE_ICON_URL)sn16.gif"
   img7.src = "%(BASE_ICON_URL)sn17.gif"
   img8.src = "%(BASE_ICON_URL)sn18.gif"
   img9.src = "%(BASE_ICON_URL)sn22.gif"
   img10.src = "%(BASE_ICON_URL)sn23.gif"
   img11.src = "%(BASE_ICON_URL)sn24.gif"
   img12.src = "%(BASE_ICON_URL)sn25.gif"
   img13.src = "%(BASE_ICON_URL)sn26.gif"
   img14.src = "%(BASE_ICON_URL)sn27.gif"
   img15.src = "%(BASE_ICON_URL)sn28.gif"
   img16.src = "%(BASE_ICON_URL)sn32.gif"
   img17.src = "%(BASE_ICON_URL)sn33.gif"
   img18.src = "%(BASE_ICON_URL)sn34.gif"
   img19.src = "%(BASE_ICON_URL)sn35.gif"
   img20.src = "%(BASE_ICON_URL)sn36.gif"
   img21.src = "%(BASE_ICON_URL)sn37.gif"
   img22.src = "%(BASE_ICON_URL)sn38.gif"
   img23.src = "%(BASE_ICON_URL)sn42.gif"
   img24.src = "%(BASE_ICON_URL)sn43.gif"
   img25.src = "%(BASE_ICON_URL)sn44.gif"
   img26.src = "%(BASE_ICON_URL)sn45.gif"
   img27.src = "%(BASE_ICON_URL)sn46.gif"
   img28.src = "%(BASE_ICON_URL)sn47.gif"
   img29.src = "%(BASE_ICON_URL)sn48.gif"
   img30.src = "%(BASE_ICON_URL)sn52.gif"
   img31.src = "%(BASE_ICON_URL)sn53.gif"
   img32.src = "%(BASE_ICON_URL)sn54.gif"
   img33.src = "%(BASE_ICON_URL)sn55.gif"
   img34.src = "%(BASE_ICON_URL)sn56.gif"
   img35.src = "%(BASE_ICON_URL)sn57.gif"
   img36.src = "%(BASE_ICON_URL)sn58.gif"
}
</SCRIPT>""" % locals()
    output.append(standard_html.html_header(REQUEST, extra_headers))
    output.append(get_calendar_menu(REQUEST))
    output.append(standard_html.window_script(height=670,width=550))
    output.append(u"""
<DIV id="overDiv" style="position:absolute; visibility:hidden; z-index:1000;"></DIV>
<SCRIPT type="text/javascript" src="%soverlib.js"><!-- overLIB (c) Erik Bosrup --></SCRIPT>
<TABLE width="99%%" cellpadding="0" cellspacing="0" border="0">
  <TR>
    <TD><img src="%sspacer.gif" width=25 height=1 border=0 alt=""></TD>""" % (_Conf.BASE_WEB_URL, _Conf.BASE_ICON_URL))

    if REQUEST.form.has_key('date'):
        try:
            year, month, day = map(int, REQUEST.form['date'].value.decode('UTF8').split('-'))
        except:
            raise RuntimeError, REQUEST.TLS('tls_invdateformat')
        data = _calendar.DayHandler(REQUEST, year, month, day, show_users, show_resources)
    else:
        data = _calendar.DayHandler(REQUEST, show_users=show_users, show_resources=show_resources)

    data.load(REQUEST)

    ###
    # Main contents
    ###
    output.append(u"""<TD style="width: 100%; vertical-align: top; border: none">""")
    ns = {}
    due_date="""%04d-%02d-%02d""" % (data.year, data.month, data.day)
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_TODO])
    if right_param:
        right_param = " AND " + right_param
    if REQUEST.db.version < 740:
        QUERY = u"""SELECT t.*, i.parent_id, i.creator_id, p.item_name AS creator_name FROM todos t, items i, items p WHERE t.todo_id=i.item_id AND p.item_id=i.creator_id AND (i.creator_id=%d OR t.related_persons @ '{%d}'::int[])%s AND due_time = '%s' and percent_complete<100 ORDER BY title Limit 3""" % (REQUEST.USER.get_id(), REQUEST.USER.get_id(), right_param, due_date)
    else:
        QUERY = u"""SELECT t.*, i.parent_id, i.creator_id, p.item_name AS creator_name FROM todos t, items i, items p WHERE t.todo_id=i.item_id AND p.item_id=i.creator_id AND (i.creator_id=%d OR %d=ANY(t.related_persons))%s AND due_time = '%s' and percent_complete<100 ORDER BY title Limit 3""" % (REQUEST.USER.get_id(), REQUEST.USER.get_id(), right_param, due_date)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()
    todo_height = 85
    todo_width = 100
    index = 0
    create_todo = 0
    for todo in dbresult:
        create_todo = 1
        description = u"""<B>%s:</B> %s<BR><B>%s:</B> %s%%""" % (REQUEST.TLS('tls_description'), _Utils.newline2br(todo['description'].decode('UTF8').replace("'", "\\'").replace('"','&quot;').replace('<', '').replace('>', '')), REQUEST.TLS('todo_percentcomplete'), todo['percent_complete'])
        if(todo['percent_complete'] == 0):
            todo['complete_str'] = """<IMG src="%slgreen.gif" width="50" height="4" border=0 alt="">""" % (_Conf.BASE_ICON_URL)
        elif(todo['percent_complete'] == 100):
            todo['complete_str'] = """<IMG src="%sdgreen.gif" width="50" height="4" border=0 alt="">""" % (_Conf.BASE_ICON_URL)
        else:
            todo['first_percent']=(int) (todo['percent_complete']/2)
            todo['second_percent']=50 - todo['first_percent']
            todo['tls_complete'] = REQUEST.TLS('todo_complete')
            todo['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
            todo['complete_str'] = ("""<IMG src="%(BASE_ICON_URL)sdgreen.gif" width="%(first_percent)d" height="4" border=0 alt="%(percent_complete)d%% %(tls_complete)s"><IMG src="%(BASE_ICON_URL)slgreen.gif" width="%(second_percent)d" height="4" border=0 alt="">""" % todo)

        todo_div = {}
        todo_div['BASE_URL']= _Conf.BASE_URL
        todo_div['BASE_ICON_URL']=_Conf.BASE_ICON_URL
        todo_div['todo_overdivstr']= "<B>%s:</B> %s <BR>%s" % (REQUEST.TLS('tls_title'), todo['title'].decode('UTF8').replace("'", "\\'").replace('"','&quot;').replace('<', '').replace('>', ''), description)
        todo_div['todo_id'] = todo['todo_id']
        todo_div['todo_height']=todo_height
        todo_div['todo_width']=todo_width
        todo_div['todo_color']=colour.get_colour(REQUEST, todo)
        todo_div['todo_title']=_Utils.html_quote(todo['title'].decode('UTF8'))
        todo_div['complete_str']=todo['complete_str']
        todo_div['returl'] = returl
        todo_div['todo_title'] = _Utils.shorten_string(todo_div['todo_title'], 16)
        
        output.append(u"""<DIV onclick="document.location='%(BASE_URL)stodo/todoedit.py?todo_id=%(todo_id)s&returl=%(returl)s'" onmouseover="return overlib('%(todo_overdivstr)s', TEXTSIZE, '11px');" onmouseout="return nd();" style="cursor: pointer; cursor: hand; position: absolute; top: %(todo_height)dpx; left: %(todo_width)dpx; height: 10px; width: 140px; z-index='3';">
<TABLE border=0 width="100%%" cellpadding=0 cellspacing=0 style="background-image: url('%(BASE_ICON_URL)sn22.gif');">
<TR valign="top">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="7" height="7" border="0" alt=""></TD>
  <TD width="100%%" align="center" style="color: #FFFFFF; font-weight: bold; padding: 2px;">%(todo_title)s</TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="7" height="7" border="0" alt=""></TD>
</TR>
</TABLE>
<TABLE border=0 width="100%%" height="100%%" cellpadding=0 cellspacing=0>
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn28.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD height="100%%" align="left" bgcolor="#3F97E1" style="color: #CBFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn26.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>
<TR valign="top">
  <TD><img src="%(BASE_ICON_URL)sn23.gif" width="7" height="7" border="0" alt=""></TD>
  <TD width="100%%" style="background-image: url('%(BASE_ICON_URL)sn27.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sn24.gif" width="7" height="7" border="0" alt=""></TD>
</TR>
</TABLE>
</DIV>""" % (todo_div))
        todo_width = todo_width + 150

    day = data.active_week[0]
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_dayname = REQUEST.TLS(_Conf.WEEK_DAYS[calendar.weekday(day.year, day.month, day.day)])
    month_name = "%d %s %d" % (day.day, REQUEST.TLS('month_%d' % day.month), day.year)
    prev = mx.DateTime.DateTime(day.year, day.month, day.day)-1
    next = mx.DateTime.DateTime(day.year, day.month, day.day)+1
    prevdate = '%04d-%02d-%02d' % (prev.year, prev.month, prev.day)
    nextdate = '%04d-%02d-%02d' % (next.year, next.month, next.day)
    tls_prev = REQUEST.TLS('cal_prevday')
    tls_next = REQUEST.TLS('cal_nextday')
    tls_resources = REQUEST.TLS('tls_resources')

    REQUEST.db.execute("""SELECT r.resource_id, r.resource_name FROM items i, resources r WHERE r.resource_id=i.item_id""".encode('UTF8'))
    resos = REQUEST.db.dictfetchall()
    resources = {}
    for row in resos:
        resources[row['resource_id']]=row['resource_name']
    output.append(u"""
<TABLE border=0 cellpadding=0 cellspacing=0 style="width: 100%%">
<TR>
  <TD class="dayname" colspan=2>
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
<TR style="height: 40px">
  <TD width="50%%" align="right"><A href="%(BASE_CALENDAR_URL)sday.py?date=%(prevdate)s"><IMG title="%(tls_prev)s" src="%(BASE_ICON_URL)sarr1.gif" width="11" height="16" border="0" alt=""></A></TD>
  <TD nowrap align="center" style="font-weight: bold; font-size: 16px;">&nbsp;&nbsp;%(tls_dayname)s, %(month_name)s&nbsp;&nbsp;</TD>
  <TD width="50%%" align="left"><A href="%(BASE_CALENDAR_URL)sday.py?date=%(nextdate)s"><IMG title="%(tls_next)s" src="%(BASE_ICON_URL)sarr2.gif" width="11" height="16" border="0" alt=""></A></TD>
</TR>
</TABLE>"""% locals())
    output.append(u"""</TR><TR><TD colspan=2 bgcolor="#AAAAAA" width="100%%"><img src="%sspacer.gif" width=1 height=1 border=0 alt=""></TD></TR>""" % _Conf.BASE_ICON_URL)

    if(create_todo):
        base_height = 118
        base_width = 110
    else:
        base_height = 82
        base_width = 80

    if(create_todo):
        output.append(u"""\
<TR>
  <TD bgcolor="#FFFFFF" style="padding-left: 3px; padding-right: 3px">%s:</TD>
  <TD width="100%%" bgcolor="#FFFFFF">&nbsp;</TD>
  <TD bgcolor="#FFFFFF"><img src="%sspacer.gif" width="1" height="36"></TD>
</TR>""" % (REQUEST.TLS('todo_mytasks'), _Conf.BASE_ICON_URL))


    for i in range(len(data.active_week[0].events)):
        output.append(u"""<TR>""")
        if index % 2 == 0:
            tmp = _Utils.local2utc_mx(REQUEST, mx.DateTime.Date(2001,1,1, data.active_week[0].events[i][0], data.active_week[0].events[i][1])) # Dummy date
            tmp = REQUEST.iso2userdatetime(REQUEST, tmp).split(' ')[-1]
            output.append(u"""  <TD class="calendar_hours0" nowrap style="padding-left: 3px; padding-right: 3px; text-align: center; background: #EBEBEB; cursor: pointer; cursor: hand;"  onclick="window.location='%saddevent.py?year=%d&month=%d&day=%d&hour=%d&returl=%s';" onmouseover="this.style.border='1px solid black';" onmouseout="this.style.border='1px solid #EBEBEB';">%s</TD>""" % (_Conf.BASE_CALENDAR_URL, data.year, data.month, data.day, data.active_week[0].events[i][0], returl, tmp))
        else:
            tmp = _Utils.local2utc_mx(REQUEST, mx.DateTime.Date(2001,1,1, data.active_week[0].events[i][0], data.active_week[0].events[i][1])) # Dummy date
            tmp = REQUEST.iso2userdatetime(REQUEST, tmp).split(' ')[-1]
            output.append(u"""  <TD class="calendar_hours1" nowrap style="padding-left: 3px; padding-right: 3px; text-align: center; cursor: pointer; cursor: hand;"  onclick="window.location='%saddevent.py?year=%d&month=%d&day=%d&hour=%d&returl=%s';" onmouseover="this.style.border='1px solid black';" onmouseout="this.style.border='1px solid #FFFFFF';">%s</TD>""" % (_Conf.BASE_CALENDAR_URL, data.year, data.month, data.day, data.active_week[0].events[i][0], returl, tmp))
        for day in data.active_week:
            if index % 2 == 0:
                output.append(u"""  <TD width="100%" class="calendar_hours0" bgcolor="#EBEBEB">&nbsp;""")
            else:
                output.append(u"""  <TD width="100%" class="calendar_hours1" bgcolor="#FFFFFF">&nbsp;""")
            if day.events[i][2]:
                for event in day.events[i][2]:
                    duration = event['end_stamp'] - event['start_stamp']
                    starts = event['real_start_stamp']
                    duration = duration.minutes
                    if starts.hour < 7:
                        duration = duration - (7-starts.hour)*60+starts.minute
                    event_top = (base_height+(i*32) - 1)
                    minutes_px=event['start_stamp'].minute
                    if starts.hour < 7:
                        extra_px=0
                    else:
                        extra_px=minutes_px*32/60
                    event_top = event_top + extra_px
                    if event_top > 570:
                        event_top = 570
                    event_height = (duration/1.875 - 2)
                    event_name_rows=len(event['event_name'])/19 + 1
                    min_event_height=event_name_rows*16
                    if (min_event_height>event_height):
                       event_height = min_event_height
                    if event_height > 580:
                        event_height = 580
                    if (event_height + event_top) > 615:
                        event_height = 615 - event_top

                    if event['real_start_stamp'] and event['real_end_stamp']:
                        if event['real_start_stamp'].year <> event['real_end_stamp'].year or \
                           event['real_start_stamp'].month <> event['real_end_stamp'].month or \
                           event['real_start_stamp'].day <> event['real_end_stamp'].day:
                            timestr = u"<B>%s:</B> %s <B>%s:</B> %s" % (REQUEST.TLS('cal_start'), REQUEST.iso2userdatetime(REQUEST, event['real_start_stamp'], is_utc=0), REQUEST.TLS('cal_end'), REQUEST.iso2userdatetime(REQUEST, event['real_end_stamp'], is_utc=0))
                        else:
                            timestr = u"<B>%s:</B> %s <B>%s:</B> %s" % (REQUEST.TLS('cal_start'), REQUEST.iso2usertime(REQUEST, event['real_start_stamp'], is_utc=0), REQUEST.TLS('cal_end'), REQUEST.iso2usertime(REQUEST, event['real_end_stamp'], is_utc=0))
                    elif event['real_start_stamp']:
                        if event['real_start_stamp'].year <> event['start_stamp'].year or \
                           event['real_start_stamp'].month <> event['start_stamp'].month or \
                           event['real_start_stamp'].day <> event['start_stamp'].day:
                            timestr = u"<B>%s:</B> %s" % (REQUEST.TLS('cal_start'), REQUEST.USER.iso2userdatetime(REQUEST, event['start_stamp'], is_utc=0))
                        else:
                            timestr = u"<B>%s:</B> %s" % (REQUEST.TLS('cal_start'), REQUEST.USER.iso2usertime(REQUEST, event['start_stamp'], is_utc=0))
                    else:
                        timestr = ""
                    reminder = event.get('remind_type')
                    d_name = event['event_name'].decode('UTF8').replace("'", "\\'").replace('"','&quot;').replace("<", "").replace(">", "")
                    d_name=_Utils.split_text(d_name, 15)
                    if event['description'] is None or not event['description']: description = ""
                    else:
                        description = u"""<B>%s:</B> %s""" % (REQUEST.TLS('tls_description'), _Utils.newline2br(event['description'].decode('UTF8').replace("'", "\\'").replace('"','&quot;').replace("<", "").replace(">", "")))
                    if event['creator_id'] <> REQUEST.USER.get_id():
                        description += u'<br><B>%s:</B> %s' % (REQUEST.TLS('tls_creator'), event['creator_name'].decode('UTF8'))
                    tls_title = REQUEST.TLS('tls_title')
                    tls_desc = REQUEST.TLS('tls_description')
                    
                    persons_out = []
                    event_related = _Utils.sql_parse_array(REQUEST, event.get('related_persons'))
                    event_relgroups = _Utils.sql_parse_array(REQUEST, event.get('related_groups'))
                    REQUEST.su_by_id(_Conf.SUPERUSER)
                    for person_id in event_related:
                        try:
                            rel_per = _RootObject.dispatch_item(REQUEST, person_id)
                            persons_out.append(rel_per.get_name())
                        except _Exceptions.RootObjectError:
                            pass
                    REQUEST.unsu()
                    related_persons = ", ".join(persons_out)
                    del persons_out
                    persons_out = u""
                    if related_persons:
                        tls_invpersons = REQUEST.TLS('cal_invitedpersons')
                        persons_out = u"""<BR><B>%(tls_invpersons)s:</b> %(related_persons)s""" % locals()



                    REQUEST.db.execute("""SELECT group_id, group_name from calendar_groups where parent_id=%d""" % (event.get('creator_id')))
                    related_groups = REQUEST.db.dictfetchall()
                    relcount = len(related_groups)
                    group_tmp = []
                    for group_id in related_groups:
                        if group_id['group_id'] in event_relgroups:
                            group_tmp.append("""%s""" % group_id['group_name'].decode('UTF8'))
                    related_groups = ", ".join(group_tmp)
                    groups_out = u""
                    if related_groups:
                        tls_invgroups = REQUEST.TLS('cal_invitedgroups')
                        groups_out = u"""<BR><B>%(tls_invgroups)s:</b> %(related_groups)s""" % locals()

                    event_obj = _Event.Event(REQUEST, _InitTypes.INIT_TYPE_ID, event['event_id'])
                    relation_ids = relations.get_relations(REQUEST, event_obj)
                    contact_out = ""
                    for rel in relation_ids:
                        if rel['left_type_id']==_InitTypes.ITEM_TYPE_CONTACT or rel['right_type_id']==_InitTypes.ITEM_TYPE_CONTACT:
                            if int(rel['left_item_id'])==event['event_id']:
                                contact_out = contact_out + rel['right_item_name'].decode('UTF8') + ", "
                            else:
                                contact_out = contact_out + rel['left_item_name'].decode('UTF8') + ", "
                    if contact_out:
                        contact_out = contact_out[0:-2]
                    tls_invcontacts = REQUEST.TLS('cal_invitedcontacts')
                    if contact_out:
                        contact_out = u"""<BR><B>%(tls_invcontacts)s:</b> %(contact_out)s""" % locals()

                    sel_resources = _Resource.get_event_resources(REQUEST, event['event_id'])
                    sel_resources_ids = map(lambda x: x.get_id(), sel_resources)
                    sel_resources = ""
                    for id in sel_resources_ids:
                        sel_resources += resources[id] + ", "
                    if sel_resources:
                        sel_resources = sel_resources[0:-2].decode('UTF8').replace("'", "\\'").replace('"','&quot;').replace("<", "").replace(">", "")
                        res_out = u"""<BR><B>%(tls_resources)s:</b> %(sel_resources)s""" % locals()
                    else:
                        res_out = ""

                    overdivstr = u"""\
<B>%(tls_title)s:</B> %(d_name)s<BR>\
%(timestr)s<BR>\
%(description)s\
%(persons_out)s\
%(groups_out)s\
%(contact_out)s\
%(res_out)s""" % locals()
                    if reminder:
                        event_contents = u"""<img src="%(BASE_ICON_URL)sbell.gif" width="14" height="13" border="0" alt="">&nbsp;""" % locals() + d_name
                    else:
                        event_contents = d_name
                    bgcolor = colour.get_colour(REQUEST, event)
                    event_id = event['event_id']
                    corner = corners[bgcolor]
                    t_start = REQUEST.iso2usertime(REQUEST, event['start_stamp'], is_utc=0)
                    t_end = REQUEST.iso2usertime(REQUEST, event['end_stamp'], is_utc=0)
                    f_col = fontcols[bgcolor]
                    output.append(u"""
<DIV onclick="window.location='%(BASE_CALENDAR_URL)seditevent.py?event_id=%(event_id)d&returl=%(returl)s'; return true;" onmouseover="this.style.zIndex='2'; return overlib('%(overdivstr)s', TEXTSIZE, '11px');" onmouseout="this.style.zIndex='1'; return nd();" style="cursor: pointer; cursor: hand; position: absolute; top: %(event_top)dpx; left: %(base_width)dpx; height: %(event_height)dpx; width: 140px; z-index='3';">
<TABLE border=0 width="100%%" cellpadding=0 cellspacing=0 style="background-image: url('%(BASE_ICON_URL)sn%(corner)s2.gif');">
<TR valign="top">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="7" height="7" border="0" alt=""></TD>
  <TD width="100%%" align="center" style="color: #FFFFFF; font-weight: bold;">%(t_start)s - %(t_end)s</TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="7" height="7" border="0" alt=""></TD>
</TR>
</TABLE>
<TABLE border=0 width="100%%" height="100%%" cellpadding=0 cellspacing=0>
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn%(corner)s8.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD align="left" bgcolor="%(bgcolor)s" style="color: %(f_col)s"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="2" border="0" alt=""></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn%(corner)s6.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn%(corner)s8.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD height="100%%" align="left" bgcolor="%(bgcolor)s" style="color: %(f_col)s">%(event_contents)s</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn%(corner)s6.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>
<TR valign="top">
  <TD><img src="%(BASE_ICON_URL)sn%(corner)s3.gif" width="7" height="7" border="0" alt=""></TD>
  <TD width="100%%" style="background-image: url('%(BASE_ICON_URL)sn%(corner)s7.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sn%(corner)s4.gif" width="7" height="7" border="0" alt=""></TD>
</TR>
</TABLE>
</DIV>""" % locals())
                    base_width += 40
            output.append(u"""</TD>""")
            output.append(u"""<TD><img src="%sspacer.gif" width="1" height="32" alt=""></TD></TR>""" % _Conf.BASE_ICON_URL)
        index += 1

    output.append(u"</TABLE></TD>")
    ###
    # Right menu stuff
    ###
    today = _Utils.utc2local_mx(REQUEST, _Utils.utc_now_mx())
    next_year = '%04d-%02d-01' % (data.year + 1, data.month)
    previous_year = '%04d-%02d-01' % (data.year - 1, data.month)
    if data.month == 1: previous_month = '%04d-%02d-01' % (data.year - 1, 12)
    else: previous_month = '%04d-%02d-01' % (data.year, data.month-1)
    if data.month == 12: next_month = '%04d-%02d-01' % (data.year + 1, 1)
    else: next_month = '%04d-%02d-01' % (data.year, data.month+1)
    month_name = "%s %d" % (REQUEST.TLS('month_%d' % data.month), data.year)
    BASE_CALENDAR_URL = _Conf.BASE_CALENDAR_URL

    tls_nextmonth = REQUEST.TLS('cal_nextmonth')
    tls_nextyear = REQUEST.TLS('cal_nextyear')
    tls_lastyear = REQUEST.TLS('cal_lastyear')
    tls_lastmonth = REQUEST.TLS('cal_lastmonth')
    tls_1 = REQUEST.TLS('cal_short_1')
    tls_2 = REQUEST.TLS('cal_short_2')
    tls_3 = REQUEST.TLS('cal_short_3')
    tls_4 = REQUEST.TLS('cal_short_4')
    tls_5 = REQUEST.TLS('cal_short_5')
    tls_6 = REQUEST.TLS('cal_short_6')
    tls_7 = REQUEST.TLS('cal_short_7')
    BASE_ICON_URL = _Conf.BASE_ICON_URL

    output.append(u"""
<TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
<TD style="width: 16%%; vertical-align: top; text-align: center; border: none">
<CENTER>
<TABLE cellpadding=3 width="100%%" cellspacing=0 border=0 bgcolor="#FFFFFF" style="border: solid 1px #AAAAAA">
<TR bgcolor="#609700">
  <TD><A href="%(BASE_CALENDAR_URL)sday.py?date=%(previous_year)s" class="minical_hdr" title="%(tls_lastyear)s">-</A></TD>
  <TD nowrap colspan="5" class="minical_hdr" align="center"><A href="%(BASE_CALENDAR_URL)sday.py?date=%(previous_month)s" class="minical_hdr" title="%(tls_lastmonth)s">&laquo;</A> %(month_name)s <A href="%(BASE_CALENDAR_URL)sday.py?date=%(next_month)s"  class="minical_hdr" title="%(tls_nextmonth)s">&raquo;</A></TD>
  <TD><A href="%(BASE_CALENDAR_URL)sday.py?date=%(next_year)s" class="minical_hdr" title="%(tls_nextyear)s">+</A></TD>
</TR>
<TR bgcolor="#7BC300">
  <TD class="minical_day_hdr">%(tls_1)s</TD>
  <TD class="minical_day_hdr">%(tls_2)s</TD>
  <TD class="minical_day_hdr">%(tls_3)s</TD>
  <TD class="minical_day_hdr">%(tls_4)s</TD>
  <TD class="minical_day_hdr">%(tls_5)s</TD>
  <TD class="minical_hday_hdr">%(tls_6)s</TD>
  <TD class="minical_hday_hdr">%(tls_7)s</TD>
</TR>""" % locals())

    for week in data.calendar:
        output.append(u"""<TR bgcolor="#FFFFFF">""")
        for i in range(7):
            day = week[i]
            if day == data.day:
                ms = ' background-color: #7BC300;'
            else:
                ms = ''
            if data.year == today.year and data.month == today.month and day == today.day:
                bs = ' background-color: #B2F63D;'
            else:
                bs = ''
            if day == 0:
                output.append(u"""<TD>&nbsp;</TD>""" )
            elif i == 5 or i == 6:
                output.append(u"""<TD class="minical_day" style="%s%s"><A style=" color: red;" href="%sday.py?date=%04d-%02d-%02d">%d</A></TD>""" % (ms, bs, _Conf.BASE_CALENDAR_URL, data.year, data.month, day, day))
            else:
                output.append(u"""<TD class="minical_day" style="%s%s"><A style=" color: black;" href="%sday.py?date=%04d-%02d-%02d">%d</A></TD>""" % (ms, bs, _Conf.BASE_CALENDAR_URL, data.year, data.month, day, day))
        output.append(u"""</TR>""")
    output.append(u"""</TABLE></CENTER>""")

    output.append(u"""\
<TABLE border=0 align="center">
<FORM action="%sday.py" method="POST">
<INPUT type="hidden" name="date" value="%04d-%02d-%02d">
  <TR>
    <TD align=center><BR><B>%s</B>:""" % (_Conf.BASE_CALENDAR_URL, data.year, data.month, data.day, REQUEST.TLS('cal_users')))
    if show_users or show_resources:
        output.append("""\
      <IMG src="%sspacer.gif" width=1 height=4 border=0 alt=""><br>
      <IMG src="%sspacer.gif" width=1 height=4 border=0 alt=""><br>
      <INPUT TYPE="submit" class="input1" name="show_users" value="%s"><BR>
      <IMG src="%sspacer.gif" width=1 height=2 border=0 alt=""><br>""" % (_Conf.BASE_ICON_URL, _Conf.BASE_ICON_URL, REQUEST.TLS('cal_onlymine'), _Conf.BASE_ICON_URL))
    else:
        output.append(u"""<br>""")  
    output.append(u"""<INPUT TYPE="submit" class="input1" name="show_users_list" value="%s">
    </TD>
  </TR>
</FORM>
</TABLE>
""" % REQUEST.TLS('cal_selusers'))

    BASE_ICON_URL=_Conf.BASE_ICON_URL
    tls_legend = REQUEST.TLS('cal_legend')
    tls_myevent = REQUEST.TLS('cal_myevent')
    tls_relatedevent = REQUEST.TLS('cal_related_event')
    tls_otherevent = REQUEST.TLS('cal_other_event')
    tls_groupevent = REQUEST.TLS('cal_group_event')
    tls_resourceevent = REQUEST.TLS('cal_resource_event')
    tls_birthdays = REQUEST.TLS('tls_birthdays')
    output.append(u"""\
&nbsp;<BR>
<TABLE border=0 cellpadding=0 cellspacing=4 width="100%%" style="border: 2px dashed #AAAAAA">
  <TR>
    <TD colspan=2><IMG src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD colspan=2><b>%(tls_legend)s:</b></TD>
  </TR>
  <TR>
    <TD colspan=2><IMG src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR>
    <TD bgcolor="#C4AFE8"><IMG src="%(BASE_ICON_URL)sspacer.gif" width=15 height=10 border=0 alt=""></TD>
    <TD width="100%%" align="left">- %(tls_myevent)s</TD>
  </TR>
  <TR>
    <TD bgcolor="#3F97E1"><IMG src="%(BASE_ICON_URL)sspacer.gif" width=15 height=10 border=0 alt=""></TD>
    <TD width="100%%" align="left">- %(tls_relatedevent)s</TD>
  </TR>
  <TR>
    <TD bgcolor="#70BF55"><IMG src="%(BASE_ICON_URL)sspacer.gif" width=15 height=10 border=0 alt=""></TD>
    <TD width="100%%" align="left">- %(tls_otherevent)s</TD>
  </TR>
  <TR>
    <TD bgcolor="#E2DA8D"><IMG src="%(BASE_ICON_URL)sspacer.gif" width=15 height=10 border=0 alt=""></TD>
    <TD width="100%%" align="left">- %(tls_groupevent)s</TD>
  </TR>
  <TR>
    <TD bgcolor="#EB6969"><IMG src="%(BASE_ICON_URL)sspacer.gif" width=15 height=10 border=0 alt=""></TD>
    <TD width="100%%" align="left">- %(tls_resourceevent)s</TD>
  </TR>
  <TR>
    <TD colspan=2><IMG src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
</TABLE>
""" % locals())
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_CONTACT])
    if right_param:
        right_param = " AND " + right_param
    SQL = """select c.first_name || ' ' || c.last_name as name, c.birth_date from contacts c, items i where c.contact_id=i.item_id and extract(month from age(birth_date))::int = 11 and extract(day from age(birth_date))::int >= 20 %s order by date_part('month', birth_date) asc, date_part('day', birth_date) asc, contact_id""" % right_param
    REQUEST.db.execute(SQL.encode('UTF8'))
    dbres = REQUEST.db.dictfetchall()
    if dbres:
        if int(str(random.random())[2])>4:
            n = 2
        else:
            n = 1
        output.append(u"""
&nbsp;<BR>
<TABLE border="0" cellpadding="0" cellspacing="0" width="100%%" class="text11" style="border: 2px dashed #2BA10B;">
  <TR>
    <TD colspan="2" align="left" class="pad2" style="line-height: 18px;"><img src="%(BASE_ICON_URL)sico_birthday%(n)s.gif" width="18" height="18" border="0" alt="" style="vertical-align: bottom">&nbsp;&nbsp;<b>%(tls_birthdays)s:</b></TD>
  </TR>""" % locals())
        for row in dbres:
            name = row['name'].decode('UTF8')
            day = row['birth_date'].day
            mon = REQUEST.TLS('month_name_%02d' % row['birth_date'].month)
            output.append(u"""
  <TR>
    <TD style="padding: 2px;" nowrap>%(day)s. %(mon)s</TD>
    <TD width="100%%" style="padding: 3px;" align="left">%(name)s</TD>
  </TR>""" % locals())
    output.append(u"""</TD></TR></TABLE>""")
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def users_list(REQUEST):
    if REQUEST.form.has_key('menu_id'):
        MY_MENU_ID = int(REQUEST.form['menu_id'].value)
    else:
        MY_MENU_ID = 0
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_calendar_menu(REQUEST,MY_MENU_ID))
    output.append(u"""\
<SCRIPT type="text/javascript">
function move_1()
{
	var the_select1 = window.document.vorm.show_users_set2;
	var the_select2 = window.document.vorm.show_users_set;
	for (loop=0; loop < the_select1.options.length; loop++)
	{
		if (the_select1.options[loop].selected == true)
		{
			 var opt = new Option(the_select1.options[loop].text, the_select1.options[loop].value)
			 the_select2.options[the_select2.options.length] = opt
			 the_select1.options[loop] = null;
			 loop--;
		}
	}
}
function move_2()
{
	var the_select1 = window.document.vorm.show_users_set;
	var the_select2 = window.document.vorm.show_users_set2;
	for (loop=0; loop < the_select1.options.length; loop++)
	{
		if (the_select1.options[loop].selected == true)
		{
			 var opt = new Option(the_select1.options[loop].text, the_select1.options[loop].value)
			 the_select2.options[the_select2.options.length] = opt
			 the_select1.options[loop] = null;
			 loop--;
		}
	}
}
function move_3()
{
	var the_select1 = window.document.vorm2.show_users_set2;
	var the_select2 = window.document.vorm2.show_users_set;
	for (loop=0; loop < the_select1.options.length; loop++)
	{
		if (the_select1.options[loop].selected == true)
		{
			 var opt = new Option(the_select1.options[loop].text, the_select1.options[loop].value)
			 the_select2.options[the_select2.options.length] = opt
			 the_select1.options[loop] = null;
			 loop--;
		}
	}
}
function move_4()
{
	var the_select1 = window.document.vorm2.show_users_set;
	var the_select2 = window.document.vorm2.show_users_set2;
	for (loop=0; loop < the_select1.options.length; loop++)
	{
		if (the_select1.options[loop].selected == true)
		{
			 var opt = new Option(the_select1.options[loop].text, the_select1.options[loop].value)
			 the_select2.options[the_select2.options.length] = opt
			 the_select1.options[loop] = null;
			 loop--;
		}
	}
}
function move_5()
{
	var the_select1 = window.document.vorm3.show_users_set2;
	var the_select2 = window.document.vorm3.show_users_set;
	for (loop=0; loop < the_select1.options.length; loop++)
	{
		if (the_select1.options[loop].selected == true)
		{
			 var opt = new Option(the_select1.options[loop].text, the_select1.options[loop].value)
			 the_select2.options[the_select2.options.length] = opt
			 the_select1.options[loop] = null;
			 loop--;
		}
	}
}
function move_6()
{
	var the_select1 = window.document.vorm3.show_users_set;
	var the_select2 = window.document.vorm3.show_users_set2;
	for (loop=0; loop < the_select1.options.length; loop++)
	{
		if (the_select1.options[loop].selected == true)
		{
			 var opt = new Option(the_select1.options[loop].text, the_select1.options[loop].value)
			 the_select2.options[the_select2.options.length] = opt
			 the_select1.options[loop] = null;
			 loop--;
		}
	}
}
function select_all()
{
	var the_select1 = window.document.vorm.show_users_set;
	for (loop=0; loop < the_select1.options.length; loop++)
	{
		the_select1.options[loop].selected = true;
	}
}
function select_all2()
{
	var the_select1 = window.document.vorm2.show_users_set;
	for (loop=0; loop < the_select1.options.length; loop++)
	{
		the_select1.options[loop].selected = true;
	}
}
function select_all3()
{
	var the_select1 = window.document.vorm3.show_users_set;
	for (loop=0; loop < the_select1.options.length; loop++)
	{
		the_select1.options[loop].selected = true;
	}
}
</SCRIPT>""")

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_PERSON])
    if right_param:
        right_param = " AND " + right_param
    QUERY = """SELECT p.person_id, i.item_name, o.organization_name FROM persons p, items i, organizations o WHERE p.person_id=i.item_id AND p.is_deleted=0 AND o.organization_id=i.parent_id%s ORDER BY p.last_name, p.first_name""" % right_param
    REQUEST.db.execute(QUERY.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_RESOURCE])
    if right_param:
        right_param = " AND " + right_param
    QUERY2 = """SELECT r.resource_id, i.item_name FROM resources r, items i WHERE r.resource_id=i.item_id%s ORDER BY r.resource_name""" % right_param
    REQUEST.db.execute(QUERY2.encode('UTF8'))
    dbresult2 = REQUEST.db.dictfetchall()

    QUERY3 = """SELECT group_id, group_name from calendar_groups WHERE parent_id=%d""" % REQUEST.USER.get_id()
    REQUEST.db.execute(QUERY3.encode('UTF8'))
    dbresult3 = REQUEST.db.dictfetchall()


    BASE_CALENDAR_URL = _Conf.BASE_CALENDAR_URL

    try:
        show_users = REQUEST.get_setting('cal_show_users')
    except:
        show_users = [REQUEST.USER.get_id()]
    try:
        show_resources = REQUEST.get_setting('cal_show_resources')
    except:
        show_resources = ""
    try:
        show_groups = REQUEST.get_setting('cal_show_groups')
    except:
        show_groups = ""
    tls_users = REQUEST.TLS('cal_users')
    tls_usertitle = REQUEST.TLS('cal_usertitle')
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_save = REQUEST.TLS('tls_save')
    tls_view = REQUEST.TLS('cal_myviewlist')
    tls_others = REQUEST.TLS('cal_allpeople')

    tls_groups = REQUEST.TLS('cal_groups')
    tls_selgroups = REQUEST.TLS('cal_selgroups')
    tls_myviewgroups = REQUEST.TLS('cal_myviewgroups')
    tls_allgroups = REQUEST.TLS('cal_allgroups')

    tls_resources = REQUEST.TLS('tls_resources')
    tls_select_res = REQUEST.TLS('cal_select_resources')
    tls_res_view = REQUEST.TLS('cal_myviewresources')
    tls_res_others = REQUEST.TLS('cal_allresources')


    userlist1=[]
    userlist2=[]
    for p in dbresult:
        if show_users and p['person_id'] in show_users:
            userlist1.append(u"""<OPTION value="%d">%s (%s)""" % (p['person_id'], p['item_name'].decode('UTF8'), p['organization_name'].decode('UTF8')))
        else:
            userlist2.append(u"""<OPTION value="%d">%s (%s)""" % (p['person_id'], p['item_name'].decode('UTF8'), p['organization_name'].decode('UTF8')))
    ulist1 = "\n".join(userlist1)
    ulist2 = "\n".join(userlist2)

    grouplist1=[]
    grouplist2=[]
    for p in dbresult3:
        if show_groups and p['group_id'] in show_groups:
            grouplist1.append(u"""<OPTION value="%d">%s""" % (p['group_id'], p['group_name'].decode('UTF8')))
        else:
            grouplist2.append(u"""<OPTION value="%d">%s""" % (p['group_id'], p['group_name'].decode('UTF8')))
    glist1 = "\n".join(grouplist1)
    glist2 = "\n".join(grouplist2)

    relist1=[]
    relist2=[]
    for p in dbresult2:
        if show_resources and p['resource_id'] in show_resources:
            relist1.append(u"""<OPTION value="%d">%s""" % (p['resource_id'], p['item_name'].decode('UTF8')))
        else:
            relist2.append(u"""<OPTION value="%d">%s""" % (p['resource_id'], p['item_name'].decode('UTF8')))
    rlist1 = "\n".join(relist1)
    rlist2 = "\n".join(relist2)

    output.append(standard_html.window_script(height=625,width=550))
    output.append(u"""
<BR>
<TABLE width="100%%" cellpadding=0 cellspacing=0 border=0>
<FORM name="vorm" action="%(BASE_CALENDAR_URL)sday.py/save_users_list" onsubmit="select_all();">
 <TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD width="100%%">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD background="%(BASE_ICON_URL)sdokunurk1.gif"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD class="th_listing" align=center nowrap>&nbsp;&nbsp;<b>%(tls_users)s</b>&nbsp;&nbsp;</TD>
        <TD background="%(BASE_ICON_URL)sdokunurk2.gif"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%">&nbsp;</TD>
      </TR>
    </TABLE>
  </TD>
 </TR>
<TR class="tr_listing1">
 <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 border=0 alt=""></TD>
 <TD class="td_listing1">%(tls_usertitle)s</TD>
</TR>
<TR>
 <TD colspan="2">
   <TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
     <TR>
       <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=20 border=0 alt=""></TD>
       <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=300 border=0 alt=""></TD>
       <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=40 border=0 alt=""></TD>
       <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=40 border=0 alt=""></TD>
       <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=300 border=0 alt=""></TD>
       <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=10 border=0 alt=""></TD>
     </TR>
     <TR class="tr_listing0">
       <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" height="20" width=20 border=0 alt=""></TD>
       <TD class="td_listing0">%(tls_view)s</TD>
       <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=40 border=0 alt=""></TD>
       <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=40 border=0 alt=""></TD>
       <TD class="td_listing0">%(tls_others)s</TD>
       <TD width="100%%" class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=10 border=0 alt=""></TD>
     </TR>
     <TR class="tr_listing1">
       <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=20 border=0 alt=""></TD>
       <TD class="td_listing1" align="center">
         <SELECT name="show_users_set" multiple size="5">
%(ulist1)s
         </SELECT>
       </TD>
       <TD class="td_listing1" align="center"><a href="#" onclick="move_1();"><img src="%(BASE_ICON_URL)sleft_arr.gif" width="17" height="17" border="0" alt=""></a></TD>
       <TD class="td_listing1" align="center"><a href="#" onclick="move_2();"><img src="%(BASE_ICON_URL)sright_arr.gif" width="17" height="17" border="0" alt=""></a></TD>
       <TD class="td_listing1" align="center">
         <SELECT name="show_users_set2" multiple size="5">
%(ulist2)s
         </SELECT>
       </TD>
       <TD width="100%%" class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 border=0 alt=""></TD>
     </TR>
   </TABLE>
 </TD>
</TR>
<TR class="tr_listing0">
 <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 border=0 alt=""></TD>
 <TD class="td_listing0"><INPUT type="submit" class="input2" value="%(tls_save)s"></TD>
</TR>
</TABLE>
</FORM>""" % locals())
    if(rlist1 or rlist2):
        output.append(u"""
<BR>
<FORM name="vorm2" action="%(BASE_CALENDAR_URL)sday.py/save_resource_list" onsubmit="select_all2();">
<TABLE width="100%%" cellpadding=0 cellspacing=0 border=0>
 <TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD width="100%%">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD background="%(BASE_ICON_URL)sdokunurk1.gif"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD class="th_listing" align=center nowrap>&nbsp;&nbsp;<b>%(tls_resources)s</b>&nbsp;&nbsp;</TD>
        <TD background="%(BASE_ICON_URL)sdokunurk2.gif"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%">&nbsp;</TD>
      </TR>
    </TABLE>
  </TD>
 </TR>
<TR class="tr_listing1">
 <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 border=0 alt=""></TD>
 <TD class="td_listing1">%(tls_select_res)s</TD>
</TR>
<TR>
 <TD colspan="2">
   <TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
     <TR>
       <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=20 border=0 alt=""></TD>
       <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=300 border=0 alt=""></TD>
       <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=40 border=0 alt=""></TD>
       <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=40 border=0 alt=""></TD>
       <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=300 border=0 alt=""></TD>
       <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=10 border=0 alt=""></TD>
     </TR>
     <TR class="tr_listing0">
       <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" height="10" width=20 border=0 alt=""></TD>
       <TD class="td_listing0">%(tls_res_view)s</TD>
       <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=40 border=0 alt=""></TD>
       <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=40 border=0 alt=""></TD>
       <TD class="td_listing0">%(tls_res_others)s</TD>
       <TD width="100%%" class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=10 border=0 alt=""></TD>
     </TR>
     <TR class="tr_listing1">
       <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=20 border=0 alt=""></TD>
       <TD class="td_listing1" align="center">
         <SELECT name="show_users_set" multiple size="5">
%(rlist1)s
         </SELECT>
       </TD>
       <TD class="td_listing1" align="center"><a href="#" onclick="move_3();"><img src="%(BASE_ICON_URL)sleft_arr.gif" width="17" height="17" border="0" alt=""></a></TD>
       <TD class="td_listing1" align="center"><a href="#" onclick="move_4();"><img src="%(BASE_ICON_URL)sright_arr.gif" width="17" height="17" border="0" alt=""></a></TD>
       <TD class="td_listing1" align="center">
         <SELECT name="show_users_set2" multiple size="5">
%(rlist2)s
         </SELECT>
       </TD>
       <TD width="100%%" class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 border=0 alt=""></TD>
     </TR>
   </TABLE>
 </TD>
</TR>
<TR class="tr_listing0">
 <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 border=0 alt=""></TD>
 <TD class="td_listing0"><INPUT type="submit" class="input2" value="%(tls_save)s"></TD>
</TR>
</TABLE>
</FORM>""" % (locals()))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def save_users_list(REQUEST):
    if not REQUEST.form.has_key('show_users_set'):
        raise RuntimeError, REQUEST.TLS('tls_nousers')

    try:
        show_users = [REQUEST.form['show_users_set'].value]
    except AttributeError:
        show_users = REQUEST.form['show_users_set']

    if not show_users:
        raise RuntimeError, REQUEST.TLS('tls_nousers')

    show_users = map(int, show_users)

    REQUEST.set_setting('cal_show_users', show_users)

    loc = u"%s%s" % (_Conf.BASE_CALENDAR_URL, 'day.py/users_list')
    REQUEST.mod_req.headers_out["Location"] = loc.encode('UTF8')
    return apache.HTTP_MOVED_TEMPORARILY


def save_resource_list(REQUEST):
    if not REQUEST.form.has_key('show_users_set'):
        show_resources = None
    else:
        try:
            show_resources = [REQUEST.form['show_users_set'].value]
        except AttributeError:
            show_resources = REQUEST.form['show_users_set']

    if not show_resources:
        REQUEST.del_setting('cal_show_resources')
    else:
        show_resources = map(int, show_resources)
        REQUEST.set_setting('cal_show_resources', show_resources)

    loc = u"%s%s" % (_Conf.BASE_CALENDAR_URL, 'day.py/users_list')
    REQUEST.mod_req.headers_out["Location"] = loc.encode('UTF8')
    return apache.HTTP_MOVED_TEMPORARILY


