# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

from mod_python import apache

import mx.DateTime
import standard_html
import _Event, _InitTypes, _Conf, _Utils, _Access, _RootObject, _Exceptions, _Resource, _Log, _Usernote, _mail
from Menus import get_calendar_menu
import relations
import urllib

MY_MENU_ID = -1

def index(REQUEST):
    if not REQUEST.form.has_key('event_id'):
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    event_id = REQUEST.form['event_id'].value
    event = _Event.Event(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['event_id'].value))
    relation_ids = relations.get_relations(REQUEST, event)
    if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value.strip():
        returl = """<input name="returl" type="hidden" value="%s">""" % urllib.unquote(REQUEST.form['returl'].value.strip())
    else:
        returl = ""
    rel_contact_id = ""
    contact_ids = ""
    contact_out = ""
    for rel in relation_ids:
        if rel['left_type_id']==_InitTypes.ITEM_TYPE_CONTACT or rel['right_type_id']==_InitTypes.ITEM_TYPE_CONTACT:
            if int(rel['left_item_id'])==int(REQUEST.form['event_id'].value):
                contact_ids = contact_ids + "," + str(rel['right_item_id'])
                contact_out = contact_out + rel['right_item_name'].decode('UTF8') + "<br>"
            else:
                contact_ids = contact_ids + "," + str(rel['left_item_id'])
                contact_out = contact_out + rel['left_item_name'].decode('UTF8') + "<br>"
    if len(contact_ids)>0 and contact_ids[0]==",":
        contact_ids = contact_ids[1:]
    menu = menu_output(REQUEST, event)
    if REQUEST.form.has_key('rel'):
        return relations_contents(REQUEST)
    elif REQUEST.form.has_key('log'):
        return show_log(REQUEST, REQUEST.form['event_id'].value)
    elif REQUEST.form.has_key('note'):
        return notes_contents(REQUEST)
    
    tls_sendrelated = REQUEST.TLS('cal_sendrelated')
    tls_editevent = REQUEST.TLS('cal_editevent')
    tls_subject = REQUEST.TLS('tls_title')
    tls_activity = REQUEST.TLS('cal_showas')
    tls_priority = REQUEST.TLS('tls_priority')
    tls_related = REQUEST.TLS('tls_related')
    tls_save = REQUEST.TLS('tls_save')
    tls_email = REQUEST.TLS('tls_email')
    tls_sms = REQUEST.TLS('tls_sms')
    tls_starttime = REQUEST.TLS('cal_starttime')
    tls_endtime = REQUEST.TLS('cal_endtime')
    tls_startdate = REQUEST.TLS('cal_startdate')
    tls_enddate = REQUEST.TLS('cal_enddate')
    tls_desc = REQUEST.TLS('tls_description')
    tls_private = REQUEST.TLS('tls_private')
    tls_remind = REQUEST.TLS('cal_reminder')
    tls_remindtime = REQUEST.TLS('cal_remindtime')
    tls_reptyp = REQUEST.TLS('cal_repeattype')
    tls_repint = REQUEST.TLS('cal_repeatinterval')
    tls_repweek = REQUEST.TLS('cal_repweek')
    tls_repmonth = REQUEST.TLS('cal_repmonth')
    tls_repyear = REQUEST.TLS('cal_repyear')
    tls_onthe = REQUEST.TLS('cal_onthe')
    tls_repmonthstr = REQUEST.TLS('cal_repmonthstr')
    tls_dayof = REQUEST.TLS('cal_dayof')
    tls_every = REQUEST.TLS('cal_every')
    tls_mon = REQUEST.TLS('day_monday')
    tls_tue = REQUEST.TLS('day_tuesday')
    tls_wed = REQUEST.TLS('day_wednesday')
    tls_thu = REQUEST.TLS('day_thursday')
    tls_fri = REQUEST.TLS('day_friday')
    tls_sat = REQUEST.TLS('day_saturday')
    tls_hasseen = REQUEST.TLS('cal_hasseen')
    tls_hasaccepted = REQUEST.TLS('cal_hasaccepted')
    tls_hasrejected = REQUEST.TLS('cal_hasrejected')
    tls_sun = REQUEST.TLS('day_sunday')
    tls_minutes = REQUEST.TLS('cal_minutes')
    tls_doesnot = REQUEST.TLS('cal_doesnotrepeat')
    tls_daily = REQUEST.TLS('cal_daily')
    tls_monthly = REQUEST.TLS('cal_monthly')
    tls_weekly = REQUEST.TLS('cal_weekly')
    tls_yearly = REQUEST.TLS('cal_yearly')
    tls_off = REQUEST.TLS('cal_off')
    tls_1 = REQUEST.TLS('tls_month_1')
    tls_2 = REQUEST.TLS('tls_month_2')
    tls_3 = REQUEST.TLS('tls_month_3')
    tls_4 = REQUEST.TLS('tls_month_4')
    tls_5 = REQUEST.TLS('tls_month_5')
    tls_6 = REQUEST.TLS('tls_month_6')
    tls_7 = REQUEST.TLS('tls_month_7')
    tls_8 = REQUEST.TLS('tls_month_8')
    tls_9 = REQUEST.TLS('tls_month_9')
    tls_10 = REQUEST.TLS('tls_month_10')
    tls_11 = REQUEST.TLS('tls_month_11')
    tls_12 = REQUEST.TLS('tls_month_12')
    tls_onday = REQUEST.TLS('cal_onday')
    tls_onweek = REQUEST.TLS('cal_onweek')
    tls_onmonth = REQUEST.TLS('cal_onmonth')
    tls_onyear = REQUEST.TLS('cal_onyear')
    tls_resources = REQUEST.TLS('tls_resources')
    BASE_CALENDAR_URL = _Conf.BASE_CALENDAR_URL
    BASE_WEB_URL = _Conf.BASE_WEB_URL
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    REQ_FIELD = _Conf.REQ_FIELD
    tls_invdateformat = REQUEST.TLS('tls_invdateformat')
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_relgroups = REQUEST.TLS('cal_relgroups')
    tls_dayevery = REQUEST.TLS('cal_dayevery')
    tls_weekevery = REQUEST.TLS('cal_weekevery')
    tls_monthevery = REQUEST.TLS('cal_monthevery')
    tls_yearevery = REQUEST.TLS('cal_yearevery')
    tls_show_rels = REQUEST.TLS('cal_show_rels')
    tls_hide_rels = REQUEST.TLS('cal_hide_rels')
    div_help1 = div_help2 = REQUEST.TLS('cal_div_help')
    tls_rel_persons = REQUEST.TLS('type_Persons')
    tls_rel_contacts = REQUEST.TLS('type_Contacts')
    
    datecheck_js = REQUEST.datecheck_js(REQUEST)
    timecheck_js = REQUEST.timecheck_js()
    dformat = _Utils.dateformat2jscalformat(REQUEST)
    output = []
    output.append(standard_html.html_header(REQUEST, '<link rel="stylesheet" type="text/css" media="all" href="%sjscalendar/calendar-blue.css" title="win2k-1" />' % _Conf.BASE_WEB_URL))
    output.append(get_calendar_menu(REQUEST,MY_MENU_ID))
    dformat = _Utils.dateformat2jscalformat(REQUEST)
    lformat = _Utils.lang2jscalformat(REQUEST)
    output.append(u"""<script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/calendar.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/lang/calendar-%(lformat)s.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/cal_setup.js"></script>""" % locals())
    output.append(u"""\
<script language="JavaScript" type="text/javascript">
<!--
%(datecheck_js)s
%(timecheck_js)s

  function check_values()
  {
    if (!document.addform.event_name.value || 
        !document.addform.start_stamp_d.value || !document.addform.start_stamp_t.value ||
        !document.addform.end_stamp_d.value || !document.addform.end_stamp_t.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }

  
function show_rel()
{
  s1 = document.getElementById('91');
  if(s1.style.display=='block')
  {
    s1.style.display='none';
    document.forms[0].sbtn.value="%(tls_show_rels)s";
  }
  else
  {
    s1.style.display='block';
    document.forms[0].sbtn.value="%(tls_hide_rels)s";
  }
}

// -->
</SCRIPT>"""%locals())
    start_stamp_d, start_stamp_t = REQUEST.iso2userdatetime(REQUEST, event.get('start_stamp')).split(' ')
    end_stamp_d, end_stamp_t = REQUEST.iso2userdatetime(REQUEST, event.get('end_stamp')).split(' ')
    event_id = event.get_id()
    event_name = _Utils.html_quote(event.get('event_name'))
    event_desc = _Utils.html_quote(event.get('description') or "")
    
    if event.get('creator_id') <> REQUEST.USER.get_id():
        event_is_private = u""
    elif event.get('is_private'):
        event_is_private = u"""
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_private)s</TD>
    <TD class="td_listing1" colspan="4"><INPUT type="checkbox" name="event_is_private" CHECKED></TD>
  </TR>""" % locals()
    else:
        event_is_private = u"""
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_private)s</TD>
    <TD class="td_listing1" colspan="4"><INPUT type="checkbox" name="event_is_private"></TD>
  </TR>""" % locals()

    if event.get('creator_id') <> REQUEST.USER.get_id():
        event_sendrelated = u""
    elif event.get('event_flags') & _Event.EVENT_REMINDER_OTHERS:
        event_sendrelated = u"""  
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" colspan="3">%(tls_sendrelated)s</TD>
    <TD class="td_listing0" colspan="2"><INPUT type="checkbox" name="sendrelated" CHECKED></TD>
  </TR>""" % locals()
    else:
        event_sendrelated = u"""
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" colspan="3">%(tls_sendrelated)s</TD>
    <TD class="td_listing1" colspan="2"><INPUT type="checkbox" name="sendrelated"></TD>
  </TR>""" % locals()

    priorities = _Utils.make_setting_selection(REQUEST, event, 'event_priority', 'cal_priorities')
    sel = event.get('event_activity')
    if sel=="0": 
        selected = ['SELECTED', '', '', '']
    elif sel=="1":
        selected = ['', 'SELECTED', '', '']
    elif sel=="2":
        selected = ['', '', 'SELECTED', '']
    else:
        selected = ['', '', '', 'SELECTED']
    activities = u"""
<SELECT name="event_activity">
  <OPTION %s value="0">%s</OPTION>
  <OPTION %s value="1">%s</OPTION>
  <OPTION %s value="2">%s</OPTION>
  <OPTION %s value="3">%s</OPTION>
</SELECT>""" % (selected[0],REQUEST.TLS('cal_showas_0'),selected[1],REQUEST.TLS('cal_showas_1'),selected[2],REQUEST.TLS('cal_showas_2'),selected[3],REQUEST.TLS('cal_showas_3'))
    if event.get('creator_id') <> REQUEST.USER.get_id() and _Access.get_item_right(REQUEST, event.get_id(), REQUEST.USER.get_id()) < _Access.ACCESS_MANAGE:
        priorities = priorities.replace('<SELECT', '<SELECT disabled')
        activities = activities.replace('<SELECT', '<SELECT disabled')

    if event.get('creator_id') == REQUEST.USER.get_id():
        event_reminder = event.get('remind_type')
        reminders = [tls_off, tls_email, tls_sms]
        reminder = ["""<SELECT class="textfield1" name="remind_type">"""]
        for i in range(3):
            if event_reminder == i:
                reminder.append("""<OPTION value="%d" SELECTED>%s""" % (i, reminders[i]))
            else:
                reminder.append("""<OPTION value="%d">%s""" % (i, reminders[i]))
        reminder.append("""</SELECT>""")
        reminder = "\n".join(reminder)

        event_reminder_time = event.get('remind_time').delta
        reminders = ["5", "10", "15", "20", "30"]
        reminders_time = [5, 10, 15, 20, 30]
        reminder_time = ["""<SELECT class="textfield1" name="remind_time">"""]
        for i in range(5):
            if event_reminder_time and event_reminder_time.minutes == reminders_time[i]:
                reminder_time.append("""<OPTION value="%s minutes" SELECTED>%s %s""" % (reminders[i], reminders[i], tls_minutes))
            else:
                reminder_time.append("""<OPTION value="%s minutes">%s %s""" % (reminders[i], reminders[i], tls_minutes))
        reminder_time.append("""</SELECT>""")
        reminder_time = "\n".join(reminder_time)
        event_reminder_tr = u"""
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" nowrap>%(tls_remind)s</TD>
    <TD class="td_listing0">%(reminder)s</TD>
    <TD class="td_listing0" nowrap>%(tls_remindtime)s</TD>
    <TD class="td_listing0" colspan="2">%(reminder_time)s</TD>
  </TR>""" % locals()
    else:
        event_reminder_tr = u""

    event_related = _Utils.sql_parse_array(REQUEST, event.get('related_persons'))
    event_seen = _Utils.sql_parse_array(REQUEST, event.get('seen_persons'))
    event_accepted = _Utils.sql_parse_array(REQUEST, event.get('accepted_persons'))
    event_rejected = _Utils.sql_parse_array(REQUEST, event.get('rejected_persons'))
    if REQUEST.USER.get_id()<> event.get('creator_id') and REQUEST.USER.get_id() in event_related and REQUEST.USER.get_id() not in event_seen:
        if REQUEST.db.version < 740:
            REQUEST.db.execute("""UPDATE events SET seen_persons = seen_persons + '{%d}'::int[] WHERE event_id=%d""" % (REQUEST.USER.get_id(), event.get_id()))
        else:
            REQUEST.db.execute("""UPDATE events SET seen_persons = seen_persons || '{%d}'::int[] WHERE event_id=%d""" % (REQUEST.USER.get_id(), event.get_id()))
        event_seen += [REQUEST.USER.get_id()]

    if event.get('creator_id') == REQUEST.USER.get_id() or _Access.get_item_right(REQUEST, event.get_id(), REQUEST.USER.get_id()) == _Access.ACCESS_MANAGE or (_Access.get_item_right(REQUEST, event.get_id(), REQUEST.USER.get_id()) == _Access.ACCESS_WRITE and REQUEST.USER.get_id() in event_related):
        right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_PERSON])
        if right_param:
            right_param = " AND " + right_param
        REQUEST.db.execute(("""SELECT i.item_name, p.person_id FROM items i, persons p WHERE p.person_id=i.item_id AND p.is_deleted=0""").encode('UTF8'))
        related_persons = REQUEST.db.dictfetchall()
        
        persons_out = ""
        persons_ids = ""
        for person in related_persons:
            if person['person_id'] in event_related:
                persons_out = persons_out + person['item_name'].decode('UTF8') + "<BR>"
                persons_ids = persons_ids + "," + str(person['person_id'])
        if persons_ids and persons_ids[0]==",":
            persons_ids = persons_ids[1:]
        if persons_out:
            div_help1 = persons_out
        if contact_out:
            div_help2 = contact_out


    else:
        persons_ids = ""
        persons_out = []
        REQUEST.su_by_id(_Conf.SUPERUSER)
        for person_id in event_related:
            try:
                rel_per = _RootObject.dispatch_item(REQUEST, person_id)
                persons_out.append(rel_per.get_name())
                persons_ids = persons_ids + "," + str(rel_per.get('person_id'))
            except _Exceptions.RootObjectError:
                pass
        REQUEST.unsu()
        if persons_ids and persons_ids[0]==",":
            persons_ids = persons_ids[1:]
        related_persons = "<BR>\n".join(persons_out)
        del persons_out

    seen_out = []
    REQUEST.su_by_id(_Conf.SUPERUSER)
    for person_id in event_seen:
        try:
            p = _RootObject.dispatch_item(REQUEST, person_id)
            seen_out.append("""%s %s""" % (p.get_name(), tls_hasseen))
        except _Exceptions.RootObjectError:
            pass
    seen_out = "<BR>\n".join(seen_out)
    accepted_out = []
    for person_id in event_accepted:
        try:
            p = _RootObject.dispatch_item(REQUEST, person_id)
            accepted_out.append("""%s %s""" % (p.get_name(), tls_hasaccepted))
        except _Exceptions.RootObjectError:
            pass
    accepted_out = "<BR>\n".join(accepted_out)
    rejected_out = []
    for person_id in event_rejected:
        try:
            p = _RootObject.dispatch_item(REQUEST, person_id)
            rejected_out.append("""%s %s""" % (p.get_name(), tls_hasrejected))
        except _Exceptions.RootObjectError:
            pass
    REQUEST.unsu()
    rejected_out = "<BR>\n".join(rejected_out)

    btn_save = 1
    if REQUEST.USER.get_id() == event.get('creator_id') or REQUEST.USER.get_id() == _Conf.SUPERUSER: # FIXME
        delete_button = u"""&nbsp;<INPUT type="submit" class="input2" name="_delete" value="%s" onClick="return confirm('%s');">""" % (REQUEST.TLS('tls_delete'), REQUEST.TLS('email_confirm_del'))
    else:
        delete_button = ""
    if REQUEST.USER.get_id()<> event.get('creator_id') and REQUEST.USER.get_id() in event_related and REQUEST.USER.get_id() not in event_accepted and REQUEST.USER.get_id() not in event_rejected:
        accept_button = u"""&nbsp;<INPUT type="submit" class="input6" name="_accept" value="%s">""" % REQUEST.TLS('todo_accept')
        btn_save = 0
    else:
        accept_button = ""
    if REQUEST.USER.get_id()<> event.get('creator_id') and REQUEST.USER.get_id() in event_related and REQUEST.USER.get_id() not in event_accepted and REQUEST.USER.get_id() not in event_rejected:
        reject_button = u"""&nbsp;<INPUT type="submit" class="input6" name="_reject" value="%s">""" % REQUEST.TLS('todo_reject')
        btn_save = 0
    else:
        reject_button = ""
    if btn_save:
        save_button = u"""<INPUT type="submit" class="input2" name="_save" value="%s">""" % REQUEST.TLS('tls_save')
    else:
        save_button = ""

    sel_resources = _Resource.get_event_resources(REQUEST, event.get_id())
    sel_resources_ids = map(lambda x: x.get_id(), sel_resources)
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_RESOURCE])
    if right_param:
        right_param = " AND " + right_param
    REQUEST.db.execute(("""SELECT r.resource_name, r.resource_id FROM items i, resources r WHERE r.resource_id=i.item_id%s""" % right_param).encode('UTF8'))
    resources = REQUEST.db.dictfetchall()
    rescount = len(resources)
    resources = """<SELECT class="textfield1" name="cal_resources" multiple size="4">\n%s</SELECT>""" % "\n".join(map(lambda x: """<OPTION value="%d"%s>%s""" % (x['resource_id'], (x['resource_id'] in sel_resources_ids and u"SELECTED") or u"", x['resource_name'].decode('UTF8')), resources))

    if rescount:
      res1 = tls_resources
      res2 = resources
    else:
      res1 = "&nbsp;"
      res2 = "&nbsp;"

    if REQUEST._translator.dateformat=='en_US_12':
        timestruct = ['12:00AM','12:15AM','12:30AM','12:45AM','1:00AM','1:15AM','1:30AM','1:45AM','2:00AM','2:15AM','2:30AM','2:45AM','3:00AM','3:15AM','3:30AM','3:45AM','4:00AM','4:15AM','4:30AM','4:45AM','5:00AM','5:15AM','5:30AM','5:45AM','6:00AM','6:15AM','6:30AM','6:45AM','7:00AM','7:15AM','7:30AM','7:45AM','8:00AM','8:15AM','8:30AM','8:45AM','9:00AM','9:15AM','9:30AM','9:45AM','10:00AM','10:15AM','10:30AM','10:45AM','11:00AM','11:15AM','11:30AM','11:45AM','12:00PM','12:15PM','12:30PM','12:45PM','1:00PM','1:15PM','1:30PM','1:45PM','2:00PM','2:15PM','2:30PM','2:45PM','3:00PM','3:15PM','3:30PM','3:45PM','4:00PM','4:15PM','4:30PM','4:45PM','5:00PM','5:15PM','5:30PM','5:45PM','6:00PM','6:15PM','6:30PM','6:45PM','7:00PM','7:15PM','7:30PM','7:45PM','8:00PM','8:15PM','8:30PM','8:45PM','9:00PM','9:15PM','9:30PM','9:45PM','10:00PM','10:15PM','10:30PM','10:45PM','11:00PM','11:15PM','11:30PM','11:45PM']
        if start_stamp_t[0]=="0":
            start_stamp_t = start_stamp_t[1:]
        if end_stamp_t[0]=="0":
            end_stamp_t = end_stamp_t[1:]
    else:
        timestruct = ['00:00','00:15','00:30','00:45','01:00','01:15','01:30','01:45','02:00','02:15','02:30','02:45','03:00','03:15','03:30','03:45','04:00','04:15','04:30','04:45','05:00','05:15','05:30','05:45','06:00','06:15','06:30','06:45','07:00','07:15','07:30','07:45','08:00','08:15','08:30','08:45','09:00','09:15','09:30','09:45','10:00','10:15','10:30','10:45','11:00','11:15','11:30','11:45','12:00','12:15','12:30','12:45','13:00','13:15','13:30','13:45','14:00','14:15','14:30','14:45','15:00','15:15','15:30','15:45','16:00','16:15','16:30','16:45','17:00','17:15','17:30','17:45','18:00','18:15','18:30','18:45','19:00','19:15','19:30','19:45','20:00','20:15','20:30','20:45','21:00','21:15','21:30','21:45','22:00','22:15','22:30','22:45','23:00','23:15','23:30','23:45']
    start_time = u"""<SELECT class="textfield1" name="start_stamp_t">"""
    for time in timestruct:
        if time==start_stamp_t:
            start_time = start_time + u"""<option selected value="%s">%s</option>""" % (time, time)
        else:
            start_time = start_time + u"""<option value="%s">%s</option>""" % (time, time)
    start_time = start_time + u"""</SELECT>"""

    end_time = u"""<SELECT class="textfield1" name="end_stamp_t">"""
    for time in timestruct:
        if time==end_stamp_t:
            end_time = end_time + u"""<option selected value="%s">%s</option>""" % (time, time)
        else:
            end_time = end_time + u"""<option value="%s">%s</option>""" % (time, time)
    end_time = end_time + u"""</SELECT>"""

    BASE_CALENDAR_URL = _Conf.BASE_CALENDAR_URL
    rels = _Utils.sql_parse_array(REQUEST, event.get('related_persons'))
    if event.get('creator_id') == REQUEST.USER.get_id() or _Access.get_item_right(REQUEST, event.get_id(), REQUEST.USER.get_id()) == _Access.ACCESS_MANAGE or (_Access.get_item_right(REQUEST, event.get_id(), REQUEST.USER.get_id()) == _Access.ACCESS_WRITE and REQUEST.USER.get_id() in rels): # How creator sees events
        output.append(u"""
<TABLE border=0 cellpadding=0 cellspacing=0 width="100%%">
<FORM method="POST" action="%(BASE_CALENDAR_URL)seditevent.py/edit" name="addform" onsubmit="return check_values();">
%(returl)s
<INPUT TYPE="hidden" name="event_id" value="%(event_id)d">
  <TR>
    <TD colspan=6>%(menu)s</TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_subject)s%(REQ_FIELD)s</TD>
    <TD class="td_listing1" colspan="4"><INPUT type="text" size=35 class="textfield1" name="event_name" value="%(event_name)s"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD width="1%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" width="10%%" nowrap>%(tls_activity)s</TD>
    <TD class="td_listing0" width="15%%">%(activities)s</TD>
    <TD class="td_listing0" width="10%%" nowrap>%(tls_priority)s</TD>
    <TD class="td_listing0" width="15%%">%(priorities)s</TD>
    <TD class="td_listing0" width="50%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" colspan="5"><input type="button" value="%(tls_show_rels)s" name="sbtn" class="input3" onclick="show_rel()"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD colspan="5">
      <img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt="">
      <TABLE border=0 cellpadding=0 cellspacing=0 id="91" style="display: none">
        <TR class="tr_listing1" valign="top">
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
          <TD class="td_listing1" width="15%%"><input class="input6" type="button" value="%(tls_rel_persons)s" onclick="open_window('%(BASE_CALENDAR_URL)spopup_persons.py?persons='+document.forms[0].rel_persons.value)"></TD>
          <TD class="td_listing1" width="35%%" align="left"><div id="98">%(div_help1)s</div>&nbsp;<input type="hidden" name="rel_persons" value="%(persons_ids)s"></TD>
          <TD class="td_listing1" width="15%%">%(res1)s</TD>
          <TD class="td_listing1" width="35%%" align="center">%(res2)s</TD>
        </TR>
      </TABLE>
    </TD>
    <TD class="td_listing1" width="50%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" nowrap>%(tls_startdate)s%(REQ_FIELD)s</TD>
    <TD class="td_listing0"><INPUT type="text" size="10" class="textfield1" name="start_stamp_d" onchange="this.form.end_stamp_d.value=this.value;" id="start_stamp_d" value="%(start_stamp_d)s" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }">&nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('start_stamp_d', '%(dformat)s', 'end_stamp_d');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt="" style="position: relative; top: 3px;"></A></TD>
    <TD class="td_listing0" nowrap>%(tls_starttime)s%(REQ_FIELD)s</TD>
    <TD class="td_listing0" colspan="2">%(start_time)s</TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_enddate)s%(REQ_FIELD)s</TD>
    <TD class="td_listing1"><INPUT type="text" size="10" class="textfield1" name="end_stamp_d" id="end_stamp_d" value="%(end_stamp_d)s" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }">&nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('end_stamp_d', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt="" style="position: relative; top: 3px;"></A></TD>
    <TD class="td_listing1" nowrap>%(tls_endtime)s%(REQ_FIELD)s</TD>
    <TD class="td_listing1" colspan="2">%(end_time)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" colspan="5">%(tls_desc)s<BR><TEXTAREA class="textarea4" name="description" rows="6" cols="65">%(event_desc)s</TEXTAREA></TD>
  </TR>
%(event_is_private)s
%(event_reminder_tr)s
%(event_sendrelated)s
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" colspan="5">%(save_button)s%(accept_button)s%(reject_button)s%(delete_button)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" colspan=5><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt="">%(seen_out)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" colspan=5><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt="">%(accepted_out)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" colspan=5><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt="">%(rejected_out)s</TD>
  </TR>
</TABLE>
</FORM>"""%locals())
    else: # How others see events
        event_desc = _Utils.newline2br(event_desc)
        output.append("""\
<br>
<TABLE border=0 cellpadding=0 cellspacing=0 width="100%%">
<FORM method="POST" action="%(BASE_CALENDAR_URL)seditevent.py/edit2" name="addform">
<INPUT TYPE="hidden" name="event_id" value="%(event_id)d">
<input type="hidden" name="rel_persons" value="%(persons_ids)s">
<input type="hidden" name="start_stamp_d" value="%(start_stamp_d)s">
<input type="hidden" name="end_stamp_d" value="%(end_stamp_d)s">
<input type="hidden" name="start_stamp_t" value="%(start_stamp_t)s">
<input type="hidden" name="end_stamp_t" value="%(end_stamp_t)s">
%(returl)s
  <TR>
    <TD colspan=6>%(menu)s</TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_subject)s</TD>
    <TD class="td_listing1" colspan="3">%(event_name)s</TD>
    <TD class="td_listing1" width="50%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing0" nowrap>%(tls_activity)s</TD>
    <TD class="td_listing0">%(activities)s</TD>
    <TD class="td_listing0" nowrap>%(tls_priority)s</TD>
    <TD class="td_listing0">%(priorities)s</TD>
    <TD class="td_listing0" width="50%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD colspan="2" class="td_listing1" nowrap>%(tls_related)s</TD>
    <TD colspan="2" class="td_listing1">%(related_persons)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing0" nowrap>%(tls_startdate)s</TD>
    <TD class="td_listing0">%(start_stamp_d)s</TD>
    <TD class="td_listing0" nowrap>%(tls_starttime)s</TD>
    <TD class="td_listing0" colspan="2">%(start_stamp_t)s</TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_enddate)s</TD>
    <TD class="td_listing1">%(end_stamp_d)s</TD>
    <TD class="td_listing1" nowrap>%(tls_endtime)s</TD>
    <TD class="td_listing1" colspan="2">%(end_stamp_t)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing0" colspan="5">%(tls_desc)s<BR>%(event_desc)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" colspan="5"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt="">%(seen_out)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" colspan="5"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt="">%(accepted_out)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" colspan="5"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt="">%(rejected_out)s</TD>
  </TR>
</TABLE>
</FORM>
<BR>
"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def edit(REQUEST):
    if not REQUEST.form.has_key('event_id'):
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    output = []
    output.append(standard_html.html_header(REQUEST))
    event = _Event.Event(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['event_id'].value))
    if REQUEST.form.has_key('_delete') or REQUEST.form.has_key('_delete.x') and (REQUEST.USER.get_id() == event.get('creator_id') or REQUEST.USER.get_id() == _Conf.SUPERUSER):
        if event.get('start_stamp')>_Utils.utc_now_mx() and _Access.get_item_right(REQUEST, event.get('event_id'), REQUEST.USER.get_id()) >= _Access.ACCESS_WRITE:
            try:
                _mail.send_invitation_update(REQUEST, event, 2)
            except:
                raise RuntimeError, REQUEST.TLS('eventinverror')
        event.delete()
        output.append("""<SCRIPT language="javascript">\n<!--\nwindow.opener.location.href=window.opener.location.href;\nwindow.close();\n// -->\n</SCRIPT>\n%s.""" % REQUEST.TLS('cal_deleted'))
    else:
        event.load_req()
        if not event.get('event_name'):
            raise RuntimeError, REQUEST.TLS('required_parameters_missing')

        _Resource.remove_event_resources(REQUEST, event.get_id())
        if REQUEST.form.has_key('cal_resources') and isinstance(REQUEST.form['cal_resources'], list):
            res_ids = map(int, REQUEST.form['cal_resources'])
            for res_id in res_ids:
                res = _Resource.Resource(REQUEST, _InitTypes.INIT_TYPE_ID, res_id)
                res.add_to_event(event.get_id())
        elif REQUEST.form.has_key('cal_resources') and REQUEST.form['cal_resources'].value:
            res = _Resource.Resource(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['cal_resources'].value))
            res.add_to_event(event.get_id())

        if REQUEST.form.has_key('_accept') or REQUEST.form.has_key('_accept.x'):
            event.set('accepted_persons', _Utils.sql_parse_array(REQUEST, event.get('accepted_persons')) + [REQUEST.USER.get_id()])
        if REQUEST.form.has_key('_reject') or REQUEST.form.has_key('_reject.x'):
            event.set('rejected_persons', _Utils.sql_parse_array(REQUEST, event.get('rejected_persons')) + [REQUEST.USER.get_id()])
        if REQUEST.form.has_key('start_stamp_d') and REQUEST.form.has_key('start_stamp_t') and REQUEST.form['start_stamp_d'].value.decode('UTF8').strip() and REQUEST.form['start_stamp_t'].value.decode('UTF8').strip():
            event.set('start_stamp', REQUEST.user2isodatetime(REQUEST, '%s %s' % (REQUEST.form['start_stamp_d'].value.decode('UTF8'), REQUEST.form['start_stamp_t'].value.decode('UTF8'))))
        else:
            raise RuntimeError, REQUEST.TLS('required_parameters_missing')
        if REQUEST.form.has_key('end_stamp_d') and REQUEST.form.has_key('end_stamp_t') and REQUEST.form['end_stamp_d'].value.decode('UTF8').strip() and REQUEST.form['end_stamp_t'].value.decode('UTF8').strip():
            event.set('end_stamp', REQUEST.user2isodatetime(REQUEST, '%s %s' % (REQUEST.form['end_stamp_d'].value.decode('UTF8'), REQUEST.form['end_stamp_t'].value.decode('UTF8'))))
        else:
            raise RuntimeError, REQUEST.TLS('required_parameters_missing')
        if REQUEST.user2isodatetime(REQUEST, '%s %s' % (REQUEST.form['start_stamp_d'].value.decode('UTF8'), REQUEST.form['start_stamp_t'].value.decode('UTF8'))) > REQUEST.user2isodatetime(REQUEST, '%s %s' % (REQUEST.form['end_stamp_d'].value.decode('UTF8'), REQUEST.form['end_stamp_t'].value.decode('UTF8'))):
            raise RuntimeError, REQUEST.TLS('cal_wrongstamp')
        if REQUEST.form.has_key('rel_persons') and REQUEST.form['rel_persons'].value:
            related_persons = map(int, REQUEST.form['rel_persons'].value.split(","))
            event.set('related_persons', related_persons)
        else:
            event.set('related_persons', [])
        event.set('related_groups', [])
        if event.get('creator_id') == REQUEST.USER.get_id():
            if REQUEST.form.has_key('event_is_private'):
                event.set('is_private', 1)
            else:
                event.set('is_private', 0)

        event.set('last_reminder',None)
        if REQUEST.form.has_key('sendrelated'):
            event.set('event_flags', _Event.EVENT_REMINDER_OTHERS)
        else:
            event.set('event_flags', 0)
        SQL = """SELECT ir.* FROM item_rels ir, items i, items i2 WHERE ((i.item_id=ir.left_item_id AND i2.item_id=ir.right_item_id AND ir.left_item_id = %d AND i2.item_type_id = %d) OR (i.item_id=ir.right_item_id AND i2.item_id=ir.left_item_id AND ir.right_item_id = %d AND i2.item_type_id = %d))""" % (event.get_id(), _InitTypes.ITEM_TYPE_CONTACT, event.get_id(), _InitTypes.ITEM_TYPE_CONTACT)
        REQUEST.db.execute(SQL)
        dbres = REQUEST.db.fetchall()
        for row in dbres:
             REQUEST.db.execute("""DELETE from item_rels WHERE (left_item_id=%d AND right_item_id=%d) OR (left_item_id=%d AND right_item_id=%d)""" % (row[0], row[1], row[1], row[0]))
        event.save()
        event = _Event.Event(REQUEST, _InitTypes.INIT_TYPE_ID, event.get_id())
        conflicts = _Resource.check_for_conflicts(REQUEST, event)
        if conflicts:
            error_output = []
            for (conflict_resource, conflict_event) in conflicts:
                error_output.append(REQUEST.TLS('resource_conflictmsg') % (conflict_resource.get_name(),conflict_event.get_name()))
            error_output = u"\n%s" % "\n".join(error_output)
            raise RuntimeError, error_output
    if event.get('start_stamp')>_Utils.utc_now_mx():
        SQL = """SELECT i.* FROM item_log i WHERE i.batch_id=(SELECT max(i2.batch_id) from item_log i2 where i2.item_id=%d) and i.item_id=%d AND (i.log_flags & %d) = 0 AND (i.log_flags & %d) = 0 and i.change_time>(now()-'1 second'::interval) order by i.batch_id desc, i.field_name asc""" % (event.get('event_id'), event.get('event_id'), _RootObject.LOG_INSERT, _RootObject.LOG_DELETE)
        REQUEST.db.execute(SQL)
        dbres = REQUEST.db.dictfetchall()
        do_send = 0
        do_accept = 0
        do_reject = 0
        for row in dbres:
            if row['field_name']=='start_stamp' or row['field_name'] == 'description':
                do_send = do_send + 1
            if row['field_name']=='accepted_persons':
                do_accept = do_accept + 1
            if row['field_name']=='rejected_persons':
                do_reject = do_reject + 1
        if do_send >= 1:
            try:
                _mail.send_invitation_update(REQUEST, event, 1)
            except:
                raise RuntimeError, REQUEST.TLS('eventinverror')
        if do_accept:
            try:
                _mail.send_invitation_notify(REQUEST, event, 1)
            except:
                raise
                raise RuntimeError, REQUEST.TLS('eventinverror')
        if do_reject:
            try:
                _mail.send_invitation_notify(REQUEST, event, 2)
            except:
                raise RuntimeError, REQUEST.TLS('eventinverror')
    if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value.strip():
        REQUEST.mod_req.headers_out["Location"] = "%s" % urllib.unquote(REQUEST.form['returl'].value.strip())
    else:
        REQUEST.mod_req.headers_out["Location"] = "%sday.py" % _Conf.BASE_CALENDAR_URL
    return apache.HTTP_MOVED_TEMPORARILY

def edit2(REQUEST):
    if not REQUEST.form.has_key('event_id'):
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    output = []
    output.append(standard_html.html_header(REQUEST))
    event = _Event.Event(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['event_id'].value))
    event.save()
    if REQUEST.form.has_key('_accept') or REQUEST.form.has_key('_accept.x'):
        accepted_persons = _Utils.sql_cast_array(REQUEST, _Utils.sql_parse_array(REQUEST, event.get('accepted_persons')) + [REQUEST.USER.get_id()])
        REQUEST.db.execute((u"""UPDATE events SET accepted_persons=%s WHERE event_id=%d""" % (accepted_persons, int(REQUEST.form['event_id'].value))).encode('UTF8'))
    if REQUEST.form.has_key('_reject') or REQUEST.form.has_key('_reject.x'):
        rejected_persons = _Utils.sql_cast_array(REQUEST, _Utils.sql_parse_array(REQUEST, event.get('rejected_persons')) + [REQUEST.USER.get_id()])
        REQUEST.db.execute((u"""UPDATE events SET rejected_persons=%s WHERE event_id=%d""" % (rejected_persons, int(REQUEST.form['event_id'].value))).encode('UTF8'))
    if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value.strip():
        REQUEST.mod_req.headers_out["Location"] = "%s" % urllib.unquote(REQUEST.form['returl'].value.strip())
    else:
        REQUEST.mod_req.headers_out["Location"] = "%sday.py" % _Conf.BASE_CALENDAR_URL
    return apache.HTTP_MOVED_TEMPORARILY


def relations_contents(REQUEST):
    if not REQUEST.form.has_key('event_id') or not REQUEST.form['event_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    event_id = REQUEST.form['event_id'].value
    event_obj = _Event.Event(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['event_id'].value))
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_CONTACT_URL = _Conf.BASE_CONTACT_URL
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_calendar_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST, event_obj)
    output.append(" " + menu)
    event_obj = _Event.Event(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['event_id'].value))
    relation_output = relations.show_relations(REQUEST, event_obj)
    output.append(relation_output)
    real_stamp_d, start_stamp_t = REQUEST.iso2userdatetime(REQUEST, event_obj.get('start_stamp')).split(' ')
    rel_persons = event_obj.get('related_persons')
    rel_persons = _Utils.sql_parse_array(REQUEST, rel_persons)
    rel_p = ""
    for person in rel_persons:
        rel_p = rel_p + "," + str(person)
    if rel_p:
        rel_p = rel_p[1:]
    rel_groups = event_obj.get('related_groups')
    rel_groups = _Utils.sql_parse_array(REQUEST, rel_groups)
    rel_g = ""
    for group in rel_groups:
        rel_g = rel_g + "," + str(group)
    if rel_g:
        rel_g = rel_g[1:]
    output.append(u"""
<FORM name="addform" method="POST">
<input type="hidden" name="real_stamp_d" value="%(real_stamp_d)s">
<input type="hidden" name="rel_persons" value="%(rel_p)s">
<input type="hidden" name="rel_groups" value="%(rel_g)s">
</FORM>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def menu_output(REQUEST, event_obj):
    if not REQUEST.form.has_key('event_id') or not REQUEST.form['event_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')

    output=[]
    output.append(standard_html.window_script(height=600,width=600, resizable='yes'))
    event_id = int(REQUEST.form['event_id'].value)
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_CALENDAR_URL = _Conf.BASE_CALENDAR_URL

    tls_editevent = REQUEST.TLS('cal_editevent')
    tls_info = REQUEST.TLS('contact_info')
    tls_relations = REQUEST.TLS('tls_relations')
    tls_emails = REQUEST.TLS('tls_emails')
    tls_notes = REQUEST.TLS('compmenu_todo_notes')
    tls_log = REQUEST.TLS('log_log')
    tls_scheduling = REQUEST.TLS('cal_scheduling')
    relations_count = relations.relations_count(REQUEST, event_obj)
    
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_USERNOTE])
    if right_param:
        right_param = " AND " + right_param
    QUERY = u"""SELECT count(*) FROM usernotes u, items i, items p WHERE u.note_id=i.item_id AND i.creator_id=p.item_id AND (i.parent_id=%d)%s""" % (event_id, right_param)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    note_count = REQUEST.db.fetchone()[0]

    active = 0
    if REQUEST.form.has_key('rel') and REQUEST.form['rel']=='1':
      active = 1
      el2 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_CALENDAR_URL)seditevent.py?event_id=%(event_id)s&rel=1">%(tls_relations)s <span class="efoldercount">(%(relations_count)d)</span></a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el2 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;<a class="blacklink" href="%(BASE_CALENDAR_URL)seditevent.py?event_id=%(event_id)s&rel=1">%(tls_relations)s <span class="efoldercount">(%(relations_count)d)</span></a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if REQUEST.form.has_key('note') and REQUEST.form['note'].value=='1':
      active = 1
      el3 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;<a class="blackboldlink" href="%(BASE_CALENDAR_URL)seditevent.py?event_id=%(event_id)s&note=1">%(tls_notes)s <span class="efoldercount">(%(note_count)s)</span></a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el3 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;<a class="blacklink" href="%(BASE_CALENDAR_URL)seditevent.py?event_id=%(event_id)s&note=1">%(tls_notes)s <span class="efoldercount">(%(note_count)s)</span></a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if REQUEST.form.has_key('log') and REQUEST.form['log'].value=='1':
      active = 1
      el4 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_CALENDAR_URL)seditevent.py?event_id=%(event_id)s&log=1">%(tls_log)s</a>&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el4 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;&nbsp;<a class="blacklink" href="%(BASE_CALENDAR_URL)seditevent.py?event_id=%(event_id)s&log=1">%(tls_log)s</a>&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if active<> 1:
      el1 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_CALENDAR_URL)seditevent.py?event_id=%(event_id)s">%(tls_editevent)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el1 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;<a class="blacklink" href="%(BASE_CALENDAR_URL)seditevent.py?event_id=%(event_id)s">%(tls_editevent)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()

    tls_object = REQUEST.TLS('log_event_id')
    object_name = _Utils.html_quote_show(event_obj.get('item_name'))
    output.append(u"""
      <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></TD>
        <TD width="100%%" class="object_name">%(tls_object)s: %(object_name)s</TD>
      </TR>
      <TR>
        <TD colspan="2"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="15" border=0 alt=""></TD>
      </TR>
      </TABLE>
      <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
        <TR>
          <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
          %(el1)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el2)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el3)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el4)s
          <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
        </TR>
      </TABLE>""" % locals())
    return "\n".join(output)

def show_log(REQUEST, obj_id):
    obj = _Event.Event(REQUEST, _InitTypes.INIT_TYPE_ID, int(obj_id))
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_calendar_menu(REQUEST, -1))
    menu = menu_output(REQUEST, obj)
    output.append(u""" %(menu)s""" % locals())
    output.append(_Log.standard_log_output(REQUEST, obj_id))
    real_stamp_d, start_stamp_t = REQUEST.iso2userdatetime(REQUEST, obj.get('start_stamp')).split(' ')
    rel_persons = obj.get('related_persons')
    rel_persons = _Utils.sql_parse_array(REQUEST, rel_persons)
    rel_p = ""
    for person in rel_persons:
        rel_p = rel_p + "," + str(person)
    if rel_p:
        rel_p = rel_p[1:]
    rel_groups = obj.get('related_groups')
    rel_groups = _Utils.sql_parse_array(REQUEST, rel_groups)
    rel_g = ""
    for group in rel_groups:
        rel_g = rel_g + "," + str(group)
    if rel_g:
        rel_g = rel_g[1:]
    output.append(u"""
<FORM name="addform" method="POST">
<input type="hidden" name="real_stamp_d" value="%(real_stamp_d)s">
<input type="hidden" name="rel_persons" value="%(rel_p)s">
<input type="hidden" name="rel_groups" value="%(rel_g)s">
</FORM>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def notes_contents(REQUEST):
    if not REQUEST.form.has_key('event_id') or not REQUEST.form['event_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    obj_id = int(REQUEST.form['event_id'].value)
    obj = _Event.Event(REQUEST, _InitTypes.INIT_TYPE_ID, obj_id)
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_calendar_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST, obj)
    BASE_CALENDAR_URL = _Conf.BASE_CALENDAR_URL
    returl = "%(BASE_CALENDAR_URL)seditevent.py?event_id=%(obj_id)s&note=1" % locals()
    returl = urllib.quote(returl)
    show_menu = "events"
    output.append(_Usernote.note_out(REQUEST, obj, obj_id, returl, menu, show_menu))
    real_stamp_d, start_stamp_t = REQUEST.iso2userdatetime(REQUEST, obj.get('start_stamp')).split(' ')
    rel_persons = obj.get('related_persons')
    rel_persons = _Utils.sql_parse_array(REQUEST, rel_persons)
    rel_p = ""
    for person in rel_persons:
        rel_p = rel_p + "," + str(person)
    if rel_p:
        rel_p = rel_p[1:]
    rel_groups = obj.get('related_groups')
    rel_groups = _Utils.sql_parse_array(REQUEST, rel_groups)
    rel_g = ""
    for group in rel_groups:
        rel_g = rel_g + "," + str(group)
    if rel_g:
        rel_g = rel_g[1:]
    output.append(u"""
<FORM name="addform" method="POST">
<input type="hidden" name="real_stamp_d" value="%(real_stamp_d)s">
<input type="hidden" name="rel_persons" value="%(rel_p)s">
<input type="hidden" name="rel_groups" value="%(rel_g)s">
</FORM>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)
