# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

import time

import mx.DateTime
import _Conf, _Exceptions, _Utils, _Access, _InitTypes, _Event, relations, _RootObject
from Menus import get_calendar_menu
from mod_python import apache
import standard_html
import _calendar, _Resource
import urllib

MY_MENU_ID=1

class Colour:
  def __init__(self, REQUEST):
    try:
        self.show_resources = REQUEST.get_setting('cal_show_resources')
    except:
        self.show_resources = []
    try:
        self.show_groups = REQUEST.get_setting('cal_show_groups')
    except:
        self.show_groups = []

  def get_colour_class(self, REQUEST, event, show_resources):
    if self.show_groups and event.has_key('related_groups') and event['related_groups'] <> '{}':
        return "week_group"
    sel_resources = _Resource.get_event_resource_ids(REQUEST, event.get('event_id'))
    if show_resources:
        for i in show_resources:
            if i in sel_resources:
                return "week_res"
    event_related = _Utils.sql_parse_array(REQUEST, event.get('related_persons'))
    if REQUEST.USER.get_id() != event.get('creator_id'):
        if REQUEST.USER.get_id() not in event_related:
            return "week_notrel"
        else:
            return "week_rel"
    else:
        return "week_my"

def index(REQUEST):
    output = []
    BASE_CALENDAR_URL = _Conf.BASE_CALENDAR_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    colour = Colour(REQUEST)
    if REQUEST.form.has_key('show_users_list'):
        loc = u"%sday.py/users_list" % (_Conf.BASE_CALENDAR_URL)
        REQUEST.mod_req.headers_out["Location"] = loc.encode('UTF8')
        return apache.HTTP_MOVED_TEMPORARILY

    if REQUEST.form.has_key('show_users'):
        REQUEST.del_setting('cal_show_users')
        REQUEST.del_setting('cal_show_resources')
        REQUEST.del_setting('cal_show_groups')

    formstring = REQUEST.get_formstring(['qs', 'show_users'])
    returl = urllib.quote("%sweek.py%s" % (BASE_CALENDAR_URL, formstring))

    tls_resources = REQUEST.TLS('tls_resources')
    REQUEST.db.execute("""SELECT r.resource_id, r.resource_name FROM items i, resources r WHERE r.resource_id=i.item_id""".encode('UTF8'))
    resos = REQUEST.db.dictfetchall()
    resources = {}
    for row in resos:
        resources[row['resource_id']]=row['resource_name']

    try:
        show_users = REQUEST.get_setting('cal_show_users')
    except:
        show_users = None
    try:
        show_resources = REQUEST.get_setting('cal_show_resources')
    except:
        show_resources = None
    try:
        show_groups = REQUEST.get_setting('cal_show_groups')
    except:
        show_groups = None

    if show_groups:
        dic = {}
        REQUEST.db.execute("""SELECT members from calendar_groups where group_id in (%s)""" % ",".join(map(str, show_groups)))
        group_members = map(lambda x:_Utils.sql_parse_array(REQUEST, x[0]), REQUEST.db.fetchall())
        for gr in group_members:
            for member in gr:
                dic[member]=1
        group_members = dic.keys()
        if show_users:
            show_users+=group_members
        else:
            show_users=group_members

    output.append(standard_html.html_header(REQUEST))
    output.append(get_calendar_menu(REQUEST,MY_MENU_ID))
    output.append(standard_html.window_script(height=670,width=550))
    output.append(u"""\
<DIV id="overDiv" style="position:absolute; visibility:hidden; z-index:1000;"></DIV>
<SCRIPT language="JavaScript" type="text/javascript" src="%soverlib.js"><!-- overLIB (c) Erik Bosrup --></SCRIPT>
<TABLE width="99%%" border=0 cellpadding=0 cellspacing=0>
  <TR>
    <TD><img src="%sspacer.gif" width=20 height=1 border=0 alt=""></TD>""" % (_Conf.BASE_WEB_URL, _Conf.BASE_ICON_URL))


    if REQUEST.form.has_key('date'):
        try:
            year, month, day = map(int, REQUEST.form['date'].value.decode('UTF8').split('-'))
        except:
            raise RuntimeError, REQUEST.TLS('tls_invdateformat')
        data = _calendar.WeekHandler(REQUEST, year, month, day, show_users, show_resources=show_resources)
    else:
        data = _calendar.WeekHandler(REQUEST, show_users=show_users, show_resources=show_resources)

    data.load(REQUEST)

    ###
    # Main contents
    ###
    output.append(u"""<TD style="width: 100%; vertical-align: top; border: none">""")

    ns = {}
    year = int(data.active_week[0].year)
    month = int(data.active_week[0].month)
    day = int(data.active_week[0].day)
    currday = mx.DateTime.DateTime(year, month, day)
    prev = currday-7
    next = currday+7
    prevdate = '%04d-%02d-%02d' % (prev.year, prev.month, prev.day)
    nextdate = '%04d-%02d-%02d' % (next.year, next.month, next.day)
    tls_prev = REQUEST.TLS('cal_prevweek')
    tls_next = REQUEST.TLS('cal_nextweek')
    month_name = "%s %s - %s %s" % (data.active_week[0].day, REQUEST.TLS('month_%d' % data.active_week[0].month), data.active_week[6].day, REQUEST.TLS('month_%d' % data.active_week[6].month))
    output.append(u"""
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
<TR style="height: 40px">
  <TD width="50%%" align="right"><A href="%(BASE_CALENDAR_URL)sweek.py?date=%(prevdate)s"><IMG title="%(tls_prev)s" src="%(BASE_ICON_URL)sarr1.gif" width="11" height="16" border="0" alt=""></A></TD>
  <TD nowrap align="center" style="font-weight: bold; font-size: 16px;">&nbsp;&nbsp;%(month_name)s&nbsp;&nbsp;</TD>
  <TD width="50%%" align="left"><A href="%(BASE_CALENDAR_URL)sweek.py?date=%(nextdate)s"><IMG title="%(tls_next)s" src="%(BASE_ICON_URL)sarr2.gif" width="11" height="16" border="0" alt=""></A></TD>
</TR>
</TABLE>
<TABLE border=0 cellpadding=0 cellspacing=0  width="100%%">
<TR>
  <TD>&nbsp;</TD>""" % locals())
    for i in range(len(data.active_week)):
        day = data.active_week[i]
        day_short = REQUEST.TLS("cal_short_"+str(i+1))
        output.append(u"""
<TD width="14%%" align="center" class="calendar_week4">
%s&nbsp;%s
</TD>"""% (day_short, day.name))
    for i in range(len(data.active_week[0].events)):
        output.append(u"""<TR valign="top" bgcolor="#FFFFFF">""")
        output.append(u"""
  <TD class="calendar_week1">%02d:%02d</TD>""" % (data.active_week[0].events[i][0], data.active_week[0].events[i][1]))
        for day in data.active_week:
            output.append(u"""
  <TD class="calendar_week2" onmouseover="this.style.backgroundColor='#F0F5FB';" onmouseout="this.style.backgroundColor='#FFFFFF';" onclick="window.location='addevent.py?year=%d&month=%d&day=%d&hour=%d&returl=%s';">""" % (day.year, day.month, day.day, data.active_week[0].events[i][0], returl))
            if day.events[i][2]:
                for event in day.events[i][2]:
                    if event['real_start_stamp'] and event['real_end_stamp']:
                        if event['real_start_stamp'].year <> event['real_end_stamp'].year or \
                           event['real_start_stamp'].month <> event['real_end_stamp'].month or \
                           event['real_start_stamp'].day <> event['real_end_stamp'].day:
                            timestr = u"<B>%s:</B> %s <B>%s:</B> %s" % (REQUEST.TLS('cal_start'), REQUEST.iso2userdatetime(REQUEST, event['real_start_stamp'], is_utc=0), REQUEST.TLS('cal_end'), REQUEST.iso2userdatetime(REQUEST, event['real_end_stamp'], is_utc=0))
                        else:
                            timestr = u"<B>%s:</B> %s <B>%s:</B> %s" % (REQUEST.TLS('cal_start'), REQUEST.iso2usertime(REQUEST, event['real_start_stamp'], is_utc=0), REQUEST.TLS('cal_end'), REQUEST.iso2usertime(REQUEST, event['real_end_stamp'], is_utc=0))
                    elif event['real_start_stamp']:
                        if event['real_start_stamp'].year <> event['start_stamp'].year or \
                           event['real_start_stamp'].month <> event['start_stamp'].month or \
                           event['real_start_stamp'].day <> event['start_stamp'].day:
                            timestr = u"<B>%s:</B> %s" % (REQUEST.TLS('cal_start'), REQUEST.USER.iso2userdatetime(REQUEST, event['start_stamp'], is_utc=0))
                        else:
                            timestr = u"<B>%s:</B> %s" % (REQUEST.TLS('cal_start'), REQUEST.USER.iso2usertime(REQUEST, event['start_stamp'], is_utc=0))
                    else:
                        timestr = ""
                    reminder = event.get('remind_type')
                    d_name = event['event_name'].decode('UTF8').replace("'", "\\'").replace('"','&quot;').replace("<", "").replace(">", "")
                    if event['description'] is None or not event['description']: description = ""
                    else:
                        description = u"""<B>%s:</B> %s""" % (REQUEST.TLS('tls_description'), _Utils.newline2br(event['description'].decode('UTF8').replace("'", "\\'").replace('"','&quot;').replace("<", "").replace(">", "")))
                    if event['creator_id'] <> REQUEST.USER.get_id():
                        description += u'<br><B>%s:</B> %s' % (REQUEST.TLS('tls_creator'), event['creator_name'].decode('UTF8'))
                    tls_title = REQUEST.TLS('tls_title')
                    tls_desc = REQUEST.TLS('tls_description')
                    
                    persons_out = []
                    event_related = _Utils.sql_parse_array(REQUEST, event.get('related_persons'))
                    event_relgroups = _Utils.sql_parse_array(REQUEST, event.get('related_groups'))
                    REQUEST.su_by_id(_Conf.SUPERUSER)
                    for person_id in event_related:
                        try:
                            rel_per = _RootObject.dispatch_item(REQUEST, person_id)
                            persons_out.append(rel_per.get_name())
                        except _Exceptions.RootObjectError:
                            rel_per = ""
                            pass
                        del rel_per
                    REQUEST.unsu()
                    related_persons = ", ".join(persons_out)
                    del persons_out
                    persons_out = u""
                    if related_persons:
                        tls_invpersons = REQUEST.TLS('cal_invitedpersons')
                        persons_out = u"""<BR><B>%(tls_invpersons)s:</b> %(related_persons)s""" % locals()



                    REQUEST.db.execute("""SELECT group_id, group_name from calendar_groups where parent_id=%d""" % (event.get('creator_id')))
                    related_groups = REQUEST.db.dictfetchall()
                    relcount = len(related_groups)
                    group_tmp = []
                    for group_id in related_groups:
                        if group_id['group_id'] in event_relgroups:
                            group_tmp.append("""%s""" % group_id['group_name'].decode('UTF8'))
                    related_groups = ", ".join(group_tmp)
                    groups_out = u""
                    if related_groups:
                        tls_invgroups = REQUEST.TLS('cal_invitedgroups')
                        groups_out = u"""<BR><B>%(tls_invgroups)s:</b> %(related_groups)s""" % locals()

                    event_obj = _Event.Event(REQUEST, _InitTypes.INIT_TYPE_ID, event['event_id'])
                    relation_ids = relations.get_relations(REQUEST, event_obj)
                    contact_out = ""
                    for rel in relation_ids:
                        if rel['left_type_id']==_InitTypes.ITEM_TYPE_CONTACT or rel['right_type_id']==_InitTypes.ITEM_TYPE_CONTACT:
                            if int(rel['left_item_id'])==event['event_id']:
                                contact_out = contact_out + rel['right_item_name'].decode('UTF8') + ", "
                            else:
                                contact_out = contact_out + rel['left_item_name'].decode('UTF8') + ", "
                    if contact_out:
                        contact_out = contact_out[0:-2]
                    tls_invcontacts = REQUEST.TLS('cal_invitedcontacts')
                    if contact_out:
                        contact_out = u"""<BR><B>%(tls_invcontacts)s:</b> %(contact_out)s""" % locals()

                    sel_resources = _Resource.get_event_resources(REQUEST, event['event_id'])
                    sel_resources_ids = map(lambda x: x.get_id(), sel_resources)
                    sel_resources = ""
                    for id in sel_resources_ids:
                        sel_resources += resources[id] + ", "
                    if sel_resources:
                        sel_resources = sel_resources[0:-2].decode('UTF8').replace("'", "\\'").replace('"','&quot;').replace("<", "").replace(">", "")
                        res_out = u"""<BR><B>%(tls_resources)s:</b> %(sel_resources)s""" % locals()
                    else:
                        res_out = ""
                    overdivstr = u"""\
<B>%(tls_title)s:</B> %(d_name)s<BR>\
%(timestr)s<BR>\
%(description)s\
%(persons_out)s\
%(groups_out)s\
%(contact_out)s\
%(res_out)s""" % locals()
                    output.append(u"""<A class="%s" href="%seditevent.py?event_id=%d&returl=%s" onmouseover="return overlib('%s', TEXTSIZE, '11px');" onmouseout="return nd();">%s</A><BR>""" % (colour.get_colour_class(REQUEST, event, show_resources), _Conf.BASE_CALENDAR_URL, event['event_id'], returl, overdivstr, _Utils.shorten_string(event['event_name'].decode('UTF8').replace('&quot;','"'), 14)))
            else:
                output.append(u"""&nbsp;""")
            output.append(u"""</TD>""")
            
        output.append(u"""</TR>""")

    output.append(u"</TABLE></TD>")
    output.append(_calendar.mini_calendar(REQUEST, data, "week.py", "week.py"))
    output.append(u"</TR></TABLE>")
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)
