# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

import standard_html
import _InitTypes, _Conf, _Utils, Menus

import _Contact, _RootObject, _Email, _Efolder, _Access, _Usernote, _Log
import relations
import mx.DateTime
import urllib

MY_MENU_ID = -1

def index(REQUEST):
    if not REQUEST.form.has_key('contact_id') or not REQUEST.form['contact_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    contact_id = REQUEST.form['contact_id'].value
    if REQUEST.form.has_key('_edit'):
        return edit_contents(REQUEST)
    elif REQUEST.form.has_key('rel'):
        return relations_contents(REQUEST)
    elif REQUEST.form.has_key('email'):
        return emails_contents(REQUEST)
    elif REQUEST.form.has_key('note'):
        return notes_contents(REQUEST)
    elif REQUEST.form.has_key('log'):
        return show_log(REQUEST, REQUEST.form['contact_id'].value)
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_contact_menu(REQUEST, MY_MENU_ID))
    contact_obj = _Contact.Contact(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['contact_id'].value))

    if contact_obj.get('creator_id') <> REQUEST.USER.get_id():
        contact_is_private = u""
    elif contact_obj.get('is_private'):
        contact_is_private = u"""  <TR class="tr_listing1">
    <TD><img src="%sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD><img src="%sspacer.gif" width=2 height=1 border=0 alt=""></TD>
    <TD class="td_listing1">%s</TD>
    <TD class="td_listing1" colspan="2"><INPUT type="checkbox" name="contact_is_private" CHECKED></TD>
  </TR>""" % (_Conf.BASE_ICON_URL, _Conf.BASE_ICON_URL, REQUEST.TLS('tls_private'))
    else:
        contact_is_private = u"""  <TR class="tr_listing1">
    <TD><img src="%sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD><img src="%sspacer.gif" width=2 height=1 border=0 alt=""></TD>
    <TD class="td_listing1">%s</TD>
    <TD class="td_listing1" colspan="2"><INPUT type="checkbox" name="contact_is_private"></TD>
  </TR>""" % (_Conf.BASE_ICON_URL, _Conf.BASE_ICON_URL, REQUEST.TLS('tls_private'))
    contact_id = contact_obj.get_id()
    first_name = _Utils.html_quote(contact_obj.get('first_name'))
    last_name = _Utils.html_quote(contact_obj.get('last_name'))
    middle_name = _Utils.html_quote(contact_obj.get('middle_name') or '')
    company = _Utils.html_quote(contact_obj.get('company') or '')
    department = _Utils.html_quote(contact_obj.get('department') or '')
    jobtitle = _Utils.html_quote(contact_obj.get('jobtitle') or '')
    phone_work = _Utils.html_quote(contact_obj.get('phone_work') or '')
    phone_home = _Utils.html_quote(contact_obj.get('phone_home') or '')
    phone_cell = _Utils.html_quote(contact_obj.get('phone_cell') or '')
    phone_fax = _Utils.html_quote(contact_obj.get('phone_fax') or '')
    e_mail = _Utils.html_quote(contact_obj.get('e_mail') or '')
    e_mail2 = _Utils.html_quote(contact_obj.get('e_mail2') or '')
    e_mail3 = _Utils.html_quote(contact_obj.get('e_mail3') or '')
    mailing_address = _Utils.html_quote(contact_obj.get('mailing_address') or '')
    description = _Utils.html_quote(contact_obj.get('description') or '')
    homepage = _Utils.html_quote(contact_obj.get('homepage') or '')
    if e_mail:
        e_mail = """<a href="%scompose.py?mail_to=%s%%20%s%%20<%s>">%s</a>""" % (_Conf.BASE_EMAIL_URL, first_name, last_name, e_mail, e_mail)
    if e_mail:
        e_mail2 = """<a href="%scompose.py?mail_to=%s%%20%s%%20<%s>">%s</a>""" % (_Conf.BASE_EMAIL_URL, first_name, last_name, e_mail2, e_mail2)
    if e_mail:
        e_mail3 = """<a href="%scompose.py?mail_to=%s%%20%s%%20<%s>">%s</a>""" % (_Conf.BASE_EMAIL_URL, first_name, last_name, e_mail3, e_mail3)

    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_first_name = REQUEST.TLS('tls_first_name')
    tls_last_name = REQUEST.TLS('tls_last_name')
    tls_middle_names = REQUEST.TLS('tls_middle_names')
    tls_company = REQUEST.TLS('contact_company')
    tls_department = REQUEST.TLS('contact_department')
    tls_job = REQUEST.TLS('contact_job')
    tls_phone_work = REQUEST.TLS('tls_phone_work')
    tls_phone_cell = REQUEST.TLS('tls_phone_cell')
    tls_phone_home = REQUEST.TLS('tls_phone_home')
    tls_phone_fax = REQUEST.TLS('tls_phone_fax')
    tls_email = REQUEST.TLS('tls_email')
    tls_email2 = REQUEST.TLS('tls_email') + " #2"
    tls_email3 = REQUEST.TLS('tls_email') + " #3"
    tls_category = REQUEST.TLS('tls_category')
    tls_dateofbirth = REQUEST.TLS('contact_dateofbirth')
    tls_sex = REQUEST.TLS('contact_sex')
    tls_private = REQUEST.TLS('tls_private')
    tls_address = REQUEST.TLS('contact_address')
    tls_description = REQUEST.TLS('tls_description')
    tls_edit = REQUEST.TLS('tls_edit')
    tls_description = REQUEST.TLS('tls_description')
    tls_viewcontact = REQUEST.TLS('contact_viewcontact')
    tls_homepage = REQUEST.TLS('contact_homepage')
    tls_male = REQUEST.TLS('contact_male')
    tls_female = REQUEST.TLS('contact_female')
    tls_invdateformat = REQUEST.TLS('tls_invdateformat')
    datecheck_js = REQUEST.datecheck_js(REQUEST)

    
    contact_category = contact_obj.get('contact_category') or ''
    contact_category = _Utils.make_setting_selection(REQUEST, contact_obj, 'contact_category', 'contact_categories', is_multiple=1, read_only=1)
    contact_sex = [u""""""]
    sexes = [u"&nbsp;&nbsp;", u"%(tls_male)s"%locals(), u"%(tls_female)s"%locals()]
    i = contact_obj.get('contact_sex')
    for j in range(3):
        if i == j:
            contact_sex.append(u"""%s""" % (sexes[j]))
    contact_sex = "\n".join(contact_sex)

    birth_date = contact_obj.get('birth_date')
    if birth_date:
        birth_date = REQUEST.iso2userdate(birth_date)
    else:
        birth_date = ''

    BASE_CONTACT_URL = _Conf.BASE_CONTACT_URL
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    REQ_FIELD = _Conf.REQ_FIELD
    BASE_ICON_URL = _Conf.BASE_ICON_URL


    menu = menu_output(REQUEST, contact_obj)
    output.append("""\
<SCRIPT type="text/JavaScript">
<!--
function cal_popup(url, fieldname)
{
    window.date_result = document.editform[fieldname];
    window.open(url,'popupcal','width=170,height=150,scrollbars=no');
}
  function check_values()
  {
    if (!document.editform.first_name.value || !document.editform.last_name.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
%(datecheck_js)s
// -->   
</SCRIPT>
<TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
<FORM name="editform" method="POST" action="%(BASE_CONTACT_URL)scontactedit.py">
<INPUT type="hidden" name="contact_id" value="%(contact_id)s">
  <TR class="tr_listing0">
    <TD colspan=5>%(menu)s</TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing1b" width="15%%">%(tls_first_name)s:</TD>
    <TD class="td_listing1" width="25%%">%(first_name)s</TD>
    <TD class="td_listing1b" width="15%%">%(tls_company)s:</TD>
    <TD class="td_listing1" width="45%%">%(company)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing0b">%(tls_middle_names)s:</TD>
    <TD class="td_listing0">%(middle_name)s&nbsp;</TD>
    <TD class="td_listing0b">%(tls_department)s:</TD>
    <TD class="td_listing0">%(department)s&nbsp;</TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing1b">%(tls_last_name)s:</TD>
    <TD class="td_listing1">%(last_name)s&nbsp;</TD>
    <TD class="td_listing1b">%(tls_job)s:</TD>
    <TD class="td_listing1">%(jobtitle)s&nbsp;</TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing0b">%(tls_phone_work)s:</TD>
    <TD class="td_listing0">%(phone_work)s&nbsp;</TD>
    <TD class="td_listing0b">%(tls_email)s:</TD>
    <TD class="td_listing0">%(e_mail)s&nbsp;</TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing1b">%(tls_phone_fax)s:</TD>
    <TD class="td_listing1">%(phone_fax)s&nbsp;</TD>
    <TD class="td_listing1b">%(tls_email2)s:</TD>
    <TD class="td_listing1">%(e_mail2)s&nbsp;</TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing0b">%(tls_phone_home)s:</TD>
    <TD class="td_listing0">%(phone_home)s&nbsp;</TD>
    <TD class="td_listing0b">%(tls_email3)s:</TD>
    <TD class="td_listing0">%(e_mail3)s&nbsp;</TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing1b">%(tls_phone_cell)s:</TD>
    <TD class="td_listing1">%(phone_cell)s&nbsp;</TD>
    <TD class="td_listing1b">%(tls_homepage)s:</TD>
    <TD class="td_listing1">%(homepage)s&nbsp;</TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing0b">%(tls_address)s:</TD>
    <TD class="td_listing0">%(mailing_address)s&nbsp;</TD>
    <TD class="td_listing0b">%(tls_description)s:</TD>
    <TD class="td_listing0">%(description)s&nbsp;</TD>
  </TR>
  <TR class="tr_listing1" valign="top">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD colspan=2>
      <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
        <TR>
          <TD class="td_listing1b" width="40%%">%(tls_dateofbirth)s:</TD>
          <TD class="td_listing1" width="60%%">%(birth_date)s&nbsp;</TD>
        </TR>
        <TR>
          <TD class="td_listing1b" width="40%%">%(tls_sex)s:</TD>
          <TD class="td_listing1" width="60%%">%(contact_sex)s&nbsp;</TD>
        </TR>
      </TABLE>
    </TD>
    <TD class="td_listing1b">%(tls_category)s:</TD>
    <TD class="td_listing1">%(contact_category)s&nbsp;</TD>
  </TR>""" % locals())
    if _Access.get_item_right(REQUEST, contact_obj.get_id(), REQUEST.USER.get_id()) >= _Access.ACCESS_WRITE:
        output.append(u"""
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=25 border=0 alt=""></TD>
    <TD class="td_listing0" colspan="4"><INPUT type="submit" name="_edit" value="%(tls_edit)s" class="input2"></TD>
  </TR>
</TABLE>
</FORM>"""%locals())
    else:
        output.append(u"""
</TABLE>
</FORM>"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def edit_contents(REQUEST):
    if not REQUEST.form.has_key('contact_id') or not REQUEST.form['contact_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')

    output = []
    output.append(standard_html.html_header(REQUEST, '<link rel="stylesheet" type="text/css" media="all" href="%sjscalendar/calendar-blue.css" />' % _Conf.BASE_WEB_URL))
    output.append(Menus.get_contact_menu(REQUEST, MY_MENU_ID))
    contact_obj = _Contact.Contact(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['contact_id'].value))
    menu = menu_output(REQUEST, contact_obj)
    if contact_obj.get('creator_id') <> REQUEST.USER.get_id():
        contact_is_private = u""
    elif contact_obj.get('is_private'):
        contact_is_private = u"""
    <TR class="tr_listing1">
      <TD class="td_listing1">%s</TD>
      <TD class="td_listing1"><INPUT type="checkbox" name="contact_is_private" CHECKED></TD>
    </TR>""" % (REQUEST.TLS('tls_private'))
    else:
        contact_is_private = u"""
    <TR class="tr_listing1">
      <TD class="td_listing1">%s</TD>
      <TD class="td_listing1"><INPUT type="checkbox" name="contact_is_private"></TD>
    </TR>""" % (REQUEST.TLS('tls_private'))
    contact_id = contact_obj.get_id()
    first_name = _Utils.html_quote(contact_obj.get('first_name'))
    last_name = _Utils.html_quote(contact_obj.get('last_name'))
    middle_name = _Utils.html_quote(contact_obj.get('middle_name') or '')
    company = _Utils.html_quote(contact_obj.get('company') or '')
    department = _Utils.html_quote(contact_obj.get('department') or '')
    jobtitle = _Utils.html_quote(contact_obj.get('jobtitle') or '')
    phone_work = _Utils.html_quote(contact_obj.get('phone_work') or '')
    phone_home = _Utils.html_quote(contact_obj.get('phone_home') or '')
    phone_cell = _Utils.html_quote(contact_obj.get('phone_cell') or '')
    phone_fax = _Utils.html_quote(contact_obj.get('phone_fax') or '')
    e_mail = _Utils.html_quote(contact_obj.get('e_mail') or '')
    e_mail2 = _Utils.html_quote(contact_obj.get('e_mail2') or '')
    e_mail3 = _Utils.html_quote(contact_obj.get('e_mail3') or '')
    mailing_address = _Utils.html_quote(contact_obj.get('mailing_address') or '')
    description = _Utils.html_quote(contact_obj.get('description') or '')
    homepage = _Utils.html_quote(contact_obj.get('homepage') or '')

    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_first_name = REQUEST.TLS('tls_first_name')
    tls_last_name = REQUEST.TLS('tls_last_name')
    tls_middle_names = REQUEST.TLS('tls_middle_names')
    tls_company = REQUEST.TLS('contact_company')
    tls_department = REQUEST.TLS('contact_department')
    tls_job = REQUEST.TLS('contact_job')
    tls_phone_work = REQUEST.TLS('tls_phone_work')
    tls_phone_cell = REQUEST.TLS('tls_phone_cell')
    tls_phone_home = REQUEST.TLS('tls_phone_home')
    tls_phone_fax = REQUEST.TLS('tls_phone_fax')
    tls_email = REQUEST.TLS('tls_email')
    tls_email2 = REQUEST.TLS('tls_email') + " #2"
    tls_email3 = REQUEST.TLS('tls_email') + " #3"
    tls_category = REQUEST.TLS('tls_category')
    tls_dateofbirth = REQUEST.TLS('contact_dateofbirth')
    tls_sex = REQUEST.TLS('contact_sex')
    tls_private = REQUEST.TLS('tls_private')
    tls_address = REQUEST.TLS('contact_address')
    tls_description = REQUEST.TLS('tls_description')
    tls_save = REQUEST.TLS('tls_save')
    tls_description = REQUEST.TLS('tls_description')
    tls_editcontact = REQUEST.TLS('contact_editcontact')
    tls_homepage = REQUEST.TLS('contact_homepage')
    tls_male = REQUEST.TLS('contact_male')
    tls_female = REQUEST.TLS('contact_female')
    tls_invdateformat = REQUEST.TLS('tls_invdateformat')
    datecheck_js = REQUEST.datecheck_js(REQUEST)
    BASE_WEB_URL = _Conf.BASE_WEB_URL
    dformat = _Utils.dateformat2jscalformat(REQUEST)
    lformat = _Utils.lang2jscalformat(REQUEST)
    output.append(u"""<script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/calendar.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/lang/calendar-%(lformat)s.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/cal_setup.js"></script>""" % locals())
    
    contact_category = contact_obj.get('contact_category') or ''
    contact_category = _Utils.make_setting_selection(REQUEST, contact_obj, 'contact_category', 'contact_categories', is_multiple=1)
    contact_sex = [u"""<SELECT name="contact_sex">"""]
    sexes = [u"&nbsp;&nbsp;", u"%(tls_male)s"%locals(), u"%(tls_female)s"%locals()]
    i = contact_obj.get('contact_sex')
    for j in range(3):
        if i == j:
            contact_sex.append(u"""<OPTION value="%d" SELECTED>%s""" % (j, sexes[j]))
        else:
            contact_sex.append(u"""<OPTION value="%d">%s""" % (j, sexes[j]))
    contact_sex.append(u"</SELECT>")
    contact_sex = "\n".join(contact_sex)

    birth_date = contact_obj.get('birth_date')
    if birth_date:
        birth_date = REQUEST.iso2userdate(birth_date)
    else:
        birth_date = ''

    BASE_CONTACT_URL = _Conf.BASE_CONTACT_URL
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    REQ_FIELD = _Conf.REQ_FIELD
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    output.append("""\
<SCRIPT type="text/JavaScript">
<!--
function cal_popup(url, fieldname)
{
    window.date_result = document.editform[fieldname];
    window.open(url,'popupcal','width=170,height=150,scrollbars=no');
}
  function check_values()
  {
    if (!document.editform.first_name.value || !document.editform.last_name.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
%(datecheck_js)s
// -->   
</SCRIPT>
<TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
<FORM name="editform" method="POST" action="%(BASE_CONTACT_URL)scontactedit.py/edit" onsubmit="return check_values();">
<INPUT type="hidden" name="contact_id" value="%(contact_id)s">
  <TR class="tr_listing0">
    <TD colspan=6>%(menu)s</TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_first_name)s%(REQ_FIELD)s</TD>
    <TD class="td_listing1"><INPUT type="text" class="textfield4" name="first_name" value="%(first_name)s"></TD>
    <TD class="td_listing1">%(tls_company)s</TD>
    <TD class="td_listing1"><INPUT type="text" class="textfield4" name="company" value="%(company)s"></TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_middle_names)s</TD>
    <TD class="td_listing0"><INPUT type="text" class="textfield4" name="middle_name" value="%(middle_name)s"></TD>
    <TD class="td_listing0">%(tls_department)s</TD>
    <TD class="td_listing0"><INPUT type="text" class="textfield4" name="department" value="%(department)s"></TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_last_name)s%(REQ_FIELD)s</TD>
    <TD class="td_listing1"><INPUT type="text" class="textfield4" name="last_name" value="%(last_name)s"></TD>
    <TD class="td_listing1">%(tls_job)s</TD>
    <TD class="td_listing1"><INPUT type="text" class="textfield4" name="jobtitle" value="%(jobtitle)s"></TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_phone_work)s</TD>
    <TD class="td_listing0"><INPUT type="text" class="textfield4" name="phone_work" value="%(phone_work)s"></TD>
    <TD class="td_listing0">%(tls_email)s</TD>
    <TD class="td_listing0"><INPUT type="text" class="textfield4" name="e_mail" value="%(e_mail)s"></TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_phone_fax)s</TD>
    <TD class="td_listing1"><INPUT type="text" class="textfield4" name="phone_fax" value="%(phone_fax)s"></TD>
    <TD class="td_listing1">%(tls_email2)s</TD>
    <TD class="td_listing1"><INPUT type="text" class="textfield4" name="e_mail2" value="%(e_mail2)s"></TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_phone_home)s</TD>
    <TD class="td_listing0"><INPUT type="text" class="textfield4" name="phone_home" value="%(phone_home)s"></TD>
    <TD class="td_listing0">%(tls_email3)s</TD>
    <TD class="td_listing0"><INPUT type="text" class="textfield4" name="e_mail3" value="%(e_mail3)s"></TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_phone_cell)s</TD>
    <TD class="td_listing1"><INPUT type="text" class="textfield4" name="phone_cell" value="%(phone_cell)s"></TD>
    <TD class="td_listing1">%(tls_homepage)s</TD>
    <TD class="td_listing1"><INPUT type="text" class="textfield4" name="homepage" value="%(homepage)s"></TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing0" valign="top">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" colspan="2">%(tls_address)s<BR><TEXTAREA class="textarea5" name="mailing_address" rows="8" cols="40">%(mailing_address)s</TEXTAREA></TD>
    <TD class="td_listing0" colspan="2">%(tls_description)s<BR><TEXTAREA class="textarea5" name="description" rows="8" cols="40">%(description)s</TEXTAREA></TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD colspan=2>
      <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
        <TR>
          <TD class="td_listing1">%(tls_dateofbirth)s</TD>
          <TD class="td_listing1" colspan="2"><INPUT size="10" type="text" class="textfield1" name="birth_date" id="birth_date" value="%(birth_date)s" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }"> <A href="javascript:void(0);" OnClick="return showCalendar('birth_date', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt=""></A></TD>
        </TR>
        <TR>
          <TD class="td_listing1">%(tls_sex)s</TD>
          <TD class="td_listing1" colspan="2">%(contact_sex)s</TD>
        </TR>
        %(contact_is_private)s
      </TABLE>
    </TD>
    <TD class="td_listing1">%(tls_category)s</TD>
    <TD class="td_listing1" colspan="2">%(contact_category)s</TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" colspan="4"><INPUT type="submit" name="_save" value="%(tls_save)s" class="input2"></TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
</TABLE>
</FORM>
<BR>"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def edit(REQUEST):
    if not REQUEST.form.has_key('contact_id') or not REQUEST.form['contact_id'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_contact_menu(REQUEST, MY_MENU_ID))

    contact_obj = _Contact.Contact(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['contact_id'].value))

    if not REQUEST.form.has_key('first_name') or not REQUEST.form.has_key('last_name') or \
       not REQUEST.form['first_name'].value.decode('UTF8').strip() or not REQUEST.form['last_name'].value.decode('UTF8').strip():
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')

    contact_obj.load_req()
    if REQUEST.form.has_key('contact_category') and isinstance(REQUEST.form['contact_category'], list) and REQUEST.form['contact_category']:
        contact_obj.set('contact_category', u"|%s|" % "|".join(map(lambda x:x.decode('UTF8'), REQUEST.form['contact_category'])))
    elif REQUEST.form.has_key('contact_category') and not isinstance(REQUEST.form['contact_category'], list) and REQUEST.form['contact_category'].value.decode('UTF8'):
        contact_obj.set('contact_category', u"|%s|" % REQUEST.form['contact_category'].value.decode('UTF8'))
    else:
        contact_obj.set('contact_category', u"")

    if contact_obj.get('creator_id') == REQUEST.USER.get_id():
        if REQUEST.form.has_key('contact_is_private'):
            contact_obj.set('is_private', 1)
            contact_obj.set('parent_id', REQUEST.USER.get_id())
        else:
            contact_obj.set('is_private', 0)
            if REQUEST.USER.get_id() == contact_obj.get_parent_id():
                contact_obj.set('parent_id', REQUEST.USER.get_parent_id(REQUEST))
    if REQUEST.form.has_key('birth_date') and REQUEST.form['birth_date'].value.decode('UTF8').strip():
        contact_obj.set('birth_date', REQUEST.user2isodate(REQUEST, REQUEST.form['birth_date'].value.decode('UTF8').strip()))
    else:
        contact_obj.set('birth_date', None)
    contact_obj.save()
    ref_url = REQUEST.SERVER_URL+_Conf.BASE_CONTACT_URL+"contactedit.py?contact_id="+str(contact_obj.get_id())
    output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(REQUEST.TLS('contact_saved'))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def relations_contents(REQUEST):
    if not REQUEST.form.has_key('contact_id') or not REQUEST.form['contact_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    contact_id = REQUEST.form['contact_id'].value
    contact_obj = _Contact.Contact(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['contact_id'].value))
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_CONTACT_URL = _Conf.BASE_CONTACT_URL
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_contact_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST, contact_obj)
    output.append(" " + menu)
    contact_obj = _Contact.Contact(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['contact_id'].value))
    relation_output = relations.show_relations(REQUEST, contact_obj)
    output.append(relation_output)
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def emails_contents(REQUEST):
    if not REQUEST.form.has_key('contact_id') or not REQUEST.form['contact_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    contact_id = REQUEST.form['contact_id'].value
    contact_obj = _Contact.Contact(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['contact_id'].value))
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_CONTACT_URL = _Conf.BASE_CONTACT_URL
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_contact_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST, contact_obj)
    contact_obj = _Contact.Contact(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['contact_id'].value))
    contact_email = _Utils.sql_quote_simple((contact_obj.get('e_mail') or '').lower())
    contact_email2 = _Utils.sql_quote_simple((contact_obj.get('e_mail2') or '').lower())
    contact_email3 = _Utils.sql_quote_simple((contact_obj.get('e_mail3') or '').lower())

    tls_folders = REQUEST.TLS('tls_folders')
    tls_active = REQUEST.TLS('tls_active')
    tls_from = REQUEST.TLS('email_from')
    tls_to = REQUEST.TLS('email_to')
    tls_subject = REQUEST.TLS('tls_subject')
    tls_size = REQUEST.TLS('size')
    tls_date = REQUEST.TLS('tls_date')
    tls_createnew = REQUEST.TLS('email_createnew')
    tls_deletefolder = REQUEST.TLS('email_deletefolder')
    tls_short_newmail = REQUEST.TLS('email_short_newmail')
    tls_short_attach = REQUEST.TLS('email_short_attach')
    tls_corresp = REQUEST.TLS('contact_corresp') %  _Utils.html_quote_show(contact_obj.get('item_name'))

    output.append(u"""
<TABLE border=0 cellpadding=0 cellspacing=0 width="100%%">
<TR>
  <TD colspan="3">%(menu)s</TD>
</TR>
<TR class="tr_listing1">
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=20 border=0 alt=""></TD>
  <TD class="td_listing1b" width="100%%" colspan="2">%(tls_corresp)s:</TD>
</TR>
<TR class="tr_listing0">
  <TD colspan="3">&nbsp;</TD>
</TR>
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=18 height=1 border=0 alt=""></TD>
  <TD width="100%%">
<TABLE border=0 width="100%%" cellpadding=3 cellspacing=0 bgcolor="#FAFAFA">
 <TR class="email_contentsb" bgcolor="#EEEEEE">
  <TH nowrap style="border-bottom: 1px solid #AAAAAA; border-right: 1px solid #AAAAAA; border-top: 1px solid #AAAAAA; border-left: 1px solid #AAAAAA" nowrap><IMG src="%(BASE_ICON_URL)sspacer.gif" width=2 height=1 border=0 alt="">%(tls_short_attach)s<IMG src="%(BASE_ICON_URL)sspacer.gif" width=2 height=1 border=0 alt=""></TH>
  <TH nowrap style="border-bottom: 1px solid #AAAAAA; border-right: 1px solid #AAAAAA; border-top: 1px solid #AAAAAA;">%(tls_short_newmail)s</TH>
  <TH nowrap style="border-bottom: 1px solid #AAAAAA; border-right: 1px solid #AAAAAA; border-top: 1px solid #AAAAAA;" width="25%%">%(tls_from)s</TH>
  <TH nowrap style="border-bottom: 1px solid #AAAAAA; border-right: 1px solid #AAAAAA; border-top: 1px solid #AAAAAA;" width="25%%">%(tls_to)s</TH>
  <TH nowrap style="border-bottom: 1px solid #AAAAAA; border-right: 1px solid #AAAAAA; border-top: 1px solid #AAAAAA;" width="50%%">%(tls_subject)s</TH>
  <TH nowrap style="border-bottom: 1px solid #AAAAAA; border-right: 1px solid #AAAAAA; border-top: 1px solid #AAAAAA;" align="center">%(tls_date)s</TH>
  <TH nowrap style="border-bottom: 1px solid #AAAAAA; border-right: 1px solid #AAAAAA; border-top: 1px solid #AAAAAA; padding: 5px;">%(tls_size)s</TH>
 </TR>""" % locals())

    # We want to exclude messages in deleted items and drafts, so we will have to select efolder_id'd for these.
    deleted_items = 0
    drafts = 0
    REQUEST.db.execute("""SELECT e.*, i.* FROM items i, efolders e WHERE e.efolder_id=i.item_id AND i.parent_id=%d ORDER by efolder_id ASC""" % REQUEST.USER.get_id())
    result = REQUEST.db.dictfetchall()
    for i in range(len(result)):
        temp = result[i]
        if temp.get('efolder_flags') & _Efolder.EFOLDER_DELETED:
            deleted_items = result[i]['efolder_id']
        if temp.get('efolder_flags') & _Efolder.EFOLDER_DRAFTS:
            drafts = result[i]['efolder_id']
    if contact_email or contact_email2 or contact_email3:
        str_email1 = ""
        str_email2 = ""
        str_email3 = ""
        if contact_email:
            str_email1 = "lower(email_from) like '%%%s%%' or lower(email_from_addr) like '%%%s%%' or lower(email_from_addr) like '%%%s%%' " % (contact_email, contact_email, contact_email)
        if contact_email2:
            str_email2 = "lower(email_from) like '%%%s%%' or lower(email_from_addr) like '%%%s%%' or lower(email_from_addr) like '%%%s%%' " % (contact_email2, contact_email2, contact_email2)
        if contact_email3:
            str_email3 = "lower(email_from) like '%%%s%%' or lower(email_from_addr) like '%%%s%%' or lower(email_from_addr) like '%%%s%%' " % (contact_email3, contact_email3, contact_email3)
        str_email = " or ".join(filter(None, [str_email1, str_email2, str_email3]))
        SQL = ("""SELECT e.*, i.* FROM items i, emails e WHERE item_id=email_id and item_type_id=%d and creator_id=%d and (%s) and i.parent_id not in (%d, %d) ORDER BY email_date desc""" % (_InitTypes.ITEM_TYPE_EMAIL, REQUEST.USER.get_id(), str_email, deleted_items, drafts)).encode('UTF8')
        REQUEST.db.execute(SQL)
        dbres = REQUEST.db.dictfetchall()
    else:
        dbres = []

    ns = {'BASE_EMAIL_URL':_Conf.BASE_EMAIL_URL}
    ndx = 0
    for email_str in dbres:
        ns['from'] = email_str['email_from']
        ns['to'] = email_str['email_to']
        ns['subject'] = _Utils.html_quote(email_str['email_subject'])
        ns['date'] = REQUEST.iso2userdatetime(REQUEST, email_str['email_date'])
        ns['size'] = _Utils.str_size(email_str['email_size'])
        ns['ndx'] = email_str['email_id']
        if email_str['email_flags'] & _Email.EMAIL_ANSWERED:
            ns['is_new'] = '<img src="%sansmail.gif" border=0 alt="">' % _Conf.BASE_ICON_URL
            ns['start_bold'] = ''
            ns['end_bold'] = ''
        else:
            if email_str['email_flags'] & _Email.EMAIL_READ:
                ns['is_new'] = '<img src="%smail.gif" width="18" height="14" border=0 alt="">' % _Conf.BASE_ICON_URL
                ns['start_bold'] = ''
                ns['end_bold'] = ''
            else:
                ns['is_new'] = '<img src="%snewmail.gif" width="18" height="12" border=0 alt="">' % _Conf.BASE_ICON_URL
                ns['start_bold'] = '<b>'
                ns['end_bold'] = '</b>'
        if email_str['email_flags'] & _Email.EMAIL_ATTACH:
            ns['has_attachment'] = '<img src="%sattatch.gif" width=14 height=12 border=0 alt="">' % _Conf.BASE_ICON_URL
        else:
            ns['has_attachment'] = '<img src="%sspacer.gif" width=1 height=1 border=0 alt="">' % _Conf.BASE_ICON_URL
        if isinstance(ns['from'], str):
            ns['from'] = ns['from'].decode('UTF8')
        if isinstance(ns['to'], str):
            ns['to'] = ns['to'].decode('UTF8')
        if isinstance(ns['subject'], str):
            ns['subject'] = ns['subject'].decode('UTF8')
        if email_str['email_flags'] & _Email.EMAIL_PRIORITY:
            ns['ispriority'] = 'red'
        else:
            ns['ispriority'] = ''
        result = u"""\
 <TR valign="middle">
  <TD class="email_contents%(ispriority)s" style="border-bottom: 1px solid #bbbbbb; border-left: 1px solid #AAAAAA;">%(has_attachment)s</TD>
  <TD class="email_contents%(ispriority)s" style="border-bottom: 1px solid #bbbbbb;">%(is_new)s</TD>
  <TD width="25%%"                         style="border-bottom: 1px solid #bbbbbb;"><A class="email_contents%(ispriority)s" href="%(BASE_EMAIL_URL)sread.py?mail_id=%(ndx)d">%(start_bold)s%(from)s%(end_bold)s</A></TD>
  <TD width="25%%"                         style="border-bottom: 1px solid #bbbbbb;"><A class="email_contents%(ispriority)s" href="%(BASE_EMAIL_URL)sread.py?mail_id=%(ndx)d">%(start_bold)s%(to)s%(end_bold)s</A></TD>
  <TD width="50%%"                         style="border-bottom: 1px solid #bbbbbb;"><A class="email_contents%(ispriority)s" href="%(BASE_EMAIL_URL)sread.py?mail_id=%(ndx)d">%(start_bold)s%(subject)s%(end_bold)s</A>&nbsp;</TD>
  <TD class="email_contents%(ispriority)s" style="border-bottom: 1px solid #bbbbbb;" align="center">%(start_bold)s%(date)s%(end_bold)s</TD>
  <TD class="email_contents%(ispriority)s" style="border-bottom: 1px solid #bbbbbb; border-right: 1px solid #AAAAAA;"">%(start_bold)s%(size)s%(end_bold)s</TD>
 </TR>""" % ns
        output.append(result)
        ndx += 1

    output.append(u"""
</TABLE>
  </TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=25 height=1 border=0 alt=""></TD>
</TR>
<TR>
   <TD colspan=3><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=25 border=0 alt=""></TD>
</TR>
</TABLE>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def notes_contents(REQUEST):
    if not REQUEST.form.has_key('contact_id') or not REQUEST.form['contact_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    obj_id = int(REQUEST.form['contact_id'].value)
    obj = _Contact.Contact(REQUEST, _InitTypes.INIT_TYPE_ID, obj_id)
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_contact_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST, obj)
    BASE_CONTACT_URL = _Conf.BASE_CONTACT_URL
    returl = "%(BASE_CONTACT_URL)scontactedit.py?contact_id=%(obj_id)s&note=1" % locals()
    returl = urllib.quote(returl)
    show_menu = "contacts"
    output.append(_Usernote.note_out(REQUEST, obj, obj_id, returl, menu, show_menu))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def menu_output(REQUEST, contact_obj):
    if not REQUEST.form.has_key('contact_id') or not REQUEST.form['contact_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')

    output=[]
    contact_id = int(REQUEST.form['contact_id'].value)
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_CONTACT_URL = _Conf.BASE_CONTACT_URL
    contact_email = _Utils.sql_quote_simple((contact_obj.get('e_mail') or '').lower())
    contact_email2 = _Utils.sql_quote_simple((contact_obj.get('e_mail2') or '').lower())
    contact_email3 = _Utils.sql_quote_simple((contact_obj.get('e_mail3') or '').lower())
    email_count = 0
    if contact_email or contact_email2:
        deleted_items = 0
        drafts = 0
        REQUEST.db.execute("""SELECT e.*, i.* FROM items i, efolders e WHERE e.efolder_id=i.item_id AND i.parent_id=%d ORDER by efolder_id ASC""" % REQUEST.USER.get_id())
        result = REQUEST.db.dictfetchall()
        for i in range(len(result)):
            temp = result[i]
            if temp.get('efolder_flags') & _Efolder.EFOLDER_DELETED:
                deleted_items = result[i]['efolder_id']
            if temp.get('efolder_flags') & _Efolder.EFOLDER_DRAFTS:
                drafts = result[i]['efolder_id']

    if contact_email or contact_email2 or contact_email3:
        str_email1 = ""
        str_email2 = ""
        str_email3 = ""
        if contact_email:
            str_email1 = "lower(email_from) like '%%%s%%' or lower(email_from_addr) like '%%%s%%' or lower(email_from_addr) like '%%%s%%' " % (contact_email, contact_email, contact_email)
        if contact_email2:
            str_email2 = "lower(email_from) like '%%%s%%' or lower(email_from_addr) like '%%%s%%' or lower(email_from_addr) like '%%%s%%' " % (contact_email2, contact_email2, contact_email2)
        if contact_email3:
            str_email3 = "lower(email_from) like '%%%s%%' or lower(email_from_addr) like '%%%s%%' or lower(email_from_addr) like '%%%s%%' " % (contact_email3, contact_email3, contact_email3)
        str_email = " or ".join(filter(None, [str_email1, str_email2, str_email3]))
        SQL = ("""SELECT count(*) FROM items i, emails e WHERE item_id=email_id and item_type_id=%d and creator_id=%d and (%s) and i.parent_id not in (%d, %d)""" % (_InitTypes.ITEM_TYPE_EMAIL, REQUEST.USER.get_id(), str_email, deleted_items, drafts)).encode('UTF8')
        REQUEST.db.execute(SQL)
        email_count = REQUEST.db.fetchone()[0]

    tls_info = REQUEST.TLS('contact_info')
    tls_relations = REQUEST.TLS('tls_relations')
    tls_emails = REQUEST.TLS('tls_emails')
    tls_notes = REQUEST.TLS('compmenu_todo_notes')
    tls_log = REQUEST.TLS('log_log')
    relations_count = relations.relations_count(REQUEST, contact_obj)

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_USERNOTE])
    if right_param:
        right_param = " AND " + right_param
    QUERY = u"""SELECT count(*) FROM usernotes u, items i, items p WHERE u.note_id=i.item_id AND i.creator_id=p.item_id AND (i.parent_id=%d)%s""" % (contact_id, right_param)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    note_count = REQUEST.db.fetchone()[0]

    active = 0
    if REQUEST.form.has_key('rel') and REQUEST.form['rel'].value=='1':
      active = 1
      el2 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactedit.py?contact_id=%(contact_id)s&rel=1">%(tls_relations)s <span class="efoldercount">(%(relations_count)d)</span></a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el2 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;<a class="blacklink" href="%(BASE_CONTACT_URL)scontactedit.py?contact_id=%(contact_id)s&rel=1">%(tls_relations)s <span class="efoldercount">(%(relations_count)d)</span></a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if REQUEST.form.has_key('note') and REQUEST.form['note'].value=='1':
      active = 1
      el3 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactedit.py?contact_id=%(contact_id)s&note=1">%(tls_notes)s <span class="efoldercount">(%(note_count)s)</span></a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el3 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;<a class="blacklink" href="%(BASE_CONTACT_URL)scontactedit.py?contact_id=%(contact_id)s&note=1">%(tls_notes)s <span class="efoldercount">(%(note_count)s)</span></a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if REQUEST.form.has_key('log') and REQUEST.form['log'].value=='1':
      active = 1
      el4 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactedit.py?contact_id=%(contact_id)s&log=1">%(tls_log)s</a>&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el4 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;&nbsp;<a class="blacklink" href="%(BASE_CONTACT_URL)scontactedit.py?contact_id=%(contact_id)s&log=1">%(tls_log)s</a>&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if REQUEST.form.has_key('email') and REQUEST.form['email'].value=='1':
      active = 1
      el5 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactedit.py?contact_id=%(contact_id)s&email=1">%(tls_emails)s <span class="efoldercount">(%(email_count)s)</span></a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el5 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;<a class="blacklink" href="%(BASE_CONTACT_URL)scontactedit.py?contact_id=%(contact_id)s&email=1">%(tls_emails)s <span class="efoldercount">(%(email_count)s)</span></a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if active<> 1:
      el1 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactedit.py?contact_id=%(contact_id)s">%(tls_info)s</a>&nbsp;&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el1 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;&nbsp;&nbsp;<a class="blacklink" href="%(BASE_CONTACT_URL)scontactedit.py?contact_id=%(contact_id)s">%(tls_info)s</a>&nbsp;&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()

    tls_object = REQUEST.TLS('log_contact_id')
    object_name =  _Utils.html_quote_show(contact_obj.get('item_name'))
    output.append(u"""
      <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></TD>
        <TD width="100%%" class="object_name">%(tls_object)s: %(object_name)s</TD>
      </TR>
      <TR>
        <TD colspan="2"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="15" border=0 alt=""></TD>
      </TR>
      </TABLE>
      <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
        <TR>
          <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
          %(el1)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el2)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el3)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el5)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el4)s
          <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
        </TR>
      </TABLE>""" % locals())
    return "\n".join(output)


def show_log(REQUEST, obj_id):
    obj = _Contact.Contact(REQUEST, _InitTypes.INIT_TYPE_ID, int(obj_id))
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_contact_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST, obj)
    output.append(u""" %(menu)s""" % locals())
    output.append(_Log.standard_log_output(REQUEST, obj_id))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)
