# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

import _Conf
from Menus import get_contact_menu
from mod_python import apache
import standard_html
import _Access, _InitTypes, _Contact
import _Utils

MY_MENU_ID=1
MY_MENU_ID_MY=0

def index(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    if REQUEST.form.has_key('only_mine'):
        output.append(get_contact_menu(REQUEST, MY_MENU_ID_MY))
    else:
        output.append(get_contact_menu(REQUEST, MY_MENU_ID))
    if REQUEST.form.has_key('let') and REQUEST.form['let'].decode('UTF8').strip():
        letter = REQUEST.form['let'].decode('UTF8').strip()
    else:
        letter = 0


    try:
        contact_view = REQUEST.get_setting('contact_view')
    except:
        contact_view = "0"

    if REQUEST.form.has_key('_delete') or REQUEST.form.has_key('_delete.x'):
        del_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                del_ids.append(int(key[4:]))

        for del_id in del_ids:
            contact_obj = _Contact.Contact(REQUEST, _InitTypes.INIT_TYPE_ID, del_id)
            contact_obj.delete()


    if contact_view and contact_view=="1":
        sel_name = "last_name"
        sortby = [
'lower(last_name) ASC, lower(first_name) ASC', 'lower(last_name) DESC, lower(first_name) DESC',
'lower(company) ASC', 'lower(company) DESC',
'e_mail ASC', 'e_mail DESC',
'phone_work ASC', 'phone_work DESC',
'phone_fax ASC', 'phone_fax DESC',
]
    else:
        sel_name = "first_name"
        sortby = [
'lower(first_name) ASC, lower(last_name) ASC', 'lower(first_name) DESC, lower(last_name) DESC',
'lower(company) ASC', 'lower(company) DESC',
'e_mail ASC', 'e_mail DESC',
'phone_work ASC', 'phone_work DESC',
'phone_fax ASC', 'phone_fax DESC',
]

    tls_name = REQUEST.TLS('tls_name')
    tls_company = REQUEST.TLS('contact_company')
    tls_email = REQUEST.TLS('tls_email')
    tls_phone_work = REQUEST.TLS('tls_phone_work')
    tls_fax = REQUEST.TLS('tls_phone_fax')
    tls_contacts = REQUEST.TLS('tls_contacts')

    DEFAULT_SORTBY = 0
    sortby_id = -1
    if REQUEST.form.has_key('sort_by') and REQUEST.form['sort_by'].value.decode('UTF8').strip():
        sortby_id = int(REQUEST.form['sort_by'].value.decode('UTF8').strip())   
    if sortby_id < 0 or sortby_id >= len(sortby):
        sortby_id  = DEFAULT_SORTBY
    formstring = REQUEST.get_formstring(['qs','sort_by','_delete'])
    sortby_name = u"""<A class="blackboldlink" href="%scontactindex.py%ssort_by=0">%s</A>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_name)
    sortby_company = u"""<A class="blackboldlink" href="%scontactindex.py%ssort_by=2">%s</A>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_company)
    sortby_email = u"""<A class="blackboldlink" href="%scontactindex.py%ssort_by=4">%s</A>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_email)
    sortby_work = u"""<A class="blackboldlink" href="%scontactindex.py%ssort_by=6">%s</A>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_phone_work)
    sortby_fax = u"""<A class="blackboldlink" href="%scontactindex.py%ssort_by=8">%s</A>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_fax)
    if sortby_id == 0:
        sortby_name = u"""<A class="blackboldlink" href="%scontactindex.py%ssort_by=1">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_name)
    elif sortby_id == 1:
        sortby_name = u"""<A class="blackboldlink" href="%scontactindex.py%ssort_by=0">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_name)
    elif sortby_id == 2:
        sortby_company = u"""<A class="blackboldlink" href="%scontactindex.py%ssort_by=3">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_company)
    elif sortby_id == 3:
        sortby_company = u"""<A class="blackboldlink" href="%scontactindex.py%ssort_by=2">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_company)
    elif sortby_id == 4:
        sortby_email = u"""<A class="blackboldlink" href="%scontactindex.py%ssort_by=5">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_email)
    elif sortby_id == 5:
        sortby_email = u"""<A class="blackboldlink" href="%scontactindex.py%ssort_by=4">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_email)
    elif sortby_id == 6:
        sortby_work = u"""<A class="blackboldlink" href="%scontactindex.py%ssort_by=7">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_phone_work)
    elif sortby_id == 7:
        sortby_work = u"""<A class="blackboldlink" href="%scontactindex.py%ssort_by=6">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_phone_work)
    elif sortby_id == 8:
        sortby_fax = u"""<A class="blackboldlink" href="%scontactindex.py%ssort_by=9">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_fax)
    elif sortby_id == 9:
        sortby_fax = u"""<A class="blackboldlink" href="%scontactindex.py%ssort_by=8">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_CONTACT_URL, formstring, tls_fax)
    del formstring

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_CONTACT])
    if right_param:
        right_param = " AND " + right_param
    if REQUEST.form.has_key('only_mine'):
        only_mine = """ AND i.creator_id=%d""" % REQUEST.USER.get_id()
    else:
        only_mine = ""


    if (letter=='num'):
        QUERY = """SELECT count(*) AS count_all FROM contacts c, items i WHERE c.contact_id=i.item_id AND lower(substr(c.%s, 1, 1)) not in ('a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z') %s%s""" % (sel_name, only_mine, right_param)
    elif letter:
        QUERY = """SELECT count(*) AS count_all FROM contacts c, items i WHERE c.contact_id=i.item_id AND lower(substr(c.%s, 1, 1))='%s' %s%s""" % (sel_name, letter, only_mine, right_param)
    else:
        QUERY = """SELECT count(*) AS count_all FROM contacts c, items i WHERE c.contact_id=i.item_id %s%s""" % (only_mine, right_param)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    count_all = REQUEST.db.fetchone()[0]


    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%scontactindex.py%sqs=" % (_Conf.BASE_CONTACT_URL, REQUEST.get_formstring(['qs']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%scontactindex.py%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_CONTACT_URL, REQUEST.get_formstring(['qs']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%scontactindex.py%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_CONTACT_URL, REQUEST.get_formstring(['qs']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR2(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""


    if REQUEST.form.has_key('only_mine'):
        only_mine = """ AND i.creator_id=%d""" % REQUEST.USER.get_id()
        show_mine = """only_mine=1"""
    else:
        only_mine = ""
        show_mine = ""
    if (letter=='num'):
        SQL = """SELECT c.*, i.parent_id FROM contacts c, items i WHERE c.contact_id=i.item_id AND lower(substr(c.%s, 1, 1)) not in ('a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z') %s%s ORDER BY %s LIMIT %d OFFSET %d""" % (sel_name, only_mine, right_param, sortby[sortby_id], REQUEST.batch_size, REQUEST.qs)
    elif letter:
        SQL = """SELECT c.*, i.parent_id FROM contacts c, items i WHERE c.contact_id=i.item_id AND lower(substr(c.%s, 1, 1))='%s' %s%s ORDER BY %s LIMIT %d OFFSET %d""" % (sel_name, letter, only_mine, right_param, sortby[sortby_id], REQUEST.batch_size, REQUEST.qs)
    else:
        SQL = """SELECT c.*, i.parent_id FROM contacts c, items i WHERE c.contact_id=i.item_id %s%s ORDER BY %s LIMIT %d OFFSET %d""" % (only_mine, right_param, sortby[sortby_id], REQUEST.batch_size, REQUEST.qs)
    REQUEST.db.execute(SQL.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()


    BASE_CONTACT_URL = _Conf.BASE_CONTACT_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_all = REQUEST.TLS('tls_all').upper()
    output.append(u"""
<TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
  <TR>
    <TD colspan="2"><IMG src="%(BASE_ICON_URL)sspacer.gif" width="1" height="10" border="0" alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
    <TD class="td_listing1" width="100%%">
       <a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactindex.py?%(show_mine)s">%(tls_all)s</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactindex.py?let=num&%(show_mine)s">#</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactindex.py?let=a&%(show_mine)s">A</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactindex.py?let=b&%(show_mine)s">B</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactindex.py?let=c&%(show_mine)s">C</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactindex.py?let=d&%(show_mine)s">D</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactindex.py?let=e&%(show_mine)s">E</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactindex.py?let=f&%(show_mine)s">F</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactindex.py?let=g&%(show_mine)s">G</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactindex.py?let=h&%(show_mine)s">H</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactindex.py?let=i&%(show_mine)s">I</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactindex.py?let=j&%(show_mine)s">J</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactindex.py?let=k&%(show_mine)s">K</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactindex.py?let=l&%(show_mine)s">L</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactindex.py?let=m&%(show_mine)s">M</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactindex.py?let=n&%(show_mine)s">N</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactindex.py?let=o&%(show_mine)s">O</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactindex.py?let=p&%(show_mine)s">P</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactindex.py?let=q&%(show_mine)s">Q</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactindex.py?let=r&%(show_mine)s">R</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactindex.py?let=s&%(show_mine)s">S</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactindex.py?let=t&%(show_mine)s">T</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactindex.py?let=u&%(show_mine)s">U</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactindex.py?let=v&%(show_mine)s">V</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactindex.py?let=w&%(show_mine)s">W</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactindex.py?let=x&%(show_mine)s">X</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactindex.py?let=y&%(show_mine)s">Y</A>&nbsp;
       <a class="blackboldlink" href="%(BASE_CONTACT_URL)scontactindex.py?let=z&%(show_mine)s">Z</A>&nbsp;
    </TD>
  </TR>
</TABLE>
<br>
<FORM method="POST" action="%(BASE_CONTACT_URL)scontactindex.py">
<TABLE border=0 cellpadding=0 cellspacing=0 width="100%%">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD colspan=6 width="100%%">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD class="th_listing" align="center" nowrap>&nbsp;&nbsp;&nbsp;<b>%(tls_contacts)s</b>&nbsp;&nbsp;&nbsp;</TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%">&nbsp;</TD>
      </TR>
    </TABLE>
  </TD>
</TR>
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b" width="25%%">%(sortby_name)s</TD>
  <TD class="td_listing1b" width="25%%">%(sortby_company)s</TD>
  <TD class="td_listing1b" width="15%%">%(sortby_email)s</TD>
  <TD class="td_listing1b" width="15%%">%(sortby_work)s</TD>
  <TD class="td_listing1b" width="15%%">%(sortby_fax)s</TD>
  <TD class="td_listing1b" width="5%%">&nbsp;</TD>
</TR>""" % locals())

    index = 0
    for item in dbresult:
        item['class_type'] = index % 2
        index += 1
        item['BASE_CONTACT_URL'] = _Conf.BASE_CONTACT_URL
        item['BASE_ICON_URL'] = _Conf.BASE_ICON_URL

        if item['company'] is None: item['company'] = ""
        if item['e_mail'] is None: item['e_mail'] = ""
        if item['phone_work'] is None: item['phone_work'] = ""
        if item['phone_fax'] is None: item['phone_fax'] = ""

        item['company'] = _Utils.html_quote(item['company'].decode('UTF8'))
        item['first_name'] = _Utils.html_quote(item['first_name'].decode('UTF8'))
        item['last_name'] = _Utils.html_quote(item['last_name'].decode('UTF8'))
        item['phone_work'] = _Utils.html_quote(item['phone_work'].decode('UTF8'))
        item['phone_fax'] = _Utils.html_quote(item['phone_fax'].decode('UTF8'))
        item['e_mail'] = _Utils.html_quote(item['e_mail'].decode('UTF8'))
        if item['e_mail']:
            item['e_mail']= """<a href="%scompose.py?mail_to=%%22%s%%20%s%%22%%20<%s>">%s</a>""" % (_Conf.BASE_EMAIL_URL, item['first_name'], item['last_name'], item['e_mail'], item['e_mail'])
        if contact_view and contact_view=="1":
            item['c_name'] = """<A class="td_listing" href="%(BASE_CONTACT_URL)scontactedit.py?contact_id=%(contact_id)d">%(last_name)s,&nbsp;%(first_name)s</A>""" % item
        else:
            item['c_name'] = """<A class="td_listing" href="%(BASE_CONTACT_URL)scontactedit.py?contact_id=%(contact_id)d">%(first_name)s&nbsp;%(last_name)s</A>""" % item

        output.append(u"""<TR>
  <TD class="td_listing%(class_type)d"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD nowrap width="25%%" class="td_listing%(class_type)d">%(c_name)s</TD>
  <TD width="25%%" class="td_listing%(class_type)d">%(company)s</TD>
  <TD width="15%%" class="td_listing%(class_type)d">%(e_mail)s</TD>
  <TD width="15%%" class="td_listing%(class_type)d">%(phone_work)s</TD>
  <TD width="15%%" class="td_listing%(class_type)d">%(phone_fax)s</TD>
  <TD width="5%%"  class="td_listing%(class_type)d" style="text-align: center"><INPUT type="checkbox" name="sel_%(contact_id)d"></TD>
</TR>""" % item)
    output.append(u"""</TABLE>""")

    if FULL_BAR:
        output.append(FULL_BAR)
    output.append(u"""\
<TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
    <TR>
      <TD colspan=3>&nbsp;</TD>
    </TR>
    <TR>
      <TD><img src="%sspacer.gif" width=15 height=1 border=0 alt=""></TD>
      <TD width="100%%" align="right"><INPUT type="submit" class="input3" name="_delete" value="%s" onClick="return confirm('%s');"></TD>
      <TD><img src="%sspacer.gif" width=15 height=1 border=0 alt=""></TD>
    </TR>
  </TABLE>
  </FORM>
  <BR>""" % (_Conf.BASE_ICON_URL, REQUEST.TLS('tls_deletesel'), REQUEST.TLS('email_confirm_del') ,_Conf.BASE_ICON_URL))
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)
