# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

from mod_python import apache
import standard_html
import _InitTypes, _Conf, _Utils, Menus

import _Discussion, _RootObject

MY_MENU_ID = 2

def index(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_discussion_menu(REQUEST, MY_MENU_ID))
    try:
        parent_id = int(REQUEST.get_setting('activediscFolder'))
        parent = _RootObject.dispatch_item(REQUEST, parent_id)
    except:
        raise RuntimeError, REQUEST.TLS('disc_wrongparent')

    BASE_DISCUSSION_URL = _Conf.BASE_DISCUSSION_URL
    REQ_FIELD = _Conf.REQ_FIELD
    tls_adddisc = REQUEST.TLS('disc_add')
    tls_subject = REQUEST.TLS('tls_subject')
    tls_message = REQUEST.TLS('note_message')
    tls_front = REQUEST.TLS('disc_front')
    tls_save = REQUEST.TLS('tls_save')
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_emoticons = REQUEST.TLS('tls_emoticons')
    em_smile = REQUEST.TLS('em_smile')
    em_wink = REQUEST.TLS('em_wink')
    em_confused = REQUEST.TLS('em_confused')
    em_eek = REQUEST.TLS('em_eek')
    em_biggrin = REQUEST.TLS('em_biggrin')
    em_cool = REQUEST.TLS('em_cool')
    em_mad = REQUEST.TLS('em_mad')
    em_rolleyes = REQUEST.TLS('em_rolleyes')
    em_embarrassed = REQUEST.TLS('em_embarrassed')
    em_frown = REQUEST.TLS('em_frown')
    em_sarcastic = REQUEST.TLS('em_sarcastic')
    em_silly = REQUEST.TLS('em_silly')

    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tree_bar = _Discussion.tree_bar(REQUEST)

    if REQUEST.USER.get_id() == _Conf.SUPERUSER:
        is_superuser = 1
    else:
        top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
        if REQUEST.USER.get_id() == top_parent.get('superuser_id'):
            is_superuser = 1
        else:
            is_superuser = 0
    output.append("""\
<SCRIPT language="javascript" type="text/javascript">
<!--
  function check_values()
  {
    if (!document.addform.disc_subject.value || !document.addform.disc_message.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
function emoticon(text) {
  var txtarea = document.addform.disc_message;
  text = ' ' + text + ' ';
  if (txtarea.createTextRange && txtarea.caretPos) {
    var caretPos = txtarea.caretPos;
    caretPos.text = caretPos.text.charAt(caretPos.text.length - 1) == ' ' ? caretPos.text + text + ' ' : caretPos.text + text;
    txtarea.focus();
  }
  else {
    txtarea.value  += text;
    txtarea.focus();
  }
}
// -->
</SCRIPT>
%(tree_bar)s
<BR>
<TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
<FORM name="addform" method="POST" action="%(BASE_DISCUSSION_URL)sdiscadd.py/add" onsubmit="return check_values();">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD colspan=3 width="100%%">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD class="th_listing" align="center" nowrap>&nbsp;&nbsp;<b>%(tls_adddisc)s</b>&nbsp;&nbsp;</TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%">&nbsp;</TD>
      </TR>
    </TABLE>
  </TD>
</TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_subject)s%(REQ_FIELD)s</TD>
    <TD class="td_listing1" colspan=2><INPUT type="text" size=40 class="textfield1" name="disc_subject"></TD>
  </TR>
  <TR class="tr_listing0" valign="top">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD nowrap>
      <TABLE border=0 width="100%%" cellpadding=5 cellspacing=0>
        <TR>
          <TD>%(tls_message)s%(REQ_FIELD)s</TD>
        </TR>
        <TR>
          <TD align="center"><br>%(tls_emoticons)s</TD>
        </TR>
        <TR>
          <TD align="center" style="padding: 2px;">
            <a href="javascript:emoticon(':)')"><img src="%(BASE_ICON_URL)ssmileys/smile.gif" width="15" height="15" border=0 alt="%(em_smile)s" title="%(em_smile)s"></a>
            <a href="javascript:emoticon(';)')"><img src="%(BASE_ICON_URL)ssmileys/wink.gif" width="15" height="15" border=0 alt="%(em_wink)s" title="%(em_wink)s"></a>
            <a href="javascript:emoticon(':?')"><img src="%(BASE_ICON_URL)ssmileys/confused.gif" width="15" height="22" border=0 alt="%(em_confused)s" title="%(em_confused)s"></a>
            <a href="javascript:emoticon(':o')"><img src="%(BASE_ICON_URL)ssmileys/eek.gif" width="15" height="15" border=0 alt="%(em_eek)s" title="%(em_eek)s"></a>
          </TD>
        </TR>
        <TR>
          <TD align="center" style="padding: 2px;">
            <a href="javascript:emoticon(':D')"><img src="%(BASE_ICON_URL)ssmileys/biggrin.gif" width="15" height="15" border=0 alt="%(em_biggrin)s" title="%(em_biggrin)s"></a>
            <a href="javascript:emoticon('8)')"><img src="%(BASE_ICON_URL)ssmileys/cool.gif" width="15" height="15" border=0 alt="%(em_cool)s" title="%(em_cool)s"></a>
            <a href="javascript:emoticon(':x')"><img src="%(BASE_ICON_URL)ssmileys/mad.gif" width="15" height="15" border=0 alt="%(em_mad)s" title="%(em_mad)s"></a>
            <a href="javascript:emoticon(':roll:')"><img src="%(BASE_ICON_URL)ssmileys/rolleyes.gif" width="15" height="15" border=0 alt="%(em_rolleyes)s" title="%(em_rolleyes)s"></a>
          </TD>
        </TR>
        <TR>
          <TD align="center" style="padding: 2px;">
            <a href="javascript:emoticon(':oops:')"><img src="%(BASE_ICON_URL)ssmileys/embarrassed.gif" width="15" height="15" border=0 alt="%(em_embarrassed)s" title="%(em_embarrassed)s"></a>
            <a href="javascript:emoticon(':(')"><img src="%(BASE_ICON_URL)ssmileys/frown.gif" width="15" height="15" border=0 alt="%(em_frown)s" title="%(em_frown)s"></a>
            <a href="javascript:emoticon(':-/')"><img src="%(BASE_ICON_URL)ssmileys/sarcastic.gif" width="15" height="15" border=0 alt="%(em_sarcastic)s" title="%(em_sarcastic)s"></a>
            <a href="javascript:emoticon(':P')"><img src="%(BASE_ICON_URL)ssmileys/silly.gif" width="15" height="15" border=0 alt="%(em_silly)s" title="%(em_silly)s"></a>
          </TD>
        </TR>
        <TR>
          <TD>
            <img src="%(BASE_ICON_URL)sspacer.gif" width="100" height="1" border=0 alt="">
          </TD>
        </TR>
      </TABLE>
    </TD>
    <TD class="td_listing0" colspan=2><TEXTAREA name="disc_message" rows=20 cols=60 class="textarea4"></TEXTAREA></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" colspan="3"><INPUT type="submit" name="_save" value="%(tls_save)s" class="input2"></TD>
  </TR>
</TABLE>
</FORM>"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def add(REQUEST):
    if REQUEST.form.has_key('disc_subject') and REQUEST.form['disc_subject'].value.decode('UTF8').strip():
        disc = _Discussion.Discussion(REQUEST, _InitTypes.INIT_TYPE_REQ)

        if REQUEST.form.has_key('parent_id'):
            parent_id = int(REQUEST.form['parent_id'].value)
        else:
            try:
                parent_id = int(REQUEST.get_setting('activediscFolder'))
            except:
                parent_id = REQUEST.USER.get_parent_id(REQUEST)

        if not REQUEST.form.has_key('parent_id'):
            disc.set('parent_id', parent_id)
        try:
            parent = _RootObject.dispatch_item(REQUEST, disc.get_parent_id())
            if parent.get('item_type_id') not in [_InitTypes.ITEM_TYPE_DISCCATEGORY, _InitTypes.ITEM_TYPE_DISCUSSION]:
                raise RuntimeError, REQUEST.TLS('rootobj_noupdateaccess')
        except:
            raise RuntimeError, 'Discussion threads can only be created under categories!' # FIXME
        disc.save()
    else:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    if REQUEST.form.has_key('parent_id'):
        REQUEST.mod_req.headers_out["Location"] = "%sdiscread.py?discussion_id=%d" % (_Conf.BASE_DISCUSSION_URL, disc.get_parent_id())
    else:
        REQUEST.mod_req.headers_out["Location"] = "%sdiscread.py?discussion_id=%d" % (_Conf.BASE_DISCUSSION_URL, disc.get_id())
    return apache.HTTP_MOVED_TEMPORARILY

def reply(REQUEST):
    if not REQUEST.form.has_key('discussion_id') or not REQUEST.form['discussion_id'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    disc_obj = _Discussion.Discussion(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['discussion_id'].value))
    if disc_obj.get_parent().get('item_type_id') not in [_InitTypes.ITEM_TYPE_ORGANIZATION, _InitTypes.ITEM_TYPE_DISCCATEGORY]:
        raise RuntimeError, "You can only reply to top-level threads"

    tls_replydisc = REQUEST.TLS('disc_reply')
    tls_subject = REQUEST.TLS('tls_subject')
    tls_message = REQUEST.TLS('note_message')
    tls_save = REQUEST.TLS('tls_save')
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_emoticons = REQUEST.TLS('tls_emoticons')
    em_smile = REQUEST.TLS('em_smile')
    em_wink = REQUEST.TLS('em_wink')
    em_confused = REQUEST.TLS('em_confused')
    em_eek = REQUEST.TLS('em_eek')
    em_biggrin = REQUEST.TLS('em_biggrin')
    em_cool = REQUEST.TLS('em_cool')
    em_mad = REQUEST.TLS('em_mad')
    em_rolleyes = REQUEST.TLS('em_rolleyes')
    em_embarrassed = REQUEST.TLS('em_embarrassed')
    em_frown = REQUEST.TLS('em_frown')
    em_sarcastic = REQUEST.TLS('em_sarcastic')
    em_silly = REQUEST.TLS('em_silly')

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_discussion_menu(REQUEST, MY_MENU_ID))

    BASE_DISCUSSION_URL = _Conf.BASE_DISCUSSION_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    REQ_FIELD = _Conf.REQ_FIELD
    parent_id = disc_obj.get_id()
    subject = u"%s" % _Utils.html_quote(disc_obj.get('disc_subject'))
    save_subject = u"re: %s" % disc_obj.get('disc_subject')
    tree_bar = _Discussion.tree_bar(REQUEST)
    output.append("""\
<SCRIPT language="javascript" type="text/javascript">
<!--
  function check_values()
  {
    if (!document.addform.disc_subject.value || !document.addform.disc_message.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
function emoticon(text) {
  var txtarea = document.addform.disc_message;
  text = ' ' + text + ' ';
  if (txtarea.createTextRange && txtarea.caretPos) {
    var caretPos = txtarea.caretPos;
    caretPos.text = caretPos.text.charAt(caretPos.text.length - 1) == ' ' ? caretPos.text + text + ' ' : caretPos.text + text;
    txtarea.focus();
  }
  else {
    txtarea.value  += text;
    txtarea.focus();
  }
}
// -->
</SCRIPT>
%(tree_bar)s
<BR>
<TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
<FORM name="addform" method="POST" action="%(BASE_DISCUSSION_URL)sdiscadd.py/add" onsubmit="return check_values();">
<INPUT type="hidden" name="disc_subject" value="%(save_subject)s">
<INPUT type="hidden" name="parent_id" value="%(parent_id)d">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD colspan=3 width="100%%">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD class="th_listing" align="center" nowrap>&nbsp;&nbsp;<b>%(tls_replydisc)s</b>&nbsp;&nbsp;</TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%">&nbsp;</TD>
      </TR>
    </TABLE>
  </TD>
</TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="20" border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_subject)s</TD>
    <TD class="td_listing1b" colspan=2>%(subject)s</TD>
  </TR>
  <TR class="tr_listing0" valign="top">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD nowrap>
      <TABLE border=0 width="100%%" cellpadding=5 cellspacing=0>
        <TR>
          <TD>%(tls_message)s%(REQ_FIELD)s</TD>
        </TR>
        <TR>
          <TD align="center"><br>%(tls_emoticons)s</TD>
        </TR>
        <TR>
          <TD align="center" style="padding: 2px;">
            <a href="javascript:emoticon(':)')"><img src="%(BASE_ICON_URL)ssmileys/smile.gif" width="15" height="15" border=0 alt="%(em_smile)s" title="%(em_smile)s"></a>
            <a href="javascript:emoticon(';)')"><img src="%(BASE_ICON_URL)ssmileys/wink.gif" width="15" height="15" border=0 alt="%(em_wink)s" title="%(em_wink)s"></a>
            <a href="javascript:emoticon(':?')"><img src="%(BASE_ICON_URL)ssmileys/confused.gif" width="15" height="22" border=0 alt="%(em_confused)s" title="%(em_confused)s"></a>
            <a href="javascript:emoticon(':o')"><img src="%(BASE_ICON_URL)ssmileys/eek.gif" width="15" height="15" border=0 alt="%(em_eek)s" title="%(em_eek)s"></a>
          </TD>
        </TR>
        <TR>
          <TD align="center" style="padding: 2px;">
            <a href="javascript:emoticon(':D')"><img src="%(BASE_ICON_URL)ssmileys/biggrin.gif" width="15" height="15" border=0 alt="%(em_biggrin)s" title="%(em_biggrin)s"></a>
            <a href="javascript:emoticon('8)')"><img src="%(BASE_ICON_URL)ssmileys/cool.gif" width="15" height="15" border=0 alt="%(em_cool)s" title="%(em_cool)s"></a>
            <a href="javascript:emoticon(':x')"><img src="%(BASE_ICON_URL)ssmileys/mad.gif" width="15" height="15" border=0 alt="%(em_mad)s" title="%(em_mad)s"></a>
            <a href="javascript:emoticon(':roll:')"><img src="%(BASE_ICON_URL)ssmileys/rolleyes.gif" width="15" height="15" border=0 alt="%(em_rolleyes)s" title="%(em_rolleyes)s"></a>
          </TD>
        </TR>
        <TR>
          <TD align="center" style="padding: 2px;">
            <a href="javascript:emoticon(':oops:')"><img src="%(BASE_ICON_URL)ssmileys/embarrassed.gif" width="15" height="15" border=0 alt="%(em_embarrassed)s" title="%(em_embarrassed)s"></a>
            <a href="javascript:emoticon(':(')"><img src="%(BASE_ICON_URL)ssmileys/frown.gif" width="15" height="15" border=0 alt="%(em_frown)s" title="%(em_frown)s"></a>
            <a href="javascript:emoticon(':-/')"><img src="%(BASE_ICON_URL)ssmileys/sarcastic.gif" width="15" height="15" border=0 alt="%(em_sarcastic)s" title="%(em_sarcastic)s"></a>
            <a href="javascript:emoticon(':P')"><img src="%(BASE_ICON_URL)ssmileys/silly.gif" width="15" height="15" border=0 alt="%(em_silly)s" title="%(em_silly)s"></a>
          </TD>
        </TR>
        <TR>
          <TD>
            <img src="%(BASE_ICON_URL)sspacer.gif" width="100" height="1" border=0 alt="">
          </TD>
        </TR>
      </TABLE>
    </TD>
    <TD class="td_listing0" colspan=2><TEXTAREA name="disc_message" rows=20 cols=60 class="textarea4"></TEXTAREA></TD>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" colspan="3"><INPUT type="submit" name="_save" value="%(tls_save)s" class="input2"></TD>
  </TR>
</TABLE>
</FORM>"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def edit(REQUEST):
    if not REQUEST.form.has_key('disc_id') or not REQUEST.form['disc_id'].value.strip():
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    else:
        disc_obj = _Discussion.Discussion(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['disc_id'].value))
    if disc_obj.get('creator_id')<>REQUEST.USER.get_id():
        raise RuntimeError, REQUEST.TLS('rootobj_noupdateaccess')
    disc_subject = disc_obj.get('disc_subject')
    disc_text = disc_obj.get('disc_message')
    disc_id = disc_obj.get_id()
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_discussion_menu(REQUEST, MY_MENU_ID))
    try:
        parent_id = int(REQUEST.get_setting('activediscFolder'))
        parent = _RootObject.dispatch_item(REQUEST, parent_id)
    except:
        raise RuntimeError, REQUEST.TLS('disc_wrongparent')

    BASE_DISCUSSION_URL = _Conf.BASE_DISCUSSION_URL
    REQ_FIELD = _Conf.REQ_FIELD
    tls_adddisc = REQUEST.TLS('disc_edit')
    tls_subject = REQUEST.TLS('tls_subject')
    tls_message = REQUEST.TLS('note_message')
    tls_front = REQUEST.TLS('disc_front')
    tls_save = REQUEST.TLS('tls_save')
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_emoticons = REQUEST.TLS('tls_emoticons')
    em_smile = REQUEST.TLS('em_smile')
    em_wink = REQUEST.TLS('em_wink')
    em_confused = REQUEST.TLS('em_confused')
    em_eek = REQUEST.TLS('em_eek')
    em_biggrin = REQUEST.TLS('em_biggrin')
    em_cool = REQUEST.TLS('em_cool')
    em_mad = REQUEST.TLS('em_mad')
    em_rolleyes = REQUEST.TLS('em_rolleyes')
    em_embarrassed = REQUEST.TLS('em_embarrassed')
    em_frown = REQUEST.TLS('em_frown')
    em_sarcastic = REQUEST.TLS('em_sarcastic')
    em_silly = REQUEST.TLS('em_silly')

    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tree_bar = _Discussion.tree_bar(REQUEST)

    if disc_obj.get_parent().get('item_type_id')<>_InitTypes.ITEM_TYPE_DISCUSSION:
        col1 = 0
        col2 = 1
        header_hidden = u""
        header_row = u"""
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_subject)s%(REQ_FIELD)s</TD>
    <TD class="td_listing1" colspan=2><INPUT type="text" size=40 class="textfield1" value="%(disc_subject)s" name="disc_subject"></TD>
  </TR>""" % locals()
    else:
        col1 = 1
        col2 = 0
        header_hidden = u"""<input type="hidden" name="disc_subject" value="%(disc_subject)s">""" % locals()
        header_row = u""
    output.append("""\
<SCRIPT language="javascript" type="text/javascript">
<!--
  function check_values()
  {
    if (!document.addform.disc_subject.value || !document.addform.disc_message.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
function emoticon(text) {
  var txtarea = document.addform.disc_message;
  text = ' ' + text + ' ';
  if (txtarea.createTextRange && txtarea.caretPos) {
    var caretPos = txtarea.caretPos;
    caretPos.text = caretPos.text.charAt(caretPos.text.length - 1) == ' ' ? caretPos.text + text + ' ' : caretPos.text + text;
    txtarea.focus();
  }
  else {
    txtarea.value  += text;
    txtarea.focus();
  }
}
// -->
</SCRIPT>
%(tree_bar)s
<BR>
<TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
<FORM name="addform" method="POST" action="%(BASE_DISCUSSION_URL)sdiscadd.py/edit_save" onsubmit="return check_values();">
<input type="hidden" name="disc_id" value="%(disc_id)s">%(header_hidden)s
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD colspan=3 width="100%%">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD class="th_listing" align="center" nowrap>&nbsp;&nbsp;<b>%(tls_adddisc)s</b>&nbsp;&nbsp;</TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%">&nbsp;</TD>
      </TR>
    </TABLE>
  </TD>
</TR>
  %(header_row)s
  <TR class="tr_listing%(col1)s" valign="top">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD nowrap>
      <TABLE border=0 width="100%%" cellpadding=5 cellspacing=0>
        <TR>
          <TD>%(tls_message)s%(REQ_FIELD)s</TD>
        </TR>
        <TR>
          <TD align="center"><br>%(tls_emoticons)s</TD>
        </TR>
        <TR>
          <TD align="center" style="padding: 2px;">
            <a href="javascript:emoticon(':)')"><img src="%(BASE_ICON_URL)ssmileys/smile.gif" width="15" height="15" border=0 alt="%(em_smile)s" title="%(em_smile)s"></a>
            <a href="javascript:emoticon(';)')"><img src="%(BASE_ICON_URL)ssmileys/wink.gif" width="15" height="15" border=0 alt="%(em_wink)s" title="%(em_wink)s"></a>
            <a href="javascript:emoticon(':?')"><img src="%(BASE_ICON_URL)ssmileys/confused.gif" width="15" height="22" border=0 alt="%(em_confused)s" title="%(em_confused)s"></a>
            <a href="javascript:emoticon(':o')"><img src="%(BASE_ICON_URL)ssmileys/eek.gif" width="15" height="15" border=0 alt="%(em_eek)s" title="%(em_eek)s"></a>
          </TD>
        </TR>
        <TR>
          <TD align="center" style="padding: 2px;">
            <a href="javascript:emoticon(':D')"><img src="%(BASE_ICON_URL)ssmileys/biggrin.gif" width="15" height="15" border=0 alt="%(em_biggrin)s" title="%(em_biggrin)s"></a>
            <a href="javascript:emoticon('8)')"><img src="%(BASE_ICON_URL)ssmileys/cool.gif" width="15" height="15" border=0 alt="%(em_cool)s" title="%(em_cool)s"></a>
            <a href="javascript:emoticon(':x')"><img src="%(BASE_ICON_URL)ssmileys/mad.gif" width="15" height="15" border=0 alt="%(em_mad)s" title="%(em_mad)s"></a>
            <a href="javascript:emoticon(':roll:')"><img src="%(BASE_ICON_URL)ssmileys/rolleyes.gif" width="15" height="15" border=0 alt="%(em_rolleyes)s" title="%(em_rolleyes)s"></a>
          </TD>
        </TR>
        <TR>
          <TD align="center" style="padding: 2px;">
            <a href="javascript:emoticon(':oops:')"><img src="%(BASE_ICON_URL)ssmileys/embarrassed.gif" width="15" height="15" border=0 alt="%(em_embarrassed)s" title="%(em_embarrassed)s"></a>
            <a href="javascript:emoticon(':(')"><img src="%(BASE_ICON_URL)ssmileys/frown.gif" width="15" height="15" border=0 alt="%(em_frown)s" title="%(em_frown)s"></a>
            <a href="javascript:emoticon(':-/')"><img src="%(BASE_ICON_URL)ssmileys/sarcastic.gif" width="15" height="15" border=0 alt="%(em_sarcastic)s" title="%(em_sarcastic)s"></a>
            <a href="javascript:emoticon(':P')"><img src="%(BASE_ICON_URL)ssmileys/silly.gif" width="15" height="15" border=0 alt="%(em_silly)s" title="%(em_silly)s"></a>
          </TD>
        </TR>
        <TR>
          <TD>
            <img src="%(BASE_ICON_URL)sspacer.gif" width="100" height="1" border=0 alt="">
          </TD>
        </TR>
      </TABLE>
    </TD>
    <TD class="td_listing%(col1)s" colspan=2><TEXTAREA name="disc_message" rows=20 cols=60 class="textarea4">%(disc_text)s</TEXTAREA></TD>
  </TR>
  <TR class="tr_listing%(col2)s">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing%(col2)s" colspan="3"><INPUT type="submit" name="_save" value="%(tls_save)s" class="input2"></TD>
  </TR>
</TABLE>
</FORM>"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def edit_save(REQUEST):
    if REQUEST.form.has_key('disc_subject') and REQUEST.form['disc_subject'].value.decode('UTF8').strip() and REQUEST.form.has_key('disc_id') and REQUEST.form['disc_id'].value:
        disc = _Discussion.Discussion(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['disc_id'].value))
        if disc.get('creator_id')<> REQUEST.USER.get_id():
            raise RuntimeError, REQUEST.TLS('rootobj_noupdateaccess')
        disc.load_req()
        disc.save()
    else:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    REQUEST.mod_req.headers_out["Location"] = "%sdiscread.py?discussion_id=%d" % (_Conf.BASE_DISCUSSION_URL, disc.get_id())
    return apache.HTTP_MOVED_TEMPORARILY
