# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

import standard_html
import _Conf, _Indexer, _Access, _Utils, _InitTypes, Menus, _Person


MY_MENU_ID = 1

def index(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_discussion_menu(REQUEST, MY_MENU_ID))

    BASE_DISCUSSION_URL = _Conf.BASE_DISCUSSION_URL
    tls_discsearch = REQUEST.TLS('disc_search')
    tls_search = REQUEST.TLS('tls_search')
    tls_author = REQUEST.TLS('tls_author')
    tls_subject = REQUEST.TLS('tls_subject')
    tls_message = REQUEST.TLS('note_message')
    tls_deletesel = REQUEST.TLS('tls_deletesel')
    email_confirm_del = REQUEST.TLS('email_confirm_del')
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    output.append(u"""\
<BR>
<TABLE width="100%%" cellpadding=0 cellspacing=0 border=0>
<FORM name="search_form" method="POST" action="%(BASE_DISCUSSION_URL)sdiscsearch.py/search">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD colspan=2 width="100%%">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD class="th_listing" align="center" nowrap>&nbsp;&nbsp;<b>%(tls_discsearch)s</b>&nbsp;&nbsp;</TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%">&nbsp;</TD>
      </TR>
    </TABLE>
  </TD>
</TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_author)s</TD>
    <TD class="td_listing1"><INPUT  class="textfield1" size=30 type="text" name="disc_author"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" nowrap>%(tls_subject)s</TD>
    <TD class="td_listing0"><INPUT class="textfield1" size=30 type="text" name="disc_subject"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_message)s</TD>
    <TD class="td_listing1"><INPUT class="textfield1" size=30 type="text" name="disc_message"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=23 border=0 alt=""></TD>
    <TD class="td_listing0" colspan="2"><INPUT class="input2" type="submit" name="_search" value="%(tls_search)s"></TD>
  </TR>
</TABLE>
</FORM>
"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def search(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_discussion_menu(REQUEST, MY_MENU_ID))

    search_params = []
    search_params2 = []
    
    if REQUEST.form.has_key('disc_message') and REQUEST.form['disc_message'].value.decode('UTF8').strip():
        content_words = "".join(map(_Indexer.clean_garbage, REQUEST.form['disc_message'].value.decode("UTF8").strip().lower()))
        content_words = map(lambda x:x.strip(), content_words.split(u" "))
        words = []
        for word in content_words:
            if len(word) < 3:
                continue
            words.append(_Utils.sql_cast_str(REQUEST, word))
        del content_words
        for word in words:
            search_params.append("d.discussion_id in (SELECT item_id FROM fti_search WHERE word = %s and fti_type=true)" % word)
            search_params2.append("d2.discussion_id in (SELECT item_id FROM fti_search WHERE word = %s and fti_type=true)" % word)
    if REQUEST.form.has_key('disc_subject') and REQUEST.form['disc_subject'].value.decode('UTF8').strip():
        search_params.append("lower(d.disc_subject) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['disc_subject'].value.decode('UTF8').strip().lower()))
        search_params2.append("lower(d2.disc_subject) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['disc_subject'].value.decode('UTF8').strip().lower()))
    if REQUEST.form.has_key('disc_author') and REQUEST.form['disc_author'].value.decode('UTF8').strip():
        search_params.append("lower(p.item_name) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['disc_author'].value.decode('UTF8').strip().lower()))
        search_params2.append("lower(p2.item_name) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['disc_author'].value.decode('UTF8').strip().lower()))

    search_params = " AND\n".join(search_params)
    search_params2 = " AND\n".join(search_params2)

    if search_params:
        search_params = " AND (%s OR" % search_params
    else:
        search_params = " AND (1=1 OR"
    if search_params2:
        search_params2 = " AND %s" % search_params2

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_DISCUSSION])
    if right_param:
        right_param = " AND " + right_param

    SQL = """\
SELECT
 d.*,
 i.item_id,
 i.parent_id,
 i.create_time,
 i.creator_id,
 p.item_name AS author,
 (select coalesce(max(c.create_time), i.create_time) FROM items c WHERE c.parent_id=i.item_id) AS last_post
FROM
 discussions d,
 items i,
 items p,
 items x
WHERE
 d.discussion_id=i.item_id AND
 i.creator_id=p.item_id AND
 i.parent_id=x.item_id AND
 x.item_type_id=%d
-- Right param
%s
-- Search params
%s
-- children
(
SELECT
 i.parent_id
FROM
 discussions d2,
 items i,
 items p2,
 items x2
WHERE
 d2.discussion_id=i.item_id AND
 x2.item_id=d.discussion_id AND
 i.creator_id=p2.item_id AND
 i.parent_id=x2.item_id AND
 x2.item_type_id=%d
-- Right param
%s
-- Search params
%s
limit 1
) is not null
)
ORDER BY i.create_time DESC
LIMIT %d OFFSET %d
""" % (_InitTypes.ITEM_TYPE_DISCCATEGORY, right_param, search_params, _InitTypes.ITEM_TYPE_DISCUSSION, right_param, search_params2, REQUEST.batch_size, REQUEST.qs)

    REQUEST.db.execute(SQL.encode('utf8'))
    dbresult = REQUEST.db.dictfetchall()


    children = {}
    if dbresult:
        QUERY = u"""SELECT parent_id, count(*) AS count_children FROM items WHERE parent_id in (%s) GROUP BY parent_id""" % ",".join(map(lambda x: str(x['discussion_id']), dbresult))
        REQUEST.db.execute(QUERY.encode('UTF8'))
        for child in REQUEST.db.dictfetchall():
            children[child['parent_id']] = child['count_children']

    BASE_DISCUSSION_URL = _Conf.BASE_DISCUSSION_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_discs = REQUEST.TLS('tls_discussions')
    tls_subject = REQUEST.TLS('tls_subject')
    tls_author = REQUEST.TLS('tls_author')
    tls_posted = REQUEST.TLS('disc_posted')
    tls_replies = REQUEST.TLS('disc_replies')
    tls_updated = REQUEST.TLS('disc_updated')
    tls_creator = REQUEST.TLS('tls_creator')
    tls_deletesel = REQUEST.TLS('tls_deletesel')
    email_confirm_del = REQUEST.TLS('email_confirm_del')

    output.append(u"""\
<FORM method="POST" action="%(BASE_DISCUSSION_URL)sdiscindex.py">
<TABLE border=0 cellpadding=0 cellspacing=0 width="100%%">
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=15 height=1 border=0 alt=""></TD>
  <TD width="100%%">
    <TABLE border=0 cellpadding=0 cellspacing=1 width="100%%" bgcolor="#7BA5BD">
    <TR>
      <TD class="td_listing2b" width="100%%"  align="center">%(tls_subject)s</TD>
      <TD class="td_listing2b" nowrap align="center">%(tls_replies)s</TD>
      <TD class="td_listing2b" nowrap align="center">%(tls_creator)s</TD>
      <TD class="td_listing2b" nowrap align="center">%(tls_updated)s</TD>
      <TD class="td_listing2b" width="5%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=15 height=15 border=0 alt=""></TD>
    </TR>""" % locals())
    can_delete = 0
    index = 0
    for item in dbresult:
        if children.has_key(item['discussion_id']):
            item['replies'] = "%d" % children[item['discussion_id']]
        else:
            item['replies'] = "0"
        item['class_type'] = index % 2
        index += 1
        item['BASE_DISCUSSION_URL'] = _Conf.BASE_DISCUSSION_URL
        item['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
        item['disc_subject'] = _Utils.html_quote(item['disc_subject'].decode('UTF8'))
        item['updated'] = REQUEST.iso2userdatetime(REQUEST, item['last_post'])
        item['author'] = item['author'].decode('UTF8')
        item['urllink'] = u"""%(BASE_DISCUSSION_URL)sdiscread.py?parent_id=%(parent_id)s&discussion_id=%(discussion_id)d""" % item
        if REQUEST.USER.get_id() == _Conf.SUPERUSER or REQUEST.USER.get_id() == REQUEST.USER.get_parent(REQUEST).get_top_parent().get('superuser_id'):
            can_delete = 1
            item['checkbox'] = """<INPUT type="checkbox" name="sel_%(discussion_id)d">""" % item
        else:
            item['checkbox'] = ""
        output.append(u"""
<TR>
  <TD class="td_listingd%(class_type)d"><A href="%(urllink)s" class="blackboldlink2">%(disc_subject)s</A></TD>
  <TD class="td_listingd%(class_type)d" nowrap align="center">%(replies)s</TD>
  <TD class="td_listingd%(class_type)d" nowrap>%(author)s</TD>
  <TD class="td_listingd%(class_type)d" nowrap>%(updated)s</TD>
  <TD class="td_listingd%(class_type)d" nowrap style="text-align: center"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=19 border=0 alt="">%(checkbox)s</TD>
</TR>""" % item)

    output.append(u"</TABLE>")
    if can_delete:
        output.append(u"""
    <BR>
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
    <TR class="tr_listing0">
      <TD><INPUT type="submit" class="input3" name="_delete" value="%(tls_deletesel)s" onClick="return confirm('%(email_confirm_del)s');"></TD>
    </TR>
    </TABLE>""" % locals())
    output.append(u"""
  </TD>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=15 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
</FORM>""" % (locals()))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)
