# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

import standard_html
import _Conf, _Indexer, _Access, _Utils, _InitTypes, Menus, _RootObject, os
from string import strip
import mx.DateTime


MY_MENU_ID = 1

def index(REQUEST):
    output = []
    extra_headers = standard_html.frametree_script(REQUEST) + '<link rel="stylesheet" type="text/css" media="all" href="%sjscalendar/calendar-blue.css" />' % _Conf.BASE_WEB_URL
    extra_body = u""" onload="show_frametree();\""""
    output.append(standard_html.html_header(REQUEST, extra_headers, extra_body))
    output.append(Menus.get_document_menu(REQUEST, MY_MENU_ID))
    output.append(standard_html.window_script(height=300,width=300))

    BASE_DOCUMENT_URL = _Conf.BASE_DOCUMENT_URL
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    simple_search_tls = REQUEST.TLS('doc_simple_search')
    complex_search_tls = REQUEST.TLS('doc_complex_search')
    filename_tls = REQUEST.TLS('doc_filename')
    title_tls = REQUEST.TLS('tls_title')
    folder_tls = REQUEST.TLS('doc_folder')
    author_tls = REQUEST.TLS('tls_author')
    modification_date_tls = REQUEST.TLS('doc_modification_date')
    creation_date_tls = REQUEST.TLS('doc_creation_date')
    desc_tls = REQUEST.TLS("tls_description")
    comments_tls = REQUEST.TLS("tls_comments")
    tls_search = REQUEST.TLS('tls_search')
    tls_to = REQUEST.TLS('tls_fromto_to')
    tls_invdateformat = REQUEST.TLS('tls_invdateformat')
    tls_category = REQUEST.TLS('tls_category')
    categories = _Utils.make_setting_selection(REQUEST, None, 'doc_category', 'doc_categories')
    datecheck_js = REQUEST.datecheck_js(REQUEST)
    tls_search = REQUEST.TLS('tls_search')
    tls_asearch = REQUEST.TLS('tls_adv_search')
    tls_keyword = REQUEST.TLS('tls_keyword')
    BASE_WEB_URL = _Conf.BASE_WEB_URL
    dformat = _Utils.dateformat2jscalformat(REQUEST)
    lformat = _Utils.lang2jscalformat(REQUEST)
    output.append(u"""<script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/calendar.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/lang/calendar-%(lformat)s.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/cal_setup.js"></script>""" % locals())
    output.append(u"""\
<SCRIPT type="text/javascript">
<!--
function cal_popup(url, fieldname)
{
    window.date_result = document.complex_search_form[fieldname];
    window.open(url,'popupcal','width=170,height=150,scrollbars=no');
}
%(datecheck_js)s
function change(numb)
{
  el1 = document.getElementById('1');
  el2 = document.getElementById('2');
  if(numb=='1')
  {
    el1.style.visibility='visible';
    el2.style.visibility='hidden';
  }
  else if(numb=='2')
  {
    el1.style.visibility='hidden';
    el2.style.visibility='visible';  }
}
// -->
</SCRIPT>
<DIV id="1" style="position: absolute; left: 0px; top: 50px; visibility: visible;">
<FORM name="searchform" method="POST" action="%(BASE_DOCUMENT_URL)sdocsearch.py/search">
<TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
  <TR class="tr_listing0">
    <TD colspan=5>
      <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
        <TR>
          <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;<a class="blackboldlink" href="#" onclick="change('1');">%(tls_search)s</a></b>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;<a class="blacklink" href="#" onclick="change('2');">%(tls_asearch)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
          <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
        </TR>
      </TABLE>
    </TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD nowrap class="td_listing1">%(tls_keyword)s</TD>
    <TD class="td_listing1"><INPUT type="text" class="textfield4" name="search_keyword"></TD>
    <TD nowrap class="td_listing1"><INPUT type="submit" name="_search" value="%(tls_search)s" class="input2"></TD>
    <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
</TABLE>
</FORM>
</DIV>
<DIV id="2" style="position: absolute; left: 0px; top: 50px; visibility: hidden;">
<FORM name="complex_search_form" method="POST" action="%(BASE_DOCUMENT_URL)sdocsearch.py/search">
<INPUT type="hidden" name="parent_id" value="">
<INPUT type="hidden" name="creator_id" value="">
<INPUT type="hidden" name="editor_id" value="">
<TABLE width="100%%" cellpadding=0 cellspacing=0 border=0>
  <TR class="tr_listing0">
    <TD colspan=4>
      <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
        <TR>
          <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;<a class="blacklink" href="#" onclick="change('1');">%(tls_search)s</a></b>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;<a class="blackboldlink" href="#" onclick="change('2');">%(tls_asearch)s</a>&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
          <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
        </TR>
      </TABLE>
    </TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(filename_tls)s</TD>
    <TD width="100%%" class="td_listing1" colspan="2"><INPUT class="textfield1" size=35 type="text" name="filename"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" nowrap>%(title_tls)s</TD>
    <TD class="td_listing0" colspan="2"><INPUT class="textfield1" size=35 type="text" name="title"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(creation_date_tls)s</TD>
    <TD class="td_listing1" colspan="2"><INPUT class="textfield1" type="text" name="create_date_start" id="create_date_start" size="10" maxlength="10" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }"> <A href="javascript:void(0);" OnClick="return showCalendar('create_date_start', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt=""></A> %(tls_to)s <INPUT type="text" class="textfield1" name="create_date_end" id="create_date_end" size="10" maxlength="10" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }"> <A href="javascript:void(0);" OnClick="return showCalendar('create_date_end', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt=""></A></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" nowrap>%(modification_date_tls)s</TD>
    <TD class="td_listing0" colspan="2"><INPUT class="textfield1" type="text" name="edit_date_start" id="edit_date_start" size="10" maxlength="10" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }"> <A href="javascript:void(0);" OnClick="return showCalendar('edit_date_start', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt=""></A> %(tls_to)s <INPUT class="textfield1" type="text" name="edit_date_end" id="edit_date_end" size="10" maxlength="10" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }"> <A href="javascript:void(0);" OnClick="return showCalendar('edit_date_end', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt=""></A></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_category)s</TD>
    <TD class="td_listing1" colspan="2">%(categories)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" nowrap>%(desc_tls)s</TD>
    <TD class="td_listing0" colspan="2"><INPUT class="textfield1" size=35 type="text" name="desc"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(comments_tls)s</TD>
    <TD class="td_listing1" colspan="2"><INPUT class="textfield1" size=35 type="text" name="comments"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0">%(folder_tls)s</TD>
    <TD class="td_listing0" colspan="2"><INPUT class="textfield1" size=35 type="text" name="parent_name" value="" disabled>&nbsp;&nbsp;<A target="popup_window" href="%(BASE_DOCUMENT_URL)sdoctree.py/complexsearchtree" onClick="open_window('about:blank');"><IMG src="%(BASE_ICON_URL)sfld.gif" alt="" border="0"></A></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=23 border=0 alt=""></TD>
    <TD colspan="3" class="td_listing1"><INPUT type="submit" class="input2" name="_search" value="%(tls_search)s"></TD>
  </TR>
</TABLE>
</FORM>
</DIV>
"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def search(REQUEST):
    output = []
    extra_headers = standard_html.frametree_script(REQUEST)
    extra_body = u""" onload="show_frametree();\""""
    output.append(standard_html.html_header(REQUEST, extra_headers, extra_body))
    output.append(Menus.get_document_menu(REQUEST, MY_MENU_ID))

    search_params = []
    if REQUEST.form.has_key('search_keyword'):
        w = _Utils.sql_quote_simple(REQUEST.form['search_keyword'].value.decode('UTF8').lower())
        w2 = _Utils.sql_quote_simple(REQUEST.form['search_keyword'].value.decode('UTF8'))
        search_params = u""" AND (
lower(d.title) like '%%%s%%' OR 
lower(d.filename) like '%%%s%%' OR 
lower(d.author) = '%%%s%%' OR
lower(d.doc_category) = '%s' OR
lower(d.description) like '%%%s%%' OR
lower(d.comments) like '%%%s%%')""" % (w,w,w,w,w,w)
    else:
        if REQUEST.form.has_key('title') and REQUEST.form['title'].value:
            search_params.append("lower(d.title) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['title'].value.decode('UTF8').lower()))
        if REQUEST.form.has_key('author') and REQUEST.form['author'].value:
            search_params.append("lower(d.author) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['author'].value.decode('UTF8').lower()))
        if REQUEST.form.has_key('filename') and REQUEST.form['filename'].value:
            search_params.append("lower(d.filename) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['filename'].value.decode('UTF8').lower()))
        if REQUEST.form.has_key('parent_id') and REQUEST.form['parent_id'].value:
            search_params.append("i.parent_id = %d" % _Utils.sql_cast_int(REQUEST, REQUEST.form['parent_id'].value.decode('UTF8')))
        if REQUEST.form.has_key('create_date_start') and REQUEST.form['create_date_start'].value:
            y, m, d = map(int, REQUEST.user2isodate(REQUEST, REQUEST.form['create_date_start'].value.decode('UTF8').strip()).split('-'))
            tmp = _Utils.local2utc_mx(REQUEST, mx.DateTime.Date(y,m,d)).strftime("%Y-%m-%d %H:%M")
            search_params.append("i.create_time >= %s::timestamptz" % _Utils.sql_cast_str(REQUEST, tmp))
        if REQUEST.form.has_key('create_date_end') and REQUEST.form['create_date_end'].value:
            y, m, d = map(int, REQUEST.user2isodate(REQUEST, REQUEST.form['create_date_end'].value.decode('UTF8').strip()).split('-'))
            tmp = _Utils.local2utc_mx(REQUEST, mx.DateTime.Date(y,m,d)).strftime("%Y-%m-%d %H:%M")
            search_params.append("i.create_time < (%s::timestamptz + '1 day'::interval)" % _Utils.sql_cast_str(REQUEST, tmp))
        if REQUEST.form.has_key('edit_date_start') and REQUEST.form['edit_date_start'].value:
            y, m, d = map(int, REQUEST.user2isodate(REQUEST, REQUEST.form['edit_date_start'].value.decode('UTF8').strip()).split('-'))
            tmp = _Utils.local2utc_mx(REQUEST, mx.DateTime.Date(y,m,d)).strftime("%Y-%m-%d %H:%M")
            search_params.append("i.edit_time >= %s::timestamptz" % _Utils.sql_cast_str(REQUEST, tmp))
        if REQUEST.form.has_key('edit_date_end') and REQUEST.form['edit_date_end'].value:
            y, m, d = map(int, REQUEST.user2isodate(REQUEST, REQUEST.form['edit_date_end'].value.decode('UTF8').strip()).split('-'))
            tmp = _Utils.local2utc_mx(REQUEST, mx.DateTime.Date(y,m,d)).strftime("%Y-%m-%d %H:%M")
            search_params.append("i.edit_time < (%s::timestamptz + '1 day'::interval)" % _Utils.sql_cast_str(REQUEST, tmp))
        if REQUEST.form.has_key('doc_category') and REQUEST.form['doc_category'].value:
            search_params.append("d.doc_category = '%s'" % _Utils.sql_quote_simple(REQUEST.form['doc_category'].value.decode('UTF8')))
        if REQUEST.form.has_key('desc') and REQUEST.form['desc'].value:
            search_params.append("lower(d.description) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['desc'].value.decode('UTF8').lower()))
        if REQUEST.form.has_key('comments') and REQUEST.form['comments'].value:
            search_params.append("lower(d.comments) like '%%%s%%'" % _Utils.sql_quote_simple(REQUEST.form['comments'].value.decode('UTF8').lower()))
        search_params = " AND\n".join(search_params)
        if search_params:
            search_params = " AND %s" % search_params

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_DOCUMENT])
    if right_param:
        right_param = " AND " + right_param

    sortby = [
'item_name ASC', 'item_name DESC',
'item_size ASC', 'item_size DESC',
'edit_time ASC', 'edit_time DESC']

    DEFAULT_SORTBY = 0
    sortby_id = -1
    if REQUEST.form.has_key('sort_by') and REQUEST.form['sort_by'].value.decode('UTF8').strip():
        sortby_id = int(REQUEST.form['sort_by'].value.decode('UTF8').strip())
    if sortby_id < 0 or sortby_id >= len(sortby):
        sortby_id  = DEFAULT_SORTBY

    SQL = """\
SELECT
 count(*) AS count_all
FROM
 documents d,
 items i,
 item_types it
WHERE
 d.document_id=i.item_id AND
 d.final_version_id is NULL AND
 i.item_type_id=it.item_type_id
-- Search params
%s
-- Right param
%s
""" % (search_params, right_param)
    REQUEST.db.execute(SQL.encode('utf8'))
    count_all = REQUEST.db.dictfetchone()['count_all']

    SQL = """\
SELECT
 d.*,
 i.item_type_id,
 i.item_id,
 i.parent_id,
 i.item_name,
 i.item_size,
 i.edit_time,
 it.item_type_icon
FROM
 documents d,
 items i,
 item_types it
WHERE
 d.document_id=i.item_id AND
 d.final_version_id is NULL AND
 i.item_type_id=it.item_type_id
-- Search params
%s
-- Right param
%s
ORDER BY %s
LIMIT %d OFFSET %d
""" % (search_params, right_param, sortby[sortby_id], REQUEST.batch_size, REQUEST.qs)
    REQUEST.db.execute(SQL.encode('utf8'))
    dbresult = REQUEST.db.dictfetchall()
    output.append(draw_table(REQUEST, dbresult, sortby_id, count_all))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def draw_table(REQUEST, dbresult, sortby_id, count_all):
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    output = []
    output.append(u"""\
<SCRIPT language="javascript" type="text/javascript">
<!--
  function markAll(formvar) {
    for(var x=0;x<formvar.elements.length;x++) { 
       var y=formvar.elements[x];
       if(y.name != 'all') 
          y.checked = formvar.all.checked;
    }
  }
//-->
</SCRIPT>
""")

    tls_name = REQUEST.TLS('tls_name')
    tls_size = REQUEST.TLS('size')
    tls_date = REQUEST.TLS('date')


    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%sdocsearch.py/search%sqs=" % (_Conf.BASE_DOCUMENT_URL, REQUEST.get_formstring(['qs']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%sdocsearch.py/search%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_DOCUMENT_URL, REQUEST.get_formstring(['qs']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%sdocsearch.py/search%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_DOCUMENT_URL, REQUEST.get_formstring(['qs']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""

    formstring = REQUEST.get_formstring(['qs','sort_by','parent_id'])
    sortby_name = u"""<A class="blacklink" href="%sdocsearch.py/search%ssort_by=0">%s</A>&nbsp;&nbsp;""" % (_Conf.BASE_DOCUMENT_URL, formstring, tls_name)
    sortby_size = u"""<A class="blacklink" href="%sdocsearch.py/search%ssort_by=2">%s</A>&nbsp;&nbsp;""" % (_Conf.BASE_DOCUMENT_URL, formstring, tls_size)
    sortby_date = u"""<A class="blacklink" href="%sdocsearch.py/search%ssort_by=4">%s</A>&nbsp;&nbsp;""" % (_Conf.BASE_DOCUMENT_URL, formstring, tls_date)

    if sortby_id == 0:
        sortby_name = u"""<A class="blacklink" href="%sdocsearch.py/search%ssort_by=1">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_DOCUMENT_URL, formstring, tls_name)
    elif sortby_id == 1:
        sortby_name = u"""<A class="blacklink" href="%sdocsearch.py/search%ssort_by=0">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" %  (_Conf.BASE_DOCUMENT_URL, formstring, tls_name)
    if sortby_id == 2:
        sortby_size = u"""<A class="blacklink" href="%sdocsearch.py/search%ssort_by=3">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" %  (_Conf.BASE_DOCUMENT_URL, formstring, tls_size)
    elif sortby_id == 3:
        sortby_size = u"""<A class="blacklink" href="%sdocsearch.py/search%ssort_by=2">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" %  (_Conf.BASE_DOCUMENT_URL, formstring, tls_size)
    if sortby_id == 4:
        sortby_date = u"""<A class="blacklink" href="%sdocsearch.py/search%ssort_by=5">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" %  (_Conf.BASE_DOCUMENT_URL, formstring, tls_date)
    elif sortby_id == 5:
        sortby_date = u"""<A class="blacklink" href="%sdocsearch.py/search%ssort_by=4">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" %  (_Conf.BASE_DOCUMENT_URL, formstring, tls_date)
    del formstring

    output.append(u"""<TABLE cellpadding=0 cellspacing=0 border=0><FORM name="doclist" method="POST" action="%sdocops.py">""" % _Conf.BASE_DOCUMENT_URL)
    output.append(u"""<TR>
  <TD class="td_listing">&nbsp;</TD>
  <TD class="td_listing" width="100%%">
    <TABLE cellpadding=0 cellspacing=0 border=0 width="100%%">
      <TR>
        <TD width="100%%">&nbsp;</TD>
        <TD background="%(BASE_ICON_URL)sdokunurk1.gif"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD class="th_listing" align=center>&nbsp;&nbsp;&nbsp;&nbsp;%(sortby_name)s&nbsp;&nbsp;&nbsp;&nbsp;</TD>
      </TR>
    </TABLE>
  </TD>
  <TD background="%(BASE_ICON_URL)sdokuvahe1.gif"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD class="th_listing" align=center>&nbsp;&nbsp;&nbsp;&nbsp;%(sortby_size)s&nbsp;&nbsp;&nbsp;&nbsp;</TD>
  <TD background="%(BASE_ICON_URL)sdokuvahe1.gif"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD class="th_listing" align=center>%(sortby_date)s</TD>
  <TD background="%(BASE_ICON_URL)sdokuvahe1.gif"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD class="th_listing_check" align=center><INPUT type="checkbox" name="all" onClick="javascript:markAll(this.form);"></TD>
  <TD background="%(BASE_ICON_URL)sdokunurk2.gif"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD class="white"><img src="%(BASE_ICON_URL)sspacer.gif" width="8" height="1" border=0 alt=""></TD>
</TR>""" % locals())
    if dbresult:
        index = 1
        ns = {'BASE_ICON_URL':_Conf.BASE_ICON_URL,'BASE_DOCUMENT_URL':_Conf.BASE_DOCUMENT_URL,'BASE_GENERAL_URL':_Conf.BASE_GENERAL_URL}
        for row in dbresult:
            ns.update(row)
            if ns['item_type_id'] == _InitTypes.ITEM_TYPE_DOCUMENT:
                file_name = ns['filename']
                file_ext = os.path.splitext(file_name)[-1]
                if(_Conf.MIME_TYPES.has_key(file_ext)):
                    ns['item_type_icon'] =  _Conf.MIME_TYPES[file_ext]
                else:
                    ns['item_type_icon'] =  _Conf.MIME_TYPES["unknown_ext"]
            ns['str_size'] = _Utils.str_size(ns['item_size'])
            ns['edit_time'] = REQUEST.iso2userdatetime(REQUEST, ns['edit_time'])
            ns['class_type'] = index % 2
            index += 1
            ns['title'] = _Utils.html_quote_show(ns['title'].decode('UTF8'))
            output.append(u"""<TR class="tr_listing%(class_type)d">
  <TD class="td_listing%(class_type)d" style="text-align: center"><A href="%(BASE_GENERAL_URL)sinfo.py?item_id=%(item_id)d"><IMG src="%(BASE_ICON_URL)s%(item_type_icon)s" width="18" height="14" alt="Info" border="0"></A></TD>
  <TD class="td_listing%(class_type)d"><A  class="td_listing" href="%(BASE_DOCUMENT_URL)sdocops.py/file?document_id=%(item_id)d">%(title)s</A></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border=0 alt=""></TD>
  <TD class="td_listing%(class_type)d" style="text-align: right">%(str_size)s</TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border=0 alt=""></TD>
  <TD class="td_listing%(class_type)d" style="text-align: center" nowrap>%(edit_time)s</TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border=0 alt=""></TD>
  <TD class="td_listing%(class_type)d" style="text-align: center"><INPUT type="checkbox" name="sel_%(item_id)d"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border=0 alt=""></TD>
  <TD class="white"><img src="%(BASE_ICON_URL)sspacer.gif" width="8" height="1" border=0 alt=""></TD>
</TR>""" % ns)
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    cut_btn = REQUEST.TLS('doc_cutbutton')
    copy_btn = REQUEST.TLS('doc_copybutton')
    rename_btn = REQUEST.TLS('doc_renamebutton')
    output.append(u"""<TR>
  <TD colspan=9 width="100%%" style="text-align: right">
    <INPUT TYPE="image" src="%(BASE_ICON_URL)s%(cut_btn)s" name="submit_cut" value="Cut"><INPUT TYPE="image" src="%(BASE_ICON_URL)s%(copy_btn)s" name="submit_copy" value="Copy"><INPUT TYPE="image" src="%(BASE_ICON_URL)s%(rename_btn)s" name="submit_rename" value="Rename">
  </TD>
  <TD class="white"><img src="%(BASE_ICON_URL)sspacer.gif" width="8" height="1" border=0 alt=""></TD>
</TR>""" % locals())
    output.append(u"</TABLE></FORM>")
    if FULL_BAR:
        output.append(FULL_BAR)
    output.append(u"<BR>")

    return "\n".join(output)
