# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

import _Conf

import standard_html

import _InitTypes, _Access, _RootObject, _Utils, Menus, os, _Document

MY_MENU_ID = 0

def index(REQUEST):
    output = []
    extra_headers = standard_html.frametree_script(REQUEST)
    extra_body = u""" onload="show_frametree();\""""
    output.append(standard_html.html_header(REQUEST, extra_headers, extra_body))
    output.append(Menus.get_document_menu(REQUEST, MY_MENU_ID))

    if REQUEST.form.has_key('parent_id'):
        parent_id = int(REQUEST.form['parent_id'].value)
    else:
        try:
            parent_id = int(REQUEST.getCookie('activeFolder'))
        except:
            parent_id = REQUEST.USER.get_parent_id(REQUEST)

    active_folder = _RootObject.dispatch_item(REQUEST, parent_id)
    REQUEST.setCookie('activeFolder',str(parent_id))

    sortby = [
'title ASC, folder_name ASC', 'title DESC, folder_name DESC',
'item_size ASC', 'item_size DESC',
'edit_time ASC', 'edit_time DESC']
        
    DEFAULT_SORTBY = 0
    sortby_id = -1
    if REQUEST.form.has_key('sort_by') and REQUEST.form['sort_by'].value.decode('UTF8').strip():
        sortby_id = int(REQUEST.form['sort_by'].value.decode('UTF8').strip())  
    if sortby_id < 0 or sortby_id >= len(sortby):
        sortby_id  = DEFAULT_SORTBY

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_FOLDER, _InitTypes.ITEM_TYPE_DOCUMENT, _InitTypes.ITEM_TYPE_ORGANIZATION])
    if right_param:
        right_param = " AND %s" % right_param
    sql_query = """\
SELECT
 count(*) AS count_all
FROM
 items i
LEFT JOIN item_types it ON i.item_type_id=it.item_type_id
LEFT JOIN documents d ON i.item_id=d.document_id
LEFT JOIN folders f ON i.item_id=f.folder_id
LEFT JOIN organizations o ON i.item_id=o.organization_id
WHERE
 (f.folder_id IS NOT NULL OR
  (d.document_id IS NOT NULL and d.final_version_id IS NULL) OR
  o.organization_id IS NOT NULL) AND
 i.parent_id=%d%s""" % (parent_id, right_param)
    REQUEST.db.execute(sql_query.encode('utf8'))
    count_all = REQUEST.db.dictfetchone()['count_all']

    sql_query = """\
SELECT
 i.*,
 d.*,
 f.*,
 o.*,
 it.item_type_icon
FROM
 items i
LEFT JOIN item_types it ON i.item_type_id=it.item_type_id
LEFT JOIN documents d ON i.item_id=d.document_id
LEFT JOIN folders f ON i.item_id=f.folder_id
LEFT JOIN organizations o ON i.item_id=o.organization_id
WHERE
 (f.folder_id IS NOT NULL OR
  (d.document_id IS NOT NULL and d.final_version_id IS NULL) OR
  o.organization_id IS NOT NULL) AND
 i.parent_id=%d%s ORDER BY item_type_id, %s LIMIT %d OFFSET %d""" % (parent_id, right_param, sortby[sortby_id], REQUEST.batch_size, REQUEST.qs)
    REQUEST.db.execute(sql_query.encode('utf8'))
    dbresult = REQUEST.db.dictfetchall()

    virtual_path = []
    REQUEST.su_by_id(_Conf.SUPERUSER)
    parent_obj = active_folder
    while parent_obj.get_id() <> _Conf.ROOTOBJECT:
        REQUEST.unsu()
        can_read = parent_obj.canRead()
        REQUEST.su_by_id(_Conf.SUPERUSER)
        if can_read:
            virtual_path.append(u"""<A class="apath" href="%sfolder.py?parent_id=%d">%s</A>""" % (_Conf.BASE_DOCUMENT_URL, parent_obj.get_id(), _Utils.html_quote(parent_obj.get_name())))
        else:
            virtual_path.append(u"""%s""" % parent_obj.get_name())
        parent_obj = parent_obj.get_parent()
    REQUEST.unsu()
    virtual_path.reverse()
    virtual_path = u"/%s" % "/".join(virtual_path)

    output.append(u"""<DIV class="path">&nbsp;&nbsp;%s:&nbsp;%s</DIV>""" % (REQUEST.TLS('tls_path'), virtual_path))
    output.append(draw_table(REQUEST, active_folder, dbresult, sortby_id, count_all))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)


def draw_table(REQUEST, active_folder, dbresult, sortby_id, count_all):
    output = []
    output.append(u"""\
<SCRIPT type="text/javascript">
<!--
  function markAll(formvar) {
    for(var x=0;x<formvar.elements.length;x++) { 
       var y=formvar.elements[x];
       if(y.name != 'all') 
          y.checked = formvar.all.checked;
    }
  }
//-->
</SCRIPT>
""")

    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%sfolder.py%sparent_id=%s&qs=" % (_Conf.BASE_DOCUMENT_URL, REQUEST.get_formstring(['qs', 'parent_id']), active_folder.get_id())
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%sfolder.py%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_DOCUMENT_URL, REQUEST.get_formstring(['qs']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%sfolder.py%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_DOCUMENT_URL, REQUEST.get_formstring(['qs']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""

    tls_name = REQUEST.TLS('tls_name')
    tls_size = REQUEST.TLS('size')
    tls_date = REQUEST.TLS('date')

    formstring = REQUEST.get_formstring(['qs','sort_by','parent_id'])
    sortby_name = u"""<A class="blacklink" href="%sfolder.py%ssort_by=0">%s</A>&nbsp;&nbsp;""" % (_Conf.BASE_DOCUMENT_URL, formstring, tls_name)
    sortby_size = u"""<A class="blacklink" href="%sfolder.py%ssort_by=2">%s</A>&nbsp;&nbsp;""" % (_Conf.BASE_DOCUMENT_URL, formstring, tls_size)
    sortby_date = u"""<A class="blacklink" href="%sfolder.py%ssort_by=4">%s</A>&nbsp;&nbsp;""" % (_Conf.BASE_DOCUMENT_URL, formstring, tls_date)

    if sortby_id == 0:
        sortby_name = u"""<A class="blacklink" href="%sfolder.py%ssort_by=1">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_DOCUMENT_URL, formstring, tls_name)
    elif sortby_id == 1:
        sortby_name = u"""<A class="blacklink" href="%sfolder.py%ssort_by=0">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" %  (_Conf.BASE_DOCUMENT_URL, formstring, tls_name)
    if sortby_id == 2:
        sortby_size = u"""<A class="blacklink" href="%sfolder.py%ssort_by=3">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" %  (_Conf.BASE_DOCUMENT_URL, formstring, tls_size)
    elif sortby_id == 3:
        sortby_size = u"""<A class="blacklink" href="%sfolder.py%ssort_by=2">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" %  (_Conf.BASE_DOCUMENT_URL, formstring, tls_size)
    if sortby_id == 4:
        sortby_date = u"""<A class="blacklink" href="%sfolder.py%ssort_by=5">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" %  (_Conf.BASE_DOCUMENT_URL, formstring, tls_date)
    elif sortby_id == 5:
        sortby_date = u"""<A class="blacklink" href="%sfolder.py%ssort_by=4">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" %  (_Conf.BASE_DOCUMENT_URL, formstring, tls_date)
    del formstring

    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_DOCUMENT_URL = _Conf.BASE_DOCUMENT_URL
    output.append(u"""\
<BR>
<FORM name="doclist" method="POST" action="%(BASE_DOCUMENT_URL)sdocops.py">
<TABLE cellpadding=0 cellspacing=0 border=0>
<TR>
  <TD class="td_listing">&nbsp;</TD>
  <TD class="td_listing" width="100%%">
    <TABLE cellpadding=0 cellspacing=0 border=0 width="100%%">
      <TR>
        <TD width="100%%">&nbsp;</TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD class="th_listing" align="center" nowrap>&nbsp;&nbsp;&nbsp;%(sortby_name)s&nbsp;&nbsp;&nbsp;</TD>
      </TR>
    </TABLE>
  </TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sdokuvahe1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD class="th_listing" align="center" nowrap>&nbsp;&nbsp;&nbsp;%(sortby_size)s&nbsp;&nbsp;&nbsp;</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sdokuvahe1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD class="th_listing" align="center" nowrap>%(sortby_date)s</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sdokuvahe1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD class="th_listing_check" align="center" nowrap><INPUT type="checkbox" name="all" onClick="javascript:markAll(this.form);"></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
  <TD class="white"><img src="%(BASE_ICON_URL)sspacer.gif" width="8" height="1" border=0 alt=""></TD>
</TR>""" % locals())

    cut_btn = REQUEST.TLS('doc_cutbutton')
    copy_btn = REQUEST.TLS('doc_copybutton')
    paste_btn = REQUEST.TLS('doc_pastebutton')
    rename_btn = REQUEST.TLS('doc_renamebutton')
    del_btn = REQUEST.TLS('doc_deletebutton')
    if _Access.get_item_right(REQUEST, active_folder.get_id(), REQUEST.USER.get_id()) >= _Access.ACCESS_WRITE:
        buttons = ["""<INPUT TYPE="image" src="%s%s" name="submit_cut" value="Cut">""" % (_Conf.BASE_ICON_URL, cut_btn), """<INPUT TYPE="image" src="%s%s" name="submit_copy" value="Copy">""" % (_Conf.BASE_ICON_URL, copy_btn), """<INPUT TYPE="image" src="%s%s" name="submit_paste" value="Paste">""" % (_Conf.BASE_ICON_URL, paste_btn),"""<INPUT TYPE="image" src="%s%s" name="submit_rename" value="Rename">""" % (_Conf.BASE_ICON_URL, rename_btn), """<INPUT TYPE="image" src="%s%s" name="submit_delete" value="Delete" onClick="return confirm('%s');">""" % (_Conf.BASE_ICON_URL, del_btn, REQUEST.TLS('email_confirm_del'))]
        try: REQUEST.getCookie('doc_cut_ids')
        except:
            try: REQUEST.getCookie('doc_copy_ids')
            except: buttons.remove(buttons[2])
    else:
        buttons = ["""<INPUT TYPE="image" src="%s%s" name="submit_copy" value="Copy">""" % (_Conf.BASE_ICON_URL, copy_btn)]

    if dbresult:
        index = 1
        ns = {'BASE_ICON_URL':_Conf.BASE_ICON_URL,'BASE_DOCUMENT_URL':_Conf.BASE_DOCUMENT_URL,'BASE_GENERAL_URL':_Conf.BASE_GENERAL_URL}
        for row in dbresult:
            ns.update(row)
            if ns['item_type_id'] == _InitTypes.ITEM_TYPE_DOCUMENT:
                file_name = ns['filename']
                file_ext = os.path.splitext(file_name)[-1]
                if file_ext:
                    file_ext = file_ext.lower()
                if(_Conf.MIME_TYPES.has_key(file_ext)):
                    ns['item_type_icon'] =  _Conf.MIME_TYPES[file_ext]
                else:
                    ns['item_type_icon'] =  _Conf.MIME_TYPES["unknown_ext"]
            if ns['title']:
                ns['item_name'] = _Utils.html_quote_show(ns['title'].decode('UTF8'))
            else:
                ns['item_name'] = _Utils.html_quote_show(ns['item_name'].decode('UTF8'))
            ns['str_size'] = ""
            ns['edit_time'] = REQUEST.iso2userdatetime(REQUEST, ns['edit_time'])
            ns['class_type'] = index % 2
            index += 1
            if row['item_type_id'] in [_InitTypes.ITEM_TYPE_FOLDER, _InitTypes.ITEM_TYPE_ORGANIZATION]:
                ns['startlink'] = '<A class="td_listing" href="%(BASE_DOCUMENT_URL)sfolder.py?parent_id=%(item_id)d">' % ns
                ns['endlink'] = '</A>'
            elif row['item_type_id'] in [_InitTypes.ITEM_TYPE_DOCUMENT]:
                ns['str_size'] = _Utils.str_size(ns['item_size'])
                ns['startlink'] = '<A class="td_listing" href="%(BASE_DOCUMENT_URL)sdocops.py/file?document_id=%(item_id)d">' % ns
                ns['endlink'] = '</A>'
            else:
                ns['startlink'] = ''
                ns['endlink'] = ''
            ns['checkbox'] = """<INPUT type="checkbox" name="sel_%(item_id)d">""" % ns
            if row['item_type_id'] not in [_InitTypes.ITEM_TYPE_FOLDER, _InitTypes.ITEM_TYPE_DOCUMENT]:
                ns['checkbox'] = ""
            ns['info_tls'] = REQUEST.TLS('tls_information')
            ns['lock'] = ""
            output.append(u"""<TR class="tr_listing%(class_type)d">
  <TD class="td_listing%(class_type)d" style="text-align: center"><A href="%(BASE_GENERAL_URL)sinfo.py?item_id=%(item_id)d"><IMG src="%(BASE_ICON_URL)s%(item_type_icon)s" title="%(info_tls)s" alt="%(info_tls)s" width="18" height="14" border="0"></A></TD>
  <TD class="td_listing%(class_type)d">%(lock)s%(startlink)s%(item_name)s%(endlink)s</TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border=0 alt=""></TD>
  <TD class="td_listing%(class_type)d" style="text-align: right">%(str_size)s</TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border=0 alt=""></TD>
  <TD class="td_listing%(class_type)d" style="text-align: center" nowrap>%(edit_time)s</TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border=0 alt=""></TD>
  <TD class="td_listing%(class_type)d" style="text-align: center">%(checkbox)s</TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border=0 alt=""></TD>
  <TD class="white"><img src="%(BASE_ICON_URL)sspacer.gif" width="8" height="1" border=0 alt=""></TD>
</TR>""" % ns)
    else:
        if len(buttons) == 5: buttons = [buttons[2]]
        else: buttons = []
    if buttons:
        output.append(u"""\
<TR>
  <TD colspan=9 width="100%%" style="text-align: right">
    %s
  </TD>
  <TD class="white"><img src="%sspacer.gif" width="8" height="1" border=0 alt=""></TD>
</TR>""" % ("".join(buttons), _Conf.BASE_ICON_URL))
    output.append(u"""\
</TABLE>
</FORM>""")

    if FULL_BAR:
        output.append(FULL_BAR)

    return "\n".join(output)
