# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

from mod_python import apache
import urllib
import base64, email, email.Header, email.MIMEMultipart, email.MIMEText, mx.DateTime, smtplib, email.Utils, email.MIMEMessage
import _Conf, _Utils, _mail, _InitTypes, _Email, _Efolder, _Document, _Contact, _Access, _InitTypes
from Menus import get_email_menu
import standard_html
import MIMEFile
import popen2
import re

MY_MENU_ID=2

def index(REQUEST):
    try:
        tmp = REQUEST.get_setting('email_sender_name')
        tmp = REQUEST.get_setting('email_sender_email')
    except:
        raise RuntimeError, REQUEST.TLS('email_nosettings')
    if REQUEST.form.has_key('email_type') and REQUEST.form['email_type'].value == '1':
        return delete(REQUEST)
    elif REQUEST.form.has_key('email_type') and REQUEST.form['email_type'].value == '2':
        return forward(REQUEST)
    elif REQUEST.form.has_key('email_type') and REQUEST.form['email_type'].value == '3':
        return reply(REQUEST)
    elif REQUEST.form.has_key('email_type') and REQUEST.form['email_type'].value == '5':
        return forward(REQUEST, attach=1)
    elif REQUEST.form.has_key('email_type') and REQUEST.form['email_type'].value == '4':
        return replyall(REQUEST)
    elif REQUEST.form.has_key('email_delete'):
        return delete(REQUEST)
    elif REQUEST.form.has_key('email_forward'):
        return forward(REQUEST)
    elif REQUEST.form.has_key('email_reply'):
        return reply(REQUEST)
    elif REQUEST.form.has_key('email_forward2'):
        return forward(REQUEST, attach=1)
    elif REQUEST.form.has_key('email_replyall'):
        return replyall(REQUEST)
    elif REQUEST.form.has_key('email_contact'):
        return contactmail(REQUEST)
    else:
        return compose(REQUEST)

def parse_obj_addresses(msg, val, include_groups=1):
    if val is None: return ""
    to_emails = email.Utils.getaddresses([val])
    to = []
    for r in to_emails:
        if r[0]:
            n = _mail.parse_quoted_string(msg, r[0])
            if n.find('"') == -1:
                to.append('%s <%s>' % (email.Header.Header(u'"%s"'%n).encode().strip(), r[1].strip().encode('UTF8')))
            else:
                to.append('%s <%s>' % (email.Header.Header(u'"%s"'%r[0]).encode().strip(), r[1].strip().encode('UTF8')))
            if to[-1].find('"=?') <> -1: # Double-quoting issue. Maybe FIXME?
                to[-1] = to[-1].replace('"=?', '=?').replace('?="', '?=')
        else:
            if ((r[1] and r[1][0]=="{") or r[1][:2] == '"{') and ((r[1] and r[1][-1]=="}") or r[1][-2:]=='}"') and include_groups:
                to.append(email.Header.Header(u'%s'%r[1]).encode().strip())               
                if to[-1].find('"=?') <> -1: # Double-quoting issue. Maybe FIXME?
                    to[-1] = to[-1].replace('"=?', '=?').replace('?="', '?=')
            elif ((r[1] and r[1][0]=="{") or r[1][:2] == '"{') and ((r[1] and r[1][-1]=="}") or r[1][-2:]=='}"') and not include_groups:
                pass
            else:
                try:
                    if isinstance(r[1], unicode):
                        to.append(r[1].encode('UTF8'))
                    else:
                        to.append(r[1])
                except:
                    raise RuntimeError, [r[1], type(r[1])]
    return ", ".join(to)


def compose(REQUEST):
    # Find out drafts id
    REQUEST.db.execute("""SELECT e.efolder_id FROM items i, efolders e WHERE e.efolder_id=i.item_id AND i.parent_id=%d AND (e.efolder_flags & %d) <> 0""" % (REQUEST.USER.get_id(), _Efolder.EFOLDER_DRAFTS))
    result = REQUEST.db.dictfetchone()
    if not result:
        raise RuntimeError, REQUEST.TLS('email_nodraftsfolder')
    DRAFT_ID = result['efolder_id']

    if REQUEST.form.has_key('is_html'):
        email_format = REQUEST.form['is_html'].value
    else:
        try:
            email_format = REQUEST.get_setting('email_format')
        except:
            email_format = "1"

    REQUEST.db.execute("""SELECT e.email_id, e.email_to, e.email_subject FROM items i, emails e WHERE i.item_id=e.email_id AND i.parent_id=%d AND (e.email_flags & %d) <> 0""" % (DRAFT_ID, _Email.EMAIL_DRAFT))
    result = REQUEST.db.dictfetchall()
    drafts = []
    for draft in result:
        drafts.append(u"""<OPTION value="%d">%s""" % (draft['email_id'], _Utils.html_quote(draft['email_subject'].decode('UTF8'))))
    if drafts:
        drafts = u"""
 <TR class="tr_listing1">
  <TD><img src="%sspacer.gif" width=15 height=20 border=0 alt=""></TD>
  <TD class="td_listing1b">%s:</TD>
  <TD class="td_listing1"><SELECT name="select_draft" onChange="change_url(document.composeform.select_draft[document.composeform.select_draft.selectedIndex].value)"><OPTION value="">&nbsp;&nbsp;&nbsp;\n%s\n</SELECT></TD>
 </TR>""" % (_Conf.BASE_ICON_URL, REQUEST.TLS('email_drafts'), "\n".join(drafts))
    else:
        drafts = u""

    if REQUEST.form.has_key('mail_id') and REQUEST.form['mail_id'].value:
        msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['mail_id'].value))
        if msg.get('email_contacts'):
            return contactmail(REQUEST)
        message = _mail.message_from_string(base64.decodestring(msg.get('email_contents')))
        attachments = _mail.get_attachments(REQUEST, message, show_messages=1)
        attach_output = []
        for attach in attachments:
            if attach.get_content_type() == 'message/rfc822':
                filename = REQUEST.TLS('email_forwardedemail')
            else:
                filename = _mail.parse_quoted_string(attach, (attach.get_filename() or _mail.get_alt_name(attach) or 'noname.bin'))
            attach_output.append(u"""<B>%s</B>: %s (%s) <A href="javascript:document.location.href='%scompose.py/delpart?mail_id=%d&type_compose=1&part=%s&is_html='+document.forms['composeform'].is_html[document.forms['composeform'].is_html.selectedIndex].value;">%s</A>""" % (REQUEST.TLS('email_attachment'), filename, attach.get_content_type(), _Conf.BASE_EMAIL_URL, msg.get_id(), attach['conflux-ident'], REQUEST.TLS('email_short_del')))
        if attach_output:
            attach_output = """
 <TR>
  <TD><img src="%sspacer.gif" width=15 height=20 border=0 alt=""></TD>
  <TD colspan="2">%s</TD>
 </TR>""" % (_Conf.BASE_ICON_URL, "<BR>\n".join(attach_output))
        else:
            attach_output = u""
        mail_id = u"""<INPUT type="hidden" name="mail_id" value="%d">""" % msg.get_id()
        mail_to = _Utils.html_quote(_mail.parse_quoted_string(message, message['to'] or u'')).replace('\t',' ')
        mail_cc = _Utils.html_quote(_mail.parse_quoted_string(message, message['cc'] or u'')).replace('\t',' ')
        mail_bcc = _Utils.html_quote(_mail.parse_quoted_string(message, message['bcc'] or u'')).replace('\t',' ')
        mail_subject = _Utils.html_quote(_mail.parse_quoted_string(message, message['subject'] or u''))
        try:
            mail_contents = message.get_payload(0).get_payload(1).get_payload(decode=1) # FIXME ?
            chset = message.get_payload(0).get_payload(1).get_content_charset()
        except:
            mail_contents = message.get_payload(0).get_payload(decode=1) # FIXME ?
            chset = message.get_payload(0).get_content_charset()
        if chset and isinstance(mail_contents, str):
            try: 
                mail_contents = mail_contents.decode(_mail.parse_charset(chset))
            except UnicodeError: # FIXME, checking for bastards who claim one charset and use another!
                mail_contents = mail_contents.decode(_Conf.FALLBACK_ENCODING)
        else:
            try: # Since we already check for charset a few lines above, we have to assume
                 # this is a ascii message. However, not all are :(, so we try to work around
                 # with FALLBACK_ENCODING when an error occurs
                mail_contents = unicode(mail_contents)
            except UnicodeError:
                mail_contents = mail_contents.decode(_Conf.FALLBACK_ENCODING)
    else:
        attach_output = u""
        mail_id = u""
        if REQUEST.form.has_key('mail_to') and REQUEST.form['mail_to'].value.strip():
            mail_to = urllib.unquote(REQUEST.form['mail_to'].value.decode('UTF8').strip())
        else:
            mail_to = u""
        mail_cc = u""
        mail_bcc = u""
        mail_contents = u""
        mail_subject = u""

    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_EMAIL_URL = _Conf.BASE_EMAIL_URL
    tls_selectdoc = REQUEST.TLS('email_selectdoc')
    tls_choose = REQUEST.TLS('email_choose')
    output = []
    if email_format=="2":
        output.append(standard_html.html_header(REQUEST, extra_headers="", extra_body="""onbeforeunload="return confirm_leave();" onload=show_plain();"""))
    else:
        output.append(standard_html.html_header(REQUEST, "", """onbeforeunload="return confirm_leave();\""""))
    hiddenstr = ""
    if REQUEST.form.has_key('read_mail_id') and REQUEST.form['read_mail_id'].value:
        hiddenstr = """<input type="hidden" name="read_mail_id" value="%s"><input type="hidden" name="type_reply" value="1">""" % (REQUEST.form['read_mail_id'].value)
    output.append(get_email_menu(REQUEST, MY_MENU_ID))
    output.append(form_html(REQUEST, mail_id, drafts, attach_output, mail_to, mail_cc, mail_bcc, mail_subject, mail_contents, hiddenstr))
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def delete(REQUEST):
    if not REQUEST.form.has_key('read_mail_id') or not REQUEST.form['read_mail_id'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    # Find out delete-items id
    REQUEST.db.execute("""SELECT e.efolder_id FROM items i, efolders e WHERE e.efolder_id=i.item_id AND i.parent_id=%d AND (e.efolder_flags & %d) <> 0""" % (REQUEST.USER.get_id(), _Efolder.EFOLDER_DELETED))
    result = REQUEST.db.dictfetchone()
    if not result:
        raise RuntimeError, REQUEST.TLS('email_nodeletedfolder')
    DELBOX_ID = result['efolder_id']

    output = []
    output.append(standard_html.html_header(REQUEST))
    ref_url = REQUEST.SERVER_URL+_Conf.BASE_EMAIL_URL+"efolder1.py"
    output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(get_email_menu(REQUEST, -1))

    msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['read_mail_id'].value))
    if msg.get_parent_id() == DELBOX_ID:
        msg.delete()
        output.append(REQUEST.TLS('email_msgdeleted2'))
    else:
        msg.set('parent_id',DELBOX_ID)
        msg.save()
        output.append(REQUEST.TLS('email_msgdeleted'))

    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def reply(REQUEST):
    if not REQUEST.form.has_key('read_mail_id') or not REQUEST.form['read_mail_id'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    output = []

    if REQUEST.form.has_key('is_html'):
        email_format = REQUEST.form['is_html'].value
    else:   
        try:
            email_format = REQUEST.get_setting('email_format')
        except:
            email_format = "1"
    if email_format=="2":
        output.append(standard_html.html_header(REQUEST, extra_headers="", extra_body="""onbeforeunload="return confirm_leave();" onload=show_plain();"""))
    else:
        output.append(standard_html.html_header(REQUEST, "", """onbeforeunload="return confirm_leave();\""""))

    output.append(get_email_menu(REQUEST, MY_MENU_ID))

    mail_contents = []
    msg_reply = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['read_mail_id'].value))
    message_reply = _mail.message_from_string(base64.decodestring(msg_reply.get('email_contents')))
    mail_contents.append(u"On %s, %s wrote:" % (REQUEST.iso2userdatetime(REQUEST, msg_reply.get('email_date')), (email.Utils.parseaddr(msg_reply.get('email_from'))[0] or msg_reply.get('email_from')))) # FIXME
    mail_contents.append(u" ")
    mail_contents.append(_mail.reply_message(REQUEST, message_reply))
    mail_contents = "\n".join(mail_contents)
    mail_contents = mail_contents.replace('\r', '')
    ndx = mail_contents.find('\n\n\n')
    while ndx <> -1:
        mail_contents = mail_contents.replace('\n\n\n', '\n\n')
        ndx = mail_contents.find('\n\n\n')
    mail_contents = mail_contents.replace('\n', '<br>&gt; ')


    tls_to = REQUEST.TLS('email_to')
    tls_cc = REQUEST.TLS('email_cc')
    tls_bcc = REQUEST.TLS('email_bcc')
    tls_subject = REQUEST.TLS('tls_subject')
    tls_attachment = REQUEST.TLS('email_attachment')
    tls_addattachment = REQUEST.TLS('email_addattachment')
    tls_choose = REQUEST.TLS('email_choose')
    tls_send = REQUEST.TLS('email_send')
    tls_replymessage = REQUEST.TLS('email_replymessage')
    tls_save = REQUEST.TLS('tls_save')
    tls_or = REQUEST.TLS('tls_or')
    tls_selectdoc = REQUEST.TLS('email_selectdoc')

    BASE_EMAIL_URL = _Conf.BASE_EMAIL_URL
    reply_mail_id = msg_reply.get_id()

    mail_to = _mail.parse_quoted_string(message_reply, parse_obj_addresses(message_reply, message_reply['from']))

    mail_subject = "Re: %s" % msg_reply.get('email_subject') # FIXME
    if isinstance(mail_subject, str):
        mail_subject = mail_subject.decode('UTF8')
    mail_subject = _Utils.html_quote(mail_subject)

    if REQUEST.form.has_key('mail_id') and REQUEST.form['mail_id'].value:
        msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['mail_id'].value))
        message = _mail.message_from_string(base64.decodestring(msg.get('email_contents')))

        attachments = _mail.get_attachments(REQUEST, message, show_messages=1)
        attach_output = []
        for attach in attachments:
            if attach.get_content_type() == 'message/rfc822':
                filename = REQUEST.TLS('email_forwardedemail')
            else:
                filename = _mail.parse_quoted_string(attach, (attach.get_filename() or _mail.get_alt_name(message) or 'noname.bin'))
            attach_output.append(u"""<B>%s</B>: %s (%s) <A href="javascript:document.location.href='%scompose.py/delpart?mail_id=%d&read_mail_id=%d&type_forward=1&part=%s&is_html='+document.forms['composeform'].is_html[document.forms['composeform'].is_html.selectedIndex].value;">%s</A>""" % (REQUEST.TLS('email_attachment'), filename, attach.get_content_type(), _Conf.BASE_EMAIL_URL, msg.get_id(), msg_reply.get_id(), attach['conflux-ident'], REQUEST.TLS('email_short_del')))

        if attach_output:
            attach_output = """
 <TR>
  <TD><img src="%sspacer.gif" width=15 height=20 border=0 alt=""></TD>
  <TD colspan="2">%s</TD>
 </TR>""" % (_Conf.BASE_ICON_URL, "<BR>\n".join(attach_output))
        else:
            attach_output = u""
        mail_id = u"""<INPUT type="hidden" name="mail_id" value="%d">""" % msg.get_id()
        mail_to = _Utils.html_quote(_mail.parse_quoted_string(message, message['to'] or u'')).replace('\t',' ')
        mail_cc = _Utils.html_quote(_mail.parse_quoted_string(message, message['cc'] or u'')).replace('\t',' ')
        mail_bcc = _Utils.html_quote(_mail.parse_quoted_string(message, message['bcc'] or u'')).replace('\t',' ')
        mail_subject = _Utils.html_quote(_mail.parse_quoted_string(message, message['subject'] or u''))
        try:
            mail_contents = message.get_payload(0).get_payload(1).get_payload(decode=1) # FIXME ?
            chset = message.get_payload(0).get_payload(1).get_content_charset()
        except:
            mail_contents = message.get_payload(0).get_payload(decode=1) # FIXME ?
            chset = message.get_payload(0).get_content_charset()
#        mail_contents = message.get_payload(0).get_payload(decode=1) # FIXME ?
        if chset and isinstance(mail_contents, str):
            try: 
                mail_contents = mail_contents.decode(_mail.parse_charset(chset))
            except UnicodeError: # FIXME, checking for bastards who claim one charset and use another!
                mail_contents = mail_contents.decode(_Conf.FALLBACK_ENCODING)
        else:
            try: # Since we already check for charset a few lines above, we have to assume
                 # this is a ascii message. However, not all are :(, so we try to work around
                 # with FALLBACK_ENCODING when an error occurs
                mail_contents = unicode(mail_contents)
            except UnicodeError:
                mail_contents = mail_contents.decode(_Conf.FALLBACK_ENCODING)
    else:
        attach_output = u""
        mail_id = u""
        mail_cc = u""
        mail_bcc = u""
        

    BASE_WEB_URL = _Conf.BASE_WEB_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    hiddenstr = u"""
<INPUT type="hidden" name="read_mail_id" value="%(reply_mail_id)s">
<INPUT type="hidden" name="type_reply" value="1">""" % locals()
    output.append(form_html(REQUEST, mail_id, "", attach_output, mail_to, mail_cc, mail_bcc, mail_subject, mail_contents, hiddenstr))
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def forward(REQUEST, attach=0):
    if not REQUEST.form.has_key('read_mail_id') or not REQUEST.form['read_mail_id'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    REQUEST.db.execute("""SELECT e.efolder_id FROM items i, efolders e WHERE e.efolder_id=i.item_id AND i.parent_id=%d AND (e.efolder_flags & %d) <> 0""" % (REQUEST.USER.get_id(), _Efolder.EFOLDER_DRAFTS))
    result = REQUEST.db.dictfetchone()
    if not result:
        raise RuntimeError, REQUEST.TLS('email_nodraftsfolder')
    DRAFT_ID = result['efolder_id']

    output = []

    if REQUEST.form.has_key('is_html'):
        email_format = REQUEST.form['is_html'].value
    else:   
        try:
            email_format = REQUEST.get_setting('email_format')
        except:
            email_format = "1"
    if email_format=="2":
        output.append(standard_html.html_header(REQUEST, extra_headers="", extra_body="""onbeforeunload="return confirm_leave();" onload=show_plain();"""))
    else:
        output.append(standard_html.html_header(REQUEST, "", """onbeforeunload="return confirm_leave();\""""))

    output.append(get_email_menu(REQUEST, MY_MENU_ID))

    mail_contents = []
    msg_reply = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['read_mail_id'].value))
    message_reply = _mail.message_from_string(base64.decodestring(msg_reply.get('email_contents')))
    if not attach:
        mail_contents.append(u"")
        mail_contents.append(u"----- Forwarded message -----")
        mail_contents.append(u"&gt; Date: %s" % REQUEST.iso2userdatetime(REQUEST, msg_reply.get('email_date')))
        try:
            email_from_addr = email.Utils.getaddresses([message_reply['from']])[0]
            if email_from_addr[0]:
                mail_contents.append(u"&gt; From: %s &lt;%s&gt;" % (msg_reply.get('email_from'), email_from_addr[1]))
            else:
                mail_contents.append(u"&gt; From: %s" % msg_reply.get('email_from'))
        except:
            mail_contents.append(u"&gt; From: %s" % msg_reply.get('email_from'))
        mail_contents.append(u"&gt; Subject: %s" % msg_reply.get('email_subject'))

        try:
            tmp = u"&gt; To: "
            start = 0
            email_to_addr = email.Utils.getaddresses([message_reply['to']])
            for i in email_to_addr:
                if i[0] and i[0] <> i[1]:
                    tmp += u"%s%s &lt;%s&gt;" % ((((start <> 0 and ", ") or ""), _mail.parse_quoted_string(message_reply, i[0]), i[1]))
                else:
                    tmp += u"%s%s" % ((((start <> 0 and ", ") or ""), i[1]))
                start = 1
            mail_contents.append(tmp)
        except:
            mail_contents.append(u"&gt; To: %s" % msg_reply.get('email_to'))
        mail_contents.append(u"&gt; ")
        mail_contents.append(_mail.reply_message(REQUEST, message_reply))
        mail_contents.append(u"----- End forwarded message -----")
    mail_contents = "\n".join(mail_contents)
    if email_format == "2":
        mail_contents = mail_contents.replace('\n', '\n&gt; ')
        mail_contents = _Utils.strip_html(mail_contents, valid_tags=[])#.replace('\n', '<br>')
    else:
        mail_contents = mail_contents.replace('\n', '<br>&gt; ')

    tls_to = REQUEST.TLS('email_to')
    tls_cc = REQUEST.TLS('email_cc')
    tls_bcc = REQUEST.TLS('email_bcc')
    tls_subject = REQUEST.TLS('tls_subject')
    tls_attachment = REQUEST.TLS('email_attachment')
    tls_addattachment = REQUEST.TLS('email_addattachment')
    tls_choose = REQUEST.TLS('email_choose')
    tls_send = REQUEST.TLS('email_send')
    tls_forwardmessage = REQUEST.TLS('email_forwardmessage')
    tls_save = REQUEST.TLS('tls_save')
    tls_or = REQUEST.TLS('tls_or')
    tls_selectdoc = REQUEST.TLS('email_selectdoc')

    BASE_EMAIL_URL = _Conf.BASE_EMAIL_URL
    reply_mail_id = msg_reply.get_id()
    mail_subject = "Fwd: %s" % msg_reply.get('email_subject') # FIXME
    if isinstance(mail_subject, str):
        mail_subject = mail_subject.decode('UTF8')

    if REQUEST.form.has_key('mail_id') and REQUEST.form['mail_id'].value:
        msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['mail_id'].value))
        message = _mail.message_from_string(base64.decodestring(msg.get('email_contents')))

        attachments = _mail.get_attachments(REQUEST, message, show_messages=1)
        attach_output = []
        for attach in attachments:
            if attach.get_content_type() == 'message/rfc822':
                filename = REQUEST.TLS('email_forwardedemail')
            else:
                filename = _mail.parse_quoted_string(attach, (attach.get_filename() or _mail.get_alt_name(attach) or 'noname.bin'))
            attach_output.append(u"""<B>%s</B>: %s (%s) <A href="javascript:document.location.href='%scompose.py/delpart?mail_id=%d&read_mail_id=%d&type_forward=1&part=%s&is_html='+document.forms['composeform'].is_html[document.forms['composeform'].is_html.selectedIndex].value;">%s</A>""" % (REQUEST.TLS('email_attachment'), filename, attach.get_content_type(), _Conf.BASE_EMAIL_URL, msg.get_id(), msg_reply.get_id(), attach['conflux-ident'], REQUEST.TLS('email_short_del')))

        if attach_output:
            attach_output = """ <TR>
  <TD><img src="%sspacer.gif" width=15 height=20 border=0 alt=""></TD>
  <TD colspan="2">%s</TD>
 </TR>""" % (_Conf.BASE_ICON_URL, "<BR>\n".join(attach_output))
        else:
            attach_output = u""
        mail_id = u"""<INPUT type="hidden" name="mail_id" value="%d">""" % msg.get_id()
        mail_to = _Utils.html_quote(_mail.parse_quoted_string(message, message['to'] or u'')).replace('\t',' ')
        mail_bcc = _Utils.html_quote(_mail.parse_quoted_string(message, message['bcc'] or u'')).replace('\t',' ')
        mail_cc = _Utils.html_quote(_mail.parse_quoted_string(message, message['cc'] or u'')).replace('\t',' ')
        mail_subject = _Utils.html_quote(_mail.parse_quoted_string(message, message['subject'] or u''))
        try:
            mail_contents = message.get_payload(0).get_payload(1).get_payload(decode=1) # FIXME ?
            chset = message.get_payload(0).get_payload(1).get_content_charset()
        except:
            mail_contents = message.get_payload(0).get_payload(decode=1) # FIXME ?
            chset = message.get_payload(0).get_content_charset()
#        mail_contents = message.get_payload(0).get_payload(decode=1) # FIXME ?
        if chset and isinstance(mail_contents, str):
            try: 
                mail_contents = mail_contents.decode(_mail.parse_charset(chset))
            except UnicodeError: # FIXME, checking for bastards who claim one charset and use another!
                mail_contents = mail_contents.decode(_Conf.FALLBACK_ENCODING)
        else:
            try: # Since we already check for charset a few lines above, we have to assume
                 # this is a ascii message. However, not all are :(, so we try to work around
                 # with FALLBACK_ENCODING when an error occurs
                mail_contents = unicode(mail_contents)
            except UnicodeError:
                mail_contents = mail_contents.decode(_Conf.FALLBACK_ENCODING)
    else:
        msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_NEW)
        msg.set('index_this_item', 1)
        msg.set('parent_id', DRAFT_ID)
        message = email.MIMEMultipart.MIMEMultipart()
        message['Subject'] = mail_subject
        try:
            msg.set('email_from', u"%s <%s>" % (REQUEST.get_setting('email_sender_name'), REQUEST.get_setting('email_sender_email')))
            del message['from']
            message['From'] = u"%s <%s>" % (email.Header.Header(REQUEST.get_setting('email_sender_name')), REQUEST.get_setting('email_sender_email'))
        except:
            raise RuntimeError, REQUEST.TLS('email_nosettings')

        submsg = email.MIMEText.MIMEText(mail_contents.encode('UTF8'))
        del submsg['content-type']
        if REQUEST.form.has_key('is_html'):
            email_format = REQUEST.form['is_html'].value
        else:
            try:
                email_format = REQUEST.get_setting('email_format')
            except:
                email_format = "1"

        if email_format == "1":
            submsg['Content-Type'] = 'text/html; charset="utf-8"' 
        else:
            submsg['Content-Type'] = 'text/plain; charset="utf-8"'
        message.attach(submsg)
        if attach: # if attach, send whole old message.
            submsg = email.MIMEMessage.MIMEMessage(message_reply)
            message.attach(submsg)
        else: # else add attachments of the old message
            for attachobj in _mail.get_attachments(REQUEST, message_reply, show_messages=0):
                submsg = MIMEFile.MIMEFile(attachobj.get_payload(decode=1), _mail.parse_quoted_string(attachobj, (_mail.parse_quoted_string(attachobj, attachobj.get_filename() or _mail.get_alt_name(attachobj) or 'noname.bin'))))
                message.attach(submsg)

        msg.set('email_contents', base64.encodestring(message.as_string()))
        msg.set('email_date', REQUEST.user2isodatetime(REQUEST, REQUEST.iso2userdatetime(REQUEST, _Utils.utc_now_mx())))
        msg.set('email_size', len(message.as_string()))
        msg.set('email_to', u'')
        msg.set('email_flags', _Email.EMAIL_READ)
        msg.set('email_subject', mail_subject)
        msg.save()
        mail_id = u"""<INPUT type="hidden" name="mail_id" value="%d">""" % msg.get_id()

        attachments = _mail.get_attachments(REQUEST, message, show_messages=1)
        attach_output = []
        for attach in attachments:
            if attach.get_content_type() == 'message/rfc822':
                filename = REQUEST.TLS('email_forwardedemail')
            else:
                filename = _mail.parse_quoted_string(attach, (attach.get_filename() or _mail.get_alt_name(attach) or 'noname.bin'))
            attach_output.append(u"""<B>%s</B>: %s (%s) <A href="javascript:document.location.href='%scompose.py/delpart?mail_id=%d&read_mail_id=%d&type_forward=1&part=%s&is_html='+document.forms['composeform'].is_html[document.forms['composeform'].is_html.selectedIndex].value;">%s</A>""" % (REQUEST.TLS('email_attachment'), filename, attach.get_content_type(), _Conf.BASE_EMAIL_URL, msg.get_id(), msg_reply.get_id(), attach['conflux-ident'], REQUEST.TLS('email_short_del')))
        if attach_output:
            attach_output = """ <TR>
  <TD><img src="%sspacer.gif" width=15 height=20 border=0 alt=""></TD>
  <TD colspan="2">%s</TD>
 </TR>""" % (_Conf.BASE_ICON_URL, "<BR>\n".join(attach_output))
        else:
            attach_output = u""
        mail_to = u""
        mail_cc = u""
        mail_bcc = u""


    BASE_WEB_URL = _Conf.BASE_WEB_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    hiddenstr = u"""
<INPUT type="hidden" name="read_mail_id" value="%(reply_mail_id)s">
<INPUT type="hidden" name="type_forward" value="1">""" % locals()
    output.append(form_html(REQUEST, mail_id, "", attach_output, mail_to, mail_cc, mail_bcc, mail_subject, mail_contents, hiddenstr, REQUEST.TLS('email_forwardmessage')))
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def replyall(REQUEST):
    if not REQUEST.form.has_key('read_mail_id') or not REQUEST.form['read_mail_id'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    output = []
    if REQUEST.form.has_key('is_html'):
        email_format = REQUEST.form['is_html'].value
    else:   
        try:
            email_format = REQUEST.get_setting('email_format')
        except:
            email_format = "1"
    if email_format=="2":
        output.append(standard_html.html_header(REQUEST, extra_headers="", extra_body="""onbeforeunload="return confirm_leave();" onload=show_plain();"""))
    else:
        output.append(standard_html.html_header(REQUEST, "", """onbeforeunload="return confirm_leave();\""""))
    output.append(get_email_menu(REQUEST, MY_MENU_ID))

    mail_contents = []
    msg_reply = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['read_mail_id'].value))
    message_reply = _mail.message_from_string(base64.decodestring(msg_reply.get('email_contents')))
    mail_contents.append(u"On %s, %s wrote:" % (REQUEST.iso2userdatetime(REQUEST, msg_reply.get('email_date')), (email.Utils.parseaddr(msg_reply.get('email_from'))[0] or msg_reply.get('email_from')))) # FIXME
    mail_contents.append(u" ")
    mail_contents.append(_mail.reply_message(REQUEST, message_reply))
    mail_contents = "\n".join(mail_contents)
    if email_format == "1":
        mail_contents = _Utils.strip_html(mail_contents, valid_tags=[])
    mail_contents = mail_contents.replace('\r', '')
    ndx = mail_contents.find('\n\n\n')
    while ndx <> -1:
        mail_contents = mail_contents.replace('\n\n\n', '\n\n')
        ndx = mail_contents.find('\n\n\n')
    mail_contents = mail_contents.replace('\n', '<br>&gt; ')



    tls_to = REQUEST.TLS('email_to')
    tls_cc = REQUEST.TLS('email_cc')
    tls_bcc = REQUEST.TLS('email_bcc')
    tls_subject = REQUEST.TLS('tls_subject')
    tls_attachment = REQUEST.TLS('email_attachment')
    tls_addattachment = REQUEST.TLS('email_addattachment')
    tls_choose = REQUEST.TLS('email_choose')
    tls_send = REQUEST.TLS('email_send')
    tls_replyallmessage = REQUEST.TLS('email_replyallmessage')
    tls_save = REQUEST.TLS('tls_save')
    tls_or = REQUEST.TLS('tls_or')
    tls_selectdoc = REQUEST.TLS('email_selectdoc')

    BASE_EMAIL_URL = _Conf.BASE_EMAIL_URL
    reply_mail_id = msg_reply.get_id()

    mail_to = _mail.parse_quoted_string(message_reply, parse_obj_addresses(message_reply, message_reply['from']))
    if _mail.parse_quoted_string(message_reply, parse_obj_addresses(message_reply, message_reply['to'])):
        mail_to += ", " + _mail.parse_quoted_string(message_reply, parse_obj_addresses(message_reply, message_reply['to']))
    if _mail.parse_quoted_string(message_reply, parse_obj_addresses(message_reply, message_reply['cc'])):
        mail_to += ", " + _mail.parse_quoted_string(message_reply, parse_obj_addresses(message_reply, message_reply['cc']))

    mail_subject = "Re: %s" % msg_reply.get('email_subject') # FIXME
    if isinstance(mail_subject, str):
        mail_subject = mail_subject.decode('UTF8')

    if REQUEST.form.has_key('mail_id') and REQUEST.form['mail_id'].value:
        msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['mail_id'].value))
        message = _mail.message_from_string(base64.decodestring(msg.get('email_contents')))

        attachments = _mail.get_attachments(REQUEST, message, show_messages=1)
        attach_output = []
        for attach in attachments:
            if attach.get_content_type() == 'message/rfc822':
                filename = REQUEST.TLS('email_forwardedemail')
            else:
                filename = _mail.parse_quoted_string(attach, (attach.get_filename() or _mail.get_alt_name(attach) or 'noname.bin'))
            attach_output.append(u"""<B>%s</B>: %s (%s) <A href="javascript:document.location.href='%scompose.py/delpart?mail_id=%d&read_mail_id=%d&type_forward=1&part=%s&is_html='+document.forms['composeform'].is_html[document.forms['composeform'].is_html.selectedIndex].value;">%s</A>""" % (REQUEST.TLS('email_attachment'), filename, attach.get_content_type(), _Conf.BASE_EMAIL_URL, msg.get_id(), msg_reply.get_id(), attach['conflux-ident'], REQUEST.TLS('email_short_del')))

        if attach_output:
            attach_output = """ <TR>
  <TD><img src="%sspacer.gif" width=15 height=20 border=0 alt=""></TD>
  <TD colspan="2">%s</TD>
 </TR>""" % (_Conf.BASE_ICON_URL, "<BR>\n".join(attach_output))
        else:
            attach_output = u""
        mail_id = u"""<INPUT type="hidden" name="mail_id" value="%d">""" % msg.get_id()
        mail_to = _Utils.html_quote(_mail.parse_quoted_string(message, message['to'] or u'')).replace('\t',' ')
        mail_cc = _Utils.html_quote(_mail.parse_quoted_string(message, message['cc'] or u'')).replace('\t',' ')
        mail_bcc = _Utils.html_quote(_mail.parse_quoted_string(message, message['bcc'] or u'')).replace('\t',' ')
        mail_subject = _Utils.html_quote(_mail.parse_quoted_string(message, message['subject'] or u''))
        try:
            mail_contents = message.get_payload(0).get_payload(1).get_payload(decode=1) # FIXME ?
            chset = message.get_payload(0).get_payload(1).get_content_charset()
        except:
            mail_contents = message.get_payload(0).get_payload(decode=1) # FIXME ?
            chset = message.get_payload(0).get_content_charset()
#        mail_contents = message.get_payload(0).get_payload(decode=1) # FIXME ?
        if chset and isinstance(mail_contents, str):
            try: 
                mail_contents = mail_contents.decode(_mail.parse_charset(chset))
            except UnicodeError: # FIXME, checking for bastards who claim one charset and use another!
                mail_contents = mail_contents.decode(_Conf.FALLBACK_ENCODING)
        else:
            try: # Since we already check for charset a few lines above, we have to assume
                 # this is a ascii message. However, not all are :(, so we try to work around
                 # with FALLBACK_ENCODING when an error occurs
                mail_contents = unicode(mail_contents)
            except UnicodeError:
                mail_contents = mail_contents.decode(_Conf.FALLBACK_ENCODING)
    else:
        attach_output = u""
        mail_id = u""
        mail_cc = u""
        mail_bcc = u""


    BASE_WEB_URL = _Conf.BASE_WEB_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    hiddenstr = u"""
<INPUT type="hidden" name="read_mail_id" value="%(reply_mail_id)s">
<INPUT type="hidden" name="type_reply" value="1">""" % locals()
    output.append(form_html(REQUEST, mail_id, "", attach_output, mail_to, mail_cc, mail_bcc, mail_subject, mail_contents, hiddenstr, REQUEST.TLS('email_replyallmessage')))
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def send(REQUEST):
    # Find out drafts id
    REQUEST.db.execute("""SELECT e.efolder_id FROM items i, efolders e WHERE e.efolder_id=i.item_id AND i.parent_id=%d AND (e.efolder_flags & %d) <> 0""" % (REQUEST.USER.get_id(), _Efolder.EFOLDER_DRAFTS))
    result = REQUEST.db.dictfetchone()
    if not result:
        raise RuntimeError, REQUEST.TLS('email_nodraftsfolder')
    DRAFT_ID = result['efolder_id']

    # Find out sent-items id
    REQUEST.db.execute("""SELECT e.efolder_id FROM items i, efolders e WHERE e.efolder_id=i.item_id AND i.parent_id=%d AND (e.efolder_flags & %d) <> 0""" % (REQUEST.USER.get_id(), _Efolder.EFOLDER_SENT))
    result = REQUEST.db.dictfetchone()
    if not result:
        raise RuntimeError, REQUEST.TLS('email_nosentfolder')
    SENT_ID = result['efolder_id']

    if REQUEST.form.has_key('_attach') or REQUEST.form.has_key('_attach.x'):
        filedata = None
        if not REQUEST.form.has_key('filepointer') or not REQUEST.form['filepointer'].file or not REQUEST.form['filepointer'].filename:
            if REQUEST.form.has_key('_attachid') and REQUEST.form['_attachid'].value.decode('UTF8').strip() and REQUEST.form.has_key('_attachname') and REQUEST.form['_attachname'].value.decode('UTF8').strip():
                try:
                    doc = _Document.Document(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['_attachid'].value))
                except:
                    raise RuntimeError, REQUEST.TLS('doc_file_notfound')
                filepath = doc.get_path()
                filefp = open(filepath.encode('UTF8'),'rb')
                filedata = filefp.read()
                filefp.close()
                del filepath
                del filefp
                filename = REQUEST.form['_attachname'].value.decode('UTF8').strip().encode('UTF8')
            else:
                raise RuntimeError, REQUEST.TLS('email_nofileattached')
        if filedata is None:
            filedata = REQUEST.form['filepointer'].file.read()
            filename = REQUEST.form['filepointer'].filename.split('\\')[-1].split('/')[-1]
        if not filedata:
            raise RuntimeError, REQUEST.TLS('email_emptyfileattached')

        if REQUEST.form.has_key('mail_id') and REQUEST.form['mail_id'].value:
            msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['mail_id'].value))
            message2 = _mail.message_from_string(base64.decodestring(msg.get('email_contents')))
            message = email.MIMEMultipart.MIMEMultipart()
            message.set_payload(message2.get_payload())
            try:
                msg.set('email_from', u"%s <%s>" % (REQUEST.get_setting('email_sender_name'), REQUEST.get_setting('email_sender_email')))
                del message['from']
                message['From'] = u"%s <%s>" % (email.Header.Header(REQUEST.get_setting('email_sender_name')), REQUEST.get_setting('email_sender_email'))
            except:
                raise RuntimeError, REQUEST.TLS('email_nosettings')
            NEW = 0
        else:
            msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_NEW)
            msg.set('index_this_item', 1)
            msg.set('parent_id', DRAFT_ID)
            message = email.MIMEMultipart.MIMEMultipart()
            try:
                msg.set('email_from', u"%s <%s>" % (REQUEST.get_setting('email_sender_name'), REQUEST.get_setting('email_sender_email')))
                del message['from']
                message['From'] = u"%s <%s>" % (email.Header.Header(REQUEST.get_setting('email_sender_name')), REQUEST.get_setting('email_sender_email'))
            except:
                raise RuntimeError, REQUEST.TLS('email_nosettings')
            NEW = 1
        del message['to']
        del message['cc']
        del message['bcc']
        del message['subject']
        if REQUEST.form.has_key('email_to') and REQUEST.form['email_to'].value:
            msg.set('email_to', REQUEST.form['email_to'].value.decode('UTF8'))
            message['To'] = parse_obj_addresses(msg, msg.get('email_to'))
        else:
            msg.set('email_to', u'')
            message['To'] = ''
        if REQUEST.form.has_key('email_cc') and REQUEST.form['email_cc'].value:
            message['Cc'] = parse_obj_addresses(msg, REQUEST.form['email_cc'].value.decode('UTF8'))
        else:
            message['Cc'] = ''
        if REQUEST.form.has_key('email_bcc') and REQUEST.form['email_bcc'].value:
            message['bcc'] = parse_obj_addresses(msg, REQUEST.form['email_bcc'].value.decode('UTF8'))
        else:
            message['bcc'] = ''
        if REQUEST.form.has_key('email_subject') and REQUEST.form['email_subject'].value:
            msg.set('email_subject', REQUEST.form['email_subject'].value.decode('UTF8'))
            message['Subject'] = email.Header.Header(REQUEST.form['email_subject'].value.decode('UTF8')).encode()
        else:
            msg.set('email_subject', u'')
            message['Subject'] = ''
        if REQUEST.form.has_key('email_contents') and REQUEST.form['email_contents'].value:
            submsg = email.MIMEText.MIMEText(REQUEST.form['email_contents'].value) # _charset = utf8
            del submsg['content-type']
            if REQUEST.form.has_key('is_html') and REQUEST.form['is_html'].value == "1":
                submsg['Content-Type'] = 'text/html; charset="utf-8"'
                submsgcontainer = email.MIMEMultipart.MIMEMultipart(_subtype='alternative')
                mail_contents2 = REQUEST.form['email_contents'].value.decode('UTF8').replace('\n',' ')
                mail_contents2 = mail_contents2.replace('\r', '')
                mail_contents2 = mail_contents2.replace('<br>','\n').replace('<BR>','\n')
                mail_contents2 = mail_contents2.replace('<p>','\n\n').replace('<P>','\n\n')
                mail_contents2 = mail_contents2.replace('</li>','\n').replace('</LI>','\n')
                mail_contents2 = _Utils.strip_html(mail_contents2, valid_tags=[])
                ndx = mail_contents2.find('\n\n\n')
                while ndx <> -1:
                    mail_contents2 = mail_contents2.replace('\n\n\n', '\n\n')
                    ndx = mail_contents2.find('\n\n\n')
                submsgalter = email.MIMEText.MIMEText(mail_contents2.encode('UTF8'))
                del submsgalter['content-type']
                submsgalter['Content-Type'] = 'text/plain; charset="utf-8"'
                submsgcontainer.set_payload([submsgalter, submsg])
                submsg = submsgcontainer
            else:
                submsg['Content-Type'] = 'text/plain; charset="utf-8"'
            if NEW:
                message.attach(submsg)
            else:
                children = message.get_payload()
                children[0] = submsg
                message.set_payload(children)
        else:
            submsg = email.MIMEText.MIMEText('')
            del submsg['content-type']
            if REQUEST.form.has_key('is_html') and REQUEST.form['is_html'].value == "1":
                submsg['Content-Type'] = 'text/html; charset="utf-8"' 
            else:
                submsg['Content-Type'] = 'text/plain; charset="utf-8"'
            if NEW:
                message.attach(submsg)
            else:
                children = message.get_payload()
                children[0] = submsg
                message.set_payload(children)
        submsg = MIMEFile.MIMEFile(filedata, filename.decode('UTF8'))
        message.attach(submsg)
        msg.set('email_contents', base64.encodestring(message.as_string()))
        msg.set('email_date', REQUEST.user2isodatetime(REQUEST, REQUEST.iso2userdatetime(REQUEST, _Utils.utc_now_mx())))
        msg.set('email_size', len(message.as_string()))

        con_ids = []
        for key in REQUEST.form.keys():
            try:
                if key[:4] == 'sel_':
                    con_ids.append(key[4:])
            except: raise RuntimeError, (key, REQUEST.form.keys())
        if con_ids:
            msg.set('email_contacts', ",".join(con_ids))
        else:
            msg.set('email_contacts', None)
        msg.set('email_flags', (msg.get('email_flags') or 0) | _Email.EMAIL_READ | _Email.EMAIL_ATTACH)
        msg.save()

        if REQUEST.form.has_key('type_reply'):
            REQUEST.mod_req.headers_out["Location"] = "%scompose.py/reply?read_mail_id=%d&mail_id=%d&is_html=%s" % (_Conf.BASE_EMAIL_URL, int(REQUEST.form['read_mail_id'].value), msg.get_id(), REQUEST.form['is_html'].value)
            return apache.HTTP_MOVED_TEMPORARILY
        elif REQUEST.form.has_key('type_compose'):
            REQUEST.mod_req.headers_out["Location"] = "%scompose.py/compose?mail_id=%d&is_html=%s" % (_Conf.BASE_EMAIL_URL, msg.get_id(), REQUEST.form['is_html'].value)
            return apache.HTTP_MOVED_TEMPORARILY
        elif REQUEST.form.has_key('type_forward'):
            REQUEST.mod_req.headers_out["Location"] = "%scompose.py/forward?read_mail_id=%d&mail_id=%d&is_html=%s" % (_Conf.BASE_EMAIL_URL, int(REQUEST.form['read_mail_id'].value), msg.get_id(), REQUEST.form['is_html'].value)
            return apache.HTTP_MOVED_TEMPORARILY
        elif REQUEST.form.has_key('type_contact'):
            con_ids = []
            for key in REQUEST.form.keys():
                if key[:4] == 'sel_':
                    con_ids.append( u"sel_%d=1" % int(key[4:]))
            con_ids = "&".join(con_ids)
            if con_ids:
                con_ids = u"&%s" % con_ids
            loc = u"%scompose.py/contactmail?mail_id=%d%s&is_html=%s" % (_Conf.BASE_EMAIL_URL, msg.get_id(), con_ids, REQUEST.form['is_html'].value)
            REQUEST.mod_req.headers_out["Location"] = loc.encode('UTF8')
            return apache.HTTP_MOVED_TEMPORARILY
        else:
            raise RuntimeError, REQUEST.TLS('email_noreturnpath')
    elif REQUEST.form.has_key('_save') or REQUEST.form.has_key('_save.x'):
        if REQUEST.form.has_key('mail_id') and REQUEST.form['mail_id'].value:
            msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['mail_id'].value))
            message = _mail.message_from_string(base64.decodestring(msg.get('email_contents')))
            try:
                msg.set('email_from', u"%s <%s>" % (REQUEST.get_setting('email_sender_name'), REQUEST.get_setting('email_sender_email')))
                del message['from']
                message['From'] = u"%s <%s>" % (email.Header.Header(REQUEST.get_setting('email_sender_name')), REQUEST.get_setting('email_sender_email'))
            except:
                raise RuntimeError, REQUEST.TLS('email_nosettings')
            NEW = 0
        else:
            msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_NEW)
            msg.set('index_this_item', 1)
            msg.set('parent_id', DRAFT_ID)
            message = email.MIMEMultipart.MIMEMultipart()
            try:
                msg.set('email_from', u"%s <%s>" % (REQUEST.get_setting('email_sender_name'), REQUEST.get_setting('email_sender_email')))
                del message['from']
                message['From'] = u"%s <%s>" % (email.Header.Header(REQUEST.get_setting('email_sender_name')), REQUEST.get_setting('email_sender_email'))
            except:
                raise RuntimeError, REQUEST.TLS('email_nosettings')
            NEW = 1
        del message['to']
        del message['cc']
        del message['bcc']
        del message['subject']
        if REQUEST.form.has_key('email_to') and REQUEST.form['email_to'].value:
            msg.set('email_to', REQUEST.form['email_to'].value.decode('UTF8'))
            message['To'] = parse_obj_addresses(msg, msg.get('email_to'))
        else:
            msg.set('email_to', u'')
            message['To'] = ''
        if REQUEST.form.has_key('email_cc') and REQUEST.form['email_cc'].value:
            message['Cc'] = parse_obj_addresses(msg, REQUEST.form['email_cc'].value.decode('UTF8'))
        else:
            message['Cc'] = ''
        if REQUEST.form.has_key('email_bcc') and REQUEST.form['email_bcc'].value:
            message['bcc'] = parse_obj_addresses(msg, REQUEST.form['email_bcc'].value.decode('UTF8'))
        else:
            message['bcc'] = ''
        if REQUEST.form.has_key('email_subject') and REQUEST.form['email_subject'].value:
            msg.set('email_subject', REQUEST.form['email_subject'].value.decode('UTF8'))
            message['Subject'] = email.Header.Header(REQUEST.form['email_subject'].value.decode('UTF8')).encode()
        else:
            msg.set('email_subject', u'')
            message['Subject'] = ''
        if REQUEST.form.has_key('email_contents') and REQUEST.form['email_contents'].value:
            submsg = email.MIMEText.MIMEText(REQUEST.form['email_contents'].value)
            del submsg['content-type']
            if REQUEST.form.has_key('is_html') and REQUEST.form['is_html'].value == "1":
                submsg['Content-Type'] = 'text/html; charset="utf-8"' 
                submsgcontainer = email.MIMEMultipart.MIMEMultipart(_subtype='alternative')
                mail_contents2 = REQUEST.form['email_contents'].value.decode('UTF8').replace('\n',' ')
                mail_contents2 = mail_contents2.replace('\r', '')
                mail_contents2 = mail_contents2.replace('<br>','\n').replace('<BR>','\n')
                mail_contents2 = mail_contents2.replace('<p>','\n\n').replace('<P>','\n\n')
                mail_contents2 = mail_contents2.replace('</li>','\n').replace('</LI>','\n')
                mail_contents2 = _Utils.strip_html(mail_contents2, valid_tags=[])
                ndx = mail_contents2.find('\n\n\n')
                while ndx <> -1:
                    mail_contents2 = mail_contents2.replace('\n\n\n', '\n\n')
                    ndx = mail_contents2.find('\n\n\n')
                submsgalter = email.MIMEText.MIMEText(mail_contents2.encode('UTF8'))
                del submsgalter['content-type']
                submsgalter['Content-Type'] = 'text/plain; charset="utf-8"'
                submsgcontainer.set_payload([submsgalter, submsg])
                submsg = submsgcontainer
            else:
                submsg['Content-Type'] = 'text/plain; charset="utf-8"'
            if NEW:
                message.attach(submsg)
            else:
                children = message.get_payload()
                children[0] = submsg
                message.set_payload(children)
        else:
            submsg = email.MIMEText.MIMEText('')
            del submsg['content-type']
            if REQUEST.form.has_key('is_html') and REQUEST.form['is_html'].value == "1":
                submsg['Content-Type'] = 'text/html; charset="utf-8"' 
            else:
                submsg['Content-Type'] = 'text/plain; charset="utf-8"'
            if NEW:
                message.attach(submsg)
            else:
                children = message.get_payload()
                children[0] = submsg
                message.set_payload(children)
        msg.set('email_contents', base64.encodestring(message.as_string()))
        msg.set('email_date', REQUEST.user2isodatetime(REQUEST, REQUEST.iso2userdatetime(REQUEST, _Utils.utc_now_mx())))
        msg.set('email_size', len(message.as_string()))
        con_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                con_ids.append(key[4:])
        if con_ids:
            msg.set('email_contacts', ",".join(con_ids))
        else:
            msg.set('email_contacts', None)
        msg.set('email_flags', (msg.get('email_flags') or 0) | _Email.EMAIL_READ | _Email.EMAIL_DRAFT)
        msg.save()

        if REQUEST.form.has_key('type_compose'):
            REQUEST.mod_req.headers_out["Location"] = "%scompose.py/compose?mail_id=%d&is_html=%s" % (_Conf.BASE_EMAIL_URL, msg.get_id(), REQUEST.form['is_html'].value)
            return apache.HTTP_MOVED_TEMPORARILY
        elif REQUEST.form.has_key('type_reply'):
            REQUEST.mod_req.headers_out["Location"] = "%scompose.py/reply?read_mail_id=%d&mail_id=%d&is_html=%s" % (_Conf.BASE_EMAIL_URL, int(REQUEST.form['read_mail_id'].value), msg.get_id(), REQUEST.form['is_html'].value)
            return apache.HTTP_MOVED_TEMPORARILY
        elif REQUEST.form.has_key('type_forward'):
            REQUEST.mod_req.headers_out["Location"] = "%scompose.py/forward?read_mail_id=%d&mail_id=%d&is_html=%s" % (_Conf.BASE_EMAIL_URL, int(REQUEST.form['read_mail_id'].value), msg.get_id(), REQUEST.form['is_html'].value)
            return apache.HTTP_MOVED_TEMPORARILY
        elif REQUEST.form.has_key('type_contact'):
            con_ids = []
            for key in REQUEST.form.keys():
                if key[:4] == 'sel_':
                    con_ids.append( u"sel_%d=1" % int(key[4:]))
            con_ids = "&".join(con_ids)
            if con_ids:
                con_ids = u"&%s" % con_ids
            loc = u"%scompose.py/contactmail?mail_id=%d%s&is_html=%s" % (_Conf.BASE_EMAIL_URL, msg.get_id(), con_ids, REQUEST.form['is_html'].value)
            REQUEST.mod_req.headers_out["Location"] = loc.encode('UTF8')
            return apache.HTTP_MOVED_TEMPORARILY
        else:
            raise RuntimeError, REQUEST.TLS('email_noreturnpath')
    elif REQUEST.form.has_key('_send') or REQUEST.form.has_key('_send.x'):
        if REQUEST.form.has_key('mail_id') and REQUEST.form['mail_id'].value:
            msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['mail_id'].value))
            message = _mail.message_from_string(base64.decodestring(msg.get('email_contents')))
            try:
                msg.set('email_from', u"%s <%s>" % (REQUEST.get_setting('email_sender_name'), REQUEST.get_setting('email_sender_email')))
                del message['from']
                message['From'] = u"%s <%s>" % (email.Header.Header(REQUEST.get_setting('email_sender_name')), REQUEST.get_setting('email_sender_email'))
            except:
                raise RuntimeError, REQUEST.TLS('email_nosettings')
            NEW = 0
        else:
            msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_NEW)
            msg.set('index_this_item', 1)
            message = email.MIMEMultipart.MIMEMultipart()
            try:
                msg.set('email_from', u"%s <%s>" % (REQUEST.get_setting('email_sender_name'), REQUEST.get_setting('email_sender_email')))
                del message['from']
                message['From'] = u"%s <%s>" % (email.Header.Header(REQUEST.get_setting('email_sender_name')), REQUEST.get_setting('email_sender_email'))
            except:
                raise RuntimeError, REQUEST.TLS('email_nosettings')
            NEW = 1
        del message['to']
        del message['cc']
        del message['bcc']
        del message['subject']
        if REQUEST.form.has_key('email_to') and REQUEST.form['email_to'].value:
            msg.set('email_to', REQUEST.form['email_to'].value.decode('UTF8'))
            message['To'] = parse_obj_addresses(msg, msg.get('email_to'))
        else:
            msg.set('email_to', u'')
            message['To'] = ''
        if REQUEST.form.has_key('email_cc') and REQUEST.form['email_cc'].value:
            message['Cc'] = parse_obj_addresses(msg, REQUEST.form['email_cc'].value.decode('UTF8'))
        else:
            message['Cc'] = ''
        if REQUEST.form.has_key('email_bcc') and REQUEST.form['email_bcc'].value:
            message['bcc'] = parse_obj_addresses(msg, REQUEST.form['email_bcc'].value.decode('UTF8'))
        else:
            message['bcc'] = ''
        if REQUEST.form.has_key('email_subject') and REQUEST.form['email_subject'].value:
            msg.set('email_subject', REQUEST.form['email_subject'].value.decode('UTF8'))
            message['Subject'] = email.Header.Header(REQUEST.form['email_subject'].value.decode('UTF8')).encode()
        else:
            msg.set('email_subject', u'')
            message['Subject'] = ''
        if REQUEST.form.has_key('email_contents') and REQUEST.form['email_contents'].value:
            submsg = email.MIMEText.MIMEText(REQUEST.form['email_contents'].value)
            del submsg['content-type']
            if REQUEST.form.has_key('is_html') and REQUEST.form['is_html'].value == "1":
                submsg['Content-Type'] = 'text/html; charset="utf-8"' 
                submsgcontainer = email.MIMEMultipart.MIMEMultipart(_subtype='alternative')
                mail_contents2 = REQUEST.form['email_contents'].value.decode('UTF8').replace('\n',' ')
                mail_contents2 = mail_contents2.replace('\r', '')
                mail_contents2 = mail_contents2.replace('<br>','\n').replace('<BR>','\n')
                mail_contents2 = mail_contents2.replace('<p>','\n\n').replace('<P>','\n\n')
                mail_contents2 = mail_contents2.replace('</li>','\n').replace('</LI>','\n')
                mail_contents2 = _Utils.strip_html(mail_contents2, valid_tags=[])
                ndx = mail_contents2.find('\n\n\n')
                while ndx <> -1:
                    mail_contents2 = mail_contents2.replace('\n\n\n', '\n\n')
                    ndx = mail_contents2.find('\n\n\n')
                submsgalter = email.MIMEText.MIMEText(mail_contents2.encode('UTF8'))
                del submsgalter['content-type']
                submsgalter['Content-Type'] = 'text/plain; charset="utf-8"'
                submsgcontainer.set_payload([submsgalter, submsg])
                submsg = submsgcontainer
            else:
                submsg['Content-Type'] = 'text/plain; charset="utf-8"'
            if NEW:
                message.attach(submsg)
            else:
                children = message.get_payload()
                children[0] = submsg
                message.set_payload(children)
        else:
            submsg = email.MIMEText.MIMEText('')
            del submsg['content-type']
            if REQUEST.form.has_key('is_html') and REQUEST.form['is_html'].value == "1":
                submsg['Content-Type'] = 'text/html; charset="utf-8"' 
            else:
                submsg['Content-Type'] = 'text/plain; charset="utf-8"'
            if NEW:
                message.attach(submsg)
            else:
                children = message.get_payload()
                children[0] = submsg
                message.set_payload(children)
        del message['date']
        message['Date'] = str(email.Header.Header(email.Utils.formatdate(localtime=1)))
        bcc_to = message['bcc']
        del message['bcc']
        msg.set('email_contents', base64.encodestring(message.as_string()))
        msg.set('email_date', REQUEST.user2isodatetime(REQUEST, REQUEST.iso2userdatetime(REQUEST, _Utils.utc_now_mx())))
        msg.set('email_size', len(message.as_string()))
        con_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                con_ids.append(key[4:])
        if con_ids:
            msg.set('email_contacts', ",".join(con_ids))
        else:
            msg.set('email_contacts', None)
        msg.set('email_flags', (msg.get('email_flags') or 0) | _Email.EMAIL_READ)
        if msg.get_id() is None: # Unsaved message:
            msg.set('parent_id', SENT_ID)
            msg.save()
        elif (msg.get('email_flags') & _Email.EMAIL_DRAFT): # Draft
            msg.copyto(SENT_ID)
            msg.save()
        else:
            msg.set('parent_id', SENT_ID)
            msg.save()

        to_1 = []
        to_2 = []
        to_3 = []
        if REQUEST.form.has_key('type_contact'):
            to = []
            con_ids = msg.get('email_contacts') or u''
            con_ids = map(int, con_ids.split(u','))
            for con_id in con_ids:
                con_obj = _Contact.Contact(REQUEST, _InitTypes.INIT_TYPE_ID, con_id)
                if con_obj.get('e_mail'):
                    to.append(con_obj.get('e_mail').strip().encode('UTF8'))
        else:
            to1 = _mail.parse_quoted_string(message, message['to'] or u'')
            to2 = _mail.parse_quoted_string(message, message['cc'] or u'')
            to3 = _mail.parse_quoted_string(message, bcc_to or u'')
            groups1 = []
            groups2 = []
            groups3 = []
            for (tox, groupsx) in [(to1, groups1),(to2, groups2),(to3, groups3)]:
                while 1:
                    ndx1 = tox.find("{")
                    if ndx1<>-1:
                        ndx2 = tox.find("}", ndx1)
                        if ndx2<>-1:
                            toid = tox[ndx1+1:ndx2]
                            gid = re.search(':\d+:', toid)
                            if gid:
                                gid = gid.group()
                                if gid:
                                    groupsx.append(gid[1:-1])
                            tox = tox[ndx2:]
                        else:
                            break
                    else:
                        break
            for (to_x, groupsx) in [(to_1, groups1), (to_2, groups2), (to_3, groups3)]:
                if groupsx:
                    groups = map(int, groupsx)
                    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_CONTACTGROUP])
                    if right_param:
                        right_param = " AND " + right_param
                    SQL = """SELECT c.contacts from contact_groups c, items i where i.item_id=c.group_id and c.group_id in (%s) %s""" % (",".join(map(str, groups)), right_param)
                    REQUEST.db.execute(SQL.encode('UTF8'))
                    contacts = REQUEST.db.fetchall()
                    c = []
                    for row in contacts:
                        c = c + _Utils.sql_parse_array(REQUEST, row[0])
                    if c:
                        SQL = """SELECT c.first_name || ' ' || c.last_name, c.e_mail from contacts c, items i where i.item_id = c.contact_id and c.contact_id in (%s) and c.e_mail is not null""" % (",".join(map(str, c)))
                        REQUEST.db.execute(SQL)
                        contacts = REQUEST.db.fetchall()
                        for row in contacts:
                            if row[0] and row[0].strip() and row[1] and row[1].strip():
                                to_x.append((row[0].decode('UTF8'), row[1].decode('UTF8')))

            tmp1 = parse_obj_addresses(message, message['to'] or u'', include_groups=0)
            tmp2 = parse_obj_addresses(message, message['cc'] or u'', include_groups=0)
            del message['to']
            del message['cc']
            message['to'] = tmp1
            message['cc'] = tmp2
            to = filter(None, map(lambda x: x[1], email.Utils.getaddresses([message['to'], message['cc'] or '', bcc_to or ''])))
        server = smtplib.SMTP(_Conf.SMTPSERVER) # FIXME - error handling (raises)
        if to:
            errors = server.sendmail(message['from'], to, message.as_string())
        to_old = parse_obj_addresses(message, message['to'] or '')
        cc_old = parse_obj_addresses(message, message['cc'] or '')
        for (tolist, messfield, oldmessfield) in [(to_1,'to',to_old),(to_2,'cc',cc_old),(to_3,'','')]:
            if tolist:
                del message['to']
                del message['cc']
                message['to'] = to_old
                message['cc'] = cc_old
                for targets in tolist:
                    if messfield and oldmessfield:
                        del message[messfield]
                        message[messfield] = "%s, %s <%s>" % (oldmessfield, email.Header.Header(u'"%s"'%targets[0]).encode().strip(), targets[1].strip().encode('UTF8'))
                    elif messfield and not oldmessfield:
                        del message[messfield]
                        message[messfield] = "%s <%s>" % (email.Header.Header(u'"%s"'%targets[0]).encode().strip(), targets[1].strip().encode('UTF8'))
                    errors = server.sendmail(message['from'], [targets[1].strip().encode('UTF8')], message.as_string())
        server.quit()
        errors = {}

        if REQUEST.form.has_key('type_reply'):
            try:
                reply_id = int(REQUEST.form['read_mail_id'].value)
                REQUEST.db.execute("""UPDATE emails set email_flags=(email_flags | %d) WHERE email_id=%d""" % (_Email.EMAIL_ANSWERED, reply_id))
            except:
                pass # FIXME

        output = []
        output.append(standard_html.html_header(REQUEST))
        ref_url = REQUEST.SERVER_URL+_Conf.BASE_EMAIL_URL+"efolder1.py"
        output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
        output.append(get_email_menu(REQUEST, MY_MENU_ID))
        output.append("""<BR>&nbsp;&nbsp;%s""" % REQUEST.TLS('email_messagesent'))
        for key, value in errors.items():
            output.append("""<BR>&nbsp;&nbsp;%s""" % (REQUEST.TLS('email_sendmailerror') % (key, value[0], value[1])))
        output.append(standard_html.html_footer(REQUEST))
        return '\n'.join(output)
    return "NOT IMPLEMENTED. FIXME"

def delpart(REQUEST):
    if not REQUEST.form.has_key('mail_id') or not REQUEST.form['mail_id'].value or not REQUEST.form.has_key('part') or not REQUEST.form['part'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['mail_id'].value))
    message = _mail.message_from_string(base64.decodestring(msg.get('email_contents')))

    part = int(REQUEST.form['part'].value.split('.')[1])

    payload = message.get_payload()
    del payload[part]
    message.set_payload(payload)

    msg.set('email_contents', base64.encodestring(message.as_string()))
    msg.save()

    if REQUEST.form.has_key('type_compose'):
        REQUEST.mod_req.headers_out["Location"] = "%scompose.py/compose?mail_id=%d&is_html=%s" % (_Conf.BASE_EMAIL_URL, msg.get_id(), REQUEST.form['is_html'].value)
        return apache.HTTP_MOVED_TEMPORARILY
    elif REQUEST.form.has_key('type_reply'):
        REQUEST.mod_req.headers_out["Location"] = "%scompose.py/reply?read_mail_id=%d&mail_id=%d&is_html=%s" % (_Conf.BASE_EMAIL_URL, int(REQUEST.form['read_mail_id'].value), msg.get_id(), REQUEST.form['is_html'].value)
        return apache.HTTP_MOVED_TEMPORARILY
    elif REQUEST.form.has_key('type_forward'):
        REQUEST.mod_req.headers_out["Location"] = "%scompose.py/forward?read_mail_id=%d&mail_id=%d&is_html=%s" % (_Conf.BASE_EMAIL_URL, int(REQUEST.form['read_mail_id'].value), msg.get_id(), REQUEST.form['is_html'].value)
        return apache.HTTP_MOVED_TEMPORARILY
    elif REQUEST.form.has_key('type_contact'):
        con_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                con_ids.append( u"sel_%d=1" % int(key[4:]))
        con_ids = "&".join(con_ids)
        if con_ids:
            con_ids = u"&%s" % con_ids
        loc = u"%scompose.py/contactmail?mail_id=%d%s&is_html=%s" % (_Conf.BASE_EMAIL_URL, msg.get_id(), con_ids, REQUEST.form['is_html'].value)
        REQUEST.mod_req.headers_out["Location"] = loc.encode('UTF8')
        return apache.HTTP_MOVED_TEMPORARILY
    else:
        raise RuntimeError, REQUEST.TLS('email_noreturnpath')


def form_html(REQUEST, mail_id, drafts, attach_output, mail_to, mail_cc, mail_bcc, mail_subject, mail_contents, hiddenstr, title="", to_str=""):
    output = []
    spell_ok = 1
    top_px = 225
    is_drafts = 0
    if len(drafts)>5:
        is_drafts = 1
        top_px = top_px + 30
    BASE_EMAIL_URL = _Conf.BASE_EMAIL_URL

    if not title:
        title = REQUEST.TLS('email_newmessage')
    if mail_to.find('&') == -1:
        mail_to = _Utils.html_quote(mail_to)
    if mail_cc.find('&') == -1:
        mail_cc = _Utils.html_quote(mail_cc)
    if mail_bcc.find('&') == -1:
        mail_bcc = _Utils.html_quote(mail_bcc)
    tls_to = REQUEST.TLS('email_to')
    tls_cc = REQUEST.TLS('email_cc')
    tls_bcc = REQUEST.TLS('email_bcc')
    tls_subject = REQUEST.TLS('tls_subject')
    tls_attachment = REQUEST.TLS('email_attachment')
    tls_addattachment = REQUEST.TLS('email_addattachment')
    tls_choose = REQUEST.TLS('email_choose')
    tls_send = REQUEST.TLS('email_send')
    tls_newmessage = REQUEST.TLS('email_newmessage')
    tls_save = REQUEST.TLS('tls_save')
    tls_or = REQUEST.TLS('tls_or')
    tls_selectdoc = REQUEST.TLS('email_selectdoc')
    tls_addattachment = REQUEST.TLS('email_addattachment')
    tls_format = REQUEST.TLS('tls_format')
    tls_signature = REQUEST.TLS('email_signature')
    timestamp = REQUEST.iso2userdatetime(REQUEST, _Utils.utc_now_mx())
    tls_format_conf = REQUEST.TLS('email_format_confirm')
    tls_format1 = REQUEST.TLS('email_format_html')
    tls_format2 = REQUEST.TLS('email_format_plain')
    tls_missing_attachment = REQUEST.TLS('email_missingattachment')
    tls_confirm_leave = REQUEST.TLS('email_confirm_leave')
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    BASE_WEB_URL = _Conf.BASE_WEB_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    
    conflux_att = ""
    
    signatures = []
    try:
        sig1 = REQUEST.get_setting('user_signature1')
        signatures.append(sig1)
    except:
        pass
    try:
        sig2 = REQUEST.get_setting('user_signature2')
        signatures.append(sig2)
    except:
        pass
    try:
        sig3 = REQUEST.get_setting('user_signature3')
        signatures.append(sig3)
    except:
        pass
    sign_out = ""
    script_out = ""
    if signatures:
        sign_out = u"""&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>%(tls_signature)s:</b>&nbsp;&nbsp;<SELECT id="sig_select" name="signature">""" % locals()
        n = 1
        for sig in signatures:
            sign_out = sign_out + u"""<option value="%s">%s</option>""" % (n, sig[0])
            n = n + 1
        sign_out = sign_out + u"""</SELECT>&nbsp;&nbsp;&nbsp;<input type="button" class="input6" value="OK" onclick="do_sig();">"""
        script_out = u"""function do_sig() { html = document.forms['composeform']['is_html'].value; elem = document.forms['composeform']['signature'].selectedIndex + 1;if(html=="2") { if(0){;}"""
        n = 1
        for sig in signatures:
            script_out = script_out + u"""\n    else if(elem==%s){ document.forms['0'].email_contents.value = document.forms['0'].email_contents.value + '%s';} """ % (n,"\\n"+sig[1].replace("\r","").replace("\n","\\n").replace("'", "\\'"))
            n = n + 1;
        script_out = script_out + u""" } else { if(0){;}"""
        n = 1
        for sig in signatures:
            script_out = script_out + u"""\n    else if(elem==%s){ SwitchViewMode(1);document.forms['0'].email_contents.value = document.forms['0'].email_contents.value + '%s';SwitchViewMode(0);} """ % (n,"<BR>\\n"+_Utils.newline2br(sig[1].replace("'", "\\'")))
            n = n + 1;
        script_out = script_out + u""" } }"""
        
    spell_tr = ""
    output.append(standard_html.window_script(height=500,width=550))
    output.append(u"""<SCRIPT LANGUAGE="JavaScript" type="text/javascript">function change_url(id){ self.location.href='%(BASE_EMAIL_URL)scompose.py/compose?mail_id=' + (id) + '&datetime=%(timestamp)s';} function change_editor(confi){ elem = document.forms['composeform']['is_html'].value; if(elem=="2") { if(confi&&confi=='1') { if(confirm('%(tls_format_conf)s')) { show_plain(); } else { document.forms['composeform']['is_html'].selectedIndex='0'; } } else { show_plain(); } } else { if(confi&&confi=='1') { if(confirm('%(tls_format_conf)s')) { show_html(); } else { document.forms['composeform']['is_html'].selectedIndex='1'; } } else { show_html(); } } } function parse_tags(){data = document.forms['composeform']['email_contents'].value;while(data.indexOf('<br>')!=-1){data = data.replace('<br>',"\\n");}while(data.indexOf('<BR>')!=-1){data = data.replace('<BR>',"\\n");}var tags= /<\S[^>]*>/g;data = data.replace(tags,"");while(data.indexOf('&nbsp;')!=-1){data = data.replace('&nbsp;'," ");}while(data.indexOf('&amp;')!=-1){data = data.replace('&amp;',"&");}while(data.indexOf('&gt;')!=-1){data = data.replace('&gt;',">");}while(data.indexOf('&lt;')!=-1){data = data.replace('&lt;',"<");}while(data.indexOf('\\t')!=-1){data = data.replace('\\t'," ");}while(data.indexOf('  ')!=-1){data = data.replace('  ',' ');}document.forms['composeform']['email_contents'].value=data;} function nl2br(){ data = document.forms['composeform']['email_contents'].value; while(data.indexOf('\\n')!=-1) { data = data.replace('\\n','<br>'); } document.forms['composeform']['email_contents'].value=data; } %(script_out)s </script>""" % locals())
    output.append(u"""<SCRIPT LANGUAGE="JavaScript" type="text/javascript">function show_html() { document.getElementById('EpozViewMode').checked = false; document.forms['composeform']['is_html'].selectedIndex='0'; document.getElementById('HtmlDiv').style.display='block'; nl2br(); SwitchViewMode(0); } function show_plain() { document.getElementById('EpozViewMode').checked = true; document.forms['composeform']['is_html'].selectedIndex='1'; SwitchViewMode(1); document.getElementById('HtmlDiv').style.display='none'; parse_tags(); }</script>""" % locals())
    if REQUEST.form.has_key('is_html'):
        email_format = REQUEST.form['is_html'].value
    else:   
        try:
            email_format = REQUEST.get_setting('email_format')
        except:
            email_format = "1"
    mail_contents = mail_contents.replace("\n", "<BR>")
    text_area = _Utils.get_epoz_field(REQUEST, 'email_contents', mail_contents)
    format_str = u"""
        <select id="html_select" name="is_html" onchange="change_editor('1');">
          <option value="1" SELECTED>%(tls_format1)s</option>
          <option value="2">%(tls_format2)s</option>
        </select>""" % locals()
    REQ_FIELD = _Conf.REQ_FIELD
    format_sig_spellcheck = u"""\n <TR class="tr_listing1">\n  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=15 height=20 border=0 alt=""></TD>\n  <TD class="td_listing1b">%(tls_format)s:</td>\n  <TD class="td_listing1" nowrap>%(format_str)s %(sign_out)s&nbsp;&nbsp;&nbsp;&nbsp;</TD>\n </TR>""" % locals()
    if REQUEST.form.has_key('is_html'):
        spell_html = REQUEST.form['is_html'].value
    output.append(u"""<SCRIPT type="text/javascript">
function check_contacts(field_name) { return true; }
function destroy_div() { return true; }
</SCRIPT>""")
    output.append(u"""
<SCRIPT language="javascript" type="text/javascript">
<!--
function check_values(){ if (!document.composeform.email_to.value) { alert("%(tls_missing_input)s"); return false; } return true; }
function confirm_leave()
{
 try{ SyncEpoz(); } catch(e) { ; }
 try{ a = document.forms['composeform']['email_contents'].value; } catch(e) { a=""; } 
 if(a && a.length>6)
 {
    return "%(tls_confirm_leave)s";
 }
}
// -->
</SCRIPT>
<BR>
<TABLE border="0" width="100%%" cellpadding=0 cellspacing=0>
<FORM action="%(BASE_EMAIL_URL)scompose.py/send" method="POST" ENCTYPE="multipart/form-data" onsubmit="confirm_leave=function(){};" name="composeform">
<INPUT type="hidden" name="type_compose" value="1">
<INPUT type="hidden" name="act" value="">
%(mail_id)s
%(hiddenstr)s
 <TR class="tr_listing0">
  <TD colspan=3>
     <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=10 border=0 alt=""></TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD nowrap class="th_listing" nowrap>&nbsp;&nbsp;<b>%(title)s</b>&nbsp;&nbsp;</TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
      </TR>
     </TABLE>
  </TD>
</TR>
%(drafts)s
 <TR class="tr_listing1">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=15 height=20 border=0 alt=""></TD>
  <TD class="td_listing1b" width="10%%">%(tls_to)s%(REQ_FIELD)s:</TD>
  <TD class="td_listing1" width="90%%"><INPUT  tabindex=1 class=textfield2 type="text" name="email_to" size="90" value="%(mail_to)s"> <A target="popup_window" href="%(BASE_EMAIL_URL)setree.py/contacts?field=email_to" onClick="open_window('about:blank');"><IMG src="%(BASE_WEB_URL)sicons/mycontact.gif" width="18" height="16" border="0" alt=""></A>&nbsp;<BR>%(to_str)s</TD>
 </TR>
 <TR class="tr_listing0">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=15 height=20 border=0 alt=""></TD>
  <TD class="td_listing0b">%(tls_cc)s:</TD>
  <TD class="td_listing0"><INPUT tabindex=2 class=textfield2 type="text" name="email_cc" size="90" value="%(mail_cc)s"> <A target="popup_window" href="%(BASE_EMAIL_URL)setree.py/contacts?field=email_cc" onClick="open_window('about:blank');"><IMG src="%(BASE_WEB_URL)sicons/mycontact.gif" width="18" height="16" border="0" alt=""></A>&nbsp;</TD>
 </TR>
 <TR class="tr_listing1">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=15 height=20 border=0 alt=""></TD>
  <TD class="td_listing1b">%(tls_bcc)s:</TD>
  <TD class="td_listing1"><INPUT class=textfield2 type="text" name="email_bcc" size="90" value="%(mail_bcc)s"> <A target="popup_window" href="%(BASE_EMAIL_URL)setree.py/contacts?field=email_bcc" onClick="open_window('about:blank');"><IMG src="%(BASE_WEB_URL)sicons/mycontact.gif" width="18" height="16" border="0" alt=""></A>&nbsp;</TD>
 </TR>
 <TR class="tr_listing0">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=15 height=20 border=0 alt=""></TD>
  <TD class="td_listing0b">%(tls_subject)s:</TD>
  <TD class="td_listing0"><INPUT tabindex=4 class=textfield2 type="text" name="email_subject" size="90" value="%(mail_subject)s"></TD>
 </TR>
%(format_sig_spellcheck)s
%(spell_tr)s
 <TR class="tr_listing0">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=15 height=20 border=0 alt=""></TD>
  <TD class="td_listing0" colspan="2">%(text_area)s</TD>
 </TR>""" % locals())
    if spell_ok:
      output.append(u"""
 <TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=15 height=20 border=0 alt=""></TD>
  <TD class="td_listing0" colspan="2"><INPUT class="input6" type="submit" name="_send" value="%(tls_send)s" onclick="confirm_leave=function(){;};return check_values();"> <INPUT class="input6" type="submit" onclick="confirm_leave=function(){};" name="_save" value="%(tls_save)s"></TD>
 </TR>
</TABLE>
<TABLE border="0" width="100%%" cellpadding=0 cellspacing=0>
 <TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=15 height=20 border=0 alt=""></TD>
  <TD class="td_listing0" nowrap>%(tls_addattachment)s:</TD>
  <TD class="td_listing0" width="100%%"><INPUT size=26 class="inputfile" type="file" name="filepointer">&nbsp;%(tls_or)s</TD>
 </TR>
%(conflux_att)s
 <TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=15 height=20 border=0 alt=""></TD>
  <TD class="td_listing0" colspan="2"><INPUT class="input6" type="submit" name="_attach" value="%(tls_addattachment)s" onclick="confirm_leave=function(){}; if(!this.form.filepointer.value&&(!this.form._attachid||!this.form._attachid.value)){ alert('%(tls_missing_attachment)s'); return false;};"></TD>
 </TR>
%(attach_output)s
</TABLE>""" % locals())
    else:
      output.append("</TABLE>")
    output.append("""
<DIV id="placeholder"></DIV>
<SCRIPT TYPE="text/javascript">
document.forms['composeform']['email_to'].focus();
</SCRIPT>
</FORM>""")
    return "\n".join(output)
