# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

import standard_html

import _Access, _InitTypes, _Conf, Menus, SQLTree, _Utils, _ContactGroup

def contacts(REQUEST):
    if REQUEST.form.has_key('field') and REQUEST.form['field'].decode('UTF8').strip():
        field_name = REQUEST.form['field'].decode('UTF8').strip()
    else:
        field_name = 'email_to'
    if REQUEST.form.has_key('let') and REQUEST.form['let'].decode('UTF8').strip():
        letter = REQUEST.form['let'].decode('UTF8').strip()
    else:
        letter = 0

    BASE_EMAIL_URL = _Conf.BASE_EMAIL_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_done = REQUEST.TLS('todo_done')
    tls_search = REQUEST.TLS('tls_search')
    tls_my = REQUEST.TLS('tls_my')
    tls_all = REQUEST.TLS('tls_all')
    tls_name = REQUEST.TLS('tls_name')
    tls_email = REQUEST.TLS('tls_email')
    output = []
    output.append(standard_html.html_header_popup(REQUEST))
    output.append(u"""
<SCRIPT language="javascript" type="text/javascript">
<!--
window.moveTo(0,250);

function replace_vals(returnval)
{
    if (window.opener.top.frames['topcontents'].document.forms.composeform.%(field_name)s.value)
        window.opener.top.frames['topcontents'].document.forms.composeform.%(field_name)s.value=window.opener.top.frames['topcontents'].document.forms.composeform.%(field_name)s.value+', ' + returnval; 
    else
        window.opener.top.frames['topcontents'].document.forms.composeform.%(field_name)s.value=returnval; 
}
// -->
</SCRIPT>
""" % locals())

    formstring = REQUEST.get_formstring(['qs','sort_by','_delete'])
    word = ""
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_CONTACT])
    if right_param:
        right_param = " AND " + right_param
    if REQUEST.form.has_key('_word') and REQUEST.form['_word'].value.strip():
      word = _Utils.sql_quote_simple(REQUEST.form['_word'].value.decode('UTF8').strip().lower())
      QUERY = """SELECT count(*) FROM contacts c, items i WHERE c.contact_id=i.item_id %s AND (lower(c.e_mail) like '%%%s%%' or lower(c.first_name) like '%%%s%%' or lower(c.last_name) like '%%%s%%' or lower(c.middle_name) like '%%%s%%')""" % (right_param, word, word, word, word)
    elif (letter=='my'):
        QUERY = """SELECT count(*) FROM contacts c, items i WHERE c.contact_id=i.item_id AND c.e_mail IS NOT NULL and c.e_mail <> ''%s and i.creator_id=%d""" % (right_param, REQUEST.USER.get_id())
    elif (letter=='num'):
        QUERY = """SELECT count(*) FROM contacts c, items i WHERE c.contact_id=i.item_id AND c.e_mail IS NOT NULL and c.e_mail <> ''%s and lower(substr(c.last_name, 1, 1)) not in ('a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z')""" % right_param
    elif letter:
        QUERY = """SELECT count(*) FROM contacts c, items i WHERE c.contact_id=i.item_id AND c.e_mail IS NOT NULL and c.e_mail <> ''%s and lower(c.last_name) like '%s%%' """ % (right_param, letter)
    else:
        QUERY = """SELECT count(*) FROM contacts c, items i WHERE c.contact_id=i.item_id AND c.e_mail IS NOT NULL and c.e_mail <> ''%s """ % right_param
    REQUEST.db.execute(QUERY.encode('UTF8'))
    count_all = REQUEST.db.fetchone()[0]

    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%setree.py/contacts%sqs=" % (_Conf.BASE_EMAIL_URL, REQUEST.get_formstring(['qs']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%setree.py/contacts%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_EMAIL_URL, REQUEST.get_formstring(['qs']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%setree.py/contacts%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_EMAIL_URL, REQUEST.get_formstring(['qs']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR2(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""

    try:
        contact_view = REQUEST.get_setting('contact_view')
    except:
        contact_view = "0"

    if contact_view and contact_view=="1":
        sort_by = "lower(last_name), lower(first_name)"
        sel = "last_name"
    else:
        sort_by = "lower(first_name), lower(last_name)"
        sel = "first_name"
    if REQUEST.form.has_key('_word') and REQUEST.form['_word'].value.strip():
      word = _Utils.sql_quote_simple(REQUEST.form['_word'].value.decode('UTF8').strip().lower())
      SQL = """SELECT c.*, i.* FROM contacts c, items i WHERE c.contact_id=i.item_id %s AND (lower(c.e_mail) like '%%%s%%' or lower(c.first_name) like '%%%s%%' or lower(c.last_name) like '%%%s%%' or lower(c.middle_name) like '%%%s%%') ORDER BY %s LIMIT %d OFFSET %d""" % (right_param, word, word, word, word, sort_by, REQUEST.batch_size, REQUEST.qs)
    elif (letter=='my'):
        SQL = """SELECT c.*, i.* FROM contacts c, items i WHERE c.contact_id=i.item_id AND c.e_mail IS NOT NULL and c.e_mail <> ''%s and i.creator_id=%d ORDER BY %s LIMIT %d OFFSET %d""" % (right_param, REQUEST.USER.get_id(), sort_by, REQUEST.batch_size, REQUEST.qs)
    elif (letter=='num'):
        SQL = """SELECT c.*, i.* FROM contacts c, items i WHERE c.contact_id=i.item_id AND c.e_mail IS NOT NULL and c.e_mail <> ''%s and lower(substr(c.%s, 1, 1)) not in ('a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z')  ORDER BY %s LIMIT %d OFFSET %d""" % (right_param, sel, sort_by, REQUEST.batch_size, REQUEST.qs)
    elif letter:
        SQL = """SELECT c.*, i.* FROM contacts c, items i WHERE c.contact_id=i.item_id AND c.e_mail IS NOT NULL and c.e_mail <> ''%s and lower(c.%s) like '%s%%' ORDER BY %s LIMIT %d OFFSET %d""" % (right_param, sel, letter, sort_by, REQUEST.batch_size, REQUEST.qs)
    else:
        SQL = """SELECT c.*, i.* FROM contacts c, items i WHERE c.contact_id=i.item_id AND c.e_mail IS NOT NULL and c.e_mail <> ''%s ORDER BY %s LIMIT %d OFFSET %d""" % (right_param, sort_by, REQUEST.batch_size, REQUEST.qs)
    REQUEST.db.execute(SQL.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()

    if REQUEST.form.has_key('_word') and REQUEST.form['_word'].value.strip():
      word = _Utils.html_quote_edit(REQUEST.form['_word'].value.decode('UTF8').strip())
    output.append(u"""
<TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
  <TR>
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
    <TD class="td_listing1" width="100%%" align="center" colspan="2">
       <a class="blacklargelink" href="%(BASE_EMAIL_URL)setree.py/contacts?field=%(field_name)s&let=my">%(tls_my)s</A>
       <a class="blacklargelink" href="%(BASE_EMAIL_URL)setree.py/contacts?field=%(field_name)s">%(tls_all)s</A>
       <a class="blacklargelink" href="%(BASE_EMAIL_URL)setree.py/contacts?field=%(field_name)s&let=num">#</A>
       <a class="blacklargelink" href="%(BASE_EMAIL_URL)setree.py/contacts?field=%(field_name)s&let=a">A</A>
       <a class="blacklargelink" href="%(BASE_EMAIL_URL)setree.py/contacts?field=%(field_name)s&let=b">B</A>
       <a class="blacklargelink" href="%(BASE_EMAIL_URL)setree.py/contacts?field=%(field_name)s&let=c">C</A>
       <a class="blacklargelink" href="%(BASE_EMAIL_URL)setree.py/contacts?field=%(field_name)s&let=d">D</A>
       <a class="blacklargelink" href="%(BASE_EMAIL_URL)setree.py/contacts?field=%(field_name)s&let=e">E</A>
       <a class="blacklargelink" href="%(BASE_EMAIL_URL)setree.py/contacts?field=%(field_name)s&let=f">F</A>
       <a class="blacklargelink" href="%(BASE_EMAIL_URL)setree.py/contacts?field=%(field_name)s&let=g">G</A>
       <a class="blacklargelink" href="%(BASE_EMAIL_URL)setree.py/contacts?field=%(field_name)s&let=h">H</A>
       <a class="blacklargelink" href="%(BASE_EMAIL_URL)setree.py/contacts?field=%(field_name)s&let=i">I</A>
       <a class="blacklargelink" href="%(BASE_EMAIL_URL)setree.py/contacts?field=%(field_name)s&let=j">J</A>
       <a class="blacklargelink" href="%(BASE_EMAIL_URL)setree.py/contacts?field=%(field_name)s&let=k">K</A>
       <a class="blacklargelink" href="%(BASE_EMAIL_URL)setree.py/contacts?field=%(field_name)s&let=l">L</A>
       <a class="blacklargelink" href="%(BASE_EMAIL_URL)setree.py/contacts?field=%(field_name)s&let=m">M</A>
       <a class="blacklargelink" href="%(BASE_EMAIL_URL)setree.py/contacts?field=%(field_name)s&let=n">N</A>
       <a class="blacklargelink" href="%(BASE_EMAIL_URL)setree.py/contacts?field=%(field_name)s&let=o">O</A>
       <a class="blacklargelink" href="%(BASE_EMAIL_URL)setree.py/contacts?field=%(field_name)s&let=p">P</A>
       <a class="blacklargelink" href="%(BASE_EMAIL_URL)setree.py/contacts?field=%(field_name)s&let=q">Q</A>
       <a class="blacklargelink" href="%(BASE_EMAIL_URL)setree.py/contacts?field=%(field_name)s&let=r">R</A>
       <a class="blacklargelink" href="%(BASE_EMAIL_URL)setree.py/contacts?field=%(field_name)s&let=s">S</A>
       <a class="blacklargelink" href="%(BASE_EMAIL_URL)setree.py/contacts?field=%(field_name)s&let=t">T</A>
       <a class="blacklargelink" href="%(BASE_EMAIL_URL)setree.py/contacts?field=%(field_name)s&let=u">U</A>
       <a class="blacklargelink" href="%(BASE_EMAIL_URL)setree.py/contacts?field=%(field_name)s&let=v">V</A>
       <a class="blacklargelink" href="%(BASE_EMAIL_URL)setree.py/contacts?field=%(field_name)s&let=w">W</A>
       <a class="blacklargelink" href="%(BASE_EMAIL_URL)setree.py/contacts?field=%(field_name)s&let=x">X</A>
       <a class="blacklargelink" href="%(BASE_EMAIL_URL)setree.py/contacts?field=%(field_name)s&let=y">Y</A>
       <a class="blacklargelink" href="%(BASE_EMAIL_URL)setree.py/contacts?field=%(field_name)s&let=z">Z</A>
    </TD>
    <TD class="td_listing1" nowrap><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""><A href="javascript:void(0);" onClick="javascript:window.close()">%(tls_done)s</A></TD>
  </TR>
  <TR>
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
    <TD colspan="2" class="td_listing0" nowrap align="center"><FORM method="POST" action="%(BASE_EMAIL_URL)setree.py/contacts"><input name="_word" type="text" class="textfield1" value="%(word)s"><input type=hidden name="field" value="%(field_name)s"> <input name="_search" class="input6" type="submit" value="%(tls_search)s"></FORM></TD>
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
  </TR>
  <TR>
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
    <TD class="td_listing1b" width="50%%">%(tls_name)s</TD>
    <TD class="td_listing1b" width="50%%">%(tls_email)s</TD>
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
  </TR>
""" %locals())
    index = 0
    for result in dbresult:
        if(index % 2 == 0):
            td_class='td_listing0'
        else:
            td_class='td_listing1'
        index = index + 1
        ns = {'person_name_email':u'%s&nbsp;%s' % (result['first_name'].decode('UTF8').replace("'", "\\'"), result['last_name'].decode('UTF8').replace("'", "\\'"))}
        if contact_view and contact_view=="1":
            ns['person_name'] = u"%s,&nbsp;%s" % (result['last_name'].decode('UTF8'), result['first_name'].decode('UTF8'))
        else:
            ns['person_name'] = u"%s&nbsp;%s" % (result['first_name'].decode('UTF8'), result['last_name'].decode('UTF8'))
        ns['td_class'] = td_class
        ns['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
        ns['person_email'] = result['e_mail'].decode('UTF8').replace("'", "\\'")
        output.append(u"""
  <TR>
    <TD class="%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
    <TD class="%(td_class)s"><A class="blacklink" href="javascript:void(0);" onClick="replace_vals('&quot;%(person_name_email)s&quot; <%(person_email)s>')";>%(person_name)s&nbsp;</A></TD>
    <TD class="%(td_class)s"><A class="blacklink" href="javascript:void(0);" onClick="replace_vals('&quot;%(person_name_email)s&quot; <%(person_email)s>')";>%(person_email)s</A></TD>
    <TD class="%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
  </TR>""" % ns)
    output.append(u"""</TABLE>""")
    if FULL_BAR:
        output.append(FULL_BAR)

    output.append(standard_html.html_footer3(REQUEST))
    return "\n".join(output)

def doctree(REQUEST):
    output = []
    output.append(standard_html.html_header_popup(REQUEST))

    a = SQLTree.SQLTree(REQUEST, "emaildoctree")
    a.set_param('item_types', [_InitTypes.ITEM_TYPE_ORGANIZATION, _InitTypes.ITEM_TYPE_FOLDER, _InitTypes.ITEM_TYPE_DOCUMENT])
    a.set_param('linked_types', [_InitTypes.ITEM_TYPE_DOCUMENT])
    a.set_param('target_url', '')
    a.set_param('tree_url', _Conf.BASE_EMAIL_URL + 'etree.py/doctree')
    a.set_param('js', u"""<A href="javascript:void(0);" onClick="window.opener.document.forms.composeform._attachid.value=%(item_id)d; window.opener.document.forms.composeform._attachname.value='%(doc_name)s'; window.close();\">""")
    a.maketree()

    output.append(a.getTree())

    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def groups(REQUEST):
    if REQUEST.form.has_key('field') and REQUEST.form['field'].decode('UTF8').strip():
        field_name = REQUEST.form['field'].decode('UTF8').strip()
    else:
        field_name = 'email_to'

    BASE_EMAIL_URL = _Conf.BASE_EMAIL_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_done = REQUEST.TLS('todo_done')
    tls_search = REQUEST.TLS('tls_search')
    tls_my = REQUEST.TLS('tls_my')
    tls_all = REQUEST.TLS('tls_all')
    tls_name = REQUEST.TLS('tls_groupname')
    tls_desc = REQUEST.TLS('tls_description')
    tls_closewin = REQUEST.TLS('tls_closewin')
    tls_add = REQUEST.TLS('tls_add')
    tls_group = REQUEST.TLS('tls_group')
    tls_view = REQUEST.TLS('tls_viewmembers')
    output = []
    output.append(standard_html.html_header_popup(REQUEST))
    output.append(u"""
<SCRIPT language="javascript" type="text/javascript">
<!--
window.focus();
window.moveTo(0,250);
time = ""

function replace_vals(returnval)
{
    if (window.opener.top.frames['topcontents'].document.forms.composeform.%(field_name)s.value)
        window.opener.top.frames['topcontents'].document.forms.composeform.%(field_name)s.value=window.opener.top.frames['topcontents'].document.forms.composeform.%(field_name)s.value+', ' + returnval; 
    else
        window.opener.top.frames['topcontents'].document.forms.composeform.%(field_name)s.value=returnval; 
}
// -->
</SCRIPT>
""" % locals())

    formstring = REQUEST.get_formstring(['qs','sort_by','_delete'])
    word = ""
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_CONTACTGROUP])
    if right_param:
        right_param = " AND " + right_param
    QUERY = """SELECT count(*) FROM contact_groups c, items i WHERE c.group_id=i.item_id %s """ % right_param
    REQUEST.db.execute(QUERY.encode('UTF8'))
    count_all = REQUEST.db.fetchone()[0]

    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%setree.py/groups%sqs=" % (_Conf.BASE_EMAIL_URL, REQUEST.get_formstring(['qs']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%setree.py/groups%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_EMAIL_URL, REQUEST.get_formstring(['qs']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%setree.py/groups%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_EMAIL_URL, REQUEST.get_formstring(['qs']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR2(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""

    SQL = """SELECT c.*, i.* FROM contact_groups c, items i WHERE c.group_id=i.item_id %s ORDER BY group_name, group_id LIMIT %d OFFSET %d""" % (right_param, REQUEST.batch_size, REQUEST.qs)
    REQUEST.db.execute(SQL.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()
    output.append(u"""
<TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
  <TR>
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
    <TD class="td_listing1b">%(tls_name)s</TD>
    <TD class="td_listing1b">%(tls_desc)s</TD>
    <TD class="td_listing1b" align="right"><A href="javascript:void(0);" onClick="javascript:window.close()">%(tls_closewin)s</A></TD>
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
  </TR>
""" %locals())
    index = 0
    for result in dbresult:
        if(index % 2 == 0):
            td_class='td_listing0'
        else:
            td_class='td_listing1'
        index = index + 1
        BASE_ICON_URL = _Conf.BASE_ICON_URL
        g_id = result['group_id']
        g_name = _Utils.html_quote_show(result['group_name'].decode('UTF8').replace("{","").replace("}",""))
        g_name2 = g_name.replace("'","").replace(";","")
        g_desc = _Utils.html_quote_show(result['group_description'].decode('UTF8'))
        members = len(_Utils.sql_parse_array(REQUEST, result['contacts']))

        output.append(u"""
  <TR>
    <TD class="%(td_class)s" width="1%%"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
    <TD class="%(td_class)s" width="40%%"><a href="javascript:void(0);" onClick="replace_vals('&quot;{%(tls_group)s:%(g_id)s:%(g_name2)s}&quot;');window.close();">%(g_name)s</a></TD>
    <TD class="%(td_class)s" width="45%%">%(g_desc)s</TD>
    <TD class="%(td_class)s" width="13%%" nowrap><a href="%(BASE_EMAIL_URL)setree.py/members?group_id=%(g_id)s">%(tls_view)s</a></TD>
    <TD class="%(td_class)s" width="1%%"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border=0 alt=""></TD>
  </TR>""" % locals())
    output.append(u"""</TABLE>""")
    if FULL_BAR:
        output.append(FULL_BAR)

    output.append(standard_html.html_footer3(REQUEST))
    return "\n".join(output)

def members(REQUEST):
    if REQUEST.form.has_key('group_id') and REQUEST.form['group_id'].value:
        group_id = int(REQUEST.form['group_id'].value)
    else:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    if REQUEST.form.has_key('field') and REQUEST.form['field'].decode('UTF8').strip():
        field_name = REQUEST.form['field'].decode('UTF8').strip()
    else:
        field_name = 'email_to'
    obj = _ContactGroup.ContactGroup(REQUEST, _InitTypes.INIT_TYPE_ID, group_id)
    contacts = str(_Utils.sql_parse_array(REQUEST, obj.get('contacts')))[1:-1]
    if contacts:
        right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_CONTACT])
        if right_param:
            right_param = " AND " + right_param
        SQL = """SELECT c.*, i.* FROM contacts c, items i WHERE c.contact_id=i.item_id and c.contact_id in (%s) %s""" % (contacts, right_param)
        REQUEST.db.execute(SQL.encode('UTF8'))
        cres = REQUEST.db.dictfetchall()
    else:
        cres = []

    BASE_EMAIL_URL = _Conf.BASE_EMAIL_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_group = REQUEST.TLS('tls_group')
    object_name = obj.get('item_name')
    tls_name = REQUEST.TLS('tls_name')
    tls_email = REQUEST.TLS('tls_email')
    tls_back = REQUEST.TLS('tls_back')
    tls_closewin = REQUEST.TLS('tls_closewin')
    tls_add = REQUEST.TLS('tls_add')
    g_id = obj.get_id()
    g_name2 = obj.get('item_name').replace("{", "").replace("}", "")
    tls_nomembers = REQUEST.TLS('tls_nomembers')
    output = []
    output.append(standard_html.html_header_popup(REQUEST))
    output.append(u"""
<SCRIPT type="text/javascript">
function replace_vals(returnval)
{
    if (window.opener.top.frames['topcontents'].document.forms.composeform.%(field_name)s.value)
        window.opener.top.frames['topcontents'].document.forms.composeform.%(field_name)s.value=window.opener.top.frames['topcontents'].document.forms.composeform.%(field_name)s.value+', ' + returnval; 
    else
        window.opener.top.frames['topcontents'].document.forms.composeform.%(field_name)s.value=returnval;
}
// -->
</SCRIPT>
<BR>
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></TD>
  <TD width="100%%" class="object_name">%(tls_group)s: %(object_name)s</TD>
</TR>
</TABLE>
<BR>
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></TD>
  <TD class="td_listing1b" width="50%%">%(tls_name)s</TD>
  <TD class="td_listing1b" width="50%%">%(tls_email)s</TD>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></TD>
</TR>""" % locals())
    if not cres:
        output.append(u"""
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></TD>
  <TD class="td_listing0" width="100%%" colspan="2" align="center">%(tls_nomembers)s</TD>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></TD>
</TR>
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></TD>
  <TD class="td_listing1" width="100%%" colspan="2" align="center"><input type="button" value="%(tls_back)s" class="input6" onclick="javascript:history.back(1)"></TD>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></TD>
</TR>""" % locals())
    else:
        index = 0
        for row in cres:
            if index%2==0:
                td_class="td_listing0"
            else:
                td_class="td_listing1"
            index = index + 1
            c_name = row['first_name'].decode('UTF8') + " " + row['last_name'].decode('UTF8')
            c_mail = row['e_mail'].decode('UTF8')
            output.append(u"""
<TR>
  <TD class="%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></TD>
  <TD class="%(td_class)s" width="50%%">%(c_name)s</TD>
  <TD class="%(td_class)s" width="50%%">%(c_mail)s</TD>
  <TD class="%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></TD>
</TR>""" % locals())
        if index%2==0:
            td_class="td_listing0"
        else:
            td_class="td_listing1"
        output.append(u"""
<TR>
  <TD class="%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></TD>
  <TD class="%(td_class)s" width="100%%" colspan="2" align="center"><input type="button" value="%(tls_back)s" class="input6" onclick="javascript:history.back(1)">&nbsp;&nbsp;&nbsp;<input type="button" value="%(tls_add)s" onClick="replace_vals('&quot;{%(tls_group)s:%(g_id)s:%(g_name2)s}&quot;');window.close();" class="input6">&nbsp;&nbsp;&nbsp;<input type="button" value="%(tls_closewin)s" class="input6" onclick="window.close();"></TD>
  <TD class="%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></TD>
</TR>""" % locals())
    output.append(u"</TABLE>")
    output.append(standard_html.html_footer3(REQUEST))
    return "\n".join(output)
