# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

from mod_python import apache

import email

import _mail, _InitTypes, _Email, base64, _Conf, cStringIO, _Utils, os, _Document
import Menus
import standard_html
import mx.DateTime

reload(_mail)

MY_MENU_ID=-1

def index(REQUEST): # Add folder management
    output = []
    output.append(standard_html.html_header(REQUEST))
    if not REQUEST.form.has_key('mail_id') or not REQUEST.form['mail_id'].value:
        output.append(standard_html.html_footer(REQUEST))
        return "\n".join(output)

    output = []
    output.append(standard_html.html_header(REQUEST))
    if not REQUEST.form.has_key('headers'):
        output.append(Menus.get_email_menu(REQUEST, MY_MENU_ID))

    msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['mail_id'].value))
    if (msg.get('email_flags') & _Email.EMAIL_READ) == 0:
        REQUEST.db.execute("""UPDATE emails set email_flags=(email_flags | %d) WHERE email_id=%d""" % (_Email.EMAIL_READ, msg.get_id()))
    message = _mail.message_from_string(base64.decodestring(msg.get('email_contents')))

    output.append(_mail.full_parse_message(REQUEST, message, message, msg.get_id()))
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def getpart(REQUEST):
    return _mail.getpart(REQUEST)

def getpart_inline(REQUEST):
    return _mail.getpart_inline(REQUEST)

def save_file_form(REQUEST):
    if not REQUEST.form.has_key('mail_id') or not REQUEST.form['mail_id'].value or not REQUEST.form.has_key('part') or not REQUEST.form['part'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_document_menu(REQUEST, MY_MENU_ID))
    output.append(standard_html.window_script(height=400,width=400, resizable='yes'))

    BASE_EMAIL_URL = _Conf.BASE_EMAIL_URL
    BASE_DOCUMENT_URL = _Conf.BASE_DOCUMENT_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    mail_id = int(REQUEST.form['mail_id'].value)
    part = REQUEST.form['part'].decode('UTF8')
    email_filename = local_getpart_name(REQUEST, mail_id, part)
    try:
        obj = _RootObject.dispatch_item(REQUEST, int(REQUEST.getCookie('activeFolder')))
        my_parent_id = obj.get_id()
        my_parent_name = obj.get_virtual_path()
    except:
        my_parent_id = REQUEST.USER.get_parent_id(REQUEST)
        my_parent_name = REQUEST.USER.get_parent(REQUEST).get_virtual_path()
    if REQUEST.form.has_key('headers'):
        headers = u"""<input type="hidden" name="headers" value="1">"""
    else:
        headers = u""
    add_file_tls = REQUEST.TLS("doc_addfile")
    file_tls = REQUEST.TLS("doc_file")
    save_tls = REQUEST.TLS("tls_save")
    title_tls = REQUEST.TLS("tls_title")
    author_tls = REQUEST.TLS("doc_author")
    folder_tls = REQUEST.TLS("doc_folder")
    desc_tls = REQUEST.TLS("tls_description")
    comments_tls = REQUEST.TLS("tls_comments")
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    REQ_FIELD = _Conf.REQ_FIELD
    BASE_ICON_URL = _Conf.BASE_ICON_URL

    output.append("""\
<SCRIPT language="javascript">
<!--
  function check_values()
  {
    if (!document.addform.filename.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
// -->
</SCRIPT>
<BR>
<TABLE border=0 width=100%% cellpadding=0 cellspacing=0>
<FORM name="addform" method="POST" action="%(BASE_EMAIL_URL)sread.py/addfile" ENCTYPE="multipart/form-data" onSubmit="return check_values();">
<INPUT type="hidden" name="parent_id" value="%(my_parent_id)d">
<INPUT type="hidden" name="mail_id" value="%(mail_id)d">
<INPUT type="hidden" name="part" value="%(part)s">
%(headers)s
  <TR class="tr_listing0">
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD background="%(BASE_ICON_URL)sdokunurk1.gif"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
    <TD nowrap class="th_listing" nowrap>&nbsp;&nbsp;<b>%(add_file_tls)s</b>&nbsp;&nbsp;</TD>
    <TD background="%(BASE_ICON_URL)sdokunurk2.gif"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
    <TD width=100%%><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=2 height=1 border=0 alt=""></TD>
    <TD class="td_listing1">%(file_tls)s%(REQ_FIELD)s</TD>
    <TD class="td_listing1" colspan=2><INPUT size=35 class="textfield1" type="text" name="filename" value="%(email_filename)s"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=2 height=1 border=0 alt=""></TD>
    <TD class="td_listing0">%(title_tls)s</TD>
    <TD class="td_listing0" colspan=2><INPUT  size=35 class="textfield1" type="text" name="title"></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=2 height=1 border=0 alt=""></TD>
    <TD class="td_listing1">%(author_tls)s</TD>
    <TD class="td_listing1" colspan=2><INPUT  size=35 class="textfield1" type="text" name="author"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=2 height=1 border=0 alt=""></TD>
    <TD class="td_listing0">%(folder_tls)s</TD>
    <TD class="td_listing0" colspan=2><INPUT size=35 type="text"  class="textfield1" name="parent_name" value="%(my_parent_name)s" disabled>&nbsp;&nbsp;<A target="popup_window" href="%(BASE_DOCUMENT_URL)sdoctree.py/frametree" onClick="open_window('about:blank');"><IMG src="%(BASE_ICON_URL)sfld.gif" border="0"></A></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=2 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" colspan="3">%(desc_tls)s<BR><TEXTAREA class="textarea1" name="description" rows="3" cols="20"></TEXTAREA></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=2 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" colspan="3">%(comments_tls)s<BR><TEXTAREA class="textarea1" name="comments" rows="3" cols="20"></TEXTAREA></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=23 border=0 alt=""></TD>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=2 height=1 border=0 alt=""></TD>
    <TD colspan="3"><INPUT type="submit" class="input2" name="_save" value="%(save_tls)s"></TD>
  </TR>
</TABLE>
</FORM>"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def addfile(REQUEST):
    output = []
    if not REQUEST.form.has_key('mail_id') or not REQUEST.form['mail_id'].value or not REQUEST.form.has_key('part') or not REQUEST.form['part'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    if not REQUEST.form.has_key('filename'):
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    if not REQUEST.form.has_key('title'):
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    mail_id = int(REQUEST.form['mail_id'].value)
    part = REQUEST.form['part'].decode('UTF8')

    if REQUEST.form['filename'].value.find('\\') <> -1:
        filename = REQUEST.form['filename'].value.decode('UTF8').split('\\')[-1]
    else:
        filename = REQUEST.form['filename'].value.decode('UTF8')
    filename = _Utils.make_path(os.path.split(filename)[-1])

    fp = cStringIO.StringIO(local_getpart(REQUEST, mail_id, part))
    fp.seek(0)

    doc = _Document.Document(REQUEST, _InitTypes.INIT_TYPE_REQ)
    doc.set('filename', filename)
    doc.set('filepointer', fp)
    if not REQUEST.form.has_key('title') or not REQUEST.form['title'].value.decode('UTF8').strip():
        doc.set('title', filename)
    if os.path.exists(doc.get_path().encode('UTF8')):
        # Try adding a new unique number:
        origpath = doc.get_path()
        splitpath = os.path.splitext(origpath)
        newname = None
        for i in range(1,100):
            tmppath = splitpath[0] + ('-%d'%i) + splitpath[1]
            if not os.path.exists(tmppath.encode('UTF8')):
                newname = os.path.split(splitpath[0] + ('-%d'%i) + splitpath[1])[1]
                break
        if newname is None:
            raise RuntimeError, REQUEST.TLS('doc_rename_exists')
        else:
            if not REQUEST.form.has_key('title') or not REQUEST.form['title'].value.decode('UTF8').strip():
                doc.set('title', newname)
            doc.set('filename', newname)
    doc.save()

    if REQUEST.form.has_key('headers'):
        output.append(standard_html.html_header(REQUEST))
        ref_url = REQUEST.SERVER_URL+_Conf.BASE_EMAIL_URL+"read.py?mail_id=%d&headers=1" % mail_id
        output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    else:
        output.append(standard_html.html_header(REQUEST))
        ref_url = REQUEST.SERVER_URL+_Conf.BASE_EMAIL_URL+"read.py?mail_id=%d" % mail_id
        output.append(standard_html.standard_redirect(REQUEST, ref_url, 1))
    output.append(Menus.get_document_menu(REQUEST, MY_MENU_ID))
    output.append(REQUEST.TLS('doc_fileadded'))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def local_getpart_name(REQUEST, mail_id, part):
    parts = map(int, part.split('.'))[1:]

    msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, mail_id)
    message = _mail.message_from_string(base64.decodestring(msg.get('email_contents')))

    for part_ndx in parts:
        message = message.get_payload()[part_ndx]

    return _mail.parse_quoted_string(message, message.get_filename() or _mail.get_alt_name(message) or 'noname.bin')

def local_getpart(REQUEST, mail_id, part):
    parts = map(int, part.split('.'))[1:]

    msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, mail_id)
    message = _mail.message_from_string(base64.decodestring(msg.get('email_contents')))

    for part_ndx in parts:
        message = message.get_payload()[part_ndx]

    return message.get_payload(decode=1)

def source(REQUEST):
    if not REQUEST.form.has_key('mail_id') or not REQUEST.form['mail_id'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['mail_id'].value))
    message = _mail.message_from_string(base64.decodestring(msg.get('email_contents')))

    return "<PRE>%s</PRE>" % _Utils.html_quote(base64.decodestring(msg.get('email_contents')))

def get_dict_from_ical(REQUEST, ical):
    ical_contents = filter(None, ical.split("\n"))
    event = {}
    in_event = 0
    for line in ical_contents:
        if in_event and len(line)>6 and line[0:6] == "BEGIN:":
            in_event = 0
        if line.strip() == "BEGIN:VEVENT":
            in_event = 1
        if in_event and len(line)>8 and line[0:8] == "SUMMARY:":
            event['title']=line[8:]
        if in_event and len(line)>10 and line[0:10] == "ORGANIZER:":
            event['creator'] = line[10:].replace("MAILTO:", "")
        if in_event and len(line)>12 and line[0:12] == "DESCRIPTION:":
            event['description'] = line[12:]
        if in_event and len(line)>8 and line[0:8] == "ATTENDEE":
            tmp = line.split(";")[1].replace("CN=", "").replace('"', "")
            event['attendees'] = event.get('attendees', '') + "###" + tmp
        if in_event and len(line)>8 and line[0:8] == "DTSTART:":
            date = line[8:16]
            time = line[17:21]
            event['start_stamp'] = "%s-%s-%s %s:%s" % (date[0:4], date[4:6], date[6:8], time[0:2], time[2:4])
        if in_event and len(line)>6 and line[0:6] == "DTEND:":
            date = line[6:14]
            time = line[15:19]
            event['end_stamp'] = "%s-%s-%s %s:%s" % (date[0:4], date[4:6], date[6:8], time[0:2], time[2:4])
    return event

def ical(REQUEST, contents):
    event = get_dict_from_ical(REQUEST, a)
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    title = REQUEST.TLS('log_event_id') + ": " + event.get('title')
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(u"""
<BR>
<TABLE border=0 cellpadding=0 cellspacing=0>
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn221.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="7" height="7" border="0" alt=""></TD>
  <TD style="color: #FFFFFF; font-weight: bold; padding: 4px;" bgcolor="#0068C6" nowrap><b>%(title)s</b></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn222.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="7" height="7" border="0" alt=""></TD>
</TR>""" % locals())
    creator = event.get('creator')
    if creator:
        line = "<b>" + REQUEST.TLS('tls_creator') + ":</b> " + creator
        output.append(u"""
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn28.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD class="note_td" align="left" bgcolor="#3F97E1" style="color: #CBFFFF">%(line)s</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn26.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>""" % locals())
    start_stamp = event.get('start_stamp')
    if start_stamp:
        date, time = start_stamp.split(" ")
        year, month, day = map(int, date.split("-"))
        hour, minute = map(int, time.split(":"))
        start_stamp = mx.DateTime.DateTime(year, month, day, hour, minute)
        start_stamp = REQUEST.iso2userdatetime(REQUEST, start_stamp)
        line = "<b>" + REQUEST.TLS('cal_start') + ":</b> " + start_stamp
        output.append(u"""
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn28.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD class="note_td" align="left" bgcolor="#3F97E1" style="color: #CBFFFF">%(line)s</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn26.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>""" % locals())
    end_stamp = event.get('end_stamp')
    if end_stamp:
        date, time = end_stamp.split(" ")
        year, month, day = map(int, date.split("-"))
        hour, minute = map(int, time.split(":"))
        end_stamp = mx.DateTime.DateTime(year, month, day, hour, minute)
        end_stamp = REQUEST.iso2userdatetime(REQUEST, end_stamp)
        line = "<b>" + REQUEST.TLS('cal_end') + ":</b> " + end_stamp
        output.append(u"""
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn28.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD class="note_td" align="left" bgcolor="#3F97E1" style="color: #CBFFFF">%(line)s</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn26.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>""" % locals())
    description = event.get('description')
    if description:
        line = u"<b>" + REQUEST.TLS('tls_description') + u":</b> " + _Utils.newline2br(description)
        output.append(u"""
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn28.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD class="note_td" align="left" bgcolor="#3F97E1" style="color: #CBFFFF">%(line)s</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn26.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>""" % locals())

    output.append(u"""</TABLE>""")
#
#<TR valign="top">
#  <TD style="background-image: url('/web/icons/n28.gif');"><img src="/web/icons/spacer.gif" width="1" height="1" border="0" alt=""></TD>
#  <TD height="100%" class="note_td" align="left" bgcolor="#3F97E1" style="color: #CBFFFF">Prioriteedid<BR><BR>8) s6numihaldus<BR><BR>.hdr{ color : #2243B0; font-family : Tahoma, Verdana, Helvetica, sans-serif; font-size : 22px; text-decoration : none; }<BR>javascript:(function(){var s=document.body.style;var x=s.display;s.display='none';s.display=x;})()<BR><BR>http://www.fertil.ee</TD>
#  <TD style="background-image: url('/web/icons/n26.gif');"><img src="/web/icons/spacer.gif" width="1" height="1" border="0" alt=""></TD>
#</TR>
    return "\n".join(output)
