# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

import standard_html, relations

import mx.DateTime
import SQLTree, _InitTypes, _Conf, _Access, _Utils, _RootObject

def index(REQUEST):
    output = []
    output.append(standard_html.html_header_popup(REQUEST))

    rel_type_id = int(REQUEST.form['item_type_id'].value)
    rel_id = int(REQUEST.form['item_id'].value)
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL

    if REQUEST.form.has_key('related_id') and REQUEST.form['related_id'].value.strip():
        related_item_id = int(REQUEST.form['related_id'].value)
        relations.add_relation(REQUEST, rel_id, related_item_id)
        obj1 = _RootObject.dispatch_item(REQUEST, rel_id)
        obj2 = _RootObject.dispatch_item(REQUEST, related_item_id)
        if obj1.get('item_type_id')==_InitTypes.ITEM_TYPE_CLIENT and obj2.get('item_type_id')==_InitTypes.ITEM_TYPE_CONTACT:
            obj2.set('company', obj1.get('item_name'))
            obj2.save()
        elif obj1.get('item_type_id')==_InitTypes.ITEM_TYPE_CONTACT and obj2.get('item_type_id')==_InitTypes.ITEM_TYPE_CLIENT:
            obj1.set('company', obj2.get('item_name'))
            obj1.save()
        output.append(u"""
<SCRIPT LANGUAGE="JavaScript">
<!--
a = window.opener.location.href.length;
rnd = String(Math.random(0));
rnd = rnd.substring(2,5);
if(window.opener.location.href.substring(a-2, a)=="#1")
{
  window.opener.location.href=window.opener.location.href.substring(0, a-2) + '&rnd=' + rnd + '&o=1';
}
else
{
  window.opener.location.href=window.opener.location.href + '&rnd=' + rnd + '&o=1';
}
// -->
</script>""")


    if rel_type_id == _InitTypes.ITEM_TYPE_CONTACT:
        output.append(contact_contents(REQUEST))
    elif rel_type_id == _InitTypes.ITEM_TYPE_WORKFLOW:
        output.append(workflow_contents(REQUEST))
    elif rel_type_id == _InitTypes.ITEM_TYPE_TODO:
        output.append(todo_contents(REQUEST))
    elif rel_type_id == _InitTypes.ITEM_TYPE_EVENT:
        output.append(cal_contents(REQUEST))
    elif rel_type_id == _InitTypes.ITEM_TYPE_CLIENT:
        output.append(client_contents(REQUEST))
    elif rel_type_id == _InitTypes.ITEM_TYPE_OPPORTUNITY:
        output.append(opportunity_contents(REQUEST))
    elif rel_type_id == _InitTypes.ITEM_TYPE_PRODUCT:
        output.append(product_contents(REQUEST))
    else:
        output.append(u"""<TABLE width="100%%" border="0"><TR><TD width="100%%" align="right"><A href="#" onclick='window.close();'>%s</A></TD></TR></TABLE>""" % REQUEST.TLS('todo_done'))
        a = SQLTree.SQLTree(REQUEST, "reltree")
        if rel_type_id == _InitTypes.ITEM_TYPE_ORGANIZATION:
            a.set_param('item_types', [_InitTypes.ITEM_TYPE_ORGANIZATION])
        elif rel_type_id == _InitTypes.ITEM_TYPE_EVENT:
            a.set_param('item_types', [_InitTypes.ITEM_TYPE_ORGANIZATION, _InitTypes.ITEM_TYPE_PERSON, rel_type_id])
        elif rel_type_id == _InitTypes.ITEM_TYPE_DISCUSSION:
            a.set_param('item_types', [_InitTypes.ITEM_TYPE_ORGANIZATION, _InitTypes.ITEM_TYPE_DISCCATEGORY, rel_type_id])
        else:
            a.set_param('item_types', [_InitTypes.ITEM_TYPE_ORGANIZATION, _InitTypes.ITEM_TYPE_FOLDER, rel_type_id])
        a.set_param('linked_types', [rel_type_id])
        a.set_param('tree_url', _Conf.BASE_GENERAL_URL + 'selectrel.py')
        a.set_param('target_url', _Conf.BASE_GENERAL_URL + 'selectrel.py')
        a.set_param('target', 'framecontents')
        a.set_param('js', """<A href="#" onClick="document.relform.related_id.value=%(item_id)d; document.relform.submit();\">""")
        a.maketree()
        output.append(a.getTree())
    output.append(u"""<FORM name="relform" method="POST" action="%(BASE_GENERAL_URL)sselectrel.py">
<INPUT type="hidden" name="item_id" value="%(rel_id)d">
<INPUT type="hidden" name="item_type_id" value="%(rel_type_id)s">
<INPUT type="hidden" name="related_id" value="">
<INPUT type="hidden" name="others" value="0">
<INPUT type="hidden" name="all" value="0">
<INPUT type="hidden" name="show_all" value="0">
<INPUT type="hidden" name="person_id" value="0">
</FORM>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def save(REQUEST):
    return ''

def client_contents(REQUEST):
    rel_type_id = int(REQUEST.form['item_type_id'].value)
    rel_id = int(REQUEST.form['item_id'].value)
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_done = REQUEST.TLS('todo_done')
    tls_search = REQUEST.TLS('tls_search')
    tls_results = REQUEST.TLS('type_Client')
    tls_name = REQUEST.TLS('tls_name')
    tls_org = REQUEST.TLS('clients_area')
    output = []
    output.append(u"""
<SCRIPT language="javascript" type="text/javascript">
<!--
window.moveTo(0,0);
// -->
</SCRIPT>
<FORM method="POST" name="searchform" action="%(BASE_GENERAL_URL)sselectrel.py">
<INPUT type="hidden" name="item_id" value="%(rel_id)d">
<INPUT type="hidden" name="item_type_id" value="%(rel_type_id)s">
<INPUT type="hidden" name="related_id" value="">
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
<TR>
  <TD colspan="5"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=5 border=0 alt=""></TD>
</TR>
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD align="right"><input type="text" name="search_w" class="textfield1" size="25"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD nowrap><input type="submit" class="input6" name="search" value="%(tls_search)s">&nbsp;<input type="button" class="input6" name="save" value="%(tls_done)s" onclick="window.close();"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
</FORM>""" % locals())

    w = ""
    w2 = ""
    if REQUEST.form.has_key('search_w') and REQUEST.form['search_w'].value.strip():
      w = _Utils.sql_quote_simple(REQUEST.form['search_w'].value.strip().decode('UTF8').lower())
      w2 = _Utils.sql_quote_simple(REQUEST.form['search_w'].value.strip().decode('UTF8'))
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_CLIENT])
    if right_param:
        right_param = " AND %s" % right_param
    
    if w:
      search_params = u""" AND (lower(c.client_name) like '%%%s%%' OR c.client_type = '%s' OR lower(c.client_nr) like '%%%s%%' OR c.client_field = '%s' OR lower(c.telephone) like '%%%s%%' OR lower(c.fax) like '%%%s%%' OR c.client_ownership = '%s' OR lower(c.e_mail) like '%%%s%%' OR lower(c.homepage) like '%%%s%%' OR lower(c.registry_code) like '%%%s%%' OR lower(c.vat_nr) like '%%%s%%' OR c.country = '%s' OR lower(c.mail_address) like '%%%s%%' OR lower(c.legal_address) like '%%%s%%' OR lower(c.description) like '%%%s%%' OR lower(c.bank_reqs) like '%%%s%%')""" % (w, w2, w, w2, w, w, w2, w, w, w, w, w2, w, w, w, w)
    else:
      search_params = ""
    QUERY = """SELECT count(*) FROM items i, clients c WHERE c.client_id=i.item_id %s %s""" % (search_params, right_param)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    count_all = REQUEST.db.fetchone()[0]
    formstring = REQUEST.get_formstring(['qs','sort_by','_delete'])
    
    
    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%sselectrel.py%sqs=" % (_Conf.BASE_GENERAL_URL, REQUEST.get_formstring(['persons', 'qs', '_add', '_delete', 'person_out']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%sselectrel.py%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_GENERAL_URL, REQUEST.get_formstring(['persons', 'qs', '_add', '_delete', 'person_out']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%sselectrel.py%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_GENERAL_URL, REQUEST.get_formstring(['persons', 'qs', '_add', '_delete', 'person_out']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR2(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""
    SQL = """SELECT i.item_name, c.client_id, c.client_field FROM items i, clients c WHERE c.client_id=i.item_id %s %s order by c.client_name, c.client_field LIMIT %s OFFSET %s""" % (search_params, right_param, REQUEST.batch_size, REQUEST.qs)
    REQUEST.db.execute(SQL.encode('UTF8'))
    output.append(u"""
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
<TR>
  <TD colspan="4"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=5 border=0 alt=""></TD>
</TR>
<TR>
  <TD colspan="4">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=15 height=1 border=0 alt=""></TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD nowrap class="th_listing">&nbsp;&nbsp;<b>%(tls_results)s</b>&nbsp;&nbsp;</TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
      </TR>
    </TABLE>
  </TD>
</TR>
<TR>
  <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b" width="55%%">%(tls_name)s</TD>
  <TD class="td_listing1b" width="45%%">%(tls_org)s</TD>
  <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % locals())

    res = REQUEST.db.dictfetchall()
    index = 0
    for row in res:
        if index%2==0:
            td_class = 0
        else:
            td_class = 1
        index = index + 1
        c_name = (_Utils.html_quote_show(row['item_name']) or "&nbsp").decode('UTF8')
        c_field = (row['client_field'] or "&nbsp").decode('UTF8')
        c_id = row['client_id']
        output.append(u"""
<TR>
  <TD class="td_listing%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing%(td_class)s"><A class="blueboldlink" href="#" onClick="document.relform.related_id.value=%(c_id)d; document.relform.submit();\">%(c_name)s</A></TD>
  <TD class="td_listing%(td_class)s"><A class="blacklink" href="#" onClick="document.relform.related_id.value=%(c_id)d; document.relform.submit();\">%(c_field)s</A></TD>
  <TD class="td_listing%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % locals())

    output.append("</TABLE>")
    if FULL_BAR:
        output.append(FULL_BAR)
    output.append("<BR>")
    return "\n".join(output)

def workflow_contents(REQUEST):
    rel_type_id = int(REQUEST.form['item_type_id'].value)
    rel_id = int(REQUEST.form['item_id'].value)
    tls_myworkflows = REQUEST.TLS('tls_myworkflows')
    tls_othersworkflows = REQUEST.TLS('tls_othersworkflows')
    tls_allworkflows = REQUEST.TLS('tls_allworkflows')
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    tls_done = REQUEST.TLS('todo_done')
    output = []
    others = 0
    all = 0
    if REQUEST.form.has_key('others') and int(REQUEST.form['others'].value.strip()):
        extra_pars = u" AND w.percent_complete<100"
        style1 = ""
        style2 = """style="background-image: url('%(BASE_ICON_URL)streetopbg3.gif');\"""" % locals()
        style3 = ""
        others = 1
    elif REQUEST.form.has_key('all') and int(REQUEST.form['all'].value.strip()):
        extra_pars = u""
        style1 = ""
        style2 = ""
        style3 = """style="background-image: url('%(BASE_ICON_URL)streetopbg3.gif');\"""" % locals()
        all = 1
    else:
        extra_pars = u" AND w.percent_complete<100"
        style1 = """style="background-image: url('%(BASE_ICON_URL)streetopbg3.gif');\"""" % locals()
        style2 = ""
        style3 = ""

    tls_complete = REQUEST.TLS('todo_complete')
    tls_title = REQUEST.TLS('tls_title')
    tls_creator = REQUEST.TLS('tls_creator')
    tls_due = REQUEST.TLS('todo_due')
    sortby = [
'workflow_title ASC', 'workflow_title DESC',
'workflow_start_time  ASC', 'workflow_start_time  DESC',
'workflow_due_time ASC', 'workflow_due_time DESC',
]
    DEFAULT_SORTBY = 6
    sortby_id = 4

    if REQUEST.form.has_key('sort_by') and REQUEST.form['sort_by'].value.decode('UTF8').strip():
        sortby_id = int(REQUEST.form['sort_by'].value.decode('UTF8').strip())   
    if sortby_id < 0 or sortby_id >= len(sortby):
        sortby_id  = DEFAULT_SORTBY
    formstring = REQUEST.get_formstring(['qs','sort_by'])
    sortby_title = u"""<A class="blackboldlink" href="%sselectrel.py%ssort_by=0">%s</A>""" % (_Conf.BASE_GENERAL_URL, formstring, tls_title)
    sortby_creator = u"""<A class="blackboldlink" href="%sselectrel.py%ssort_by=2">%s</A>""" % (_Conf.BASE_GENERAL_URL, formstring, tls_creator)
    sortby_due = u"""<A class="blackboldlink" href="%sselectrel.py%ssort_by=4">%s</A>""" % (_Conf.BASE_GENERAL_URL, formstring, tls_due)
    if sortby_id == 0:
        sortby_title = u"""<A class="blackboldlink" href="%sselectrel.py%ssort_by=1">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_GENERAL_URL, formstring, tls_title)
    elif sortby_id == 1:
        sortby_title = u"""<A class="blackboldlink" href="%sselectrel.py%ssort_by=0">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_GENERAL_URL, formstring, tls_title)
    elif sortby_id == 2:
        sortby_creator = u"""<A class="blackboldlink" href="%sselectrel.py%ssort_by=3">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_GENERAL_URL, formstring, tls_creator)
    elif sortby_id == 3:
        sortby_creator = u"""<A class="blackboldlink" href="%sselectrel.py%ssort_by=2">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_GENERAL_URL, formstring, tls_creator)
    elif sortby_id == 4:
        sortby_due = u"""<A class="blackboldlink" href="%sselectrel.py%ssort_by=5">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_GENERAL_URL, formstring, tls_due)
    elif sortby_id == 5:
        sortby_due = u"""<A class="blackboldlink" href="%sselectrel.py%ssort_by=4">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_GENERAL_URL, formstring, tls_due)
    del formstring

    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_workflows = REQUEST.TLS('topmenu_workflows')

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_WORKFLOW])
    if right_param:
        right_param = " AND " + right_param

    if REQUEST.form.has_key('others') and int(REQUEST.form['others'].value.strip()):
        if REQUEST.db.version < 740:
            users_limit = """\n  AND (i.creator_id <> %d OR w.related_persons @ '{%d}'::int[])""" % (REQUEST.USER.get_id(), REQUEST.USER.get_id())
        else:
            users_limit = """\n  AND (i.creator_id <> %d OR %d=ANY(w.related_persons))""" % (REQUEST.USER.get_id(), REQUEST.USER.get_id())
    elif REQUEST.form.has_key('all') and int(REQUEST.form['all'].value.strip()):
        users_limit = ""
    else:
        if REQUEST.db.version < 740:
            users_limit = """\n  AND (i.creator_id = %d OR w.related_persons @ '{%d}'::int[])""" % (REQUEST.USER.get_id(), REQUEST.USER.get_id())
        else:
            users_limit = """\n  AND (i.creator_id = %d OR %d=ANY(w.related_persons))""" % (REQUEST.USER.get_id(), REQUEST.USER.get_id())
    QUERY = u"""SELECT w.*, i.parent_id, p.item_name AS creator_name FROM workflows w, items i, items p WHERE w.workflow_id=i.item_id AND p.item_id=i.creator_id %s%s%s ORDER BY %s LIMIT %d OFFSET %d""" % (users_limit, right_param, extra_pars, sortby[sortby_id], REQUEST.batch_size, REQUEST.qs)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()


    menu_str = """\
<TABLE cellpadding=0 width="100%%" cellspacing=0 class="table_menu" style="background-image: url('%(BASE_ICON_URL)streetopbg2.gif')">
  <TR>
    <TD width="8" %(style1)s><img src="%(BASE_ICON_URL)sspacer.gif" width="8" height="26" border=0 alt=""></TD>
    <TD valign=top nowrap %(style1)s><IMG src="%(BASE_ICON_URL)sdisclist.gif" width="20" height="16" border="0" alt=""></TD><TD valign="middle" nowrap %(style1)s><A style="color: #FFFFFF; text-decoration: none; font: Verdana 10px normal" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d" target="_self">%(tls_myworkflows)s</A></TD>
    <TD width="10" %(style1)s><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="26" border=0 alt=""></TD>
    <TD width="8" %(style2)s><img src="%(BASE_ICON_URL)sspacer.gif" width="8" height="26" border=0 alt=""></TD>
    <TD  valign=top nowrap %(style2)s><IMG src="%(BASE_ICON_URL)ssearchicon.gif" width="19" height="16" border="0" alt=""></TD><TD valign="middle" nowrap %(style2)s><A style="color: #FFFFFF; text-decoration: none; font: Verdana 10px normal" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&others=1" target="_self">%(tls_othersworkflows)s</A></TD>
    <TD width="10" %(style2)s><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="26" border=0 alt=""></TD>
    <TD width="8" %(style3)s><img src="%(BASE_ICON_URL)sspacer.gif" width="8" height="26" border=0 alt=""></TD>
    <TD valign=top nowrap %(style3)s><IMG src="%(BASE_ICON_URL)ssearchicon.gif" width="19" height="16" border="0" alt=""></TD><TD valign="middle" nowrap %(style3)s><A style="color: #FFFFFF; text-decoration: none; font: Verdana 10px normal" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&all=1" target="_self">%(tls_allworkflows)s</A></TD>
    <TD width="10" %(style3)s><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="26" border=0 alt=""></TD>
    <TD align="right" width="100%%"><A style="color: #FFFFFF; text-decoration: none; font: Verdana 10px; font-weight: bold" href="javascript:void(0);" onClick="javascript:window.close()">%(tls_done)s</A>&nbsp;</TD>
  </TR>
</TABLE>
<BR>""" % locals()


    output.append(u"""\
%(menu_str)s
<TABLE width="100%%" cellpadding=0 cellspacing=0 border=0>
<TR>
  <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b" nowrap>%(tls_complete)s</TD>
  <TD class="td_listing1b">%(sortby_title)s</TD>
  <TD class="td_listing1b" nowrap>%(sortby_creator)s</TD>
  <TD class="td_listing1b" nowrap>%(sortby_due)s</TD>
</TR>""" % locals())

    index = 0
    for item in dbresult:
        item['class_type'] = index % 2
        index += 1
        item['others'] = others
        item['all'] = all
        item['BASE_WORKFLOWS_URL'] = _Conf.BASE_WORKFLOWS_URL
        item['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
        item['markredstart'] = ""
        item['markredend'] = ""
        if item['workflow_due_time'] is None:
            item['workflow_due_time'] = ""
        else:
            item['workflow_due_time'] = REQUEST.iso2userdate(item['workflow_due_time'])
        QUERY = u"""SELECT t.*, i.* FROM todos t, items i WHERE t.workflow_id=%d AND t.todo_id=i.item_id ORDER BY TITLE """ % (item['workflow_id'])
        REQUEST.db.execute(QUERY.encode('UTF8'))
        dbresult2 = REQUEST.db.dictfetchall()
        item['tododone'] = 0
        item['todocount'] = 0
        item['complete'] = 0
        item['workflow_title']= _Utils.html_quote_show(item['workflow_title'].decode('UTF8')) or "&nbsp;"
        item['creator_name']= item['creator_name'].decode('UTF8')
        for item2 in dbresult2:
            item['todocount'] = item['todocount'] + 1
            item['complete'] = item['complete'] + item2['percent_complete']
            if item2['percent_complete'] == 100:
                item['tododone'] = item['tododone'] + 1
        if item['complete']:
            item['complete'] = item['complete'] / item['todocount']
        if(item['complete'] == 0):
            item['complete_str'] = """<IMG src="%slgreen.gif" width="50" height="4" border=0 alt="0%% %s">""" % (_Conf.BASE_ICON_URL, REQUEST.TLS('todo_complete'))
        elif(item['complete'] == 100):
            item['complete_str'] = """<IMG src="%sdgreen.gif" width="50" height="4" border=0 alt="100%% %s">""" % (_Conf.BASE_ICON_URL, REQUEST.TLS('todo_complete'))
        else:
            item['first_percent']= (int) (item['complete']/2)
            item['second_percent']= 50 - item['first_percent']
            item['tls_complete'] = REQUEST.TLS('todo_complete')
            item['complete_str'] = ("""<IMG src="%(BASE_ICON_URL)sdgreen.gif" width="%(first_percent)d" height="4" border=0 alt="%(complete)d%% %(tls_complete)s"><IMG src="%(BASE_ICON_URL)slgreen.gif" width="%(second_percent)d" height="4" border=0 alt="%(complete)d%% %(tls_complete)s">""" % item)
        output.append(u"""\
<TR>
  <TD class="td_listing%(class_type)d"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing%(class_type)d" style="text-align: left">
      <TABLE border=0 width=54 cellpadding=1 cellspacing=0 bgcolor="#000000">
        <TR>
          <TD>
            <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0 bgcolor="#FFFFFF">
              <TR>
                <TD colspan=3 bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
              </TR>
              <TR>
                <TD bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
                <TD bgcolor="#FFFFFF" width="100%%">%(complete_str)s</TD>
                <TD bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
              </TR>
              <TR>
                <TD colspan=3 bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
              </TR>
            </TABLE>
          </TD>
        </TR>
      </TABLE>
  </TD>
  <TD class="td_listing%(class_type)d" width="35%%"><A class="td_listing" href="#" onClick="document.relform.others.value=%(others)s;document.relform.all.value=%(all)s;document.relform.related_id.value=%(workflow_id)d; document.relform.submit();">%(markredstart)s%(workflow_title)s%(markredend)s</A></TD>
  <TD class="td_listing%(class_type)d" width="20%%" nowrap>%(markredstart)s%(creator_name)s%(markredend)s</TD>
  <TD class="td_listing%(class_type)d" width="20%%" nowrap>%(markredstart)s%(workflow_due_time)s%(markredend)s</TD>
</TR>""" % item)

    output.append(u"""\
  <TR>
    <TD colspan=5>&nbsp;</TD>
  </TR>
</TABLE>
<BR>""")
    return "\n".join(output)

def todo_contents(REQUEST):
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    rel_type_id = int(REQUEST.form['item_type_id'].value)
    rel_id = int(REQUEST.form['item_id'].value)
    tls_done = REQUEST.TLS('todo_done')
    output = []

    if REQUEST.form.has_key('show_users'):
        REQUEST.del_setting('cal_show_users')

    try:
        show_users = REQUEST.get_setting('cal_show_users')
    except:
        show_users = None

    show_all = 0

    if REQUEST.form.has_key('show_all') and int(REQUEST.form['show_all'].value):
        sh = "show_all=1&"
        show_all=1
        style1 = ""
        style2 = """style="background-image: url('%(BASE_ICON_URL)streetopbg3.gif');\"""" % locals()
        extra_pars = u""
    else:
        sh = ""
        style1 = """style="background-image: url('%(BASE_ICON_URL)streetopbg3.gif');\"""" % locals()
        style2 = ""
        extra_pars = u" AND percent_complete < 100"

    sortby = [
'title ASC', 'title DESC',
'creator_name ASC', 'creator_name DESC',
'priority ASC', 'priority DESC',
'category ASC', 'category DESC',
'status ASC', 'status DESC',
'due_time ASC', 'due_time DESC',
'percent_complete ASC', 'percent_complete DESC',
]

    tls_tasks = REQUEST.TLS('tls_todos')
    tls_done = REQUEST.TLS('todo_done')
    tls_title = REQUEST.TLS('tls_title')
    tls_creator = REQUEST.TLS('tls_creator')
    tls_priority = REQUEST.TLS('tls_priority')
    tls_category = REQUEST.TLS('tls_category')
    tls_status = REQUEST.TLS('tls_status')
    tls_due = REQUEST.TLS('todo_due')
    tls_onlyme = REQUEST.TLS('todo_onlyme')
    tls_select_others = REQUEST.TLS('todo_select_others')
    tls_mytasks = REQUEST.TLS('compmenu_todo_active')
    tls_alltasks = REQUEST.TLS('compmenu_todo_all')
    base_todo_url = _Conf.BASE_TODO_URL

    DEFAULT_SORTBY = 10
    sortby_id = -1
    if REQUEST.form.has_key('sort_by') and REQUEST.form['sort_by'].value.decode('UTF8').strip():
        sortby_id = int(REQUEST.form['sort_by'].value.decode('UTF8').strip())   
    if sortby_id < 0 or sortby_id >= len(sortby):
        sortby_id  = DEFAULT_SORTBY
    formstring = REQUEST.get_formstring(['qs','sort_by'])
    sortby_title = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=0">%s</A>""" % (_Conf.BASE_TODO_URL, formstring, tls_title)
    sortby_creator = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=2">%s</A>""" % (_Conf.BASE_TODO_URL, formstring, tls_creator)
    sortby_priority = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=4">%s</A>""" % (_Conf.BASE_TODO_URL, formstring, tls_priority)
    sortby_category = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=6">%s</A>""" % (_Conf.BASE_TODO_URL, formstring, tls_category)
    sortby_status = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=8">%s</A>""" % (_Conf.BASE_TODO_URL, formstring, tls_status)
    sortby_due = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=10">%s</A>""" % (_Conf.BASE_TODO_URL, formstring, tls_due)
    sortby_complete = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=12">%s</A>""" % (_Conf.BASE_TODO_URL, formstring, tls_done)
    if sortby_id == 0:
        sortby_title = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=1">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_title)
    elif sortby_id == 1:
        sortby_title = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=0">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_title)
    elif sortby_id == 2:
        sortby_creator = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=3">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_creator)
    elif sortby_id == 3:
        sortby_creator = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=2">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_creator)
    elif sortby_id == 4:
        sortby_priority = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=5">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_priority)
    elif sortby_id == 5:
        sortby_priority = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=4">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_priority)
    elif sortby_id == 6:
        sortby_category = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=7">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_category)
    elif sortby_id == 7:
        sortby_category = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=6">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_category)
    elif sortby_id == 8:
        sortby_status = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=9">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_status)
    elif sortby_id == 9:
        sortby_status = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=8">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_status)
    elif sortby_id == 10:
        sortby_due = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=11">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_due)
    elif sortby_id == 11:
        sortby_due = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=10">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_due)
    elif sortby_id == 12:
        sortby_complete = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=13">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_done)
    elif sortby_id == 13:
        sortby_complete = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=12">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_done)
    del formstring





    menu_str = """\
<TABLE cellpadding=0 width="100%%" cellspacing=0 class="table_menu" style="background-image: url('%(BASE_ICON_URL)streetopbg2.gif')">
  <TR>
    <TD width="8" %(style1)s><img src="%(BASE_ICON_URL)sspacer.gif" width="8" height="26" border=0 alt=""></TD>
    <TD valign=top nowrap %(style1)s><IMG src="%(BASE_ICON_URL)sdisclist.gif" width="20" height="16" border="0" alt=""></TD><TD valign="middle" nowrap %(style1)s><A style="color: #FFFFFF; text-decoration: none; font: Verdana 10px normal" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d" target="_self">%(tls_mytasks)s</A></TD>
    <TD width="10" %(style1)s><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="26" border=0 alt=""></TD>
    <TD width="8" %(style2)s><img src="%(BASE_ICON_URL)sspacer.gif" width="8" height="26" border=0 alt=""></TD>
    <TD  valign=top nowrap %(style2)s><IMG src="%(BASE_ICON_URL)ssearchicon.gif" width="19" height="16" border="0" alt=""></TD><TD valign="middle" nowrap %(style2)s><A style="color: #FFFFFF; text-decoration: none; font: Verdana 10px normal" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&show_all=1" target="_self">%(tls_alltasks)s</A></TD>
    <TD width="10" %(style2)s><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="26" border=0 alt=""></TD>
    <TD align="right" width="100%%"><A style="color: #FFFFFF; text-decoration: none; font: Verdana 10px; font-weight: bold" href="javascript:void(0);" onClick="javascript:window.close()">%(tls_done)s</A>&nbsp;</TD>
  </TR>
</TABLE>
<BR>""" % locals()








    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_TODO])
    if right_param:
        right_param = " AND " + right_param

    if show_users: # Show involved people
        users_limit = []
        if REQUEST.db.version < 740:
            for userid in show_users:
                users_limit.append("""i.creator_id = %d""" % userid)
                users_limit.append("""t.related_persons @ '{%d}'::int[]""" % userid)
        else:
            for userid in show_users:
                users_limit.append("""i.creator_id = %d""" % userid)
                users_limit.append("""%d=ANY(t.related_persons)""" % userid)
        users_limit = "\n     (%s) " % " OR ".join(users_limit)
    else: # show only personal stuff
        if REQUEST.db.version < 740:
            users_limit = """\n     (i.creator_id = %d OR t.related_persons @ '{%d}'::int[])""" % (REQUEST.USER.get_id(), REQUEST.USER.get_id())
        else:
            users_limit = """\n     (i.creator_id = %d OR %d=ANY(t.related_persons))""" % (REQUEST.USER.get_id(), REQUEST.USER.get_id())

    QUERY = u"""SELECT count(*) AS count_all FROM todos t, items i, items p WHERE t.todo_id=i.item_id AND p.item_id=i.creator_id AND %s%s%s""" % (users_limit, extra_pars, right_param)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    count_all = REQUEST.db.dictfetchone()['count_all']

    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%sselectrel.py%sqs=" % (_Conf.BASE_GENERAL_URL, REQUEST.get_formstring(['qs']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%sselectrel.py%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_GENERAL_URL, REQUEST.get_formstring(['qs']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%sselectrel.py%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_GENERAL_URL, REQUEST.get_formstring(['qs']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR2(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""

    QUERY = u"""SELECT t.*, i.parent_id, p.item_name AS creator_name FROM todos t, items i, items p WHERE t.todo_id=i.item_id AND p.item_id=i.creator_id AND %s%s%s ORDER BY %s LIMIT %d OFFSET %d""" % (users_limit, extra_pars, right_param, sortby[sortby_id], REQUEST.batch_size, REQUEST.qs)

    REQUEST.db.execute(QUERY.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()
    BASE_ICON_URL = _Conf.BASE_ICON_URL

    output.append(u"""\
%(menu_str)s
<TABLE width="100%%" cellpadding=0 cellspacing=0 border=0>
<TR class="tr_listing0">
  <TD colspan=5><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=15 border=0 alt=""></TD>
</TR>
<TR>
  <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b" nowrap>%(sortby_complete)s</TD>
  <TD class="td_listing1b">%(sortby_title)s</TD>
  <TD class="td_listing1b" nowrap>%(sortby_creator)s</TD>
  <TD class="td_listing1b" nowrap>%(sortby_due)s</TD>
</TR>""" % locals())

    index = 0
    now = _Utils.utc_now_mx()
    now = mx.DateTime.DateTime(now.year, now.month, now.day)
    for item in dbresult:
        item['show_all'] = show_all
        item['class_type'] = index % 2
        index += 1
        item['BASE_TODO_URL'] = _Conf.BASE_TODO_URL
        item['BASE_ICON_URL'] = _Conf.BASE_ICON_URL

        item['markredstart'] = item['markredend'] = u""
        if item['due_time'] is None:
            item['due_time'] = ""
        else:
            if item['percent_complete'] < 100 and now >= item['due_time']:
                item['markredstart'] = u"<FONT color='red'>"
                item['markredend'] = u"</FONT>"
            item['due_time'] = REQUEST.iso2userdate(item['due_time'])


        if isinstance(item['creator_name'], str):
            item['creator_name'] = item['creator_name'].decode('UTF8')
        if isinstance(item['title'], str):
            item['title'] = _Utils.html_quote_show(item['title'].decode('UTF8')) or "&nbsp;"
        
        if(item['percent_complete'] == 0):
            item['complete_str'] = """<IMG src="%slgreen.gif" width="50" height="4" border=0 alt="0%% %s">""" % (_Conf.BASE_ICON_URL, REQUEST.TLS('todo_complete'))
        elif(item['percent_complete'] == 100):
            item['complete_str'] = """<IMG src="%sdgreen.gif" width="50" height="4" border=0 alt="100%% %s">""" % (_Conf.BASE_ICON_URL, REQUEST.TLS('todo_complete'))
        else:
            item['first_percent']=(int) (item['percent_complete']/2)
            item['second_percent']=50 - item['first_percent']
            item['tls_complete'] = REQUEST.TLS('todo_complete')
            item['complete_str'] = ("""<IMG src="%(BASE_ICON_URL)sdgreen.gif" width="%(first_percent)d" height="4" border=0 alt="%(percent_complete)d%% %(tls_complete)s"><IMG src="%(BASE_ICON_URL)slgreen.gif" width="%(second_percent)d" height="4" border=0 alt="%(percent_complete)d%% %(tls_complete)s">""" % item)
        output.append(u"""<TR>
  <TD class="td_listing%(class_type)d"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing%(class_type)d" style="text-align: left">
      <TABLE border=0 width=54 cellpadding=1 cellspacing=0 bgcolor="#000000">
        <TR>
          <TD>
            <TABLE border=0 width=100%% cellpadding=0 cellspacing=0 bgcolor="#FFFFFF">
              <TR>
                <TD colspan=3 bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
              </TR>
              <TR>
                <TD bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
                <TD bgcolor="#FFFFFF" width="100%%">%(complete_str)s</TD>
                <TD bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
              </TR>
              <TR>
                <TD colspan=3 bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
              </TR>
            </TABLE>
          </TD>
        </TR>
      </TABLE>
   </TD>
  <TD class="td_listing%(class_type)d" width="30%%"><A class="td_listing" href="#" onClick="document.relform.all.value=%(show_all)d;document.relform.related_id.value=%(todo_id)d; document.relform.submit();">%(markredstart)s%(title)s%(markredend)s</A></TD>
  <TD class="td_listing%(class_type)d" width="15%%" nowrap>%(markredstart)s%(creator_name)s%(markredend)s</TD>
  <TD class="td_listing%(class_type)d" width="15%%" nowrap>%(markredstart)s%(due_time)s%(markredend)s</TD>
</TR>""" % item)

    output.append(u"</TABLE>")

    if FULL_BAR:
        output.append(FULL_BAR)
    output.append("<BR>")
    return "\n".join(output)
    
def cal_contents(REQUEST):
    output = []
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    rel_type_id = int(REQUEST.form['item_type_id'].value)
    rel_id = int(REQUEST.form['item_id'].value)
    tls_done = REQUEST.TLS('todo_done')
    if REQUEST.form.has_key('person_id'):
        person_id = int(REQUEST.form['person_id'].value)
    else:
        person_id = REQUEST.USER.get_id()
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_PERSON])
    if right_param:
        right_param = " AND " + right_param
    QUERY = """SELECT p.person_id, i.item_name, o.organization_name FROM persons p, items i, organizations o WHERE p.person_id=i.item_id AND o.organization_id=i.parent_id%s ORDER BY p.last_name, p.first_name""" % right_param
    REQUEST.db.execute(QUERY.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()
    person_str = """<SELECT name="person_id" ONCHANGE="document.relform.person_id.value = this.options[this.selectedIndex].value;document.relform.submit();">"""
    for p in dbresult:
        if p['person_id'] == person_id:
            person_str += """<OPTION onselect="" value="%d" SELECTED>%s (%s)""" % (p['person_id'], p['item_name'].decode('UTF8'), p['organization_name'].decode('UTF8'))
        else:
            person_str += """<OPTION value="%d">%s (%s)""" % (p['person_id'], p['item_name'].decode('UTF8'), p['organization_name'].decode('UTF8'))
    person_str += """</SELECT>"""
    
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_EVENT])
    if right_param:
        right_param = " AND %s" % right_param
    
    sortby = [
'event_name ASC', 'event_name DESC',
'creator_name ASC', 'creator_name DESC',
'start_stamp ASC', 'start_stamp DESC',
'end_stamp ASC', 'end_stamp DESC',
'event_priority ASC', 'event_priority DESC',
'event_activity ASC', 'event_activity DESC']

    DEFAULT_SORTBY = 7
    sortby_id = -1
    if REQUEST.form.has_key('sort_by') and REQUEST.form['sort_by'].value.decode('UTF8').strip():
        sortby_id = int(REQUEST.form['sort_by'].value.decode('UTF8').strip())
    if sortby_id < 0 or sortby_id >= len(sortby):
        sortby_id  = DEFAULT_SORTBY

    tls_startdate = REQUEST.TLS('cal_startdate')
    tls_enddate = REQUEST.TLS('cal_enddate')
    tls_search = REQUEST.TLS('tls_search')
    tls_pri = REQUEST.TLS('tls_priority')
    tls_act = REQUEST.TLS('tls_activity')
    tls_subject = REQUEST.TLS('tls_subject')
    tls_creator = REQUEST.TLS('tls_creator')
    tls_done = REQUEST.TLS('todo_done')
    
    formstring = REQUEST.get_formstring(['qs','sort_by'])
    sortby_subject = u"""<A class="blackboldlink" href="%sselectrel.py%ssort_by=0">%s</A>""" % (_Conf.BASE_GENERAL_URL, formstring, tls_subject)
    sortby_creator = u"""<A class="blackboldlink" href="%sselectrel.py%ssort_by=2">%s</A>""" % (_Conf.BASE_GENERAL_URL, formstring, tls_creator)
    sortby_start = u"""<A class="blackboldlink" href="%sselectrel.py%ssort_by=4">%s</A>""" % (_Conf.BASE_GENERAL_URL, formstring, tls_startdate)
    sortby_end = u"""<A class="blackboldlink" href="%sselectrel.py%ssort_by=6">%s</A>""" % (_Conf.BASE_GENERAL_URL, formstring, tls_enddate)
    sortby_pri = u"""<A class="blackboldlink" href="%sselectrel.py%ssort_by=8">%s</A>""" % (_Conf.BASE_GENERAL_URL, formstring, tls_pri)
    sortby_act = u"""<A class="blackboldlink" href="%sselectrel.py%ssort_by=10">%s</A>""" % (_Conf.BASE_GENERAL_URL, formstring, tls_act)
    if sortby_id == 0:
        sortby_subject = u"""<A class="blackboldlink" href="%sselectrel.py%ssort_by=1">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_GENERAL_URL, formstring, tls_subject)
    elif sortby_id == 1:
        sortby_subject = u"""<A class="blackboldlink" href="%sselectrel.py%ssort_by=0">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_GENERAL_URL, formstring, tls_subject)
    elif sortby_id == 4:
        sortby_start = u"""<A class="blackboldlink" href="%sselectrel.py%ssort_by=5">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_GENERAL_URL, formstring, tls_startdate)
    elif sortby_id == 5:
        sortby_start = u"""<A class="blackboldlink" href="%sselectrel.py%ssort_by=4">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_GENERAL_URL, formstring, tls_startdate)
    elif sortby_id == 6:
        sortby_end = u"""<A class="blackboldlink" href="%sselectrel.py%ssort_by=7">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_GENERAL_URL, formstring, tls_enddate)
    elif sortby_id == 7:
        sortby_end = u"""<A class="blackboldlink" href="%sselectrel.py%ssort_by=6">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_GENERAL_URL, formstring, tls_enddate)
    elif sortby_id == 10:
        sortby_act = u"""<A class="blackboldlink" href="%sselectrel.py%ssort_by=11">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_GENERAL_URL, formstring, tls_act)
    elif sortby_id == 11:
        sortby_act = u"""<A class="blackboldlink" href="%sselectrel.py%ssort_by=10">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_GENERAL_URL, formstring, tls_act)

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_EVENT])
    if right_param:
        right_param = " AND %s" % right_param
    QUERY = u"""\
SELECT
 count(*) AS count_all
FROM
 events e,
 items i
WHERE 
 e.event_id=i.item_id AND
 i.creator_id=%s
-- right param
 %s
""" % (person_id, right_param)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    count_all = REQUEST.db.dictfetchone()['count_all']

    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%sselectrel.py%sqs=" % (_Conf.BASE_GENERAL_URL, REQUEST.get_formstring(['qs']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%sselectrel.py%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_GENERAL_URL, REQUEST.get_formstring(['qs']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%sselectrel.py%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_GENERAL_URL, REQUEST.get_formstring(['qs']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR2(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""
    
    SQL = u"""\
SELECT
 e.*,
 i.*
FROM
 events e,
 items i
WHERE 
 e.event_id=i.item_id AND
 i.creator_id=%s
-- right-param
%s
-- end q
ORDER BY %s
LIMIT %d OFFSET %d
""" % (person_id, right_param, sortby[sortby_id], REQUEST.batch_size, REQUEST.qs)
    REQUEST.db.execute(SQL.encode('UTF8'))
    dbresults = REQUEST.db.dictfetchall()
    
    output.append(u"""\
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
 <TR bgcolor="#80C709">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=30 border=0 alt=""></TD>
  <TD colspan="3" width="100%%" align="left">%(person_str)s</TD>
  <TD align="right"><A style="color: #000000; text-decoration: none; font: Verdana 10px; font-weight: bold" href="javascript:void(0);" onClick="javascript:window.close()">%(tls_done)s</A>&nbsp;&nbsp;</TD>
 </TR>
 <TR>
  <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1b">%(sortby_subject)s</TD>
  <TD class="td_listing1b">%(sortby_start)s</TD>
  <TD class="td_listing1b">%(sortby_end)s</TD>
  <TD class="td_listing1b">%(sortby_act)s</TD>
 </TR>""" % locals())
    index = 0
    for dbresult in dbresults:
        if(index % 2 == 0):
          dbresult['td_style']='td_listing0'
        else:
          dbresult['td_style']='td_listing1'
        index = index + 1
        dbresult['BASE_CALENDAR_URL'] = _Conf.BASE_CALENDAR_URL
        dbresult['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
        if dbresult['start_stamp']:
            dbresult['start_stamp'] = REQUEST.iso2userdatetime(REQUEST, dbresult['start_stamp'])
        else:
            dbresult['start_stamp'] = ''
        if dbresult['end_stamp']:
            dbresult['end_stamp'] = REQUEST.iso2userdatetime(REQUEST, dbresult['end_stamp'])
        else:
            dbresult['end_stamp'] = ''
        dbresult['event_name'] = _Utils.html_quote_show(dbresult['event_name'].decode('UTF8')) or "&nbsp;"
        dbresult['event_activity'] = (dbresult['event_activity'] and dbresult['event_activity'].decode('UTF8')) or '&nbsp;'
        dbresult['person_id'] = person_id
        output.append(u"""
 <TR>
  <TD class="%(td_style)s"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="%(td_style)s" width="30%%"><A class="blacklink" href="#" onClick="document.relform.person_id.value=%(person_id)s;document.relform.related_id.value=%(event_id)d; document.relform.submit();">%(event_name)s</A></TD>
  <TD class="%(td_style)s" nowrap width="15%%">%(start_stamp)s</TD>
  <TD class="%(td_style)s" nowrap width="15%%">%(end_stamp)s</TD>
  <TD class="%(td_style)s" nowrap width="35%%">%(event_activity)s</TD>
 </TR>""" % dbresult)
    output.append(u"""</TABLE>""")
    if FULL_BAR:
        output.append(FULL_BAR)
    output.append("<BR>")
    return "\n".join(output)

def opportunity_contents(REQUEST):
    rel_type_id = int(REQUEST.form['item_type_id'].value)
    rel_id = int(REQUEST.form['item_id'].value)
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_done = REQUEST.TLS('todo_done')
    tls_search = REQUEST.TLS('tls_search')
    tls_results = REQUEST.TLS('type_Opportunity')
    tls_name = REQUEST.TLS('tls_name')
    tls_client = REQUEST.TLS('log_client_id')
    tls_sum = REQUEST.TLS('opp_amount')
    tls_date = REQUEST.TLS('opp_date')
    output = []
    output.append(u"""
<SCRIPT language="javascript" type="text/javascript">
<!--
window.moveTo(0,0);
// -->
</SCRIPT>
<FORM method="POST" name="searchform" action="%(BASE_GENERAL_URL)sselectrel.py">
<INPUT type="hidden" name="item_id" value="%(rel_id)d">
<INPUT type="hidden" name="item_type_id" value="%(rel_type_id)s">
<INPUT type="hidden" name="related_id" value="">
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
<TR>
  <TD colspan="5"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=5 border=0 alt=""></TD>
</TR>
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD align="right"><input type="text" name="search_w" class="textfield1" size="25"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD nowrap><input type="submit" class="input6" name="search" value="%(tls_search)s">&nbsp;<input type="button" class="input6" name="save" value="%(tls_done)s" onclick="window.close();"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
</FORM>""" % locals())

    w = ""
    w2 = ""
    if REQUEST.form.has_key('search_w') and REQUEST.form['search_w'].value.strip():
      w = _Utils.sql_quote_simple(REQUEST.form['search_w'].value.strip().decode('UTF8').lower())
      w2 = _Utils.sql_quote_simple(REQUEST.form['search_w'].value.strip().decode('UTF8'))
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_OPPORTUNITY])
    if right_param:
        right_param = " AND %s" % right_param
    
    if w:
      search_params = u""" AND (lower(o.opp_name) like '%%%s%%' OR lower(o.opp_next_stage) like '%%%s%%' OR lower(o.description) like '%%%s%%' OR lower(o.req_descr) like '%%%s%%' OR lower(o.amount) like '%%%s%%' OR lower(o.opp_lost) like '%%%s%%' OR lower(o.lead_source) like '%%%s%%' OR lower(o.client_type) like '%%%s%%')""" % (w,w,w,w,w,w,w,w)
    else:
      search_params = ""
    QUERY = """SELECT count(*) FROM items i, opportunities o WHERE o.opp_id=i.item_id %s %s""" % (search_params, right_param)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    count_all = REQUEST.db.fetchone()[0]
    formstring = REQUEST.get_formstring(['qs','sort_by','_delete'])
    
    
    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%sselectrel.py%sqs=" % (_Conf.BASE_GENERAL_URL, REQUEST.get_formstring(['persons', 'qs', '_add', '_delete', 'person_out']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%sselectrel.py%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_GENERAL_URL, REQUEST.get_formstring(['persons', 'qs', '_add', '_delete', 'person_out']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%sselectrel.py%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_GENERAL_URL, REQUEST.get_formstring(['persons', 'qs', '_add', '_delete', 'person_out']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR2(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""
    SQL = """SELECT i.item_name, o.opp_id, o.amount, o.close_date, c.client_name FROM items i, opportunities o, clients c WHERE o.opp_id=i.item_id and o.client_id=c.client_id %s %s order by o.close_date desc, o.opp_name LIMIT %s OFFSET %s""" % (search_params, right_param, REQUEST.batch_size, REQUEST.qs)
    REQUEST.db.execute(SQL.encode('UTF8'))
    output.append(u"""
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
<TR>
  <TD colspan="6"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=5 border=0 alt=""></TD>
</TR>
<TR>
  <TD colspan="6">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=15 height=1 border=0 alt=""></TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD nowrap class="th_listing">&nbsp;&nbsp;<b>%(tls_results)s</b>&nbsp;&nbsp;</TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
      </TR>
    </TABLE>
  </TD>
</TR>
<TR>
  <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b" width="40%%">%(tls_name)s</TD>
  <TD class="td_listing1b" width="40%%">%(tls_client)s</TD>
  <TD class="td_listing1b" width="10%%" nowrap>%(tls_sum)s</TD>
  <TD class="td_listing1b" width="10%%" nowrap>%(tls_date)s</TD>
  <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % locals())

    res = REQUEST.db.dictfetchall()
    index = 0
    for row in res:
        if index%2==0:
            td_class = 0
        else:
            td_class = 1
        index = index + 1
        c_name = (_Utils.html_quote_show(row['item_name']) or "&nbsp").decode('UTF8')
        c_client = (_Utils.html_quote_show(row['client_name']) or "&nbsp").decode('UTF8')
        c_id = row['opp_id']
        c_amount = (row['amount'] and "%.2f" % row['amount']) or ''
        c_date = REQUEST.iso2userdate(row['close_date'])
        output.append(u"""
<TR>
  <TD class="td_listing%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing%(td_class)s"><A class="blueboldlink" href="#" onClick="document.relform.related_id.value=%(c_id)d; document.relform.submit();\">%(c_name)s</A></TD>
  <TD class="td_listing%(td_class)s">%(c_client)s</TD>
  <TD class="td_listing%(td_class)s">%(c_amount)s</TD>
  <TD class="td_listing%(td_class)s" align="center">%(c_date)s</TD>
  <TD class="td_listing%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % locals())

    output.append("</TABLE>")
    if FULL_BAR:
        output.append(FULL_BAR)
    output.append("<BR>")
    return "\n".join(output)


def product_contents(REQUEST):
    rel_type_id = int(REQUEST.form['item_type_id'].value)
    rel_id = int(REQUEST.form['item_id'].value)
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_done = REQUEST.TLS('todo_done')
    tls_search = REQUEST.TLS('tls_search')
    tls_results = REQUEST.TLS('type_Product')
    tls_name = REQUEST.TLS('tls_name')
    tls_group = REQUEST.TLS('prod_group')
    tls_price = REQUEST.TLS('prod_price')
    tls_unit = REQUEST.TLS('prod_unit')
    output = []
    output.append(u"""
<SCRIPT language="javascript" type="text/javascript">
<!--
window.moveTo(0,0);
// -->
</SCRIPT>
<FORM method="POST" name="searchform" action="%(BASE_GENERAL_URL)sselectrel.py">
<INPUT type="hidden" name="item_id" value="%(rel_id)d">
<INPUT type="hidden" name="item_type_id" value="%(rel_type_id)s">
<INPUT type="hidden" name="related_id" value="">
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
<TR>
  <TD colspan="5"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=5 border=0 alt=""></TD>
</TR>
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD align="right"><input type="text" name="search_w" class="textfield1" size="25"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD nowrap><input type="submit" class="input6" name="search" value="%(tls_search)s">&nbsp;<input type="button" class="input6" name="save" value="%(tls_done)s" onclick="window.close();"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
</FORM>""" % locals())

    w = ""
    w2 = ""
    if REQUEST.form.has_key('search_w') and REQUEST.form['search_w'].value.strip():
      w = _Utils.sql_quote_simple(REQUEST.form['search_w'].value.strip().decode('UTF8').lower())
      w2 = _Utils.sql_quote_simple(REQUEST.form['search_w'].value.strip().decode('UTF8'))
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_PRODUCT])
    if right_param:
        right_param = " AND %s" % right_param
    
    if w:
      search_params = u""" AND (lower(o.product_name) like '%%%s%%' OR lower(o.product_group) like '%%%s%%' OR lower(o.product_unit) like '%%%s%%' OR lower(o.product_price) like '%%%s%%' OR lower(o.description) like '%%%s%%') """ % (w,w2,w,w,w)
    else:
      search_params = ""
    QUERY = """SELECT count(*) FROM items i, products o WHERE o.product_id=i.item_id %s %s""" % (search_params, right_param)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    count_all = REQUEST.db.fetchone()[0]
    formstring = REQUEST.get_formstring(['qs','sort_by','_delete'])
    
    
    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%sselectrel.py%sqs=" % (_Conf.BASE_GENERAL_URL, REQUEST.get_formstring(['persons', 'qs', '_add', '_delete', 'person_out']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%sselectrel.py%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_GENERAL_URL, REQUEST.get_formstring(['persons', 'qs', '_add', '_delete', 'person_out']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%sselectrel.py%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_GENERAL_URL, REQUEST.get_formstring(['persons', 'qs', '_add', '_delete', 'person_out']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR2(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""
    SQL = """SELECT i.item_name, o.product_id, o.product_group, o.product_unit, o.product_price FROM items i, products o WHERE o.product_id=i.item_id %s %s order by product_group ASC, product_name ASC LIMIT %s OFFSET %s""" % (search_params, right_param, REQUEST.batch_size, REQUEST.qs)
    REQUEST.db.execute(SQL.encode('UTF8'))
    output.append(u"""
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
<TR>
  <TD colspan="6"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=5 border=0 alt=""></TD>
</TR>
<TR>
  <TD colspan="6">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=15 height=1 border=0 alt=""></TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD nowrap class="th_listing">&nbsp;&nbsp;<b>%(tls_results)s</b>&nbsp;&nbsp;</TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
      </TR>
    </TABLE>
  </TD>
</TR>
<TR>
  <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b" width="30%%">%(tls_group)s</TD>
  <TD class="td_listing1b" width="50%%">%(tls_name)s</TD>
  <TD class="td_listing1b" width="10%%" nowrap>%(tls_price)s</TD>
  <TD class="td_listing1b" width="10%%" nowrap>%(tls_unit)s</TD>
  <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % locals())

    res = REQUEST.db.dictfetchall()
    index = 0
    for row in res:
        if index%2==0:
            td_class = 0
        else:
            td_class = 1
        index = index + 1
        c_name = (_Utils.html_quote_show(row['item_name']) or "&nbsp").decode('UTF8')
        c_group = (_Utils.html_quote_show(row['product_group']) or "&nbsp").decode('UTF8')
        c_id = row['product_id']
        c_amount = (row['product_price'] and "%.2f" % row['product_price']) or ''
        c_unit = (row['product_unit'] or '').decode('UTF8')
        output.append(u"""
<TR>
  <TD class="td_listing%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing%(td_class)s"><A class="blueboldlink" href="#" onClick="document.relform.related_id.value=%(c_id)d; document.relform.submit();\">%(c_group)s</A></TD>
  <TD class="td_listing%(td_class)s"><A class="blueboldlink" href="#" onClick="document.relform.related_id.value=%(c_id)d; document.relform.submit();\">%(c_name)s</A></TD>
  <TD class="td_listing%(td_class)s">%(c_amount)s</TD>
  <TD class="td_listing%(td_class)s">%(c_unit)s</TD>
  <TD class="td_listing%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % locals())

    output.append("</TABLE>")
    if FULL_BAR:
        output.append(FULL_BAR)
    output.append("<BR>")
    return "\n".join(output)

def contact_contents(REQUEST):
    if REQUEST.form.has_key('let') and REQUEST.form['let'].decode('UTF8').strip():
        letter = REQUEST.form['let'].decode('UTF8').strip()
    else:
        letter = 0
    try:
        contact_view = REQUEST.get_setting('contact_view')
    except:
        contact_view = "0"
    rel_type_id = int(REQUEST.form['item_type_id'].value)
    rel_id = int(REQUEST.form['item_id'].value)
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_done = REQUEST.TLS('todo_done')
    tls_search = REQUEST.TLS('tls_search')
    tls_results = REQUEST.TLS('type_Contacts')
    tls_name = REQUEST.TLS('tls_name')
    tls_company = REQUEST.TLS('contact_company')
    tls_email = REQUEST.TLS('tls_email')
    tls_my = REQUEST.TLS('tls_my')
    tls_all = REQUEST.TLS('tls_all')
    output = []
    output.append(u"""
<SCRIPT language="javascript" type="text/javascript">
<!--
window.moveTo(0,0);
// -->
</SCRIPT>
<FORM method="POST" name="searchform" action="%(BASE_GENERAL_URL)sselectrel.py">
<INPUT type="hidden" name="item_id" value="%(rel_id)d">
<INPUT type="hidden" name="item_type_id" value="%(rel_type_id)s">
<INPUT type="hidden" name="related_id" value="">
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
<TR>
  <TD colspan="5"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=5 border=0 alt=""></TD>
</TR>
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0" width="100%%" align="center" colspan="3">
       <a class="blackboldlink" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&let=my">%(tls_my)s</A>
       <a class="blackboldlink" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d">%(tls_all)s</A>
       <a class="blackboldlink" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&let=num">#</A>
       <a class="blackboldlink" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&let=a">A</A>
       <a class="blackboldlink" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&let=b">B</A>
       <a class="blackboldlink" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&let=c">C</A>
       <a class="blackboldlink" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&let=d">D</A>
       <a class="blackboldlink" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&let=e">E</A>
       <a class="blackboldlink" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&let=f">F</A>
       <a class="blackboldlink" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&let=g">G</A>
       <a class="blackboldlink" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&let=h">H</A>
       <a class="blackboldlink" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&let=i">I</A>
       <a class="blackboldlink" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&let=j">J</A>
       <a class="blackboldlink" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&let=k">K</A>
       <a class="blackboldlink" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&let=l">L</A>
       <a class="blackboldlink" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&let=m">M</A>
       <a class="blackboldlink" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&let=n">N</A>
       <a class="blackboldlink" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&let=o">O</A>
       <a class="blackboldlink" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&let=p">P</A>
       <a class="blackboldlink" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&let=q">Q</A>
       <a class="blackboldlink" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&let=r">R</A>
       <a class="blackboldlink" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&let=s">S</A>
       <a class="blackboldlink" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&let=t">T</A>
       <a class="blackboldlink" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&let=u">U</A>
       <a class="blackboldlink" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&let=v">V</A>
       <a class="blackboldlink" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&let=w">W</A>
       <a class="blackboldlink" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&let=x">X</A>
       <a class="blackboldlink" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&let=y">Y</A>
       <a class="blackboldlink" href="%(BASE_GENERAL_URL)sselectrel.py?item_id=%(rel_id)d&item_type_id=%(rel_type_id)d&let=z">Z</A>
  </TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR>
  <TD colspan="5"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=5 border=0 alt=""></TD>
</TR>
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD align="right"><input type="text" name="search_w" class="textfield1" size="25"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
  <TD nowrap><input type="submit" class="input6" name="search" value="%(tls_search)s">&nbsp;<input type="button" class="input6" name="save" value="%(tls_done)s" onclick="window.close();"></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
</FORM>""" % locals())

    w = ""
    if REQUEST.form.has_key('search_w') and REQUEST.form['search_w'].value.strip():
      w = _Utils.sql_quote_simple(REQUEST.form['search_w'].value.strip().decode('UTF8').lower())
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_CONTACT])
    if right_param:
        right_param = " AND %s" % right_param
    
    if contact_view and contact_view=="1":
        sel_name = "last_name"
        sel_ord  = " lower(c.last_name) ASC, lower(c.first_name) ASC"
    else:
        sel_name = "first_name"
        sel_ord  = " lower(c.first_name) ASC, lower(c.last_name) ASC"

    if w:
        search_params = u"""AND (lower(c.first_name) like '%%%s%%' OR lower(c.middle_name) like '%%%s%%' OR lower(c.last_name) like '%%%s%%' OR lower(c.company) like '%%%s%%' OR lower(c.department) like '%%%s%%' OR lower(c.jobtitle) like '%%%s%%' OR lower(c.phone_work) like '%%%s%%' OR lower(c.phone_home) like '%%%s%%' OR lower(c.phone_cell) like '%%%s%%' OR lower(c.phone_fax) like '%%%s%%' OR lower(c.e_mail) like '%%%s%%' OR lower(c.mailing_address) like '%%%s%%' OR lower(c.description) like '%%%s%%' OR lower(c.homepage) like '%%%s%%' OR lower(c.contact_category) like '%%%s%%')""" % (w, w, w, w, w, w, w, w, w, w, w, w, w, w, w)
    else:
        search_params = ""
    extra_pars = ""
    if letter=='num':
        extra_pars = """ AND lower(substr(c.%s, 1, 1)) not in ('a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z') """ % sel_name
    elif letter=='my':
        extra_pars = """ AND i.creator_id=%d """ % REQUEST.USER.get_id()
    elif letter:
        extra_pars = """ AND lower(c.%s) like '%s%%' """ % (sel_name, letter)
    QUERY = """SELECT count(*) FROM items i, contacts c WHERE c.contact_id=i.item_id %s %s%s""" % (search_params, right_param, extra_pars)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    count_all = REQUEST.db.fetchone()[0]
    formstring = REQUEST.get_formstring(['qs','sort_by','_delete'])
    
    
    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%sselectrel.py%sqs=" % (_Conf.BASE_GENERAL_URL, REQUEST.get_formstring(['persons', 'qs', '_add', '_delete', 'person_out']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%sselectrel.py%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_GENERAL_URL, REQUEST.get_formstring(['persons', 'qs', '_add', '_delete', 'person_out']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%sselectrel.py%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_GENERAL_URL, REQUEST.get_formstring(['persons', 'qs', '_add', '_delete', 'person_out']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR2(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""
    SQL = """SELECT c.first_name, c.last_name, c.contact_id, c.e_mail, c.company 
                 FROM items i, contacts c 
                 WHERE c.contact_id=i.item_id %s %s%s 
                 ORDER BY %s LIMIT %s OFFSET %s""" % (search_params, right_param, extra_pars, sel_ord, REQUEST.batch_size, REQUEST.qs)
    REQUEST.db.execute(SQL.encode('UTF8'))
    output.append(u"""
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
<TR>
  <TD colspan="5"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=5 border=0 alt=""></TD>
</TR>
<TR>
  <TD colspan="5">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=15 height=1 border=0 alt=""></TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD nowrap class="th_listing">&nbsp;&nbsp;<b>%(tls_results)s</b>&nbsp;&nbsp;</TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
      </TR>
    </TABLE>
  </TD>
</TR>
<TR>
  <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b" width="35%%">%(tls_name)s</TD>
  <TD class="td_listing1b" width="35%%">%(tls_company)s</TD>
  <TD class="td_listing1b" width="30%%" nowrap>%(tls_email)s</TD>
  <TD class="td_listing1b"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % locals())

    res = REQUEST.db.dictfetchall()
    index = 0
    for row in res:
        if index%2==0:
            td_class = 0
        else:
            td_class = 1
        index = index + 1
        if contact_view and contact_view=="1":
            name = (_Utils.html_quote_show(row['last_name']) or "&nbsp").decode('UTF8') + ", " + (_Utils.html_quote_show(row['first_name']) or "&nbsp").decode('UTF8')
        else:
            name = (_Utils.html_quote_show(row['first_name']) or "&nbsp").decode('UTF8') + " " + (_Utils.html_quote_show(row['last_name']) or "&nbsp").decode('UTF8')
        company = (_Utils.html_quote_show(row['company']) or "&nbsp;").decode('UTF8')
        email = (_Utils.html_quote_show(row['e_mail']) or "&nbsp;").decode('UTF8')
        id = row['contact_id']
        output.append(u"""
<TR>
  <TD class="td_listing%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing%(td_class)s"><A class="blueboldlink" href="#" onClick="document.relform.related_id.value=%(id)d; document.relform.submit();\">%(name)s</A></TD>
  <TD class="td_listing%(td_class)s">%(company)s</A></TD>
  <TD class="td_listing%(td_class)s">%(email)s</TD>
  <TD class="td_listing%(td_class)s"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % locals())

    output.append("</TABLE>")
    if FULL_BAR:
        output.append(FULL_BAR)
    output.append("<BR>")

    return "\n".join(output)
