# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

import os
import standard_html, _Conf, Menus, _Access, _InitTypes, _Indexer, _Utils, _RootObject, urllib

MY_MENU_ID=2

def index(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_frontpage_menu(REQUEST, MY_MENU_ID))
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_URL = _Conf.BASE_URL
    tls_search = REQUEST.TLS('tls_search')
    tls_documents = REQUEST.TLS('topmenu_documents')
    tls_folders = REQUEST.TLS('tls_folders')
    tls_search_events = REQUEST.TLS('tls_search_events')
    tls_todos = REQUEST.TLS('tls_todos')
    tls_workflows = REQUEST.TLS('topmenu_workflows')
    tls_contacts = REQUEST.TLS('topmenu_contacts')
    tls_discussions = REQUEST.TLS('topmenu_disc')
    tls_emails = REQUEST.TLS('tls_emails')
    tls_notes = REQUEST.TLS('tls_notes')
    tls_clients = REQUEST.TLS('type_Client')
    tls_opps = REQUEST.TLS('type_Opportunity')
    tls_products = REQUEST.TLS('type_Product')
    tls_search_words = REQUEST.TLS('tls_search_words')
    tls_search_modules = REQUEST.TLS('tls_search_modules')
    tls_search_meta = REQUEST.TLS('tls_search_meta')
    tls_search_data = REQUEST.TLS('tls_search_data')
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_missing_meta_data = REQUEST.TLS('tls_missing_meta_data')
    tls_too_short = REQUEST.TLS('tls_input_short')
    REQ_FIELD = _Conf.REQ_FIELD
    types_menus = {_InitTypes.ITEM_TYPE_DOCUMENT: (_Conf.MODULES_DOCUMENTS, u"""<OPTION value="4"  SELECTED>%(tls_documents)s</OPTION>""" % locals()),
                   _InitTypes.ITEM_TYPE_FOLDER: (_Conf.MODULES_DOCUMENTS, u"""<OPTION value="3"  SELECTED>%(tls_folders)s</OPTION>""" % locals()),
                   _InitTypes.ITEM_TYPE_EVENT: (_Conf.MODULES_CALENDAR, u"""<OPTION value="5"  SELECTED>%(tls_search_events)s</OPTION>""" % locals()),
                   _InitTypes.ITEM_TYPE_TODO: (_Conf.MODULES_TODOS, u"""<OPTION value="6"  SELECTED>%(tls_todos)s</OPTION>""" % locals()),
                   _InitTypes.ITEM_TYPE_WORKFLOW: (_Conf.MODULES_WORKFLOWS, u"""<OPTION value="16" SELECTED>%(tls_workflows)s</OPTION>""" % locals()),
                   _InitTypes.ITEM_TYPE_CONTACT: (_Conf.MODULES_CONTACTS, u"""<OPTION value="7"  SELECTED>%(tls_contacts)s</OPTION>""" % locals()),
                   _InitTypes.ITEM_TYPE_DISCUSSION: (_Conf.MODULES_DISCUSSION, u"""<OPTION value="11" SELECTED>%(tls_discussions)s</OPTION>""" % locals()),
                   _InitTypes.ITEM_TYPE_EMAIL: (_Conf.MODULES_EMAIL, u"""<OPTION value="9"  SELECTED>%(tls_emails)s</OPTION>""" % locals()),
                   _InitTypes.ITEM_TYPE_USERNOTE: (_Conf.MODULES_TODOS, u"""<OPTION value="12" SELECTED>%(tls_notes)s</OPTION>""" % locals()),
                   _InitTypes.ITEM_TYPE_CLIENT: (_Conf.MODULES_CLIENTS, u"""<OPTION value="18" SELECTED>%(tls_clients)s</OPTION>""" % locals()),
                   _InitTypes.ITEM_TYPE_OPPORTUNITY: (_Conf.MODULES_OPPORTUNITIES, u"""<OPTION value="19" SELECTED>%(tls_opps)s</OPTION>""" % locals()),
                   _InitTypes.ITEM_TYPE_PRODUCT: (_Conf.MODULES_PRODUCTS, u"""<OPTION value="20" SELECTED>%(tls_products)s</OPTION>""" % locals()),
    }
    module_list = []
    access_str = _Utils.get_module_access(REQUEST)
    for key in types_menus.keys():
        if access_str[types_menus[key][0]]=="1":
            module_list.append(types_menus[key][1])
    module_list = "\n".join(module_list)

    output.append(u"""\
<SCRIPT type="text/javascript">
function check_form()
{
  ok1 = document.forms['searchform']._word.value;
  ok4 = 0;
  if(document.forms['searchform']._word.value.length<3)
  {
    alert("%(tls_too_short)s");
    return false;
  }
  if(!ok1)
  {
      alert("%(tls_missing_input)s");
      return false;
  }
  for(i=0; i<document.forms['searchform']._modules.options.length;i++)
  {
    if(document.forms['searchform']._modules.options[i].selected == true)
    {
      ok4=1;
      break;
    }
  }
  if(!ok4)
  {
     alert("%(tls_missing_input)s");
      return false;
  }
  return true;
}
</SCRIPT>
<BR>
<TABLE width="100%%" cellpadding=0 cellspacing=0 border=0>
<FORM method="POST" action="%(BASE_URL)ssearch.py/search" name="searchform" onsubmit="return check_form();">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD colspan="3" width="100%%">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD class="th_listing" align="center" nowrap>&nbsp;&nbsp;&nbsp;<b>%(tls_search)s</b>&nbsp;&nbsp;&nbsp;</TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%">&nbsp;</TD>
      </TR>
    </TABLE>
  </TD>
</TR>
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b" nowrap>%(tls_search_words)s: %(REQ_FIELD)s</TD>
  <TD class="td_listing1b" nowrap><input type="text" name="_word" class="textfield4"></TD>
  <TD class="td_listing1b" width="100%%">&nbsp;</TD>
</TR>
<TR>
  <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing0b" nowrap>%(tls_search_modules)s: %(REQ_FIELD)s</TD>
  <TD class="td_listing0b" nowrap>
    <SELECT name="_modules" multiple>%(module_list)s</SELECT>
  </TD>
  <TD class="td_listing0b" width="100%%">&nbsp;</TD>
</TR>
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b" colspan="3" width="100%%"><input type="submit" class="input2" value="%(tls_search)s"></TD>
</TR>
</TABLE>
</FORM>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def search(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(standard_html.window_script(height=625,width=550))
    output.append(Menus.get_frontpage_menu(REQUEST, MY_MENU_ID))
    word = REQUEST.form['_word'].decode('UTF8')
    if isinstance(REQUEST.form['_modules'], list):
        modules = map(int, REQUEST.form['_modules'])
    else:
        modules = [int(REQUEST.form['_modules'].value)]
    modules_array = modules
    modules = ",".join(map(str, modules))
    s_type = 1


    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, modules_array)
    if right_param:
        right_param = " AND %s" % right_param
    search_params = []
    if REQUEST.form.has_key('_word') and REQUEST.form['_word'].value:
        content_words = "".join(map(_Indexer.clean_garbage, REQUEST.form['_word'].value.decode("UTF8").lower()))
        content_words = map(lambda x: x.strip(), content_words.split(u" "))
        words = []
        for word in content_words:
            if len(word) < 3:
                continue
            words.append(_Utils.sql_cast_str(REQUEST, word))
        del content_words
        for word in words:
            if s_type == 1:
                search_params.append("i.item_id in (SELECT item_id FROM fti_search WHERE word = %s and fti_type=true)" % word)
    if not search_params:
        raise RuntimeError, 'No FTI-compatible search words found. (3 letters or more)'
    search_params = " AND\n".join(search_params)
    if search_params:
        search_params = " AND %s" % search_params    

    SQL = """SELECT count(DISTINCT item_id) AS count_all
FROM
 items i
LEFT JOIN item_types it ON i.item_type_id=it.item_type_id
LEFT JOIN persons p ON p.person_id=i.creator_id
WHERE 
i.item_type_id in (%(modules)s)
-- Access
%(right_param)s
-- FTI
%(search_params)s
""" % locals()

    REQUEST.db.execute(SQL.encode('utf8'))
    count_all = REQUEST.db.dictfetchone()['count_all']

    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%ssearch.py/search%sqs=" % (_Conf.BASE_URL, REQUEST.get_formstring(['qs']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%ssearch.py/search%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_URL, REQUEST.get_formstring(['qs']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%ssearch.py/search%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_URL, REQUEST.get_formstring(['qs']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR2(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""

    bsize = REQUEST.batch_size
    qs = REQUEST.qs

    sortby = [
'item_type_icon ASC', 'item_type_icon DESC',
'item_name ASC', 'item_name DESC',
'creator_name ASC', 'creator_name DESC',
'create_time ASC', 'create_time DESC',
'edit_time ASC', 'edit_time DESC',
]

    DEFAULT_SORTBY = 7
    sortby_id = -1
    if REQUEST.form.has_key('sort_by') and REQUEST.form['sort_by'].value.decode('UTF8').strip():
        sortby_id = int(REQUEST.form['sort_by'].value.decode('UTF8').strip())
    if sortby_id < 0 or sortby_id >= len(sortby):
        sortby_id  = DEFAULT_SORTBY
    sortstring = sortby[sortby_id]

    SQL = """SELECT DISTINCT i.item_id, i.create_time, i.edit_time, it.item_type_icon, i.item_name, coalesce(p.first_name || ' ' || p.last_name, 'N/A') AS creator_name
FROM
 items i
LEFT JOIN item_types it ON i.item_type_id=it.item_type_id
LEFT JOIN persons p ON p.person_id=i.creator_id
LEFT JOIN documents d ON d.document_id=i.item_id
WHERE 
i.item_type_id in (%(modules)s) AND
d.final_version_id is null
-- Access
%(right_param)s
-- FTI
%(search_params)s
--
ORDER BY %(sortstring)s
LIMIT %(bsize)d OFFSET %(qs)d
""" % locals()
    REQUEST.db.execute(SQL.encode('utf8'))
    dbresult = REQUEST.db.dictfetchall()

    BASE_URL = _Conf.BASE_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_search = REQUEST.TLS('tls_search_results')
    tls_name = REQUEST.TLS('tls_name')
    tls_author = REQUEST.TLS('tls_author')
    tls_posted = REQUEST.TLS('tls_createtime')
    tls_edited = REQUEST.TLS('tls_edittime')
    tls_type = REQUEST.TLS('tls_type')

    formstring = REQUEST.get_formstring(['qs','sort_by','parent_id'])
    sortby_type = u"""<A class="blackboldlink" href="%ssearch.py/search%ssort_by=0">%s</A>&nbsp;&nbsp;""" % (_Conf.BASE_URL, formstring, tls_type)
    sortby_name = u"""<A class="blackboldlink" href="%ssearch.py/search%ssort_by=2">%s</A>&nbsp;&nbsp;""" % (_Conf.BASE_URL, formstring, tls_name)
    sortby_creator = u"""<A class="blackboldlink" href="%ssearch.py/search%ssort_by=4">%s</A>&nbsp;&nbsp;""" % (_Conf.BASE_URL, formstring, tls_author)
    sortby_createtime = u"""<A class="blackboldlink" href="%ssearch.py/search%ssort_by=6">%s</A>&nbsp;&nbsp;""" % (_Conf.BASE_URL, formstring, tls_posted)
    sortby_edittime = u"""<A class="blackboldlink" href="%ssearch.py/search%ssort_by=8">%s</A>&nbsp;&nbsp;""" % (_Conf.BASE_URL, formstring, tls_edited)

    if sortby_id == 0:
        sortby_type = u"""<A class="blackboldlink" href="%ssearch.py/search%ssort_by=1">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_URL, formstring, tls_type)
    elif sortby_id == 1:
        sortby_type = u"""<A class="blackboldlink" href="%ssearch.py/search%ssort_by=0">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" %  (_Conf.BASE_URL, formstring, tls_type)
    if sortby_id == 2:
        sortby_name = u"""<A class="blackboldlink" href="%ssearch.py/search%ssort_by=3">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" %  (_Conf.BASE_URL, formstring, tls_name)
    elif sortby_id == 3:
        sortby_name = u"""<A class="blackboldlink" href="%ssearch.py/search%ssort_by=2">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" %  (_Conf.BASE_URL, formstring, tls_name)
    if sortby_id == 4:
        sortby_creator = u"""<A class="blackboldlink" href="%ssearch.py/search%ssort_by=5">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" %  (_Conf.BASE_URL, formstring, tls_author)
    elif sortby_id == 5:
        sortby_creator = u"""<A class="blackboldlink" href="%ssearch.py/search%ssort_by=4">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" %  (_Conf.BASE_URL, formstring, tls_author)
    if sortby_id == 6:
        sortby_createtime = u"""<A class="blackboldlink" href="%ssearch.py/search%ssort_by=7">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" %  (_Conf.BASE_URL, formstring, tls_posted)
    elif sortby_id == 7:
        sortby_createtime = u"""<A class="blackboldlink" href="%ssearch.py/search%ssort_by=6">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" %  (_Conf.BASE_URL, formstring, tls_posted)
    if sortby_id == 8:
        sortby_edittime = u"""<A class="blackboldlink" href="%ssearch.py/search%ssort_by=9">%s</A>&nbsp;<SPAN class="sort">&uarr;</SPAN>""" %  (_Conf.BASE_URL, formstring, tls_edited)
    elif sortby_id == 9:
        sortby_edittime = u"""<A class="blackboldlink" href="%ssearch.py/search%ssort_by=8">%s</A>&nbsp;<SPAN class="sort">&darr;</SPAN>""" %  (_Conf.BASE_URL, formstring, tls_edited)
    del formstring

    output.append(u"""\
<BR>
<TABLE border=0 cellpadding=0 cellspacing=0 width="100%%">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD colspan=5 width="100%%">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD class="th_listing" align="center" nowrap>&nbsp;&nbsp;&nbsp;<b>%(tls_search)s</b>&nbsp;&nbsp;&nbsp;</TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%"></TD>
      </TR>
    </TABLE>
  </TD>
</TR>
<TR>
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b">%(sortby_type)s</TD>
  <TD class="td_listing1b">%(sortby_name)s</TD>
  <TD class="td_listing1b">%(sortby_creator)s</TD>
  <TD class="td_listing1b" align="center">%(sortby_createtime)s</TD>
  <TD class="td_listing1b" align="center">%(sortby_edittime)s</TD>
</TR>""" % locals())

    link_dict = {_InitTypes.ITEM_TYPE_EVENT: "<A class=\"td_listing\" href=\"%(BASE_CALENDAR_URL)seditevent.py?event_id=%(item_id)d\">",
                 _InitTypes.ITEM_TYPE_TODO: "<a class=\"td_listing\" href=\"" + _Conf.BASE_TODO_URL + 'todoedit.py?todo_id=%(item_id)d' + "\">",
                 _InitTypes.ITEM_TYPE_WORKFLOW: "<a class=\"td_listing\" href=\"" + _Conf.BASE_WORKFLOWS_URL + 'workflowedit.py?workflow_id=%(item_id)d' + "\">",
                 _InitTypes.ITEM_TYPE_CONTACT: "<a class=\"td_listing\" href=\"" + _Conf.BASE_CONTACT_URL + 'contactedit.py?contact_id=%(item_id)d' + "\">",
                 _InitTypes.ITEM_TYPE_DISCUSSION: "<a class=\"td_listing\" href=\"" + _Conf.BASE_DISCUSSION_URL + 'discread.py?discussion_id=%(item_id)d' + "\">",
                 _InitTypes.ITEM_TYPE_EMAIL: "<a class=\"td_listing\" href=\"" + _Conf.BASE_EMAIL_URL + 'read.py?mail_id=%(item_id)d' + "\">",
                 _InitTypes.ITEM_TYPE_USERNOTE: "<a class=\"td_listing\" href=\"" + _Conf.BASE_GENERAL_URL + 'gateway.py?item_id=%(item_id)d' + "\">",
                 _InitTypes.ITEM_TYPE_CLIENT: "<a class=\"td_listing\" href=\"" + _Conf.BASE_CLIENT_URL + 'clientedit.py?client_id=%(item_id)d' + "\">",
                 _InitTypes.ITEM_TYPE_OPPORTUNITY: "<a class=\"td_listing\" href=\"" + _Conf.BASE_OPPORTUNITIES_URL + 'oppedit.py?opp_id=%(item_id)d' + "\">",
                 _InitTypes.ITEM_TYPE_PRODUCT: "<a class=\"td_listing\" href=\"" + _Conf.BASE_PRODUCTS_URL + 'editproduct.py?product_id=%(item_id)d' + "\">"}

    index = 0
    REQUEST.su_by_id(_Conf.SUPERUSER)
    for item in dbresult:
        item['class_type'] = index % 2
        index += 1
        item['BASE_CALENDAR_URL'] = _Conf.BASE_CALENDAR_URL
        obj = _RootObject.dispatch_item(REQUEST, item['item_id'])
        if obj.get('item_type_id') == _InitTypes.ITEM_TYPE_DOCUMENT:
            item['link'] = """<a class="td_listing" href=\"""" + _Conf.BASE_DOCUMENT_URL + "docframe.py?doc_url=" + urllib.quote(_Conf.BASE_GENERAL_URL + 'info.py?item_id=%(item_id)d' % item) + "\">"
        elif obj.get('item_type_id') == _InitTypes.ITEM_TYPE_FOLDER:
            item['link'] = """<a class="td_listing" href=\"""" + _Conf.BASE_DOCUMENT_URL + "docframe.py?doc_url=" + urllib.quote(_Conf.BASE_DOCUMENT_URL + 'folder.py?parent_id=%(item_id)d' % item) + "\">"
        else:
            try:
                item['link'] = link_dict[obj.get('item_type_id')] % item
            except:
                item['link'] = '#'
        item['BASE_URL'] = _Conf.BASE_URL
        item['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
        item['item_name'] = _Utils.html_quote(obj.get_name())
        item['create_time'] = REQUEST.iso2userdatetime(REQUEST, obj.get('create_time'))
        item['edit_time'] = REQUEST.iso2userdatetime(REQUEST, obj.get('edit_time'))
        if obj.get('item_type_id') == _InitTypes.ITEM_TYPE_DOCUMENT:
            file_ext = os.path.splitext(obj.get('filename'))[-1]
            if(_Conf.MIME_TYPES.has_key(file_ext)):
                item['item_type_icon'] =  _Conf.MIME_TYPES[file_ext]
            else: 
                item['item_type_icon'] =  _Conf.MIME_TYPES["unknown_ext"]

        item['author'] = item['creator_name'].decode('UTF8')
         
        output.append(u"""<TR>
  <TD class="td_listing%(class_type)d"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing%(class_type)d"><img src="%(BASE_ICON_URL)s%(item_type_icon)s" border=0 alt=""></TD>
  <TD class="td_listing%(class_type)d">%(link)s%(item_name)s</A></TD>
  <TD class="td_listing%(class_type)d">&nbsp;%(author)s</TD>
  <TD class="td_listing%(class_type)d" align="center">%(create_time)s</TD>
  <TD class="td_listing%(class_type)d" align="center">%(edit_time)s</TD>
</TR>""" % item)
    REQUEST.unsu()
    output.append(u"""</TABLE>""")
    if FULL_BAR:
        output.append(FULL_BAR)

    output.append(u"""<BR>""")
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)
