# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

import mx.DateTime
from mod_python import apache

import _Conf
import Menus
import standard_html
import _Utils
import _Contact, _Todo, _Document, _Event
import _Access, _InitTypes, _Usernote, _RootObject, _Exceptions
import urllib

MY_MENU_ID=4

def index(REQUEST):
    if REQUEST.form.has_key('_add'):
        return add(REQUEST)
    elif REQUEST.form.has_key('_delete'):
        del_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                del_ids.append(int(key[4:]))

        for del_id in del_ids:
            note = _Usernote.Usernote(REQUEST, _InitTypes.INIT_TYPE_ID, del_id)
            note.delete()
        if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value.strip():
            REQUEST.mod_req.headers_out["Location"] = "%s" % urllib.unquote(REQUEST.form['returl'].value.strip())
            return apache.HTTP_MOVED_TEMPORARILY

    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_todo_menu(REQUEST, MY_MENU_ID))

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_USERNOTE])
    if right_param:
        right_param = " AND " + right_param
    QUERY = u"""SELECT u.*, i.parent_id, i.creator_id, i.edit_time, p.item_name AS note_from FROM usernotes u, items i, items p WHERE u.note_id=i.item_id AND i.creator_id=p.item_id AND (i.parent_id=%d)%s ORDER BY i.create_time DESC""" % (REQUEST.USER.get_id(), right_param)

    REQUEST.db.execute(QUERY.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()

    tls_notes = REQUEST.TLS('tls_notes')
    tls_from = REQUEST.TLS('email_from')
    tls_contents = REQUEST.TLS('tls_contents')
    tls_del = REQUEST.TLS('tls_deletesel')
    tls_add = REQUEST.TLS('note_addnote')
    BASE_TODO_URL = _Conf.BASE_TODO_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL

    output.append(u"""
<SCRIPT type="text/javascript">
<!--
function markAll(formvar)
{
    for(var x=0;x<formvar.elements.length;x++) {
       var y=formvar.elements[x];
       if(y.name != 'all')
          y.checked = formvar.all.checked;
    }
}
//-->
</SCRIPT>
<br>
""" % locals())
    
    output.append(u"""
&nbsp;&nbsp;&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_TODO_URL)snotes.py/add">%(tls_add)s</a>
<BR>
<BR>
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
<TR>
  <TD colspan="5"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
</TR>""" % locals())
    count = 0
    count1 = 0
    count2 = 0
    temp = ""
    out1 = ""
    out2 = ""
    for row in dbresult:
        count, temp = table_output(REQUEST, row)
        if count1<=count2:
            count1 = count1 + count
            out1 = out1 + temp
        else:
            count2 = count2 + count
            out2 = out2 + temp
    output.append(u"""
<TR valign="top">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD width="50%%">%(out1)s</TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD width="50%%">%(out2)s</TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % locals())
    output.append("</TABLE>")
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def add(REQUEST):
    output = []
    obj = ""
    obj_name = ""
    returl = ""
    obj_id = ""
    if REQUEST.form.has_key('returl'):
      returl = REQUEST.form['returl'].value
    output.append(standard_html.html_header(REQUEST))
    show_col = 0
    if REQUEST.form.has_key('menu'):
      menu = REQUEST.form['menu'].value
      if menu=="contacts":
        output.append(Menus.get_contact_menu(REQUEST, -1))
        obj = _Contact.Contact(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['obj_id'].value))
      elif menu=="clients":
        output.append(Menus.get_clients_menu(REQUEST, -1))
        obj = _RootObject.dispatch_item(REQUEST, int(REQUEST.form['obj_id'].value))
      elif menu=="opp":
        output.append(Menus.get_opportunities_menu(REQUEST, -1))
        obj = _RootObject.dispatch_item(REQUEST, int(REQUEST.form['obj_id'].value))
      elif menu=="workflows":
        output.append(Menus.get_workflows_menu(REQUEST, -1))
        obj = _Workflow.Workflow(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['obj_id'].value))
      elif menu=="todo":
        output.append(Menus.get_todo_menu(REQUEST, -1))
        obj = _Todo.Todo(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['obj_id'].value))
      elif menu=="documents":
        output.append(Menus.get_document_menu(REQUEST, -1))
        obj = _Document.Document(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['obj_id'].value))
      elif menu=="events":
        output.append(Menus.get_calendar_menu(REQUEST, -1))
        obj = _RootObject.dispatch_item(REQUEST, int(REQUEST.form['obj_id'].value))
      elif menu=="products":
        output.append(Menus.get_products_menu(REQUEST, -1))
        obj = _RootObject.dispatch_item(REQUEST, int(REQUEST.form['obj_id'].value))
      elif menu=="jobs":
        output.append(Menus.get_translation_menu(REQUEST, -1))
        obj = _RootObject.dispatch_item(REQUEST, int(REQUEST.form['obj_id'].value))
      obj_id = obj.get_id()
      obj_name = _Utils.html_quote_show(obj.get('item_name'))
    else:
        obj_name = " "
        output.append(Menus.get_todo_menu(REQUEST, MY_MENU_ID))
        show_col = 1

    tls_from = REQUEST.TLS('email_from')
    tls_addnote = REQUEST.TLS('note_addnote')
    tls_message = REQUEST.TLS('note_message')
    tls_save = REQUEST.TLS('tls_save')
    tls_pubnote = REQUEST.TLS('note_public')
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_color = REQUEST.TLS('tls_bgcolor')
    BASE_TODO_URL = _Conf.BASE_TODO_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    
    col_out = ""
    if show_col:
      col_out = u"""
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=15 height=1 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_color)s</TD>
    <TD class="td_listing0">
      <TABLE border="0" cellpadding="0" cellspacing="2">
        <TR>
          <TD id="td0" style="cursor: pointer; cursor: hand; background-color: #70BF55; border: 2px solid #3C3C3C;" onclick="bg('0');"><img src="%(BASE_ICON_URL)sspacer.gif" border="0" height="15" width="15"></TD>
          <TD id="td1" style="cursor: pointer; cursor: hand; background-color: #3F97E1; border: 1px solid #5C5C5C;" onclick="bg('1');"><img src="%(BASE_ICON_URL)sspacer.gif" border="0" height="15" width="15"></TD>
          <TD id="td2" style="cursor: pointer; cursor: hand; background-color: #C4AFE8; border: 1px solid #5C5C5C;" onclick="bg('2');"><img src="%(BASE_ICON_URL)sspacer.gif" border="0" height="15" width="15"></TD>
        </TR>
      </TABLE>
    </TD>
  </TR>""" % locals()

    if obj_name:
        obj_out = u"""
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=15 height=1 border=0 alt=""></TD>
    <TD colspan="2" class="object_name">%(obj_name)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD colspan="3"><img src="%(BASE_ICON_URL)sspacer.gif" width=15 height=5 border=0 alt=""></TD>
  </TR>
  """ % locals()
    else:
        obj_out = ""
    output.append("""\
<SCRIPT type="text/JavaScript">
<!--
  function check_values()
  {
    if (!document.addform.note_message.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
  function bg(col)
  {
         document.getElementById("td0").style.border = '1px solid #5C5C5C';
         document.getElementById("td1").style.border = '1px solid #5C5C5C';
         document.getElementById("td2").style.border = '1px solid #5C5C5C';
         document.getElementById("td"+col).style.border = '2px solid #3C3C3C';
         document.forms['addform']['note_color'].value=col;
  }
// -->
</SCRIPT>
<TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
<FORM name="addform" method="POST" action="%(BASE_TODO_URL)snotes.py/save" onsubmit="return check_values();">
<input type="hidden" name="returl" value="%(returl)s">
<input type="hidden" name="obj_id" value="%(obj_id)s">
<input type="hidden" name="note_color" value="0">
%(obj_out)s
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD colspan=2 width="100%%">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD class="th_listing" align="center" nowrap>&nbsp;&nbsp;<b>%(tls_addnote)s</b>&nbsp;&nbsp;</TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%">&nbsp;</TD>
      </TR>
    </TABLE>
  </TD>
</TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_message)s</TD>
    <TD class="td_listing1"><TEXTAREA rows="20" cols="80" name="note_message" class="textarea4"></TEXTAREA></TD>
  </TR>
%(col_out)s
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" colspan="2"><INPUT type="submit" name="_save" value="%(tls_save)s" class="input2"></TD>
  </TR>
</TABLE>
</FORM>"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def save(REQUEST):
    if REQUEST.form.has_key('note_message') and REQUEST.form['note_message'].value.decode('UTF8').strip():
        note = _Usernote.Usernote(REQUEST, _InitTypes.INIT_TYPE_REQ)
  
        if REQUEST.form.has_key('obj_id') and REQUEST.form['obj_id'].value.strip():
          note.set('parent_id', int(REQUEST.form['obj_id'].value.strip()))
        else:
          note.set('parent_id', REQUEST.USER.get_id())
          note.set('is_private', 1)
        note.save()
    else:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value.strip():
      REQUEST.mod_req.headers_out["Location"] = "%s" % urllib.unquote(REQUEST.form['returl'].value.strip())
    else:
      REQUEST.mod_req.headers_out["Location"] = "%snotes.py" % _Conf.BASE_TODO_URL
    return apache.HTTP_MOVED_TEMPORARILY


def edit(REQUEST):
    if not REQUEST.form.has_key('note_id') or not REQUEST.form['note_id'].value.decode('UTF8').strip():
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    note = _Usernote.Usernote(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['note_id'].value.decode('UTF8').strip()))
    if REQUEST.form.has_key('_delete'):
        note.delete()
        REQUEST.mod_req.headers_out["Location"] = "%snotes.py" % _Conf.BASE_TODO_URL
        return apache.HTTP_MOVED_TEMPORARILY

    note_id = note.get_id()

    output = []
    output.append(standard_html.html_header(REQUEST))
    obj = ""
    obj_name = ""
    returl = ""
    obj_id = ""
    if REQUEST.form.has_key('returl'):
      returl = REQUEST.form['returl'].value
    output.append(standard_html.html_header(REQUEST))
    show_col = 0
    if REQUEST.form.has_key('menu'):
      menu = REQUEST.form['menu'].value
      if menu=="contacts":
        output.append(Menus.get_contact_menu(REQUEST, -1))
        obj = _Contact.Contact(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['obj_id'].value))
        obj_name = obj.get('first_name') + " " + obj.get('last_name')
        obj_id = obj.get_id()
      elif menu=="clients":
        output.append(Menus.get_clients_menu(REQUEST, -1))
        obj = _RootObject.dispatch_item(REQUEST, int(REQUEST.form['obj_id'].value))
        obj_name = obj.get('client_name')
        obj_id = obj.get_id()
      elif menu=="opp":
        output.append(Menus.get_opportunities_menu(REQUEST, -1))
        obj = _RootObject.dispatch_item(REQUEST, int(REQUEST.form['obj_id'].value))
        obj_name = obj.get('opp_name')
        obj_id = obj.get_id()
      elif menu=="workflows":
        output.append(Menus.get_workflows_menu(REQUEST, -1))
        obj = _Workflow.Workflow(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['obj_id'].value))
        obj_name = obj.get('workflow_title')
        obj_id = obj.get_id()
      elif menu=="todo":
        output.append(Menus.get_todo_menu(REQUEST, -1))
        obj = _Todo.Todo(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['obj_id'].value))
        obj_name = obj.get('title')
        obj_id = obj.get_id()
      elif menu=="documents":
        output.append(Menus.get_document_menu(REQUEST, -1))
        obj = _Document.Document(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['obj_id'].value))
        obj_name = obj.get('title')
        obj_id = obj.get_id()
      elif menu=="events":
        output.append(Menus.get_calendar_menu(REQUEST, -1))
        obj = _Event.Event(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['obj_id'].value))
        obj_name = obj.get('item_name')
        obj_id = obj.get_id()
      elif menu=="products":
        output.append(Menus.get_products_menu(REQUEST, -1))
        obj = _RootObject.dispatch_item(REQUEST, int(REQUEST.form['obj_id'].value))
        obj_name = obj.get('item_name')
        obj_id = obj.get_id()
    else:
        obj_name = " "
        output.append(Menus.get_todo_menu(REQUEST, MY_MENU_ID))
        show_col = 1

    note_message = _Utils.html_quote(note.get('note_message'))
    obj_name = _Utils.html_quote_show(obj_name)
    BASE_TODO_URL = _Conf.BASE_TODO_URL
    tls_from = REQUEST.TLS('email_from')
    tls_editnote = REQUEST.TLS('note_editnote')
    tls_message = REQUEST.TLS('note_message')
    tls_save = REQUEST.TLS('tls_save')
    tls_pubnote = REQUEST.TLS('note_public')
    tls_color = REQUEST.TLS('tls_bgcolor')
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    if obj_name:
        obj_out = u"""
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=15 height=1 border=0 alt=""></TD>
    <TD colspan="2" class="object_name">%(obj_name)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD colspan="3"><img src="%(BASE_ICON_URL)sspacer.gif" width=15 height=5 border=0 alt=""></TD>
  </TR>
  """ % locals()
    else:
        obj_out = ""
    
    note_color = note.get('note_color')
    col_out = ""
    if show_col:
      if note_color==0:
        px0="2px"
        px1=px2="1px"
      elif note_color==1:
        px0=px2="1px"
        px1="2px"
      else:
        px0=px1="1px"
        px2="2px"
      col_out = u"""
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=15 height=1 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_color)s</TD>
    <TD class="td_listing0">
      <TABLE border="0" cellpadding="0" cellspacing="2">
        <TR>
          <TD id="td0" style="cursor: pointer; cursor: hand; background-color: #70BF55; border: %(px0)s solid #5C5C5C;" onclick="bg('0');"><img src="%(BASE_ICON_URL)sspacer.gif" border="0" height="15" width="15"></TD>
          <TD id="td1" style="cursor: pointer; cursor: hand; background-color: #3F97E1; border: %(px1)s solid #5C5C5C;" onclick="bg('1');"><img src="%(BASE_ICON_URL)sspacer.gif" border="0" height="15" width="15"></TD>
          <TD id="td2" style="cursor: pointer; cursor: hand; background-color: #C4AFE8; border: %(px2)s solid #5C5C5C;" onclick="bg('2');"><img src="%(BASE_ICON_URL)sspacer.gif" border="0" height="15" width="15"></TD>
        </TR>
      </TABLE>
    </TD>
  </TR>""" % locals()

    output.append("""\
<script type="text/javascript">
  function bg(col)
  {
         document.getElementById("td0").style.border = '1px solid #5C5C5C';
         document.getElementById("td1").style.border = '1px solid #5C5C5C';
         document.getElementById("td2").style.border = '1px solid #5C5C5C';
         document.getElementById("td"+col).style.border = '2px solid #3C3C3C';
         document.forms['addform']['note_color'].value=col;
  }
</script>
<TABLE border=0 cellpadding=0 cellspacing=0>
<FORM name="addform" method="POST" action="%(BASE_TODO_URL)snotes.py/update">
<INPUT type="hidden" name="note_id" value="%(note_id)d">
<input type="hidden" name="returl" value="%(returl)s">
<input type="hidden" name="obj_id" value="%(obj_id)s">
<input type="hidden" name="note_color" value="%(note_color)s">
%(obj_out)s
  <TR>
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD colspan=2 width="100%%">
      <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
        <TR>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD class="th_listing" align="center" nowrap>&nbsp;&nbsp;&nbsp;<b>%(tls_editnote)s</b>&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD width="100%%">&nbsp;</TD>
        </TR>
      </TABLE>
    </TD>
  </TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_message)s:</TD>
    <TD class="td_listing1"><TEXTAREA rows="20" cols="80" name="note_message" class="textarea4">%(note_message)s</TEXTAREA></TD>
  </TR>
%(col_out)s
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" colspan="2"><INPUT type="submit" name="_save" value="%(tls_save)s" class="input2"></TD>
  </TR>
</TABLE>
</FORM>"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def update(REQUEST):
    if not REQUEST.form.has_key('note_id') or not REQUEST.form['note_id'].value.decode('UTF8').strip():
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    note = _Usernote.Usernote(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['note_id'].value.decode('UTF8').strip()))

    if REQUEST.form.has_key('note_message') and REQUEST.form['note_message'].value.decode('UTF8').strip():
        note.set('note_message', REQUEST.form['note_message'].value.decode('UTF8').strip())
        note.set('note_color', int(REQUEST.form['note_color'].value))
        note.save()
    else:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
  
    if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value.strip():
        REQUEST.mod_req.headers_out["Location"] = "%s" % urllib.unquote(REQUEST.form['returl'].value.strip())
    else:
        REQUEST.mod_req.headers_out["Location"] = "%snotes.py" % _Conf.BASE_TODO_URL
    return apache.HTTP_MOVED_TEMPORARILY

def table_output(REQUEST, item):
    output=[]
    item['BASE_TODO_URL'] = _Conf.BASE_TODO_URL
    item['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
    item['note_message'] = _Utils.newline2br(_Utils.html_quote_show(item['note_message'].decode("UTF8"))).replace("  ", " &nbsp;")
    item['date'] = REQUEST.iso2userdatetime(REQUEST, item['edit_time'])
    
    corners = {'#C4AFE8':'1','#3F97E1':'2','#70BF55':'3'}
    fontcols = {'#C4AFE8':'#5D3DC0','#3F97E1':'#CBFFFF','#70BF55':'#F0FFF0'}
    bgcols = {'#C4AFE8':'#492CA1','#3F97E1':'#0068C6','#70BF55':'#2BA10B'}
    colours = ["#70BF55", "#3F97E1", "#C4AFE8"]
    item['bgcolor'] = colours[item['note_color']]
    item['bgcolor2'] = bgcols[item['bgcolor']]
    item['corner'] = corners[item['bgcolor']]
    item['f_col'] = fontcols[item['bgcolor']]
    item['tls_edit'] = REQUEST.TLS('tls_edit')
    item['tls_del'] = REQUEST.TLS('email_short_del')
    
    output.append(u"""
<TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn%(corner)s21.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="7" height="7" border="0" alt=""></TD>
  <TD style="color: #FFFFFF; font-weight: bold; padding: 4px;" bgcolor="%(bgcolor2)s" width="50%%" nowrap><b>%(date)s</b></TD>
  <TD style="color: #FFFFFF; padding: 4px;" bgcolor="%(bgcolor2)s" width="50%%" align="right"><A style="color: #FFFFFF;" href="%(BASE_TODO_URL)snotes.py/edit?note_id=%(note_id)d">%(tls_edit)s</A> | <A style="color: #FFFFFF;" href="%(BASE_TODO_URL)snotes.py?_delete=1&sel_%(note_id)d=1">%(tls_del)s</A></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn%(corner)s22.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="7" height="7" border="0" alt=""></TD>
</TR>
</TABLE>
<TABLE border=0 width="100%%" height="100%%" cellpadding=0 cellspacing=0>
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn%(corner)s8.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD align="left" bgcolor="%(bgcolor)s" style="color: %(f_col)s"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="2" border="0" alt=""></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn%(corner)s6.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn%(corner)s8.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD height="100%%" class="note_td" align="left" bgcolor="%(bgcolor)s" style="color: %(f_col)s">%(note_message)s</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn%(corner)s6.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>
<TR valign="top">
  <TD><img src="%(BASE_ICON_URL)sn%(corner)s3.gif" width="7" height="7" border="0" alt=""></TD>
  <TD width="100%%" style="background-image: url('%(BASE_ICON_URL)sn%(corner)s7.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sn%(corner)s4.gif" width="7" height="7" border="0" alt=""></TD>
</TR>
</TABLE>
<BR>""" % item)
    return (len(item['note_message']), "\n".join(output))
