# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

import os, mx.DateTime
from mod_python import apache

import standard_html
import _InitTypes, _Conf, _Utils, Menus, _Access
import _Todo, _RootObject, _mail
import urllib, relations

MY_MENU_ID = 3

def index(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST, '<link rel="stylesheet" type="text/css" media="all" href="%sjscalendar/calendar-blue.css" />' % _Conf.BASE_WEB_URL))
    output.append(Menus.get_todo_menu(REQUEST, MY_MENU_ID))

    if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value:
      returl = REQUEST.form['returl'].value
    else:
      returl = ""
    if REQUEST.form.has_key('rel_id') and REQUEST.form['rel_id'].value:
      rel_id = REQUEST.form['rel_id'].value
    else:
      rel_id = ""

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_PERSON])
    if right_param:
        right_param = " AND " + right_param
    REQUEST.db.execute(("""SELECT i.item_name, p.person_id FROM items i, persons p WHERE p.person_id=i.item_id AND p.is_deleted=0 and p.person_id<>%d %s""" % (REQUEST.USER.get_id(), right_param)).encode('UTF8'))
    related_persons = REQUEST.db.dictfetchall()
    related_persons = filter(None, map(lambda x: (_Access.get_item_right(REQUEST, REQUEST.USER.get_parent_id(REQUEST), x['person_id']) > _Access.ACCESS_NONE and x) or None, related_persons))
    related_persons = u"""<SELECT name="related_persons" multiple size="5">\n%s%s</SELECT>""" % ("""<OPTION value="%d" SELECTED>%s</OPTION>""" % (REQUEST.USER.get_id(), REQUEST.USER.get_name()), "\n".join(map(lambda x: """<OPTION value="%d">%s""" % (x['person_id'], x['item_name'].decode('UTF8')), related_persons)))

    priorities = _Utils.make_setting_selection(REQUEST, None, 'priority', 'todo_priorities')

    tls_addtodo = REQUEST.TLS('todo_addtodo')
    tls_save = REQUEST.TLS('tls_save')
    tls_title = REQUEST.TLS('tls_title')
    tls_sta = REQUEST.TLS('tls_status')
    tls_cat = REQUEST.TLS('tls_category')
    tls_pri = REQUEST.TLS('tls_priority')
    tls_private = REQUEST.TLS('tls_private')
    tls_start = REQUEST.TLS('todo_starttime')
    tls_due = REQUEST.TLS('todo_duetime')
    tls_related = REQUEST.TLS('tls_responsible_per')
    tls_desc = REQUEST.TLS('tls_description')
    tls_percent = REQUEST.TLS('todo_percentcomplete')
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_invdateformat = REQUEST.TLS('tls_invdateformat')

    datecheck_js = REQUEST.datecheck_js(REQUEST)
    BASE_TODO_URL = _Conf.BASE_TODO_URL
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    REQ_FIELD = _Conf.REQ_FIELD
    today = REQUEST.iso2userdate(_Utils.utc_now_mx())
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_WEB_URL = _Conf.BASE_WEB_URL
    dformat = _Utils.dateformat2jscalformat(REQUEST)
    lformat = _Utils.lang2jscalformat(REQUEST)
    output.append(u"""<script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/calendar.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/lang/calendar-%(lformat)s.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/cal_setup.js"></script>""" % locals())
    output.append("""\
<SCRIPT type="text/javascript">
<!--
function cal_popup(url, fieldname)
{
    window.date_result = document.addform[fieldname];
    window.open(url,'popupcal','width=170,height=150,scrollbars=no');
}
  function check_values()
  {
    if (!document.addform.title.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
%(datecheck_js)s
// -->
</SCRIPT>
<BR>
<TABLE border=0 cellpadding=0 cellspacing=0>
<FORM name="addform" method="POST" action="%(BASE_TODO_URL)stodoadd.py/add" onsubmit="return check_values();">
<INPUT type="hidden" name="returl" value="%(returl)s">
<INPUT type="hidden" name="rel_id" value="%(rel_id)s">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD colspan=3 width="100%%">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD class="th_listing" align="center" nowrap>&nbsp;&nbsp;<b>%(tls_addtodo)s</b>&nbsp;&nbsp;</TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%">&nbsp;</TD>
      </TR>
    </TABLE>
  </TD>
</TR>
  <TR class="tr_listing1">
    <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_title)s%(REQ_FIELD)s</TD>
    <TD class="td_listing1" colspan="2"><INPUT class="textfield3"  type="text" name="title" size="50"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_pri)s</TD>
    <TD class="td_listing0" colspan=2>%(priorities)s</TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_start)s</TD>
    <TD class="td_listing1" colspan=2><INPUT class="textfield1" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }" type="text" name="start_time"  id="start_time" value="%(today)s">&nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('start_time', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt="" style="position: relative; top: 3px;"></A></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_due)s</TD>
    <TD class="td_listing0" colspan=2><INPUT class="textfield1" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }" type="text" name="due_time" id="due_time">&nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('due_time', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt="" style="position: relative; top: 3px;"></A></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_related)s</TD>
    <TD class="td_listing1" colspan=2>%(related_persons)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" colspan="3">%(tls_desc)s<BR><TEXTAREA class="textarea1" name="description" rows="3" cols="20"></TEXTAREA></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_private)s</TD>
    <TD class="td_listing1" colspan=2><INPUT type="checkbox" name="todo_is_private"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_percent)s</TD>
    <TD class="td_listing0" colspan="2">
<SELECT name="percent_complete">
<OPTION value="0">0%%
<OPTION value="10">10%%
<OPTION value="20">20%%
<OPTION value="30">30%%
<OPTION value="40">40%%
<OPTION value="50">50%%
<OPTION value="60">60%%
<OPTION value="70">70%%
<OPTION value="80">80%%
<OPTION value="90">90%%
<OPTION value="100">100%%
</SELECT>
</TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" colspan="3"><INPUT type="submit" class="input2" name="_save" value="%(tls_save)s"></TD>
  </TR>
</TABLE>
</FORM>"""%locals())
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def add(REQUEST):
    output = []
    if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value:
        output.append(standard_html.html_header(REQUEST))
        output.append(standard_html.standard_redirect(REQUEST, urllib.unquote(REQUEST.form['returl'].value), 1))
    else:
        output.append(standard_html.html_header(REQUEST))
        output.append(standard_html.standard_redirect(REQUEST, "%stodoindex.py"%_Conf.BASE_TODO_URL, 1))
    output.append(Menus.get_todo_menu(REQUEST, MY_MENU_ID))
    if REQUEST.form.has_key('title') and REQUEST.form['title'].value.decode('UTF8').strip():
        todo = _Todo.Todo(REQUEST, _InitTypes.INIT_TYPE_NEW)
        todo.set('title', REQUEST.form['title'].value.decode('UTF8').strip())
        todo.set('description', REQUEST.form['description'].value.decode('UTF8').strip())
        todo.set('priority', REQUEST.form['priority'].value.decode('UTF8'))
        todo.set('percent_complete', int(REQUEST.form['percent_complete'].value.decode('UTF8')))
        if REQUEST.form.has_key('todo_is_private'):
            todo.set('is_private', 1)
        else:
            todo.set('is_private', 0)
        if REQUEST.form['start_time'].value:
            try: todo.set('start_time', REQUEST.user2isodate(REQUEST, REQUEST.form['start_time'].value.decode('UTF8')))
            except ValueError:
                raise RuntimeError, REQUEST.TLS('tls_invdateformat')
        else:
            todo.set('start_time', None)
        if REQUEST.form['due_time'].value:
            try: todo.set('due_time', REQUEST.user2isodate(REQUEST, REQUEST.form['due_time'].value.decode('UTF8')))
            except ValueError:
                raise RuntimeError, REQUEST.TLS('tls_invdateformat')
        else:
            todo.set('due_time', None)
        if REQUEST.form.has_key('related_persons'):
            try:
                todo.set('related_persons', [int(REQUEST.form['related_persons'].value)])
            except AttributeError:
                todo.set('related_persons', REQUEST.form['related_persons'])
        else:
            todo.set('related_persons', [])
        todo.set('parent_id', REQUEST.USER.get_id())
        todo.save()
        todo = _RootObject.dispatch_item(REQUEST, todo.get_id())
        _mail.send_invitation(REQUEST, todo, 2)
        if REQUEST.form.has_key('rel_id') and REQUEST.form['rel_id'].value:
          rel_id = int(REQUEST.form['rel_id'].value)
          relations.add_relation(REQUEST, rel_id, todo.get_id())
        output.append(REQUEST.TLS('todo_saved'))
    else:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)
