# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

import os
import mx.DateTime

import standard_html
import _InitTypes, _Conf, _Utils, Menus, _Access, _Exceptions
import _Todo, _RootObject, _Usernote, _Log
import relations
import urllib

MY_MENU_ID = -1

def index(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST, '<link rel="stylesheet" type="text/css" media="all" href="%sjscalendar/calendar-blue.css" title="win2k-1" />' % _Conf.BASE_WEB_URL))
    output.append(Menus.get_todo_menu(REQUEST, MY_MENU_ID))

    BASE_URL = _Conf.BASE_URL
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_WEB_URL = _Conf.BASE_WEB_URL
    BASE_TODO_URL = _Conf.BASE_TODO_URL
    BASE_DISCUSSION_URL = _Conf.BASE_DISCUSSION_URL
    BASE_CALENDAR_URL = _Conf.BASE_CALENDAR_URL
    BASE_EMAIL_URL = _Conf.BASE_EMAIL_URL
    tls_logoff = REQUEST.TLS('tls_logoff')
    tls_m_add = REQUEST.TLS('tls_add')
    tls_m_addto = REQUEST.TLS('menu_add_to')
    tls_menu_disable = REQUEST.TLS('menu_disable')

    output.append(u"""
<script type="text/javascript">
_d = document;ns4 = false;contextDisabled = false;coord_x = 0;coord_y = 0;time_out_id = 0;time_out_id2 = 0;time_out_id3 = 0;
function hideSelect(){if(document.all){ for (j=0; j<document.forms.length; j++) { var theForm = document.forms[j]; for(i=0; i<theForm.elements.length; i++){ if(theForm.elements[i].type == "select-one" || theForm.elements[i].type == "select-multiple") { theForm.elements[i].style.visibility = "hidden";}}}}}
function unhideSelect(){if(document.all){for (j=0; j<document.forms.length; j++) {var theForm = document.forms[j]; for(i=0; i<theForm.elements.length; i++){ if(theForm.elements[i].type == "select-one" || theForm.elements[i].type == "select-multiple") { theForm.elements[i].style.visibility = "visible";}}}}}
function rclick(e){ if(contextDisabled){_d.oncontextmenu=null; return true; } if(_d.all) { ev=event.button; contextObject=event.srcElement; coord_x = window.event.clientX;coord_y = window.event.clientY;} else {ev=e.which; contextObject=e.target; coord_x = e.pageX; coord_y = e.pageY;} if(ev==2||ev==3){ show_my_menu(); return false; } return true; }
function hide_menu(){ unhideSelect();el = _d.getElementById('cont_menu'); el.style.visibility = "hidden";}
function hide_menu2(){ el = _d.getElementById('cont_menu_add'); el.style.visibility = "hidden"; }
function hide_menu3(){ el = _d.getElementById('cont_menu_add_rel'); el.style.visibility = "hidden";}
function show_my_menu(){ hideSelect();clearTimeout(time_out_id); el = _d.getElementById('cont_menu'); el.style.top = coord_y - 5 + 'px'; el.style.left = coord_x - 5 + 'px'; el.style.visibility = "visible"; }
function show_my_menu_add(){ clearTimeout(time_out_id2); el = _d.getElementById('cont_menu_add'); el.style.top = coord_y + 98 + 'px'; el.style.left = coord_x + 119 + 'px'; el.style.visibility = "visible"; }
function show_my_menu_add_rel() { clearTimeout(time_out_id2); el = _d.getElementById('cont_menu_add_rel'); el.style.top = coord_y + 112 + 'px'; el.style.left = coord_x + 119 + 'px'; el.style.visibility = "visible"; }
if(!ns4){_d.onmouseup=rclick; _d.oncontextmenu=new Function("return false");}
</script>
""")
    
    types_menus = [
                    (0,  _Conf.MODULES_DESKTOP,     REQUEST.TLS('topmenu_desktop'),    "desktop",        _Conf.BASE_URL,        "frontpage.py"),
                    (1,  _Conf.MODULES_DOCUMENTS,     REQUEST.TLS('type_Documents'),    "documents",        _Conf.BASE_DOCUMENT_URL,        "docframe.py"),
                    (2,  _Conf.MODULES_CALENDAR,      REQUEST.TLS('topmenu_calendar'),       "calendar",         _Conf.BASE_CALENDAR_URL,        "day.py"),
                    (3,  _Conf.MODULES_TODOS,         REQUEST.TLS('type_Todos'),        "tasks",            _Conf.BASE_TODO_URL,            "todoindex.py"),
                    (4,  _Conf.MODULES_TODOS,         REQUEST.TLS('type_UserNotes'),    "notes",            _Conf.BASE_TODO_URL,            "notes.py"),
                    (5,  _Conf.MODULES_WORKFLOWS,     REQUEST.TLS('type_Workflows'),    "workflows",        _Conf.BASE_WORKFLOWS_URL,       "workflowindex.py"),
                    (6,  _Conf.MODULES_DISCUSSION,    REQUEST.TLS('type_Discussions'),  "discussions",      _Conf.BASE_DISCUSSION_URL,      "discindex.py"),
                    (7,  _Conf.MODULES_CLIENTS,       REQUEST.TLS('type_Client'),       "clients",          _Conf.BASE_CLIENT_URL,          "clients.py"),
                    (8,  _Conf.MODULES_CONTACTS,      REQUEST.TLS('type_Contacts'),     "contacts",         _Conf.BASE_CONTACT_URL,         "contactindex.py?only_mine=1"),
                    (9, _Conf.MODULES_OPPORTUNITIES, REQUEST.TLS('type_Opportunity'),   "opportunities",    _Conf.BASE_OPPORTUNITIES_URL,   "opportunities.py"),
                    (10, _Conf.MODULES_PRODUCTS,      REQUEST.TLS('type_Product'),      "products",         _Conf.BASE_PRODUCTS_URL,        "products.py"),
                    (11, _Conf.MODULES_EMAIL,      REQUEST.TLS('topmenu_email'),      "email",         _Conf.BASE_EMAIL_URL,        "efolder1.py"),
                    (12, _Conf.MODULES_ADMIN,      REQUEST.TLS('topmenu_admin'),      "admin",         _Conf.BASE_ADMIN_URL,        "settings.py"),
    ]
    types_add = [
                    (0,  _Conf.MODULES_DOCUMENTS,     REQUEST.TLS('menu_add_folder'),    "folders",        _Conf.BASE_DOCUMENT_URL,        "docadd.py/addfolderform"),
                    (1,  _Conf.MODULES_DOCUMENTS,     REQUEST.TLS('menu_add_document'),    "documents",        _Conf.BASE_DOCUMENT_URL,        "docadd.py"),
                    (2,  _Conf.MODULES_CALENDAR,      REQUEST.TLS('menu_add_event'),       "calendar",         _Conf.BASE_CALENDAR_URL,        "addevent.py"),
                    (3,  _Conf.MODULES_TODOS,         REQUEST.TLS('menu_add_task'),        "tasks",            _Conf.BASE_TODO_URL,            "todoadd.py"),
                    (4,  _Conf.MODULES_TODOS,         REQUEST.TLS('menu_add_note'),    "notes",            _Conf.BASE_TODO_URL,            "notes.py/add"),
                    (5,  _Conf.MODULES_WORKFLOWS,     REQUEST.TLS('menu_add_workflow'),    "workflows",        _Conf.BASE_WORKFLOWS_URL,       "workflowadd.py"),
                    (6,  _Conf.MODULES_CLIENTS,       REQUEST.TLS('menu_add_client'),       "clients",          _Conf.BASE_CLIENT_URL,          "clientadd.py"),
                    (7,  _Conf.MODULES_CONTACTS,      REQUEST.TLS('menu_add_contact'),     "contacts",         _Conf.BASE_CONTACT_URL,         "contactadd.py"),
                    (8, _Conf.MODULES_OPPORTUNITIES,  REQUEST.TLS('menu_add_opportunity'),   "opportunities",    _Conf.BASE_OPPORTUNITIES_URL,   "oppadd.py"),
                    (9, _Conf.MODULES_PRODUCTS,       REQUEST.TLS('menu_add_product'),      "products",         _Conf.BASE_PRODUCTS_URL,        "addproduct.py"),
                    (10, _Conf.MODULES_EMAIL,         REQUEST.TLS('menu_add_mail'),      "email",         _Conf.BASE_EMAIL_URL,        "compose.py"),
    ]

    types_to_relate = {
                    'editevent.py':[0, _Conf.MODULES_CALENDAR, 'event_id', 'events'],
                    'todoedit.py':[1, _Conf.MODULES_TODOS, 'todo_id', 'todo'],
                    'workflowedit.py':[2, _Conf.MODULES_WORKFLOWS, 'workflow_id', 'workflows'],
                    'clientedit.py':[3, _Conf.MODULES_CLIENTS, 'client_id', 'clients'],
                    'contactedit.py':[4, _Conf.MODULES_CONTACTS, 'contact_id', 'contacts'],
                    'oppedit.py':[5, _Conf.MODULES_OPPORTUNITIES, 'opp_id', 'opp'],
                    'editproduct.py':[6, _Conf.MODULES_PRODUCTS, 'product_id', 'products'],
    }


    access_str = _Utils.get_module_access(REQUEST)

    relation = u""
    relations = u""
    add_rel = []
    f_path = REQUEST.mod_req.uri
    f_name = f_path.split("/")[-1]
    if f_name in types_to_relate:
        module_id = types_to_relate[f_name][1]
        this_object = REQUEST.TLS('menu_relate_to_%d' % module_id)
        if access_str[module_id]=="1":
            menu_name = types_to_relate[f_name][3]
            key = types_to_relate[f_name][2]
            key_id = REQUEST.form[key].value
            types_relate = [
                    (1,  _Conf.MODULES_DOCUMENTS,     REQUEST.TLS('menu_relate_which_%d' % _Conf.MODULES_DOCUMENTS) % this_object,    "documents",        _Conf.BASE_DOCUMENT_URL+ "docadd.py?rel_id=%(key_id)s" % locals()),
                    (2,  _Conf.MODULES_CALENDAR,      REQUEST.TLS('menu_relate_which_%d' % _Conf.MODULES_CALENDAR) % this_object,       "calendar",         _Conf.BASE_CALENDAR_URL+"addevent.py?rel_id=%(key_id)s" % locals()),
                    (3,  _Conf.MODULES_TODOS,         REQUEST.TLS('menu_relate_which_%d' % _Conf.MODULES_TODOS) % this_object,        "tasks",            _Conf.BASE_TODO_URL+"todoadd.py?rel_id=%(key_id)s" % locals()),
                    (4,  _Conf.MODULES_TODOS,         REQUEST.TLS('menu_relate_which_%d' % _Conf.MODULES_NOTES) % this_object,    "notes",            _Conf.BASE_TODO_URL+"notes.py/add?menu=%(menu_name)s&obj_id=%(key_id)s" % locals()),
                    (5,  _Conf.MODULES_WORKFLOWS,     REQUEST.TLS('menu_relate_which_%d' % _Conf.MODULES_WORKFLOWS) % this_object,    "workflows",        _Conf.BASE_WORKFLOWS_URL+"workflowadd.py?rel_id=%(key_id)s" % locals()),
                    (6,  _Conf.MODULES_CLIENTS,       REQUEST.TLS('menu_relate_which_%d' % _Conf.MODULES_CLIENTS) % this_object,       "clients",          _Conf.BASE_CLIENT_URL+"clientadd.py?rel_id=%(key_id)s" % locals()),
                    (7,  _Conf.MODULES_CONTACTS,      REQUEST.TLS('menu_relate_which_%d' % _Conf.MODULES_CONTACTS) % this_object,     "contacts",         _Conf.BASE_CONTACT_URL+"contactadd.py?rel_id=%(key_id)s" % locals()),
                    (8, _Conf.MODULES_OPPORTUNITIES,  REQUEST.TLS('menu_relate_which_%d' % _Conf.MODULES_OPPORTUNITIES) % this_object,   "opportunities",    _Conf.BASE_OPPORTUNITIES_URL+"oppadd.py?rel_id=%(key_id)s" % locals()),
                    (9, _Conf.MODULES_PRODUCTS,       REQUEST.TLS('menu_relate_which_%d' % _Conf.MODULES_PRODUCTS) % this_object,      "products",         _Conf.BASE_PRODUCTS_URL+"addproduct.py?rel_id=%(key_id)s" % locals()),
            ]
            relation = u"""\
<TR class="ra_menu_item_tr" onmouseover="rhl('addrel');hide_menu2();window.clearTimeout(time_out_id3);show_my_menu_add_rel();" onmouseout="rul('addrel');window.clearTimeout(time_out_id3);time_out_id3=window.setTimeout('hide_menu3()', 500);">
  <TD id="addrelc" style="border-top: 1px solid #8A867A;" bgcolor="#EFEDDE"><img src="%(BASE_ICON_URL)sstartmenu_add.gif" width="16" height="16" border="0" alt=""></TD>
  <TD id="addreld" class="ra_menu_item_td" style="border-top: 1px solid #8A867A;" nowrap>%(tls_m_addto)s</TD>
</TR>""" % locals()
            for item in types_relate:
                if access_str[item[1]]=="1":
                    id = item[0]
                    title = item[2]
                    img = item[3]
                    exe = item[4]
                    returl = urllib.quote(REQUEST.mod_req.uri)+urllib.quote(REQUEST.get_formstring(['sel_id','rnd','o','rel_id1', '_delete', 'delete', 'add', 'edit', '_add', '_edit']))
#docframe.py?doc_url=" + urllib.quote(_Conf.BASE_DOCUMENT_URL + 'folder.py?parent_id=%(item_id)d' % item
                    url = "%(exe)s&returl=%(returl)s" % locals()
                    if item[1]==_Conf.MODULES_DOCUMENTS:
                        url = _Conf.BASE_DOCUMENT_URL+"docframe.py?doc_url=%s" % urllib.quote(url)
                    add_rel.append(u"""\
<TR class="ra_menu_item_tr" onmouseover="rhrl('sm%(id)s');" onmouseout="rurl('sm%(id)s');" onclick="rpll('%(url)s');">
  <TD id="sm%(id)sx" bgcolor="#EFEDDE"><img src="%(BASE_ICON_URL)srightmenu_%(img)s.gif" width="16" height="16" border="0" alt=""></TD>
  <TD id="sm%(id)sy" nowrap class="ra_menu_item_td">%(title)s</TD>
</TR>""" % locals())
            relations = "\n".join(add_rel)

    res = []
    for item in types_menus:
        if access_str[item[1]]=="1":
            id = item[0]
            title = item[2]
            img = item[3]
            path = item[4]
            exe = item[5]
            res.append(u"""\
<TR class="ra_menu_item_tr" onmouseover="rhl('sm%(id)s');" onmouseout="rul('sm%(id)s');" onclick="rpll('%(path)s%(exe)s');">
  <TD id="sm%(id)sc" bgcolor="#EFEDDE"><img src="%(BASE_ICON_URL)srightmenu_%(img)s.gif" width="16" height="16" border="0" alt=""></TD>
  <TD id="sm%(id)sd" nowrap class="ra_menu_item_td">%(title)s</TD>
</TR>""" % locals())
    result = "\n".join(res)

    addres = []
    for item in types_add:
        if access_str[item[1]]=="1":
            id = item[0]
            title = item[2]
            img = item[3]
            path = item[4]
            exe = item[5]
            addres.append(u"""\
<TR class="ra_menu_item_tr" onmouseover="rhal('sm%(id)s');" onmouseout="rual('sm%(id)s');" onclick="rpll('%(path)s%(exe)s');">
  <TD id="sm%(id)st" bgcolor="#EFEDDE"><img src="%(BASE_ICON_URL)srightmenu_%(img)s.gif" width="16" height="16" border="0" alt=""></TD>
  <TD id="sm%(id)su" nowrap class="ra_menu_item_td">%(title)s</TD>
</TR>""" % locals())
    result_add = "\n".join(addres)

    output.append(u"""\
<script type="text/javascript">function rhl(id){  el_1 = document.getElementById(id+"c");  el_2 = document.getElementById(id+"d");  el_1.style.backgroundColor="#C1D2EE";  el_2.style.backgroundColor="#C1D2EE";} function rul(id){  el_1 = document.getElementById(id+"c");  el_2 = document.getElementById(id+"d");  el_1.style.backgroundColor="#EFEDDE";  el_2.style.backgroundColor="#F6F6F6";} function rpll(exe){    top.topcontents.document.location=exe; }
function rhal(id){  el_1 = document.getElementById(id+"t");  el_2 = document.getElementById(id+"u");  el_1.style.backgroundColor="#C1D2EE";  el_2.style.backgroundColor="#C1D2EE";} function rual(id){  el_1 = document.getElementById(id+"t");  el_2 = document.getElementById(id+"u");  el_1.style.backgroundColor="#EFEDDE";  el_2.style.backgroundColor="#F6F6F6";}
function rhrl(id){  el_1 = document.getElementById(id+"x");  el_2 = document.getElementById(id+"y");  el_1.style.backgroundColor="#C1D2EE";  el_2.style.backgroundColor="#C1D2EE";} function rurl(id){  el_1 = document.getElementById(id+"x");  el_2 = document.getElementById(id+"y");  el_1.style.backgroundColor="#EFEDDE";  el_2.style.backgroundColor="#F6F6F6";}
</script>
<div id="cont_menu" style="visibility: hidden; position: absolute; z-index:9876;" onMouseOut="window.clearTimeout(time_out_id);time_out_id=window.setTimeout('hide_menu()', 500);" onMouseOver="window.clearTimeout(time_out_id);">
<TABLE width="125" border="0" cellpadding="2" cellspacing="0" bgcolor="#F6F6F6" style="border: 1px solid #8A867A; spacing-left: 1px; spacing-right: 1px;">
%(result)s
<TR class="ra_menu_item_tr" onmouseover="rhl('add');hide_menu3();show_my_menu_add();" onmouseout="rul('add');window.clearTimeout(time_out_id2);time_out_id2=window.setTimeout('hide_menu2()', 500);">
  <TD id="addc" style="border-top: 1px solid #8A867A;" bgcolor="#EFEDDE"><img src="%(BASE_ICON_URL)sstartmenu_add.gif" width="16" height="16" border="0" alt=""></TD>
  <TD id="addd" class="ra_menu_item_td" style="border-top: 1px solid #8A867A;" nowrap>%(tls_m_add)s</TD>
</TR>
%(relation)s
<TR class="ra_menu_item_tr" onmouseover="rhl('closemenu');" onmouseout="rul('closemenu');" onclick="contextDisabled=true; hide_menu();">
  <TD id="closemenuc" style="border-top: 1px solid #8A867A;" bgcolor="#EFEDDE"><img src="%(BASE_ICON_URL)sspacer.gif" width="16" height="16" border="0" alt=""></TD>
  <TD id="closemenud" class="ra_menu_item_td" style="border-top: 1px solid #8A867A;" nowrap>%(tls_menu_disable)s</TD>
</TR>
<!--
<TR class="ra_menu_item_tr" onmouseover="hl('logout');" onmouseout="ul('logout');" onclick="top.document.location='%(BASE_URL)slogout.py';">
  <TD id="logouta" style="border-top: 1px solid #8A867A;" bgcolor="#EFEDDE"><img src="%(BASE_ICON_URL)sstartmenu_logout.gif" width="20" height="20" border="0" alt=""></TD>
  <TD id="logoutb" class="ra_menu_item_td" style="border-top: 1px solid #8A867A;" nowrap>%(tls_logoff)s</TD>
</TR>
//-->
</TABLE>
</div>
<div id="cont_menu_add" style="visibility: hidden; position: absolute; z-index:9876;" onMouseOut="window.clearTimeout(time_out_id2);time_out_id2=window.setTimeout('hide_menu2()', 500);window.clearTimeout(time_out_id);time_out_id=window.setTimeout('hide_menu()', 500);" onMouseOver="window.clearTimeout(time_out_id2);window.clearTimeout(time_out_id);">
<TABLE border="0" cellpadding="2" cellspacing="0" bgcolor="#F6F6F6" style="border: 1px solid #8A867A; spacing-left: 1px; spacing-right: 1px;">
%(result_add)s
</TABLE>
</div>
<div id="cont_menu_add_rel" style="visibility: hidden; position: absolute; z-index:9876;" onMouseOut="window.clearTimeout(time_out_id3);time_out_id3=window.setTimeout('hide_menu3()', 500);window.clearTimeout(time_out_id);time_out_id=window.setTimeout('hide_menu()', 500);" onMouseOver="window.clearTimeout(time_out_id3);window.clearTimeout(time_out_id);">
<TABLE border="0" cellpadding="2" cellspacing="0" bgcolor="#F6F6F6" style="border: 1px solid #8A867A; spacing-left: 1px; spacing-right: 1px;">
%(relations)s
</TABLE>
</div>
""" % locals())

    if not REQUEST.form.has_key('todo_id'):
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')

    if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value:
        returl = REQUEST.form['returl'].value
    else:
        returl = ""

    if REQUEST.form.has_key('rel'):
        return relations_contents(REQUEST)
    elif REQUEST.form.has_key('note'):
        return notes_contents(REQUEST)
    elif REQUEST.form.has_key('log'):
        return show_log(REQUEST, REQUEST.form['todo_id'].value)

    todo = _Todo.Todo(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['todo_id'].value))
    todo_id = todo.get_id()
    todo_title = _Utils.html_quote_edit(todo.get('title'))
    todo_description = _Utils.html_quote(todo.get('description') or "")
    if todo.get('creator_id') <> REQUEST.USER.get_id():
        todo_is_private = u""
    elif todo.get('is_private'):
        todo_is_private = u"""\  
  <TR class="tr_listing1">
    <TD><img src="%sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1">%s</TD>
    <TD class="td_listing1" colspan=2><INPUT type="checkbox" name="todo_is_private" CHECKED></TD>
  </TR>""" % (BASE_ICON_URL, REQUEST.TLS('tls_private'))
    else:
        todo_is_private = u"""\
  <TR class="tr_listing1">
    <TD><img src="%sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1">%s</TD>
    <TD class="td_listing1" colspan=2><INPUT type="checkbox" name="todo_is_private"></TD>
  </TR>""" % (BASE_ICON_URL, REQUEST.TLS('tls_private'))
    if todo.get('related_persons'):
        todo_related = _Utils.sql_parse_array(REQUEST, todo.get('related_persons'))
    else:
        todo_related = []
    if todo.get('seen_persons'):
        todo_seen = _Utils.sql_parse_array(REQUEST, todo.get('seen_persons'))
    else:
        todo_seen = []
    if todo.get('accepted_persons'):
        todo_accepted = _Utils.sql_parse_array(REQUEST, todo.get('accepted_persons'))
    else:
        todo_accepted = []
    if todo.get('rejected_persons'):
        todo_rejected = _Utils.sql_parse_array(REQUEST, todo.get('rejected_persons'))
    else:
        todo_rejected = []
    if REQUEST.USER.get_id() in (todo_related + [todo.get('creator_id')]) and REQUEST.USER.get_id() not in todo_seen and REQUEST.USER.get_id()<>todo.get('creator_id'):
        if REQUEST.db.version < 740:
            REQUEST.db.execute("""UPDATE todos SET seen_persons = seen_persons + '{%d}'::int[] WHERE todo_id=%d""" % (REQUEST.USER.get_id(), todo_id))
        else:
            REQUEST.db.execute("""UPDATE todos SET seen_persons = seen_persons || '{%d}'::int[] WHERE todo_id=%d""" % (REQUEST.USER.get_id(), todo_id))
        todo_seen += [REQUEST.USER.get_id()]
    if todo.get('start_time') is not None:
        todo_start_time = REQUEST.iso2userdate(todo.get('start_time'))
    else:
        todo_start_time = ""
    if todo.get('due_time') is not None:
        days_left = todo.get('due_time') 
        now = _Utils.utc2local_mx(REQUEST,_Utils.utc_now_mx())
        now = mx.DateTime.Date(now.year, now.month, now.day)
        days_left = days_left - now
        if days_left.days >1:
            days_left_str = "<BR>%s" % REQUEST.TLS('todo_date_1') % days_left.days
        elif days_left.days == 1:
            days_left_str = "<BR>%s" % REQUEST.TLS('todo_date_2')
        elif days_left.days  == 0:
            days_left_str = "<BR>%s" % REQUEST.TLS('todo_date_3')
        elif days_left.days  == -1:
            days_left_str = "<BR>%s" % REQUEST.TLS('todo_date_4')
        else:
            days_left_str = "<BR>%s" % REQUEST.TLS('todo_date_5') % abs(days_left.days)
        del days_left
        todo_due_time = REQUEST.iso2userdate(todo.get('due_time'))
    else:
        days_left_str = ""
        todo_due_time = ""
    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_PERSON])
    if right_param:
        right_param = " AND " + right_param
    REQUEST.db.execute((u"""SELECT i.item_name, p.person_id FROM items i, persons p WHERE p.person_id=i.item_id AND p.is_deleted=0 %s""" % right_param).encode('UTF8'))
    related_persons = REQUEST.db.dictfetchall()
    related_persons = filter(None, map(lambda x: (_Access.get_item_right(REQUEST, REQUEST.USER.get_parent_id(REQUEST), x['person_id']) > _Access.ACCESS_NONE and x) or None, related_persons))
    persons_out = ["""<SELECT class="textfield1" name="related_persons" multiple size="5">"""]
    for person in related_persons:
        if person['person_id'] in todo_related:
            persons_out.append(u"""<OPTION value="%d" SELECTED>%s""" % (person['person_id'], person['item_name'].decode('UTF8')))
        else:
            persons_out.append(u"""<OPTION value="%d">%s""" % (person['person_id'], person['item_name'].decode('UTF8')))
    persons_out.append("""</SELECT>""")
    related_persons = "\n".join(persons_out)
    del persons_out
    seen_out = []
    for person_id in todo_seen:
        REQUEST.su_by_id(_Conf.SUPERUSER)
        ok = 1
        try:
            p = _RootObject.dispatch_item(REQUEST, person_id)
        except _Exceptions.RootObjectError:  # We can have this fail, since it usually means a deleted user.
            ok = 0                           # Prolly should ensure with foreign keys that this does not happen, but with
                                             # intarrays and such it's a problem.
        REQUEST.unsu()
        if ok:
            seen_out.append(u"""%s %s.""" % (p.get_name(), REQUEST.TLS('todo_hasseen')))
    seen_out = "<BR>\n".join(seen_out)
    accepted_out = []
    for person_id in todo_accepted:
        REQUEST.su_by_id(_Conf.SUPERUSER)
        ok = 1
        try:
            p = _RootObject.dispatch_item(REQUEST, person_id)
        except _Exceptions.RootObjectError:  # We can have this fail, since it usually means a deleted user.
            ok = 0                           # Prolly should ensure with foreign keys that this does not happen, but with
                                             # intarrays and such it's a problem.
        REQUEST.unsu()
        if ok:
            accepted_out.append("""%s %s.""" % (p.get_name(), REQUEST.TLS('todo_hasaccepted')))
    accepted_out = "<BR>\n".join(accepted_out)
    rejected_out = []
    for person_id in todo_rejected:
        REQUEST.su_by_id(_Conf.SUPERUSER)
        ok = 1
        try:
            p = _RootObject.dispatch_item(REQUEST, person_id)
        except _Exceptions.RootObjectError:  # We can have this fail, since it usually means a deleted user.
            ok = 0                           # Prolly should ensure with foreign keys that this does not happen, but with
                                             # intarrays and such it's a problem.
        REQUEST.unsu()
        if ok:
            rejected_out.append("""%s %s.""" % (p.get_name(), REQUEST.TLS('todo_hasrejected')))
    rejected_out = "<BR>\n".join(rejected_out)

    priorities = _Utils.make_setting_selection(REQUEST, todo, 'priority', 'todo_priorities')

    complete_percent = ["""<SELECT name="percent_complete">"""]
    for i in [0, 10, 20, 30, 40, 50, 60, 70, 80, 90, 100]:
        if i == todo.get('percent_complete'):
            complete_percent.append("""<OPTION value="%d" SELECTED>%d%%""" % (i, i))
        else:
            complete_percent.append("""<OPTION value="%d">%d%%""" % (i, i))
    complete_percent.append("""</SELECT>""")
    complete_percent = "\n".join(complete_percent)

    if REQUEST.USER.get_id() == todo.get('creator_id'):
        delete = """&nbsp;<INPUT type="submit" class="input2" name="_delete" value="%s" onClick="return confirm('%s');">""" % (REQUEST.TLS('tls_delete'), REQUEST.TLS('email_confirm_del'))
    else:
        delete = ""
    save_button = """<INPUT type="submit" class="input6" name="_save" value="%s">""" % REQUEST.TLS('tls_save')
    if REQUEST.USER.get_id()<>todo.get('creator_id') and REQUEST.USER.get_id() in todo_related and REQUEST.USER.get_id() not in todo_accepted and REQUEST.USER.get_id() not in todo_rejected:
        accept_button = """&nbsp;<INPUT type="submit" name="_accept" class="input6" value="%s">""" % REQUEST.TLS('todo_accept')
        save_button = ""
    else:
        accept_button = ""
    if REQUEST.USER.get_id()<>todo.get('creator_id') and REQUEST.USER.get_id() in todo_related and REQUEST.USER.get_id() not in todo_accepted and REQUEST.USER.get_id() not in todo_rejected:
        reject_button = """&nbsp;<INPUT type="submit" name="_reject" class="input6" value="%s">""" % REQUEST.TLS('todo_reject')
        save_button = ""
    else:
        reject_button = ""

    BASE_TODO_URL = _Conf.BASE_TODO_URL
    BASE_GENERAL_URL = _Conf.BASE_GENERAL_URL
    REQ_FIELD = _Conf.REQ_FIELD
    tls_edittodo = REQUEST.TLS('todo_edittodo')
    tls_save = REQUEST.TLS('tls_save')
    tls_title = REQUEST.TLS('tls_title')
    tls_pri = REQUEST.TLS('tls_priority')
    tls_start = REQUEST.TLS('todo_starttime')
    tls_due = REQUEST.TLS('todo_duetime')
    tls_related = REQUEST.TLS('tls_responsible_per')
    tls_desc = REQUEST.TLS('tls_description')
    tls_percent = REQUEST.TLS('todo_percentcomplete')
    tls_missing_input = REQUEST.TLS('tls_missing_input')
    tls_invdateformat = REQUEST.TLS('tls_invdateformat')
    datecheck_js = REQUEST.datecheck_js(REQUEST)
    menu = menu_output(REQUEST, todo)

    BASE_WEB_URL = _Conf. BASE_WEB_URL
    dformat = _Utils.dateformat2jscalformat(REQUEST)
    lformat = _Utils.lang2jscalformat(REQUEST)
    output.append(u"""<script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/calendar.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/lang/calendar-%(lformat)s.js"></script><script type="text/javascript" src="%(BASE_WEB_URL)sjscalendar/cal_setup.js"></script>""" % locals())
    output.append("""\
<SCRIPT LANGUAGE="JavaScript" type="text/javascript">
<!--
function cal_popup(url, fieldname)
{
    window.date_result = document.editform[fieldname];
    window.open(url,'popupcal','width=170,height=150,scrollbars=no');
}
  function check_values()
  {
    if (!document.editform.title.value)
    {
      alert("%(tls_missing_input)s");
      return false;
    }
    return true;
  }
%(datecheck_js)s
// -->
</SCRIPT>
<TABLE border=0 cellpadding=0 cellspacing=0 width="100%%">
<FORM name="editform" method="POST" action="%(BASE_TODO_URL)stodoedit.py/edit" onsubmit="return check_values();">
<INPUT type="hidden" name="todo_id" value="%(todo_id)d">
<INPUT type="hidden" name="returl" value="%(returl)s">
  <TR>
    <TD colspan=4>%(menu)s</TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1" nowrap>%(tls_title)s%(REQ_FIELD)s</TD>
    <TD class="td_listing1" colspan=2><INPUT class="textfield3" size="50" type="text" name="title" value="%(todo_title)s"></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_pri)s</TD>
    <TD class="td_listing0" colspan=2>%(priorities)s</TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_start)s</TD>
    <TD class="td_listing1" colspan=2><INPUT class="textfield1" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }" type="text" name="start_time" id="start_time" value="%(todo_start_time)s">&nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('start_time', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt=""></A></TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0">%(tls_due)s</TD>
    <TD class="td_listing0" colspan=2><INPUT class="textfield1" onblur="if (datecheck_js(this.value) != true) { if (!datecheck_js(this.value)) { alert('%(tls_invdateformat)s'); } this.value=datecheck_js(this.value); }" type="text" name="due_time" id="due_time" value="%(todo_due_time)s">&nbsp;<A href="javascript:void(0);" OnClick="return showCalendar('due_time', '%(dformat)s');"><img src="%(BASE_ICON_URL)scale.gif" width="16" height="15" border=0 alt=""></A>%(days_left_str)s</TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_related)s</TD>
    <TD class="td_listing1" colspan=2>%(related_persons)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" colspan=3>%(seen_out)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" colspan=3>%(accepted_out)s</TD>
  </TR>
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" colspan=3>%(rejected_out)s</TD>
  </TR>
%(todo_is_private)s
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD  class="td_listing0" colspan="3">%(tls_desc)s<BR><TEXTAREA class="textarea1" name="description" rows="3" cols="20">%(todo_description)s</TEXTAREA></TD>
  </TR>
  <TR class="tr_listing1">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing1">%(tls_percent)s</TD>
    <TD class="td_listing1" colspan="2">%(complete_percent)s</TD>
  </TR>""" % locals())
    if _Access.get_item_right(REQUEST, todo.get_id(), REQUEST.USER.get_id()) >= _Access.ACCESS_WRITE:
        output.append("""
  <TR class="tr_listing0">
    <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" colspan="3">%(save_button)s%(accept_button)s%(reject_button)s%(delete)s</TD>
  </TR>""" % locals())
    output.append(u"""
</TABLE>
</FORM>
<BR>
""")
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def edit(REQUEST):
    if not REQUEST.form.has_key('todo_id'):
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')
    output = []
    if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value.strip():
        output.append(standard_html.html_header(REQUEST,"""<SCRIPT type="text/javascript">document.location.href='%s';</SCRIPT>"""% urllib.unquote(REQUEST.form['returl'].value)))
    else:
        output.append(standard_html.html_header(REQUEST, """"<SCRIPT type="text/javascript">document.location.href='%stodoindex.py';</SCRIPT>"""%_Conf.BASE_TODO_URL))
    output.append(Menus.get_todo_menu(REQUEST, MY_MENU_ID))
    if REQUEST.form.has_key('_delete') or REQUEST.form.has_key('_delete.x'):
        todo = _Todo.Todo(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['todo_id'].value))
        todo.delete()
        output.append(REQUEST.TLS('todo_deleted'))
    else:
        todo = _Todo.Todo(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['todo_id'].value))
        if REQUEST.form.has_key('_accept'):
            todo.set('accepted_persons', _Utils.sql_parse_array(REQUEST, todo.get('accepted_persons')) + [REQUEST.USER.get_id()])
        if REQUEST.form.has_key('_reject'):
            todo.set('rejected_persons', _Utils.sql_parse_array(REQUEST, todo.get('rejected_persons')) + [REQUEST.USER.get_id()])
        if not REQUEST.form.has_key('title') or not REQUEST.form['title'].value.decode('UTF8').strip():
            raise RuntimeError, REQUEST.TLS('required_parameters_missing')
        todo.set('title', REQUEST.form['title'].value)
        todo.set('description', REQUEST.form['description'].value)
        todo.set('priority', REQUEST.form['priority'].value)
        todo.set('percent_complete', int(REQUEST.form['percent_complete'].value))
        if todo.get('creator_id') == REQUEST.USER.get_id():
            if REQUEST.form.has_key('todo_is_private'):
                todo.set('is_private', 1)
            else:
                todo.set('is_private', 0)
        if REQUEST.form['start_time'].value:
            try: todo.set('start_time', REQUEST.user2isodate(REQUEST, REQUEST.form['start_time'].value))
            except ValueError:
                raise RuntimeError, REQUEST.TLS('tls_invdateformat')
        else:
            todo.set('start_time', None)
        if REQUEST.form['due_time'].value:
            try: todo.set('due_time', REQUEST.user2isodate(REQUEST, REQUEST.form['due_time'].value))
            except ValueError:
                raise RuntimeError, REQUEST.TLS('tls_invdateformat')
        else:
             todo.set('due_time', None)
        if REQUEST.form.has_key('related_persons'):
            try:
                todo.set('related_persons', [int(REQUEST.form['related_persons'].value)])
            except AttributeError:
                todo.set('related_persons', REQUEST.form['related_persons'])
        else:
            todo.set('related_persons', [])
        todo.save()
        output.append(REQUEST.TLS('todo_saved'))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)


def relations_contents(REQUEST):
    if not REQUEST.form.has_key('todo_id') or not REQUEST.form['todo_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    todo_id = REQUEST.form['todo_id'].value
    obj = _Todo.Todo(REQUEST, _InitTypes.INIT_TYPE_ID, int(REQUEST.form['todo_id'].value))
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_TODO_URL = _Conf.BASE_TODO_URL
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_todo_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST, obj)
    output.append(u""" %(menu)s""" % locals())
    relation_output = relations.show_relations(REQUEST, obj)
    output.append(relation_output)
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def notes_contents(REQUEST):
    if not REQUEST.form.has_key('todo_id') or not REQUEST.form['todo_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')
    obj_id = int(REQUEST.form['todo_id'].value)
    obj = _Todo.Todo(REQUEST, _InitTypes.INIT_TYPE_ID, obj_id)
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_todo_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST, obj)
    BASE_TODO_URL = _Conf.BASE_TODO_URL
    returl = "%(BASE_TODO_URL)stodoedit.py?todo_id=%(obj_id)s&note=1" % locals()
    returl = urllib.quote(returl)
    show_menu = "todo"
    output.append(_Usernote.note_out(REQUEST, obj, obj_id, returl, menu, show_menu))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def menu_output(REQUEST, obj):
    if not REQUEST.form.has_key('todo_id') or not REQUEST.form['todo_id'].value:
        raise RuntimeError, REQUEST.TLS('tls_missinginfo')

    output=[]
    todo_id = int(REQUEST.form['todo_id'].value)
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_TODO_URL = _Conf.BASE_TODO_URL

    tls_info = REQUEST.TLS('contact_info')
    tls_relations = REQUEST.TLS('tls_relations')
    tls_emails = REQUEST.TLS('tls_emails')
    tls_notes = REQUEST.TLS('compmenu_todo_notes')
    tls_contacts = REQUEST.TLS('topmenu_contacts')
    tls_log = REQUEST.TLS('log_log')
    relations_count = relations.relations_count(REQUEST, obj)

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_USERNOTE])
    if right_param:
        right_param = " AND " + right_param
    QUERY = u"""SELECT count(*) FROM usernotes u, items i, items p WHERE u.note_id=i.item_id AND i.creator_id=p.item_id AND (i.parent_id=%d)%s""" % (todo_id, right_param)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    note_count = REQUEST.db.fetchone()[0]

    active = 0
    if REQUEST.form.has_key('rel') and REQUEST.form['rel'].value=='1':
      active = 1
      el2 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;<a class="blackboldlink" href="%(BASE_TODO_URL)stodoedit.py?todo_id=%(todo_id)s&rel=1">%(tls_relations)s <span class="efoldercount">(%(relations_count)d)</span></a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el2 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;<a class="blacklink" href="%(BASE_TODO_URL)stodoedit.py?todo_id=%(todo_id)s&rel=1">%(tls_relations)s <span class="efoldercount">(%(relations_count)d)</span></a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if REQUEST.form.has_key('note') and REQUEST.form['note'].value=='1':
      active = 1
      el3 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;<a class="blackboldlink" href="%(BASE_TODO_URL)stodoedit.py?todo_id=%(todo_id)s&note=1">%(tls_notes)s <span class="efoldercount">(%(note_count)s)</span></a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el3 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;<a class="blacklink" href="%(BASE_TODO_URL)stodoedit.py?todo_id=%(todo_id)s&note=1">%(tls_notes)s <span class="efoldercount">(%(note_count)s)</span></a>&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if REQUEST.form.has_key('log') and REQUEST.form['log'].value=='1':
      active = 1
      el4 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_TODO_URL)stodoedit.py?todo_id=%(todo_id)s&log=1">%(tls_log)s</a>&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el4 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;&nbsp;<a class="blacklink" href="%(BASE_TODO_URL)stodoedit.py?todo_id=%(todo_id)s&log=1">%(tls_log)s</a>&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    if active<> 1:
      el1 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk3.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listingun">&nbsp;&nbsp;&nbsp;&nbsp;<a class="blackboldlink" href="%(BASE_TODO_URL)stodoedit.py?todo_id=%(todo_id)s">%(tls_info)s</a>&nbsp;&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk4.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()
    else:
      el1 = u"""
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
          <TD nowrap class="th_listing">&nbsp;&nbsp;&nbsp;&nbsp;<a class="blacklink" href="%(BASE_TODO_URL)stodoedit.py?todo_id=%(todo_id)s">%(tls_info)s</a>&nbsp;&nbsp;&nbsp;&nbsp;</TD>
          <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>""" % locals()


    tls_object = REQUEST.TLS('log_todo_id')
    object_name = _Utils.html_quote_show(obj.get('item_name'))
    output.append(u"""
      <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></TD>
        <TD width="100%%" class="object_name">%(tls_object)s: %(object_name)s</TD>
      </TR>
      <TR>
        <TD colspan="2"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="15" border=0 alt=""></TD>
      </TR>
      </TABLE>
      <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
        <TR>
          <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
          %(el1)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el2)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el3)s
          <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=5 height=1 border=0 alt=""></TD>
          %(el4)s
          <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
        </TR>
      </TABLE>""" % locals())
    return "\n".join(output)


def show_log(REQUEST, obj_id):
    obj = _Todo.Todo(REQUEST, _InitTypes.INIT_TYPE_ID, int(obj_id))
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(Menus.get_todo_menu(REQUEST, MY_MENU_ID))
    menu = menu_output(REQUEST, obj)
    output.append(u""" %(menu)s""" % locals())
    output.append(_Log.standard_log_output(REQUEST, obj_id))
    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)
