# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

import mx.DateTime

import _Conf
from Menus import get_todo_menu
import standard_html

import _Access, _InitTypes, _Todo, _Utils

MY_MENU_ID=0

def index(REQUEST):
    output = []
    wf_list = []
    BASE_TODO_URL = _Conf.BASE_TODO_URL
    output.append(standard_html.html_header(REQUEST))
    if REQUEST.form.has_key('show_users_list'):
        return users_list(REQUEST)

    if REQUEST.form.has_key('show_users'):
        REQUEST.del_setting('cal_show_users')
        REQUEST.del_setting('cal_show_groups')

    if REQUEST.form.has_key('_delete'):
        del_ids = []
        for key in REQUEST.form.keys():
            if key[:4] == 'sel_':
                del_ids.append(int(key[4:]))

        for del_id in del_ids:
            todo = _Todo.Todo(REQUEST, _InitTypes.INIT_TYPE_ID, del_id)
            todo.delete()
        if REQUEST.form.has_key('returl') and REQUEST.form['returl'].value.strip():
            REQUEST.mod_req.headers_out["Location"] = "%s" % urllib.unquote(REQUEST.form['returl'].value.strip())
            return apache.HTTP_MOVED_TEMPORARILY

    REQUEST.db.execute("""SELECT person_id, first_name || ' ' || last_name as person_name from persons""")
    res = REQUEST.db.fetchall()
    persons_dict = {}
    for row in res:
        persons_dict[row[0]] = row[1].decode('UTF8')
    try:
        show_users = REQUEST.get_setting('cal_show_users')
    except:
        show_users = None

    try:
        show_groups = REQUEST.get_setting('cal_show_groups')
    except:
        show_groups = None

    if show_groups:
        dic = {}
        REQUEST.db.execute("""SELECT members from calendar_groups where group_id in (%s)""" % ",".join(map(str, show_groups)))
        group_members = map(lambda x:_Utils.sql_parse_array(REQUEST, x[0]), REQUEST.db.fetchall())
        for gr in group_members:
            for member in gr:
                dic[member]=1
        group_members = dic.keys()
        if show_users:
            show_users+=group_members
        else:
            show_users=group_members


    if REQUEST.form.has_key('show_all'):
        sh = "show_all=1&"
        extra_pars = u""
        output.append(get_todo_menu(REQUEST, MY_MENU_ID+1, 1))
    else:
        sh = ""
        extra_pars = u" AND percent_complete < 100"
        output.append(get_todo_menu(REQUEST, MY_MENU_ID, 1))

    wf_id = 0


    sortby = [
'title ASC', 'title DESC',
'creator_name ASC', 'creator_name DESC',
'priority ASC', 'priority DESC',
'category ASC', 'category DESC',
'status ASC', 'status DESC',
'due_time ASC', 'due_time DESC',
'percent_complete ASC', 'percent_complete DESC',
]

    tls_tasks = REQUEST.TLS('tls_todos')
    tls_done = REQUEST.TLS('todo_done')
    tls_title = REQUEST.TLS('tls_title')
    tls_creator = REQUEST.TLS('tls_responsible')
    tls_priority = REQUEST.TLS('tls_priority')
    tls_category = REQUEST.TLS('tls_category')
    tls_status = REQUEST.TLS('tls_status')
    tls_due = REQUEST.TLS('todo_due')
    tls_onlyme = REQUEST.TLS('todo_onlyme')
    tls_select_others = REQUEST.TLS('todo_select_others')
    tls_delete = REQUEST.TLS('tls_deletesel')
    tls_confirm = REQUEST.TLS('email_confirm_del')
    base_todo_url = _Conf.BASE_TODO_URL

    DEFAULT_SORTBY = 10
    sortby_id = -1
    if REQUEST.form.has_key('sort_by') and REQUEST.form['sort_by'].value.decode('UTF8').strip():
        sortby_id = int(REQUEST.form['sort_by'].value.decode('UTF8').strip())   
    if sortby_id < 0 or sortby_id >= len(sortby):
        sortby_id  = DEFAULT_SORTBY
    formstring = REQUEST.get_formstring(['qs','sort_by'])
    sortby_title = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=0">%s</A>""" % (_Conf.BASE_TODO_URL, formstring, tls_title)
    sortby_creator = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=2">%s</A>""" % (_Conf.BASE_TODO_URL, formstring, tls_creator)
    sortby_priority = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=4">%s</A>""" % (_Conf.BASE_TODO_URL, formstring, tls_priority)
    sortby_category = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=6">%s</A>""" % (_Conf.BASE_TODO_URL, formstring, tls_category)
    sortby_status = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=8">%s</A>""" % (_Conf.BASE_TODO_URL, formstring, tls_status)
    sortby_due = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=10">%s</A>""" % (_Conf.BASE_TODO_URL, formstring, tls_due)
    sortby_complete = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=12">%s</A>""" % (_Conf.BASE_TODO_URL, formstring, tls_done)
    if sortby_id == 0:
        sortby_title = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=1">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_title)
    elif sortby_id == 1:
        sortby_title = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=0">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_title)
    elif sortby_id == 2:
        sortby_creator = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=3">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_creator)
    elif sortby_id == 3:
        sortby_creator = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=2">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_creator)
    elif sortby_id == 4:
        sortby_priority = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=5">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_priority)
    elif sortby_id == 5:
        sortby_priority = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=4">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_priority)
    elif sortby_id == 6:
        sortby_category = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=7">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_category)
    elif sortby_id == 7:
        sortby_category = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=6">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_category)
    elif sortby_id == 8:
        sortby_status = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=9">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_status)
    elif sortby_id == 9:
        sortby_status = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=8">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_status)
    elif sortby_id == 10:
        sortby_due = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=11">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_due)
    elif sortby_id == 11:
        sortby_due = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=10">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_due)
    elif sortby_id == 12:
        sortby_complete = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=13">%s</A> <SPAN class="sort">&uarr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_done)
    elif sortby_id == 13:
        sortby_complete = u"""<A class="blackboldlink" href="%stodoindex.py%ssort_by=12">%s</A> <SPAN class="sort">&darr;</SPAN>""" % (_Conf.BASE_TODO_URL, formstring, tls_done)
    del formstring

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_TODO])
    if right_param:
        right_param = " AND " + right_param

    if show_users: # Show involved people
        users_limit = []
        for userid in show_users:
            users_limit.append("""i.creator_id = %d""" % userid)
            if REQUEST.db.version < 740:
                users_limit.append("""t.related_persons @ '{%d}'::int[]""" % userid)
            else:
                users_limit.append("""%d=ANY(t.related_persons)""" % userid)
        users_limit = "\n     (%s) " % " OR ".join(users_limit)
    else: # show only personal stuff
        if REQUEST.db.version < 740:
            users_limit = """\n     (i.creator_id = %d OR t.related_persons @ '{%d}'::int[])""" % (REQUEST.USER.get_id(), REQUEST.USER.get_id())
        else:
            users_limit = """\n     (i.creator_id = %d OR %d=ANY(t.related_persons))""" % (REQUEST.USER.get_id(), REQUEST.USER.get_id())

    wf = ""
    if REQUEST.form.has_key('filter') and REQUEST.form['filter'].value=="1":
        QUERY = u"""SELECT count(*) AS count_all FROM todos t, items i, items p WHERE t.todo_id=i.item_id AND p.item_id=i.creator_id AND i.creator_id=%d %s%s""" % (REQUEST.USER.get_id(), extra_pars, right_param)
    elif REQUEST.form.has_key('filter') and REQUEST.form['filter'].value=="2":
        if REQUEST.db.version < 740:
            QUERY = u"""SELECT count(*) AS count_all FROM todos t, items i, items p WHERE t.todo_id=i.item_id AND p.item_id=i.creator_id AND t.related_persons @ '{%d}'::int[] %s%s""" % (REQUEST.USER.get_id(), extra_pars, right_param)
        else:
            QUERY = u"""SELECT count(*) AS count_all FROM todos t, items i, items p WHERE t.todo_id=i.item_id AND p.item_id=i.creator_id AND %d=ANY(t.related_persons) %s%s""" % (REQUEST.USER.get_id(), extra_pars, right_param)
    elif REQUEST.form.has_key('filter') and REQUEST.form['filter'].value=="3":
        QUERY = u"""SELECT count(*) AS count_all  FROM todos t, items i, items p WHERE t.todo_id=i.item_id AND p.item_id=i.creator_id AND t.percent_complete<100 and t.due_time is not null and t.due_time<now() %s%s""" % (extra_pars, right_param)
    else:
        QUERY = u"""SELECT count(*) AS count_all FROM todos t, items i, items p WHERE t.todo_id=i.item_id AND p.item_id=i.creator_id AND %s%s%s""" % (users_limit, extra_pars, right_param)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    count_all = REQUEST.db.dictfetchone()['count_all']

    if REQUEST.qs <> 0 or count_all > REQUEST.qs + REQUEST.batch_size:
        batch_url = "%stodoindex.py%sqs=" % (_Conf.BASE_TODO_URL, REQUEST.get_formstring(['qs']))
        batches = []
        for n in range(1, count_all+1, REQUEST.batch_size):
            if (REQUEST.qs == 0 and n == 1) or (REQUEST.qs >= n-1 and REQUEST.qs < n+REQUEST.batch_size-1):
                batches.append(u"""<A class="redlink" href="%s%d"><B>%d&minus;%d</B></A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
            else:
                batches.append(u"""<A class="redlink" href="%s%d">%d&minus;%d</A>""" % (batch_url, n-1, n, n+REQUEST.batch_size-1))
        NAV_BAR = " ".join(batches)
        START_BAR = ""
        END_BAR = ""
        if REQUEST.qs <> 0:
            START_BAR = """<A class="redlink" href="%stodoindex.py%sqs=%d">&laquo;&nbsp;&nbsp;%s</A>""" % (_Conf.BASE_TODO_URL, REQUEST.get_formstring(['qs']), REQUEST.qs-REQUEST.batch_size, (REQUEST.TLS('tls_back_x') % REQUEST.batch_size))
        if count_all > REQUEST.qs + REQUEST.batch_size:
            END_BAR = u"""<A class="redlink" href="%stodoindex.py%sqs=%d">%s&nbsp;&nbsp;&raquo;</A>""" %  (_Conf.BASE_TODO_URL, REQUEST.get_formstring(['qs']), REQUEST.batch_size+REQUEST.qs, (REQUEST.TLS('tls_forward_x') % REQUEST.batch_size))
        FULL_BAR = standard_html.FULL_BAR2(START_BAR, NAV_BAR, END_BAR)
    else:
        FULL_BAR = ""

    if wf_id:
        QUERY = u"""SELECT t.*, i.creator_id, i.parent_id, p.item_name AS creator_name FROM todos t, items i, items p WHERE t.todo_id=i.item_id AND p.item_id=i.creator_id %s%s ORDER BY %s LIMIT %d OFFSET %d""" % (right_param, wf, sortby[sortby_id], REQUEST.batch_size, REQUEST.qs)
    else:
        if REQUEST.form.has_key('filter') and REQUEST.form['filter'].value=="1":
            QUERY = u"""SELECT t.*, i.creator_id, i.parent_id, p.item_name AS creator_name FROM todos t, items i, items p WHERE t.todo_id=i.item_id AND p.item_id=i.creator_id AND i.creator_id=%d %s%s%s ORDER BY %s LIMIT %d OFFSET %d""" % (REQUEST.USER.get_id(), extra_pars, right_param, wf, sortby[sortby_id], REQUEST.batch_size, REQUEST.qs)
        elif REQUEST.form.has_key('filter') and REQUEST.form['filter'].value=="2":
            if REQUEST.db.version < 740:
                QUERY = u"""SELECT t.*, i.creator_id, i.parent_id, p.item_name AS creator_name FROM todos t, items i, items p WHERE t.todo_id=i.item_id AND p.item_id=i.creator_id AND t.related_persons @ '{%d}'::int[] %s%s%s ORDER BY %s LIMIT %d OFFSET %d""" % (REQUEST.USER.get_id(), extra_pars, right_param, wf, sortby[sortby_id], REQUEST.batch_size, REQUEST.qs)
            else:
                QUERY = u"""SELECT t.*, i.creator_id, i.parent_id, p.item_name AS creator_name FROM todos t, items i, items p WHERE t.todo_id=i.item_id AND p.item_id=i.creator_id AND %d=ANY(t.related_persons) %s%s%s ORDER BY %s LIMIT %d OFFSET %d""" % (REQUEST.USER.get_id(), extra_pars, right_param, wf, sortby[sortby_id], REQUEST.batch_size, REQUEST.qs)
        elif REQUEST.form.has_key('filter') and REQUEST.form['filter'].value=="3":
            QUERY = u"""SELECT t.*, i.creator_id, i.parent_id, p.item_name AS creator_name FROM todos t, items i, items p WHERE t.todo_id=i.item_id AND p.item_id=i.creator_id AND t.percent_complete<100 and t.due_time is not null and t.due_time<now() %s%s%s ORDER BY %s LIMIT %d OFFSET %d""" % (extra_pars, right_param, wf, sortby[sortby_id], REQUEST.batch_size, REQUEST.qs)
        else:
            QUERY = u"""SELECT t.*, i.creator_id, i.parent_id, p.item_name AS creator_name FROM todos t, items i, items p WHERE t.todo_id=i.item_id AND p.item_id=i.creator_id AND %s%s%s%s ORDER BY %s LIMIT %d OFFSET %d""" % (users_limit, extra_pars, right_param, wf, sortby[sortby_id], REQUEST.batch_size, REQUEST.qs)
    REQUEST.db.execute(QUERY.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_filter = REQUEST.TLS('tls_view')
    tls_opt1 = REQUEST.TLS('todo_v_normal')
    tls_opt2 = REQUEST.TLS('todo_v_created')
    tls_opt3 = REQUEST.TLS('todo_v_assigned')
    tls_opt4 = REQUEST.TLS('todo_v_due')
    
    if REQUEST.form.has_key('filter') and REQUEST.form['filter'].value=="1":
        tls_tasks = tls_opt2
    elif REQUEST.form.has_key('filter') and REQUEST.form['filter'].value=="2":
        tls_tasks = tls_opt3
    elif REQUEST.form.has_key('filter') and REQUEST.form['filter'].value=="3":
        tls_tasks = tls_opt4
    
    
    if REQUEST.form.has_key('show_all'):
        adr = "%(BASE_TODO_URL)stodoindex.py?show_all=1&" % locals()
    else:
        adr = "%(BASE_TODO_URL)stodoindex.py?" % locals()
    adr1 = adr + "filter=1"
    adr2 = adr + "filter=2"
    adr3 = adr + "filter=3"

    output.append(u"""
<SCRIPT type="text/javascript">
function markAll(formvar){ for(var x=0;x<formvar.elements.length;x++) { var y=formvar.elements[x]; if(y.name != 'all') y.checked = formvar.all.checked; } }
function on_over(kala){  kala.style.backgroundColor = "#91E600";}
function on_out(kala){  kala.style.backgroundColor = "#7BC300";}
</SCRIPT>
<DIV style="position: absolute; top: 23px; z-index: 1;">
<TABLE border=0 width="100%%" cellpadding=0 cellspacing=0 bgcolor="#7BC300" class="email_buttons">
<TR>
  <TD colspan="10" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="2" border="0" alt=""></TD>
</TR>
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="14" border="0" alt=""></TD>
  <TD nowrap class="pad4" style="cursor: default"><B>%(tls_filter)s:</B>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
  <TD nowrap onclick="document.location='%(adr)s';" onmouseover="on_over(this);" onmouseout="on_out(this);" class="todo_btns"><img style="vertical-align: bottom" src="%(BASE_ICON_URL)stodo_normal.gif" width="16" height="16" border="0" alt="">&nbsp;&nbsp;%(tls_opt1)s</b></TD>
  <TD><img src="%(BASE_ICON_URL)semail_sep.gif" width="11" height="20" border="0" alt=""></TD>
  <TD nowrap onclick="document.location='%(adr1)s';" onmouseover="on_over(this);" onmouseout="on_out(this);" class="todo_btns"><img style="vertical-align: bottom" src="%(BASE_ICON_URL)stodo_created.gif" width="16" height="16" border="0" alt="">&nbsp;&nbsp;%(tls_opt2)s</TD>
  <TD><img src="%(BASE_ICON_URL)semail_sep.gif" width="11" height="20" border="0" alt=""></TD>
  <TD nowrap onclick="document.location='%(adr2)s';" onmouseover="on_over(this);" onmouseout="on_out(this);" class="todo_btns"><img style="vertical-align: bottom" src="%(BASE_ICON_URL)stodo_assigned.gif" width="16" height="16" border="0" alt="">&nbsp;&nbsp;%(tls_opt3)s</TD>
  <TD><img src="%(BASE_ICON_URL)semail_sep.gif" width="11" height="20" border="0" alt=""></TD>
  <TD nowrap onclick="document.location='%(adr3)s';" onmouseover="on_over(this);" onmouseout="on_out(this);" class="todo_btns"><img style="vertical-align: bottom" src="%(BASE_ICON_URL)stodo_due.gif" width="16" height="16" border="0" alt="">&nbsp;&nbsp;%(tls_opt4)s</TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width="10" height="1" border="0" alt=""></TD>
</TR>
<TR>
  <TD colspan="10" width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="2" border="0" alt=""></TD>
</TR>
</TABLE>
</DIV>
<BR>
<BR>
<BR>
<TABLE width="100%%" cellpadding=0 cellspacing=0 border=0>
<FORM method="post" action="%(BASE_TODO_URL)stodoindex.py">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD colspan=8 width="100%%">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk1.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD class="th_listing" align="center" nowrap>&nbsp;&nbsp;&nbsp;<b>%(tls_tasks)s</b>&nbsp;&nbsp;&nbsp;</TD>
        <TD style="background-image: url('%(BASE_ICON_URL)sdokunurk2.gif')"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%">&nbsp;</TD>
        <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
      </TR>
    </TABLE>
  </TD>
</TR>
<TR>
  <TD width="1%%" class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD width="8%%" class="td_listing1b" nowrap>%(sortby_complete)s</TD>
  <TD width="45%%" class="td_listing1b">%(sortby_title)s</TD>
  <TD width="15%%" class="td_listing1b" nowrap>%(tls_creator)s</TD>
  <TD width="15%%" class="td_listing1b" nowrap>%(sortby_priority)s</TD>
  <TD width="15%%" class="td_listing1b" nowrap>%(sortby_due)s</TD>
  <TD width="1%%" class="td_listing1b"><INPUT type="checkbox" name="all" onClick="javascript:markAll(this.form);"></TD>
</TR>""" % locals())

    index = 0
    now = _Utils.utc_now_mx()
    now = mx.DateTime.DateTime(now.year, now.month, now.day)
    for item in dbresult:
        item['class_type'] = index % 2
        index += 1
        item['BASE_TODO_URL'] = _Conf.BASE_TODO_URL
        item['BASE_ICON_URL'] = _Conf.BASE_ICON_URL

        item['markredstart'] = item['markredend'] = u""
        if item['priority'] is None: item['priority'] = ""
        if item['due_time'] is None:
            item['due_time'] = ""
        else:
            if item['percent_complete'] < 100 and now >= item['due_time']:
                item['markredstart'] = u"<FONT color='red'>"
                item['markredend'] = u"</FONT>"
            item['due_time'] = REQUEST.iso2userdate(item['due_time'])

        if isinstance(item['priority'], str):
            item['priority'] = item['priority'].decode('UTF8')
        item['creator_name'] = _Utils.sql_parse_array(REQUEST, item['related_persons'])
        if item['creator_name'] == []:
            item['creator_name'] = ""
        else:
            p_out = ""
            for person in item['creator_name']:
                p_out = p_out + persons_dict.get(person, "N/A") + "<BR>"
            item['creator_name'] = p_out[0:-4]
        if isinstance(item['title'], str):
            item['title'] = _Utils.html_quote(item['title'].decode('UTF8'))
        
        if(item['percent_complete'] == 0):
            item['complete_str'] = """<IMG src="%slgreen.gif" width="50" height="4" border=0 alt="0%% %s">""" % (_Conf.BASE_ICON_URL, REQUEST.TLS('todo_complete'))
        elif(item['percent_complete'] == 100):
            item['complete_str'] = """<IMG src="%sdgreen.gif" width="50" height="4" border=0 alt="100%% %s">""" % (_Conf.BASE_ICON_URL, REQUEST.TLS('todo_complete'))
        else:
            item['first_percent']=(int) (item['percent_complete']/2)
            item['second_percent']=50 - item['first_percent']
            item['tls_complete'] = REQUEST.TLS('todo_complete')
            item['complete_str'] = ("""<IMG src="%(BASE_ICON_URL)sdgreen.gif" width="%(first_percent)d" height="4" border=0 alt="%(percent_complete)d%% %(tls_complete)s"><IMG src="%(BASE_ICON_URL)slgreen.gif" width="%(second_percent)d" height="4" border=0 alt="%(percent_complete)d%% %(tls_complete)s">""" % item)
        
        if item['creator_id'] == REQUEST.USER.get_id() or REQUEST.USER.get_id()== _Conf.SUPERUSER:
            item['checkbox_str'] = u"""<INPUT type="checkbox" name="sel_%(todo_id)d">""" % item
        else:
            item['checkbox_str'] = u""
        
        output.append(u"""<TR>
  <TD class="td_listing%(class_type)d"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing%(class_type)d" style="text-align: center">
      <TABLE border=0 width=54 cellpadding=1 cellspacing=0 bgcolor="#000000">
        <TR>
          <TD>
            <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0 bgcolor="#FFFFFF">
              <TR>
                <TD colspan=3 bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
              </TR>
              <TR>
                <TD bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
                <TD bgcolor="#FFFFFF" width="100%%">%(complete_str)s</TD>
                <TD bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
              </TR>
              <TR>
                <TD colspan=3 bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
              </TR>
            </TABLE>
          </TD>
        </TR>
      </TABLE>
   </TD>
  <TD class="td_listing%(class_type)d"><A class="td_listing" href="%(BASE_TODO_URL)stodoedit.py?todo_id=%(todo_id)d">%(markredstart)s%(title)s%(markredend)s</A></TD>
  <TD class="td_listing%(class_type)d" nowrap>%(markredstart)s%(creator_name)s%(markredend)s</TD>
  <TD class="td_listing%(class_type)d" nowrap>%(markredstart)s%(priority)s%(markredend)s</TD>
  <TD class="td_listing%(class_type)d" nowrap>%(markredstart)s%(due_time)s%(markredend)s</TD>
  <TD class="td_listing%(class_type)d">%(checkbox_str)s</TD>
</TR>""" % item)

    output.append(u"</TABLE>")
    if FULL_BAR:
        output.append(FULL_BAR)
    output.append(u"""\
<BR>
<TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
  <TR>
    <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
    <TD class="td_listing0" width="50%%">""" % locals())
    if show_users:
        output.append(u"""<INPUT TYPE="submit" class="input6" name="show_users" value="%(tls_onlyme)s"> """ % locals())
    output.append(u"""<INPUT TYPE="submit" class="input6" name="show_users_list" value="%(tls_select_others)s"></TD>
    <TD class="td_listing0" width="50%%" align="right"><INPUT TYPE="submit" class="input6" name="_delete" value="%(tls_delete)s" onClick="return confirm('%(tls_confirm)s');"></TD>
  </TR>
</TABLE>
</FORM>""" % locals())
    output.append(standard_html.html_footer(REQUEST))
    return '\n'.join(output)

def users_list(REQUEST):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_todo_menu(REQUEST,MY_MENU_ID))
    output.append(u"""\
<SCRIPT type="text/javascript">
function move_1()
{
	var the_select1 = window.document.vorm.show_users_set2;
	var the_select2 = window.document.vorm.show_users_set;
	for (loop=0; loop < the_select1.options.length; loop++)
	{
		if (the_select1.options[loop].selected == true)
		{
			 var opt = new Option(the_select1.options[loop].text, the_select1.options[loop].value)
			 the_select2.options[the_select2.options.length] = opt
			 the_select1.options[loop] = null;
			 loop--;
		}
	}
}
function move_2()
{
	var the_select1 = window.document.vorm.show_users_set;
	var the_select2 = window.document.vorm.show_users_set2;
	for (loop=0; loop < the_select1.options.length; loop++)
	{
		if (the_select1.options[loop].selected == true)
		{
			 var opt = new Option(the_select1.options[loop].text, the_select1.options[loop].value)
			 the_select2.options[the_select2.options.length] = opt
			 the_select1.options[loop] = null;
			 loop--;
		}
	}
}
function move_5()
{
	var the_select1 = window.document.vorm3.show_users_set2;
	var the_select2 = window.document.vorm3.show_users_set;
	for (loop=0; loop < the_select1.options.length; loop++)
	{
		if (the_select1.options[loop].selected == true)
		{
			 var opt = new Option(the_select1.options[loop].text, the_select1.options[loop].value)
			 the_select2.options[the_select2.options.length] = opt
			 the_select1.options[loop] = null;
			 loop--;
		}
	}
}
function move_6()
{
	var the_select1 = window.document.vorm3.show_users_set;
	var the_select2 = window.document.vorm3.show_users_set2;
	for (loop=0; loop < the_select1.options.length; loop++)
	{
		if (the_select1.options[loop].selected == true)
		{
			 var opt = new Option(the_select1.options[loop].text, the_select1.options[loop].value)
			 the_select2.options[the_select2.options.length] = opt
			 the_select1.options[loop] = null;
			 loop--;
		}
	}
}
function select_all()
{
	var the_select1 = window.document.vorm.show_users_set;
	for (loop=0; loop < the_select1.options.length; loop++)
	{
		the_select1.options[loop].selected = true;
	}
}
function select_all3()
{
	var the_select1 = window.document.vorm3.show_users_set;
	for (loop=0; loop < the_select1.options.length; loop++)
	{
		the_select1.options[loop].selected = true;
	}
}
</SCRIPT>""")

    right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_PERSON])
    if right_param:
        right_param = " AND " + right_param
    QUERY = """SELECT p.person_id, i.item_name, o.organization_name FROM persons p, items i, organizations o WHERE p.person_id=i.item_id AND o.organization_id=i.parent_id%s ORDER BY p.last_name, p.first_name""" % right_param
    REQUEST.db.execute(QUERY.encode('UTF8'))
    dbresult = REQUEST.db.dictfetchall()

    QUERY3 = """SELECT group_id, group_name from calendar_groups WHERE parent_id=%d""" % REQUEST.USER.get_id()
    REQUEST.db.execute(QUERY3.encode('UTF8'))
    dbresult3 = REQUEST.db.dictfetchall()

    BASE_TODO_URL = _Conf.BASE_TODO_URL

    try:
        show_users = REQUEST.get_setting('cal_show_users')
    except:
        show_users = [REQUEST.USER.get_id()]
    try:
        show_groups = REQUEST.get_setting('cal_show_groups')
    except:
        show_groups = ""

    tls_users = REQUEST.TLS('cal_users')
    tls_usertitle = REQUEST.TLS('cal_usertitle')
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_save = REQUEST.TLS('tls_save')
    tls_view = REQUEST.TLS('cal_myviewlist')
    tls_others = REQUEST.TLS('cal_allpeople')
    tls_groups = REQUEST.TLS('cal_groups')
    tls_selgroups = REQUEST.TLS('cal_selgroups')
    tls_myviewgroups = REQUEST.TLS('cal_myviewgroups')
    tls_allgroups = REQUEST.TLS('cal_allgroups')
    userlist1=[]
    userlist2=[]
    for p in dbresult:
        if show_users and p['person_id'] in show_users:
            userlist1.append(u"""\
            <OPTION value="%d">%s (%s)""" % (p['person_id'], p['item_name'].decode('UTF8'), p['organization_name'].decode('UTF8')))
        else:
            userlist2.append(u"""<OPTION value="%d">%s (%s)""" % (p['person_id'], p['item_name'].decode('UTF8'), p['organization_name'].decode('UTF8')))
    ulist1 = "\n".join(userlist1)
    ulist2 = "\n".join(userlist2)

    grouplist1=[]
    grouplist2=[]
    for p in dbresult3:
        if show_groups and p['group_id'] in show_groups:
            grouplist1.append(u"""<OPTION value="%d">%s""" % (p['group_id'], p['group_name'].decode('UTF8')))
        else:
            grouplist2.append(u"""<OPTION value="%d">%s""" % (p['group_id'], p['group_name'].decode('UTF8')))
    glist1 = "\n".join(grouplist1)
    glist2 = "\n".join(grouplist2)

    output.append(u"""<FORM name="vorm" action="%(BASE_TODO_URL)stodoindex.py/save_users_list" onsubmit="select_all();">
<TABLE width="100%%" cellpadding=0 cellspacing=0 border=0>
 <TR class="tr_listing0">
    <TD colspan=2><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=15 border=0 alt=""></TD>
 </TR>
 <TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD width="100%%">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD background="%(BASE_ICON_URL)sdokunurk1.gif"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD class="th_listing" align=center nowrap>&nbsp;&nbsp;%(tls_users)s&nbsp;&nbsp;</TD>
        <TD background="%(BASE_ICON_URL)sdokunurk2.gif"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%">&nbsp;</TD>
      </TR>
    </TABLE>
  </TD>
 </TR>
<TR class="tr_listing1">
 <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=20 border=0 alt=""></TD>
 <TD class="td_listing1">%(tls_usertitle)s</TD>
</TR>
<TR>
 <TD colspan="2">
   <TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
     <TR>
       <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=20 border=0 alt=""></TD>
       <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=300 border=0 alt=""></TD>
       <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=40 border=0 alt=""></TD>
       <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=40 border=0 alt=""></TD>
       <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=300 border=0 alt=""></TD>
       <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=10 border=0 alt=""></TD>
     </TR>
     <TR class="tr_listing0">
       <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" height="20" width=20 border=0 alt=""></TD>
       <TD class="td_listing0">%(tls_view)s</TD>
       <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=40 border=0 alt=""></TD>
       <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=40 border=0 alt=""></TD>
       <TD class="td_listing0">%(tls_others)s</TD>
       <TD width="100%%" class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=10 border=0 alt=""></TD>
     </TR>
     <TR class="tr_listing1">
       <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=20 border=0 alt=""></TD>
       <TD class="td_listing1" align="center">
         <SELECT name="show_users_set" multiple size="5">
%(ulist1)s
         </SELECT>
       </TD>
       <TD class="td_listing1" align="center"><a href="#" onclick="move_1();"><img src="%(BASE_ICON_URL)sleft_arr.gif" width="17" height="17" border="0" alt=""></a></TD>
       <TD class="td_listing1" align="center"><a href="#" onclick="move_2();"><img src="%(BASE_ICON_URL)sright_arr.gif" width="17" height="17" border="0" alt=""></a></TD>
       <TD class="td_listing1" align="center">
         <SELECT name="show_users_set2" multiple size="5">
%(ulist2)s
         </SELECT>
       </TD>
       <TD width="100%%" class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 border=0 alt=""></TD>
     </TR>
   </TABLE>
 </TD>
</TR>
<TR class="tr_listing0">
 <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=20 border=0 alt=""></TD>
 <TD class="td_listing0"><INPUT type="submit" class="input6" value="%(tls_save)s"></TD>
</TR>
</TABLE>
</FORM>""" % locals())
    if(glist1 or glist2):
        output.append(u"""\
<FORM name="vorm3" action="%(BASE_TODO_URL)stodoindex.py/save_groups_list" onsubmit="select_all3();">
<TABLE width="100%%" cellpadding=0 cellspacing=0 border=0>
 <TR class="tr_listing0">
    <TD colspan=2><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=15 border=0 alt=""></TD>
 </TR>
 <TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD width="100%%">
    <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
      <TR>
        <TD background="%(BASE_ICON_URL)sdokunurk1.gif"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD class="th_listing" align=center nowrap>&nbsp;&nbsp;%(tls_groups)s&nbsp;&nbsp;</TD>
        <TD background="%(BASE_ICON_URL)sdokunurk2.gif"><img src="%(BASE_ICON_URL)sspacer.gif" width="2" height="20" border=0 alt=""></TD>
        <TD width="100%%">&nbsp;</TD>
      </TR>
    </TABLE>
  </TD>
 </TR>
<TR class="tr_listing1">
 <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=20 border=0 alt=""></TD>
 <TD class="td_listing1">%(tls_selgroups)s</TD>
</TR>
<TR>
 <TD colspan="2">
   <TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
     <TR>
       <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=20 border=0 alt=""></TD>
       <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=300 border=0 alt=""></TD>
       <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=40 border=0 alt=""></TD>
       <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=40 border=0 alt=""></TD>
       <TD><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=300 border=0 alt=""></TD>
       <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=10 border=0 alt=""></TD>
     </TR>
     <TR class="tr_listing0">
       <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" height="20" width=20 border=0 alt=""></TD>
       <TD class="td_listing0">%(tls_myviewgroups)s</TD>
       <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=40 border=0 alt=""></TD>
       <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=40 border=0 alt=""></TD>
       <TD class="td_listing0">%(tls_allgroups)s</TD>
       <TD width="100%%" class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=10 border=0 alt=""></TD>
     </TR>
     <TR class="tr_listing1">
       <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" height="1" width=20 border=0 alt=""></TD>
       <TD class="td_listing1" align="center">
         <SELECT name="show_users_set" multiple size="5">
%(glist1)s
         </SELECT>
       </TD>
       <TD class="td_listing1" align="center"><a href="#" onclick="move_5();"><img src="%(BASE_ICON_URL)sleft_arr.gif" width="17" height="17" border="0" alt=""></a></TD>
       <TD class="td_listing1" align="center"><a href="#" onclick="move_6();"><img src="%(BASE_ICON_URL)sright_arr.gif" width="17" height="17" border="0" alt=""></a></TD>
       <TD class="td_listing1" align="center">
         <SELECT name="show_users_set2" multiple size="5">
%(glist2)s
         </SELECT>
       </TD>
       <TD width="100%%" class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 border=0 alt=""></TD>
     </TR>
   </TABLE>
 </TD>
</TR>
<TR class="tr_listing0">
 <TD class="td_listing0"><img src="%(BASE_ICON_URL)sspacer.gif" width=20 border=0 alt=""></TD>
 <TD class="td_listing0"><INPUT type="submit" class="input6" value="%(tls_save)s"></TD>
</TR>
</TABLE>
</FORM>""" % locals())

    output.append(standard_html.html_footer(REQUEST))
    return "\n".join(output)

def save_users_list(REQUEST):
    if not REQUEST.form.has_key('show_users_set'):
        raise RuntimeError, REQUEST.TLS('tls_nousers')

    try:
        show_users = [REQUEST.form['show_users_set'].value]
    except AttributeError:
        show_users = REQUEST.form['show_users_set']

    if not show_users:
        raise RuntimeError, REQUEST.TLS('tls_nousers')

    show_users = map(int, show_users)

    REQUEST.set_setting('cal_show_users', show_users)

    return index(REQUEST)


def save_groups_list(REQUEST):
    if not REQUEST.form.has_key('show_users_set'):
        show_groups = None
    else:
        try:
            show_groups = [REQUEST.form['show_users_set'].value]
        except AttributeError:
            show_groups = REQUEST.form['show_users_set']

    if not show_groups:
        REQUEST.del_setting('cal_show_groups')
    else:
        show_groups = map(int, show_groups)
        REQUEST.set_setting('cal_show_groups', show_groups)

    return index(REQUEST)
