# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

import _Menu
import _Conf


def get_admin_menu(REQUEST, MY_MENU_ID=None):
    if REQUEST.USER.get_id() == _Conf.SUPERUSER:
        is_superuser = 1
    else:
        is_superuser = 0

    menu = _Menu.Menu(REQUEST, MY_MENU_ID)
    menu.add_item(REQUEST.TLS('tls_myinfo'), _Conf.BASE_ADMIN_URL + "myinfo.py", _Conf.BASE_WEB_URL + "icons/users.gif\" width=\"16\" height=\"16", target="top.topcontents.")
    menu.add_item(REQUEST.TLS("compmenu_admin_settings"), _Conf.BASE_ADMIN_URL + "settings.py", _Conf.BASE_WEB_URL + "icons/settings.gif\" width=\"19\" height=\"16", target="top.topcontents.")
    menu.add_item(REQUEST.TLS("compmenu_admin_user"), _Conf.BASE_ADMIN_URL + "users.py", _Conf.BASE_WEB_URL + "icons/users.gif\" width=\"16\" height=\"16", target="top.topcontents.")
    if is_superuser:
        menu.add_item(REQUEST.TLS("compmenu_admin_org"), _Conf.BASE_ADMIN_URL + "orgs.py", _Conf.BASE_WEB_URL + "icons/organizations.gif\" width=\"18\" height=\"16", target="top.topcontents.")
        menu.add_item(REQUEST.TLS("compmenu_admin_choices"), _Conf.BASE_ADMIN_URL + "choices.py", _Conf.BASE_WEB_URL + "icons/choices.gif\" width=\"14\" height=\"16", target="top.topcontents.")
        menu.add_item(REQUEST.TLS("compmenu_admin_system"), _Conf.BASE_ADMIN_URL + "system.py", _Conf.BASE_WEB_URL + "icons/backups.gif\" width=\"18\" height=\"16", target="top.topcontents.")
    menu.set_searchlink(1)
    return menu.draw()

def get_calendar_menu(REQUEST, MY_MENU_ID=None):
    if REQUEST.USER.get_id() == _Conf.SUPERUSER:
        is_superuser = 1
    else:
        top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
        if REQUEST.USER.get_id() == top_parent.get('superuser_id'):
            is_superuser = 1
        else:
            is_superuser = 0

    menu = _Menu.Menu(REQUEST, MY_MENU_ID)
    menu.add_item(REQUEST.TLS("compmenu_cal_day"), _Conf.BASE_CALENDAR_URL + "day.py", _Conf.BASE_WEB_URL + "icons/day.gif\" width=\"21\" height=\"16")
    menu.add_item(REQUEST.TLS("compmenu_cal_week"), _Conf.BASE_CALENDAR_URL + "week.py", _Conf.BASE_WEB_URL + "icons/week.gif\" width=\"21\" height=\"16")
    menu.add_item(REQUEST.TLS("compmenu_cal_month"), _Conf.BASE_CALENDAR_URL + "month.py", _Conf.BASE_WEB_URL + "icons/month.gif\" width=\"19\" height=\"16")
    menu.add_item(REQUEST.TLS("tls_add"), _Conf.BASE_CALENDAR_URL + "addevent.py", _Conf.BASE_WEB_URL + "icons/addicon.gif\" width=\"18\" height=\"16")
    menu.add_item(REQUEST.TLS("tls_search"), _Conf.BASE_CALENDAR_URL + "eventsearch.py", _Conf.BASE_WEB_URL + "icons/searchicon.gif\" width=\"19\" height=\"16")
    if is_superuser:
        menu.add_item(REQUEST.TLS("tls_resources"), _Conf.BASE_CALENDAR_URL + "calcats.py", _Conf.BASE_WEB_URL + "icons/resources.gif\" width=\"18\" height=\"16")
    menu.set_searchlink(1)
    return menu.draw()

def get_document_menu(REQUEST, MY_MENU_ID=None):
    menu = _Menu.Menu(REQUEST, MY_MENU_ID)
    menu.add_item(REQUEST.TLS("compmenu_doc_docs"), _Conf.BASE_DOCUMENT_URL + "folder.py", _Conf.BASE_WEB_URL + "icons/documentsicon.gif\" width=\"21\" height=\"16", target="")
    menu.add_item(REQUEST.TLS("tls_search"), _Conf.BASE_DOCUMENT_URL + "docsearch.py", _Conf.BASE_WEB_URL + "icons/searchicon.gif\" width=\"19\" height=\"16", target="")
    menu.add_item(REQUEST.TLS("compmenu_doc_addfile"), _Conf.BASE_DOCUMENT_URL + "docadd.py", _Conf.BASE_WEB_URL + "icons/addfileicon.gif\" width=\"16\" height=\"16", target="")
    menu.add_item(REQUEST.TLS("compmenu_doc_addfolder"), _Conf.BASE_DOCUMENT_URL + "docadd.py/addfolderform", _Conf.BASE_WEB_URL + "icons/addfoldericon.gif\" width=\"25\" height=\"16", target="")
    menu.set_searchlink(1)
    return menu.draw("""<TD id="1213" valign="top" style="display: none; padding: 1px;" nowrap>&nbsp;&nbsp;<IMG src="/web/icons/treeicon.gif" width="17" height="16" border="0" alt="">&nbsp;&nbsp;<a class="topmenu_link" href="#" onclick="document.getElementById('1213').style.display='none'; parent.document.getElementById('1212').cols='250,*';">%s</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>""" % REQUEST.TLS('doc_showtree'))

def get_document_tree_menu(REQUEST, MY_MENU_ID):
    menu = _Menu.Menu(REQUEST, MY_MENU_ID)
    menu.back_icon = 'treetopbg.gif'
    menu.add_item(REQUEST.TLS("compmenu_doc_tree"), _Conf.BASE_DOCUMENT_URL + "doctree.py", _Conf.BASE_WEB_URL + "icons/treeicon.gif\" width=\"17\" height=\"16", target="frametree")
    return menu.draw()

def get_todo_menu(REQUEST, MY_MENU_ID, NOBR = 0):
    menu = _Menu.Menu(REQUEST, MY_MENU_ID)
    menu.add_item(REQUEST.TLS("compmenu_todo_active"), _Conf.BASE_TODO_URL + "todoindex.py", _Conf.BASE_WEB_URL + "icons/tasks.gif\" width=\"18\" height=\"16")
    menu.add_item(REQUEST.TLS("compmenu_todo_all"), _Conf.BASE_TODO_URL + "todoindex.py?show_all=1", _Conf.BASE_WEB_URL + "icons/alltasks.gif\" width=\"24\" height=\"16")
    menu.add_item(REQUEST.TLS("tls_search"), _Conf.BASE_TODO_URL + "todosearch.py", _Conf.BASE_WEB_URL + "icons/searchicon.gif\" width=\"19\" height=\"16")
    menu.add_item(REQUEST.TLS("tls_add"), _Conf.BASE_TODO_URL + "todoadd.py", _Conf.BASE_WEB_URL + "icons/addicon.gif\" width=\"18\" height=\"16")
    menu.add_item(REQUEST.TLS("compmenu_todo_notes"), _Conf.BASE_TODO_URL + "notes.py", _Conf.BASE_WEB_URL + "icons/notes.gif\" width=\"18\" height=\"16")
    menu.set_searchlink(1)
    menu.set_nobr(NOBR)
    return menu.draw()

def get_contact_menu(REQUEST, MY_MENU_ID):
    menu = _Menu.Menu(REQUEST, MY_MENU_ID)
    menu.add_item(REQUEST.TLS("compmenu_contact_listmy"), _Conf.BASE_CONTACT_URL + "contactindex.py?only_mine=1", _Conf.BASE_WEB_URL + "icons/mycontacts.gif\" width=\"18\" height=\"16")
    menu.add_item(REQUEST.TLS("compmenu_contact_all"), _Conf.BASE_CONTACT_URL + "contactindex.py", _Conf.BASE_WEB_URL + "icons/allcontacts.gif\" width=\"20\" height=\"16")
    menu.add_item(REQUEST.TLS("tls_search"), _Conf.BASE_CONTACT_URL + "contactsearch.py", _Conf.BASE_WEB_URL + "icons/searchicon.gif\" width=\"19\" height=\"16")
    menu.add_item(REQUEST.TLS("tls_add"), _Conf.BASE_CONTACT_URL + "contactadd.py", _Conf.BASE_WEB_URL + "icons/addicon.gif\" width=\"18\" height=\"16")
    menu.add_item(REQUEST.TLS("compmenu_export_import"), _Conf.BASE_CONTACT_URL + "contactport.py", _Conf.BASE_WEB_URL + "icons/backups.gif\" width=\"18\" height=\"16")
    menu.set_searchlink(1)
    return menu.draw()

def get_email_menu(REQUEST, MY_MENU_ID, NOBR = 0):
    menu = _Menu.Menu(REQUEST, MY_MENU_ID)
    menu.add_item(REQUEST.TLS("compmenu_email_list"), _Conf.BASE_EMAIL_URL + "efolder1.py", _Conf.BASE_WEB_URL + "icons/emails.gif\" width=\"20\" height=\"16", target="top.topcontents.")
    menu.add_item(REQUEST.TLS("tls_search"), _Conf.BASE_EMAIL_URL + "esearch.py", _Conf.BASE_WEB_URL + "icons/searchicon.gif\" width=\"19\" height=\"16", target="top.topcontents.")
    menu.add_item(REQUEST.TLS("compmenu_email_compose"), _Conf.BASE_EMAIL_URL + "compose.py", _Conf.BASE_WEB_URL + "icons/compose.gif\" width=\"20\" height=\"16", target="top.topcontents.")
    menu.add_item(REQUEST.TLS("compmenu_email_settings"), _Conf.BASE_EMAIL_URL + "esettings.py?show=1", _Conf.BASE_WEB_URL + "icons/settings.gif\" width=\"19\" height=\"16", target="top.topcontents.")
    menu.add_item(REQUEST.TLS("compmenu_email_sync"), _Conf.BASE_EMAIL_URL + "efolder.py/sync", _Conf.BASE_WEB_URL + "icons/recieve.gif\" width=\"15\" height=\"16", target="top.topcontents.")
    menu.add_item(REQUEST.TLS("compmenu_email_filters"), _Conf.BASE_EMAIL_URL + "efilters.py", _Conf.BASE_WEB_URL + "icons/settings.gif\" width=\"19\" height=\"16", target="top.topcontents.")
    menu.set_searchlink(0)
    menu.set_nobr(NOBR)
    return menu.draw()

def get_discussion_menu(REQUEST, MY_MENU_ID):
    if REQUEST.USER.get_id() == _Conf.SUPERUSER:
        is_superuser = 1
    else:
        top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
        if REQUEST.USER.get_id() == top_parent.get('superuser_id'):
            is_superuser = 1
        else:
            is_superuser = 0
    menu = _Menu.Menu(REQUEST, MY_MENU_ID)
    menu.add_item(REQUEST.TLS("tls_list"), _Conf.BASE_DISCUSSION_URL + "discindex.py", _Conf.BASE_WEB_URL + "icons/disclist.gif\" width=\"20\" height=\"16")
    menu.add_item(REQUEST.TLS("tls_search"), _Conf.BASE_DISCUSSION_URL + "discsearch.py", _Conf.BASE_WEB_URL + "icons/searchicon.gif\" width=\"19\" height=\"16")
    menu.add_item(REQUEST.TLS("tls_add"), _Conf.BASE_DISCUSSION_URL + "discadd.py", _Conf.BASE_WEB_URL + "icons/addicon.gif\" width=\"18\" height=\"16")
    if is_superuser:
        menu.add_item(REQUEST.TLS("compmenu_disc_mancat"), _Conf.BASE_DISCUSSION_URL + "catadd.py", _Conf.BASE_WEB_URL + "icons/discmanage.gif\" width=\"20\" height=\"16")
    menu.set_searchlink(1)
    return menu.draw()

def get_frontpage_menu(REQUEST, MY_MENU_ID):
    if REQUEST.USER.get_id() == _Conf.SUPERUSER:
        is_superuser = 1
    else:
        top_parent = REQUEST.USER.get_parent(REQUEST).get_top_parent()
        if REQUEST.USER.get_id() == top_parent.get('superuser_id'):
            is_superuser = 1
        else:
            is_superuser = 0
    menu = _Menu.Menu(REQUEST, MY_MENU_ID)
    menu.add_item(REQUEST.TLS("tls_overview"), _Conf.BASE_URL + "frontpage.py", _Conf.BASE_WEB_URL + "icons/overview.gif\" width=\"22\" height=\"16")
    menu.add_item(REQUEST.TLS("tls_links"), _Conf.BASE_URL + "links.py", _Conf.BASE_WEB_URL + "icons/links.gif\" width=\"20\" height=\"16")
    menu.add_item(REQUEST.TLS("tls_search"), _Conf.BASE_URL + "search.py", _Conf.BASE_WEB_URL + "icons/searchicon.gif\" width=\"19\" height=\"16")
    if is_superuser:
        menu.add_item(REQUEST.TLS("tls_manage"), _Conf.BASE_URL + "frontmanage.py", _Conf.BASE_WEB_URL + "icons/settings.gif\" width=\"19\" height=\"16")
    if REQUEST.USER.get_id() == _Conf.SUPERUSER:
        menu.add_item(REQUEST.TLS("compmenu_admin_news"), _Conf.BASE_ADMIN_URL + "news.py", _Conf.BASE_WEB_URL + "icons/news.gif\" width=\"18\" height=\"16", target="")
    menu.set_searchlink(1)
    return menu.draw()
