# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

class MultiForm:
    def __init__(self, REQUEST):
        self.rows = {}

        for key in REQUEST.form.keys():
            if key[:4] == "form":
                first = key.find('_')
                second = key.find('_', first+1)
                try:
                    row_id, key_id = int(key[first+1:second]), key[second+1:]
                except ValueError: # Int and key are switched around
                    key_id, row_id = key[first+1:second], int(key[second+1:])
                if self.rows.has_key(row_id):
                    if isinstance(REQUEST.form[key], list):
                        self.rows[row_id][key_id] = map(lambda x: x.decode('UTF8'), REQUEST.form[key])
                    else:
                        self.rows[row_id][key_id] = REQUEST.form[key].value.decode('UTF8')
                else:
                    self.rows[row_id] = {}
                    if isinstance(REQUEST.form[key], list):
                        self.rows[row_id][key_id] = map(lambda x: x.decode('UTF8'), REQUEST.form[key])
                    else:
                        self.rows[row_id][key_id] = REQUEST.form[key].value.decode('UTF8')

    def get_rows(self):
        rows = []
        for (key, item) in self.rows.items():
            row = {}
            for (rowkey, rowitem) in item.items():
                row[rowkey] = rowitem
            rows.append(row)
        return rows
