# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

import _Utils

def generate_search(REQUEST, item_class, form, tablename="o", banned_keys=[]):
    QUERY = ""
    objectkeys = item_class.object_fields.keys()
    itemkeys = item_class.item_fields.keys()
    for key in form.keys():
        value = form[key].value.decode('UTF8').lower()
        if key in banned_keys:
            continue
        if key in itemkeys and value:
            if item_class.item_fields[key]['type'] == _Utils.sql_cast_str:
                QUERY = QUERY + " AND lower(i.%s) like %s" % (key, item_class.item_fields[key]['type'](REQUEST, "%%%s%%" % value))
            else:
                QUERY = QUERY + " AND i.%s=%s" % (key, item_class.item_fields[key]['type'](REQUEST, value))
        if key in objectkeys and value:
            if item_class.object_fields[key]['type'] == _Utils.sql_cast_str:
                QUERY = QUERY + " AND lower(%s.%s) like %s" % (tablename, key, item_class.object_fields[key]['type'](REQUEST, "%%%s%%" % value))
            else:
                QUERY = QUERY + " AND %s.%s=%s" % (tablename, key, item_class.object_fields[key]['type'](REQUEST, value))
    return QUERY
