# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

from _ConfUser import *
from _ConfTZ import TIMEZONES, TIMEZONES_D

BASE_WEB_URL = BASE_URL + "web/"
BASE_ICON_URL = BASE_WEB_URL + "icons/"

BASE_ADMIN_URL = BASE_URL + "admin/"
BASE_CALENDAR_URL = BASE_URL + "calendar/"
BASE_DOCUMENT_URL = BASE_URL + "documents/"
BASE_TODO_URL = BASE_URL + "todo/"
BASE_CONTACT_URL = BASE_URL + "contacts/"
BASE_EMAIL_URL = BASE_URL + "email/"
BASE_GENERAL_URL = BASE_URL + "general/"
BASE_DISCUSSION_URL = BASE_URL + "discussions/"
BASE_WORKFLOWS_URL = BASE_URL + "workflows/"
BASE_HELP_URL = BASE_URL + "help/"
BASE_CLIENT_URL = BASE_URL + "clients/"
BASE_OPPORTUNITIES_URL = BASE_URL + "opportunities/"
BASE_PRODUCTS_URL = BASE_URL + "products/"
BASE_MESSENGER_URL = BASE_URL + "messenger/"
BASE_MESSAGES_URL = BASE_URL + "messages/"
BASE_TRANSLATION_URL = BASE_URL + "translation/"

BASE_EPOZ_URL = BASE_WEB_URL + 'epoz/'
BASE_EPOZ_IMG_URL = BASE_EPOZ_URL + 'img/'

ROOTOBJECT = 0
SUPERUSER = 1
ANONYMOUS = 2
SUPERUSER_NAME = 'superuser'
APP_NAME = "Conflux"
APP_EMAIL_NAME = APP_NAME.lower()

IS_MP_27 = 0
IS_MP_31 = 0
PLATFORM_WIN = 0

WEEK_DAYS = ["day_monday", "day_tuesday", "day_wednesday", "day_thursday", "day_friday", "day_saturday", "day_sunday"]

ENCODING = "UTF8"

TRANSLATION_PATH = BASE_PATH + "lib/LANG/"

REQ_FIELD = u"""<FONT color="red">*</FONT>"""

DEFAULT_BATCH = 20

LANGS = {
'en_US':'English (US)',
#'de_DE':'Deutsche',
'estonian':'Eesti',
'pt_PT':'Portugues',
}
DATES = {
'en_US':'English (US) - 24 hour',
'en_US_12':'English (US) - 12 hour',
'estonian':'European',
'ISO':'Standard ISO',
}
EMAIL_INLINE = ['jpg', 'jpe', 'jpeg', 'png', 'gif']
MIME_TYPES = {
'.txt':'mime_txt.gif',
'.csv':'mime_txt.gif',
'.php':'mime_txt.gif',
'.cfg':'mime_txt.gif',
'.ini':'mime_txt.gif',
'.js':'mime_txt.gif',
'.xml':'mime_txt.gif',
'.pdf':'mime_pdf.gif',
'.doc':'mime_doc.gif',
'.rtf':'mime_doc.gif',
'.xls':'mime_xls.gif',
'.zip':'mime_zip.gif',
'.rar':'mime_zip.gif',
'.tar':'mime_zip.gif',
'.gz':'mime_zip.gif',
'.tgz':'mime_zip.gif',
'.gzip':'mime_zip.gif',
'.rpm':'mime_zip.gif',
'.htm':'mime_html.gif',
'.html':'mime_html.gif',
'.bmp':'mime_img.gif',
'.gif':'mime_img.gif',
'.png':'mime_img.gif',
'.jpg':'mime_img.gif',
'.jpe':'mime_img.gif',
'.jpeg':'mime_img.gif',
'.psd':'mime_img.gif',
'.tif':'mime_img.gif',
'.tiff':'mime_img.gif',
'.pcx':'mime_img.gif',
'.pic':'mime_img.gif',
'.dwg':'mime_img.gif',
'.dwf':'mime_img.gif',
'.ico':'mime_img.gif',
'.ai':'mime_img.gif',
'.img':'mime_img.gif',
'.ppt':'mime_ppt.gif',
'.pps':'mime_ppt.gif',
'.mpe':'mime_vid.gif',
'.mpg':'mime_vid.gif',
'.mpeg':'mime_vid.gif',
'.wmp':'mime_vid.gif',
'.avi':'mime_vid.gif',
'.asf':'mime_vid.gif',
'.mov':'mime_vid.gif',
'.wav':'mime_wav.gif',
'.mp3':'mime_wav.gif',
'.wmf':'mime_wav.gif',
'.mid':'mime_wav.gif',
'.wma':'mime_wav.gif',
'.ogg':'mime_wav.gif',
'.sxw':'mime_sxw.gif',
'unknown_ext':'doc.gif',
}
from _ConfMessages import *
from _ConfMenu import *

countries_en_US = {
 'AD': 'Andorra',
 'AE': 'United Arab Emirates',
 'AF': 'Afghanistan',
 'AG': 'Antigua and Barbuda',
 'AI': 'Anguilla',
 'AL': 'Albania',
 'AM': 'Armenia',
 'AN': 'Netherlands Antilles',
 'AO': 'Angola',
 'AQ': 'Antarctica',
 'AR': 'Argentina',
 'AS': 'American Samoa',
 'AT': 'Austria',
 'AU': 'Australia',
 'AW': 'Aruba',
 'AX': '\xc5land Islands'.decode('ISO8859-1'),
 'AZ': 'Azerbaijan',
 'BA': 'Bosnia and Herzegovina',
 'BB': 'Barbados',
 'BD': 'Bangladesh',
 'BE': 'Belgium',
 'BF': 'Burkina Faso',
 'BG': 'Bulgaria',
 'BH': 'Bahrain',
 'BI': 'Burundi',
 'BJ': 'Benin',
 'BM': 'Bermuda',
 'BN': 'Brunei Darussalam',
 'BO': 'Bolivia',
 'BR': 'Brazil',
 'BS': 'Bahamas',
 'BT': 'Bhutan',
 'BV': 'Bouvet Island',
 'BW': 'Botswana',
 'BY': 'Belarus',
 'BZ': 'Belize',
 'CA': 'Canada',
 'CC': 'Cocos (Keeling) Islands',
 'CD': 'Congo, The Democratic Republic of The',
 'CF': 'Central African Republic',
 'CG': 'Congo',
 'CH': 'Switzerland',
 'CI': "C\xc3\xb4te D'ivoire".decode('UTF8'),
 'CK': 'Cook Islands',
 'CL': 'Chile',
 'CM': 'Cameroon',
 'CN': 'China',
 'CO': 'Colombia',
 'CR': 'Costa Rica',
 'CS': 'Serbia and Montenegro',
 'CU': 'Cuba',
 'CV': 'Cape Verde',
 'CX': 'Christmas Island',
 'CY': 'Cyprus',
 'CZ': 'Czech Republic',
 'DE': 'Germany',
 'DJ': 'Djibouti',
 'DK': 'Denmark',
 'DM': 'Dominica',
 'DO': 'Dominican Republic',
 'DZ': 'Algeria',
 'EC': 'Ecuador',
 'EE': 'Estonia',
 'EG': 'Egypt',
 'EH': 'Western Sahara',
 'ER': 'Eritrea',
 'ES': 'Spain',
 'ET': 'Ethiopia',
 'FI': 'Finland',
 'FJ': 'Fiji',
 'FK': 'Falkland Islands (Malvinas)',
 'FM': 'Micronesia, Federated States Of',
 'FO': 'Faroe Islands',
 'FR': 'France',
 'GA': 'Gabon',
 'GB': 'United Kingdom',
 'GD': 'Grenada',
 'GE': 'Georgia',
 'GF': 'French Guiana',
 'GH': 'Ghana',
 'GI': 'Gibraltar',
 'GL': 'Greenland',
 'GM': 'Gambia',
 'GN': 'Guinea',
 'GP': 'Guadeloupe',
 'GQ': 'Equatorial Guinea',
 'GR': 'Greece',
 'GS': 'South Georgia and The South Sandwich Islands',
 'GT': 'Guatemala',
 'GU': 'Guam',
 'GW': 'Guinea-Bissau',
 'GY': 'Guyana',
 'HK': 'Hong Kong',
 'HM': 'Heard Island and Mcdonald Islands',
 'HN': 'Honduras',
 'HR': 'Croatia',
 'HT': 'Haiti',
 'HU': 'Hungary',
 'ID': 'Indonesia',
 'IE': 'Ireland',
 'IL': 'Israel',
 'IN': 'India',
 'IO': 'British Indian Ocean Territory',
 'IQ': 'Iraq',
 'IR': 'Iran, Islamic Republic Of',
 'IS': 'Iceland',
 'IT': 'Italy',
 'JM': 'Jamaica',
 'JO': 'Jordan',
 'JP': 'Japan',
 'KE': 'Kenya',
 'KG': 'Kyrgyzstan',
 'KH': 'Cambodia',
 'KI': 'Kiribati',
 'KM': 'Comoros',
 'KN': 'Saint Kitts and Nevis',
 'KP': "Korea, Democratic People's Republic Of",
 'KR': 'Korea, Republic Of',
 'KW': 'Kuwait',
 'KY': 'Cayman Islands',
 'KZ': 'Kazakhstan',
 'LA': "Lao People's Democratic Republic",
 'LB': 'Lebanon',
 'LC': 'Saint Lucia',
 'LI': 'Liechtenstein',
 'LK': 'Sri Lanka',
 'LR': 'Liberia',
 'LS': 'Lesotho',
 'LT': 'Lithuania',
 'LU': 'Luxembourg',
 'LV': 'Latvia',
 'LY': 'Libyan Arab Jamahiriya',
 'MA': 'Morocco',
 'MC': 'Monaco',
 'MD': 'Moldova, Republic Of',
 'MG': 'Madagascar',
 'MH': 'Marshall Islands',
 'MK': 'Macedonia, The Former Yugoslav Republic Of',
 'ML': 'Mali',
 'MM': 'Myanmar',
 'MN': 'Mongolia',
 'MO': 'Macao',
 'MP': 'Northern Mariana Islands',
 'MQ': 'Martinique',
 'MR': 'Mauritania',
 'MS': 'Montserrat',
 'MT': 'Malta',
 'MU': 'Mauritius',
 'MV': 'Maldives',
 'MW': 'Malawi',
 'MX': 'Mexico',
 'MY': 'Malaysia',
 'MZ': 'Mozambique',
 'NA': 'Namibia',
 'NC': 'New Caledonia',
 'NE': 'Niger',
 'NF': 'Norfolk Island',
 'NG': 'Nigeria',
 'NI': 'Nicaragua',
 'NL': 'Netherlands',
 'NO': 'Norway',
 'NP': 'Nepal',
 'NR': 'Nauru',
 'NU': 'Niue',
 'NZ': 'New Zealand',
 'OM': 'Oman',
 'PA': 'Panama',
 'PE': 'Peru',
 'PF': 'French Polynesia',
 'PG': 'Papua New Guinea',
 'PH': 'Philippines',
 'PK': 'Pakistan',
 'PL': 'Poland',
 'PM': 'Saint Pierre and Miquelon',
 'PN': 'Pitcairn',
 'PR': 'Puerto Rico',
 'PS': 'Palestinian Territory, Occupied',
 'PT': 'Portugal',
 'PW': 'Palau',
 'PY': 'Paraguay',
 'QA': 'Qatar',
 'RE': 'R\xc9union'.decode('ISO8859-1'),
 'RO': 'Romania',
 'RU': 'Russian Federation',
 'RW': 'Rwanda',
 'SA': 'Saudi Arabia',
 'SB': 'Solomon Islands',
 'SC': 'Seychelles',
 'SD': 'Sudan',
 'SE': 'Sweden',
 'SG': 'Singapore',
 'SH': 'Saint Helena',
 'SI': 'Slovenia',
 'SJ': 'Svalbard and Jan Mayen',
 'SK': 'Slovakia',
 'SL': 'Sierra Leone',
 'SM': 'San Marino',
 'SN': 'Senegal',
 'SO': 'Somalia',
 'SR': 'Suriname',
 'ST': 'Sao Tome and Principe',
 'SV': 'El Salvador',
 'SY': 'Syrian Arab Republic',
 'SZ': 'Swaziland',
 'TC': 'Turks and Caicos Islands',
 'TD': 'Chad',
 'TF': 'French Southern Territories',
 'TG': 'Togo',
 'TH': 'Thailand',
 'TJ': 'Tajikistan',
 'TK': 'Tokelau',
 'TL': 'Timor-Leste',
 'TM': 'Turkmenistan',
 'TN': 'Tunisia',
 'TO': 'Tonga',
 'TR': 'Turkey',
 'TT': 'Trinidad and Tobago',
 'TV': 'Tuvalu',
 'TW': 'Taiwan, Province of China',
 'TZ': 'Tanzania, United Republic Of',
 'UA': 'Ukraine',
 'UG': 'Uganda',
 'UM': 'United States Minor Outlying Islands',
 'US': 'United States',
 'UY': 'Uruguay',
 'UZ': 'Uzbekistan',
 'VA': 'Holy See (Vatican City State)',
 'VC': 'Saint Vincent and The Grenadines',
 'VE': 'Venezuela',
 'VG': 'Virgin Islands, British',
 'VI': 'Virgin Islands, U.S.',
 'VN': 'Viet Nam',
 'VU': 'Vanuatu',
 'WF': 'Wallis and Futuna',
 'WS': 'Samoa',
 'YE': 'Yemen',
 'YT': 'Mayotte',
 'ZA': 'South Africa',
 'ZM': 'Zambia',
 'ZW': 'Zimbabwe'}

countries_estonian = countries_en_US
countries_de_DE = countries_en_US
countries_pt_PT = countries_en_US


stages_en_US = {
'':'',
'10':'Prospecting',
'20':'Needs Analysis',
'35':'Presentation/Demo',
'50':'Value Proposition',
'60':'Proposal/Price Quote',
'75':'Selected',
'90':'Negotiation',
'100':'Closed Won',
'0':'Closed Lost'}

stages_estonian = {
'':'',
'10':'Tutvumine',
'20':'Anal\xc3\xbc\xc3\xbcs'.decode('UTF8'),
'35':'Kvalifikatsioon',
'50':'Pakkumise ettevalmistus',
'60':'Hinnapakkumine',
'75':'Valitud',
'90':'L\xc3\xa4bir\xc3\xa4\xc3\xa4kimised'.decode('UTF8'),
'100':'V\xc3\xb5idetud'.decode('UTF8'),
'0':'Kaotatud'}
stages_de_DE = stages_en_US
stages_pt_PT = {
'':'',
'10':'Prospec\xc3\xa7\xc3\xa3o'.decode('UTF8'),
'20':'Necessita An\xc3\xa1lise'.decode('UTF8'),
'35':'Apresenta\xc3\xa7\xc3\xa3o/Demonstra\xc3\xa7\xc3\xa3o'.decode('UTF8'),
'50':'Preparar Proposta',
'60':'Proposta Enviada',
'75':'Selecccionado',
'90':'Negocia\xc3\xa7\xc3\xa3o'.decode('UTF8'),
'100':'Neg\xc3\xb3cio fechado'.decode('UTF8'),
'0':'Neg\xc3\xb3cio perdido'.decode('UTF8')}

LOG_TLS  = {
'create_time':'tls_createtime',
'edit_time':'tls_edittime',
'first_name':'tls_first_name',
'middle_name':'tls_middle_names',
'last_name':'tls_last_name',
'username':'admin_username',
'password':'login_password',
'phone_work':'tls_phone_work',
'phone_home':'tls_phone_home',
'phone_cell':'tls_phone_cell',
'phone_fax':'tls_phone_fax',
'e_mail':'tls_email',
'company':'contact_company',
'department':'contact_department',
'jobtitle':'contact_job',
'mailing_address':'clients_post_address',
'description':'tls_description',
'homepage':'contact_homepage',
'contact_category':'tls_category',
'birth_date':'contact_dateofbirth',
'contact_sex':'contact_sex',
'organization_name':'admin_orgname',
'address':'contact_address',
'city':'admin_city',
'state':'admin_state',
'zipcode':'admin_zipcode',
'country':'admin_country',
'website':'tls_website',
'email':'tls_email',
'telephone':'contact_tele',
'fax':'tls_phone_fax',
'event_name':'tls_subject',
'event_priority':'tls_priority',
'event_activity':'tls_activity',
'start_stamp':'cal_starttime',
'end_stamp':'cal_endtime',
'comments':'tls_comments',
'remind_type':'cal_repeattype',
'remind_time':'cal_remindtime',
'related_persons':'tls_workflow_related',
'repeat_interval':'cal_repeatinterval',
'dayofweek':'cal_onthe',
'dayofmonth':'cal_repmonthstr',
'monthofyear':'cal_onmonth',
'repeat_type':'cal_repeattype',
'related_groups':'cal_relgroups',
'filename':'doc_filename',
'title':'tls_title',
'author':'tls_author',
'doc_category':'tls_category',
'locker_id':'doc_lockedby',
'lock_due':'doc_lockeduntil',
'status':'tls_status',
'priority':'tls_priority',
'category':'tls_category',
'percent_complete':'todo_percentcomplete',
'start_time':'todo_starttime',
'due_time':'todo_duetime',
'workflow_title':'tls_title',
'workflow_description':'tls_description',
'workflow_start_time':'todo_starttime',
'workflow_due_time':'todo_duetime',
'client_name':'clients_name',
'client_nr':'clients_number',
'registry_code':'clients_regcode',
'client_type':'clients_type',
'client_field':'clients_area',
'client_rating':'clients_rating',
'client_ownership':'clients_ownership',
'vat_nr':'clients_kmkr',
'mail_address':'clients_post_address',
'legal_address':'clients_reg_address',
'bank_reqs':'clients_bank_info',
'opp_name':'log_opp_id',
'opp_stage':'opp_probability',
'opp_next_stage':'opp_nextstep',
'req_descr':'opp_req_desc',
'amount':'opp_amount',
'close_date':'opp_date',
'opp_lost':'opp_lost_reason',
'lead_source':'opp_source',
'product_name':'log_product_id',
'product_group':'prod_group',
'product_unit':'prod_unit',
'product_price':'prod_price',
}
