# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

import _RootObject, _Utils
import _InitTypes

import os

class DiscCategory(_RootObject.RootObject):
    table_name = 'disccategories'
    field_name = 'disccategory_id'
    item_type_id = _InitTypes.ITEM_TYPE_DISCCATEGORY
    is_container = 1
    object_fields = {
'disccategory_id':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 0,	 'has_default': 1,       'can_insert': 0 },
'disccategory_name':	{ 'type': _Utils.sql_cast_str,	'simple_type': str,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
    }

    fti_keys = ['disccategory_name']

    def get_name(self):
        if self.get('disccategory_name') is not None:
            return self.get('disccategory_name')
        elif self.get_id() is None:
            return self.REQUEST.TLS('disccatobj_notsaved')
        else:
            return self.REQUEST.TLS('disccatobj_noname') % self.get_id()
