# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

import _RootObject, _Utils
import _InitTypes

# _flags bits
EACCOUNT_NONE = 0
EACCOUNT_POP3 = 1
EACCOUNT_IMAP4 = 2
EACCOUNT_ACTIVE = 4
EACCOUNT_DELETE_MESSAGES = 8

class Eaccount(_RootObject.RootObject):
    table_name = 'eaccounts'
    field_name = 'eaccount_id'
    item_type_id = _InitTypes.ITEM_TYPE_EACCOUNT
    is_container = 0
    object_fields = {
'eaccount_id':	 { 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 0,	'has_default': 1,       'can_insert': 0 },
'eaccount_name': { 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'eaccount_user': { 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'eaccount_password': { 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'eaccount_flags':{ 'type': _Utils.sql_cast_int,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 1,       'can_insert': 1 },
    }

    def get_name(self):
        if self.get('eaccount_name') is not None:
            return self.get('eaccount_name')
        elif self.get_id() is None:
            return self.REQUEST.TLS('eaccountobj_notsaved')
        else:
            return self.REQUEST.TLS('eaccount_noname') % self.get_id()
