# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

import exceptions

class BaseError(exceptions.StandardError):
    pass

###
# Core errors
###

class PleaseAuthenticate(BaseError):
    pass

class SystemExpired(BaseError):
    pass

class InvalidVariable(BaseError):
    pass

class RootObjectError(BaseError):
    pass

class AccessError(BaseError):
    pass

class IndexerError(BaseError):
    pass

class RequestError(BaseError):
    pass

###
# Object errors
###

class OrganizationError(BaseError):
    pass

class FolderError(BaseError):
    pass

class DocumentError(BaseError):
    pass

###
# Component errors
###

class AdminError(BaseError):
    pass

class CalendarError(BaseError):
    pass

###
# DAV
###

class DAV_noshow(BaseError):
    pass

class DAV_notimpl(BaseError):
    pass

