# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

import _Conf, _RootObject, _Utils, _DBSpool_utils
import mx.DateTime

def standard_log_output(REQUEST, obj_id):
    output = []
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_show_det = REQUEST.TLS('log_show_det')
    tls_hide_det = REQUEST.TLS('log_hide_det')
    tls_showall = REQUEST.TLS('log_show_all')
    tls_hideall = REQUEST.TLS('log_hide_all')
    tls_log = REQUEST.TLS('log_log')
    tls_nolog = REQUEST.TLS('log_nolog')
    SQL = """SELECT i.*, p.first_name || ' ' || p.last_name as creator_name FROM item_log i, persons p WHERE i.item_id=%d and i.person_id=p.person_id AND (i.log_flags & %d) = 0 AND (i.log_flags & %d) = 0 order by i.batch_id desc, i.field_name asc""" % (int(obj_id), _RootObject.LOG_INSERT, _RootObject.LOG_DELETE)
    REQUEST.db.execute(SQL)
    dbres = REQUEST.db.dictfetchall()
    REQUEST.db.execute("""SELECT i.item_name from items i where i.item_id=%d""" % int(obj_id))
    item_name = _Utils.html_quote_show(REQUEST.db.fetchone()[0].decode('UTF8'))
    LOG_TLS = _Conf.LOG_TLS
    forbidden_list = ['editor_id','editor_ip','edit_time','related_persons','picture','parent_id','treepos','superuser_id','seen_persons','accepted_persons','rejected_persons','last_reminder','event_flags','mime_major','mime_minor','final_version_id','workflow_sequence_id','is_internal','index_this_item', 'item_name']
    dispatch_items = ['creator_id','editor_id','person_id','owner_id','contact_id','organization_id','event_id','document_id','locker_id','todo_id','workflow_id','client_id','product_id','opp_id']
    mxtype = type(mx.DateTime.now())
    if not dbres:
      output.append(u"""

<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
<TR class="tr_listing1">
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1b" width="50%%" nowrap>%(tls_nolog)s</TD>
  <TD class="td_listing1" width="20%%" nowrap align="right">&nbsp;</TD>
  <TD width="30%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
    """ % locals())
    else:
      output.append(u"""
<script type="text/javascript">
function chan(numb)
{
  el = document.getElementById(numb);
  bnumb = "b" + numb;
  el2 = document.getElementById(bnumb);
  if(el.style.display=="none")
  {
    el2.value="%(tls_hide_det)s";
    el.style.display="block";
  }
  else
  {
    el2.value="%(tls_show_det)s";
    el.style.display="none";
  }
}
function chan_all()
{
  var tables = document.getElementsByTagName("table");
  var btns = document.getElementsByName("button1");
  show = document.getElementById("4202");
  show_all = document.getElementById("4203")
  if(show.value=="1")
    show_all.value="%(tls_hideall)s";
  else
    show_all.value="%(tls_showall)s";
  for (var i = 0; i < tables.length; i++)
  {
     var tbl = tables.item(i);
     if(show.value=="1" && tbl.style.display=="none")
     {
         tbl.style.display = "block";
     }
     else if(show.value=="0" && tbl.style.display=="block")
     {
         tbl.style.display = "none";
     }
  }
  for (var i = 0; i < btns.length; i++)
  {
    var btn = btns.item(i);
    if(show.value=="1")
    {
       btn.value="%(tls_hide_det)s";
    }
    else
    {
       btn.value="%(tls_show_det)s";
    }
  }
  if(show.value=="1")
    show.value=0;
  else
    show.value=1;
}
</script>
<input type="hidden" name="show_hide" value="1" id="4202">
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0">
<TR class="tr_listing1">
  <TD class="td_listing1"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=20 border=0 alt=""></TD>
  <TD class="td_listing1b" width="50%%" nowrap>%(tls_log)s: %(item_name)s</TD>
  <TD class="td_listing1" width="20%%" nowrap align="right"><input id="4203" class="input6" type="button" value="%(tls_showall)s" onclick="chan_all();"></TD>
  <TD width="30%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
    """ % locals())
    old_batch=0
    index = 0
    index2 = 0
    for row in dbres:
        if row['field_name'] in forbidden_list:
            continue
        row['BASE_ICON_URL'] = _Conf.BASE_ICON_URL
        if row['batch_id']<>old_batch:
            index = 0
            if index2%2==1:
                row['bgcol'] = "#FFFFFF";
            else:
                row['bgcol'] = "#FFFFFF";
            index2+=1
            row['tls_show_det'] = tls_show_det
            row['change_time'] = REQUEST.iso2userdatetime(REQUEST, row['change_time'])
            row['tls_mod'] = REQUEST.TLS('log_mod_by')
            row['tls_mod_time'] = REQUEST.TLS('log_mod_time')
            row['tls_field'] = REQUEST.TLS('log_field')
            row['tls_oldval'] = REQUEST.TLS('log_oldval')
            row['tls_newval'] = REQUEST.TLS('log_newval')
            row['creator_name'] = row['creator_name'].decode('UTF8')
            output.append(u"""\
</TABLE>
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0" style="border-top: 1px solid black;">
<TR style="background-color: %(bgcol)s;">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_list" width="25%%" nowrap><b>%(tls_mod)s:</b> %(creator_name)s</TD>
  <TD class="td_list" width="25%%" nowrap><b>%(tls_mod_time)s:</b> %(change_time)s</TD>
  <TD class="td_list" width="20%%" nowrap align="right"><input name="button1" class="input6" id="b%(batch_id)s" type="button" value="%(tls_show_det)s" onclick="chan(%(batch_id)s);"></TD>
  <TD width="30%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0" style="display: none; min-width: 100%%;" id="%(batch_id)s" name="hide">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=230 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=230 height=1 border=0 alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=230 height=1 border=0 alt=""></TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
<TR class="tr_listing1">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing1b">%(tls_field)s</TD>
  <TD class="td_listing1b">%(tls_oldval)s</TD>
  <TD class="td_listing1b">%(tls_newval)s</TD>
  <TD width="100%%"><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % row)
        
        old_batch = row['batch_id']
        if LOG_TLS.has_key(row['field_name']):
            row['field_name_tls'] = REQUEST.TLS(LOG_TLS[row['field_name']])
        else:
            try:
                row['field_name_tls'] = REQUEST.TLS('log_'+str(row['field_name']))
            except:
                row['field_name_tls'] = row['field_name']
        if row['field_name'] in dispatch_items:
            REQUEST.su_by_id(_Conf.SUPERUSER)
            try:
                row['old_value'] = eval(row['old_value'])
                row['new_value'] = eval(row['new_value'])
                if row['old_value']:
                    try:
                        old_item = _RootObject.dispatch_item(REQUEST, int(row['old_value']))
                        row['old_value'] = old_item.get('item_name')
                    except:
                        row['old_value'] = REQUEST.TLS('tls_deleteditem') + " : " + str(row['old_value'])
                if row['new_value']:
                    try:
                        new_item = _RootObject.dispatch_item(REQUEST, int(row['new_value']))
                        row['new_value'] = new_item.get('item_name')
                    except:
                        row['old_value'] = REQUEST.TLS('tls_deleteditem') + " : " + str(row['new_value'])
            except:
                raise
                row['old_value'] = eval(row['old_value'])
                row['new_value'] = eval(row['new_value'])
            REQUEST.unsu()
        else:
            row['old_value'] = eval(row['old_value'])
            row['new_value'] = eval(row['new_value'])
        if isinstance(row['old_value'], unicode):
           row['old_value'] = _Utils.html_quote(row['old_value'])
        if isinstance(row['new_value'], unicode):
           row['new_value'] = _Utils.html_quote(row['new_value'])
        if row['old_value'] is None or row['old_value']=="None" :
            row['old_value'] = "&nbsp;"
        if row['new_value'] is None or row['new_value']=="None":
            row['new_value'] = "&nbsp;"
        if isinstance(row['old_value'],float):
            row['old_value'] = "%.2f" % row['old_value']
        if isinstance(row['new_value'],float):
            row['new_value'] = "%.2f" % row['new_value']
        if isinstance(row['old_value'], mxtype):
            row['old_value'] = "%s" % REQUEST.iso2userdatetime(REQUEST, row['old_value'])
        if isinstance(row['new_value'], mxtype):
            row['new_value'] = "%s" % REQUEST.iso2userdatetime(REQUEST, row['new_value'])
        if index%2==0:
           row['cl'] = "0"
        else:
           row['cl'] = "1"
        index = index + 1
        output.append(u"""\
<TR class="tr_listing%(cl)s">
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
  <TD class="td_listing%(cl)s">%(field_name_tls)s</TD>
  <TD class="td_listing%(cl)s">%(old_value)s</TD>
  <TD class="td_listing%(cl)s">%(new_value)s</TD>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>""" % row)
    
    output.append(u"""\
</TABLE>
<TABLE border="0" width="100%%" cellpadding="0" cellspacing="0" style="border-top: 1px solid black;">
<TR>
  <TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
</TR>
</TABLE>
""")
    return "\n".join(output)


def status_log_output(REQUEST, obj_id):
    output = []
    SQL = """SELECT i.*, p.first_name || ' ' || p.last_name as creator_name FROM item_log i, persons p WHERE i.item_id=%d and i.person_id=p.person_id AND (i.log_flags & %d) = 0 order by i.batch_id asc""" % (int(obj_id), _RootObject.LOG_DELETE)
    REQUEST.db.execute(SQL)
    dbres = REQUEST.db.dictfetchall()
    if dbres:
        filtered_list = []
        good_batches = []
        for row in dbres:
            if row['field_name'] == "opp_stage":
                good_batches.append(row['batch_id'])
        temp_dict = {}
        old_batch = 0
        for row in dbres:
            batch_id = row['batch_id']
            if batch_id in good_batches:
                if old_batch and old_batch<> batch_id:
                    if temp_dict:
                        filtered_list.append(temp_dict)
                        temp_dict = {}
                if row['field_name']=="opp_stage":
                    temp_dict['opp_stage']=row['new_value']
                    temp_dict['change_time']=row['change_time']
                    temp_dict['person_id'] = row['person_id']
            old_batch = batch_id
        if temp_dict:
            filtered_list.append(temp_dict)
        if filtered_list:
            user_lang=REQUEST.get_setting("user_language")
            clist = "_Conf.stages_" + user_lang
            stages = eval(clist)
            tls_date = REQUEST.TLS('tls_date')
            tls_stage = REQUEST.TLS('opp_stage')
            tls_prob = REQUEST.TLS('opp_probability')
            tls_mod = REQUEST.TLS('log_mod_by')
            output.append(u"""
<TABLE border=0 cellpadding="0" cellspacing="1" bgcolor="#AAAAAA" align="center">
<TR>
  <TD class="td_listing1b" align="center">%(tls_date)s</TD>
  <TD class="td_listing1b" align="center">%(tls_stage)s</TD>
  <TD class="td_listing1b" align="center">%(tls_prob)s</TD>
  <TD class="td_listing1b" align="center">%(tls_mod)s</TD>
</TR>""" % locals())
            for row in filtered_list:
                date = REQUEST.iso2userdate(row['change_time'])
                opp_stage = str(row['opp_stage'])
                status = stages[opp_stage]
                if opp_stage:
                    probability = str(opp_stage) + "%"
                REQUEST.su_by_id(_Conf.SUPERUSER)
                try:
                    editor = _RootObject.dispatch_item(REQUEST, int(row['person_id']))
                    editor_name = editor.get('item_name')
                except:
                    editor_name = "N/A"
                REQUEST.unsu()
                output.append(u"""
<TR>
  <TD class="td_listing0" align="center">%(date)s</TD>
  <TD class="td_listing0" align="center">%(status)s</TD>
  <TD class="td_listing0" align="center">%(probability)s</TD>
  <TD class="td_listing0" align="center">%(editor_name)s</TD>
</TR>""" % locals())
            output.append(u"""</TABLE>""")
            return "\n".join(output)
        else:
            return ""
    else:
        return ""
