# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

import _RootObject, _Utils
import _InitTypes

class Todo(_RootObject.RootObject):
    table_name = 'todos'
    field_name = 'todo_id'
    item_type_id = _InitTypes.ITEM_TYPE_TODO
    is_container = 0
    object_fields = {
'todo_id':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 0,	'has_default': 1,       'can_insert': 0 },
'related_persons':	{ 'type': _Utils.sql_cast_array,	'simple_type': list,	'null': 0,	'can_set': 1,	'has_default': 1,       'can_insert': 1 },
'seen_persons':		{ 'type': _Utils.sql_cast_array,	'simple_type': list,	'null': 0,	'can_set': 1,	'has_default': 1,       'can_insert': 1 },
'accepted_persons':	{ 'type': _Utils.sql_cast_array,	'simple_type': list,	'null': 0,	'can_set': 1,	'has_default': 1,       'can_insert': 1 },
'rejected_persons':	{ 'type': _Utils.sql_cast_array,	'simple_type': list,	'null': 0,	'can_set': 1,	'has_default': 1,       'can_insert': 1 },
'title':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 0,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'percent_complete':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 0,	'can_set': 1,	'has_default': 1,       'can_insert': 1 },
'start_time':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'due_time':	{ 'type': _Utils.sql_cast_str,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'priority':	{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'description':	{ 'type': _Utils.sql_cast_str_hidenull,	'simple_type': unicode,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'workflow_id':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
'workflow_sequence_id':	{ 'type': _Utils.sql_cast_int,	'simple_type': int,	'null': 1,	'can_set': 1,	'has_default': 0,       'can_insert': 1 },
    }

    fti_keys = ['title','description','comments', 'priority']

    def get_name(self):
        if self.get('title') is not None:
            return self.get('title')
        elif self.get_id() is None:
            return self.REQUEST.TLS('todoobj_notsaved')
        else:
            return self.REQUEST.TLS('todoobj_noname') % self.get_id()
    
    def save(self):
        _RootObject.RootObject.save(self)
