# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

import mx.DateTime
import _Conf, _Utils, _Access, _InitTypes, random

from cCore import *

def mini_calendar(REQUEST, data, self_link, cal_link, type=1):
    ###
    # Right menu stuff
    ###
    try:
        show_users = REQUEST.get_setting('cal_show_users')
    except:
        show_users = None
    try:
        show_resources = REQUEST.get_setting('cal_show_resources')
    except:
        show_resources = None
    output = []
    today = _Utils.utc2local_mx(REQUEST, _Utils.utc_now_mx())
    if not data:
      data = DayHandler(REQUEST, show_users=show_users, show_resources=show_resources)
    next_year = '%04d-%02d-01' % (data.year + 1, data.month)
    previous_year = '%04d-%02d-01' % (data.year - 1, data.month)
    if data.month == 1: previous_month = '%04d-%02d-01' % (data.year - 1, 12)
    else: previous_month = '%04d-%02d-01' % (data.year, data.month-1)
    if data.month == 12: next_month = '%04d-%02d-01' % (data.year + 1, 1)
    else: next_month = '%04d-%02d-01' % (data.year, data.month+1)
    month_name = "%s %d" % (REQUEST.TLS('month_%d' % data.month), data.year)
    BASE_CALENDAR_URL = _Conf.BASE_CALENDAR_URL

    tls_nextmonth = REQUEST.TLS('cal_nextmonth')
    tls_nextyear = REQUEST.TLS('cal_nextyear')
    tls_lastyear = REQUEST.TLS('cal_lastyear')
    tls_lastmonth = REQUEST.TLS('cal_lastmonth')
    tls_1 = REQUEST.TLS('cal_short_1')
    tls_2 = REQUEST.TLS('cal_short_2')
    tls_3 = REQUEST.TLS('cal_short_3')
    tls_4 = REQUEST.TLS('cal_short_4')
    tls_5 = REQUEST.TLS('cal_short_5')
    tls_6 = REQUEST.TLS('cal_short_6')
    tls_7 = REQUEST.TLS('cal_short_7')
    tls_birthdays = REQUEST.TLS('tls_birthdays')

    BASE_ICON_URL = _Conf.BASE_ICON_URL
    output.append(u"""\
<TD><img src="%(BASE_ICON_URL)sspacer.gif" width=10 height=1 border=0 alt=""></TD>
<TD style="vertical-align: top; text-align: center; border: none">
<CENTER>
<TABLE width="100%%" cellpadding=4 cellspacing=0 border=0 bgcolor="#FFFFFF" style="border: 1px solid #AAAAAA">
<TR bgcolor="#609700">
  <TD><A href="%(BASE_CALENDAR_URL)s%(self_link)s?date=%(previous_year)s" class="minical_hdr" title="%(tls_lastyear)s">-</A></TD>
  <TD nowrap colspan="5" class="minical_hdr" align="center"><A href="%(BASE_CALENDAR_URL)s%(self_link)s?date=%(previous_month)s" class="minical_hdr" title="%(tls_lastmonth)s">&laquo;</A> %(month_name)s <A href="%(BASE_CALENDAR_URL)s%(self_link)s?date=%(next_month)s" class="minical_hdr" title="%(tls_nextmonth)s">&raquo;</A></TD>
  <TD><A href="%(BASE_CALENDAR_URL)s%(self_link)s?date=%(next_year)s" class="minical_hdr" title="%(tls_nextyear)s">+</A></TD>
</TR>
<TR bgcolor="#7BC300">
  <TD class="minical_day_hdr">%(tls_1)s</TD>
  <TD class="minical_day_hdr">%(tls_2)s</TD>
  <TD class="minical_day_hdr">%(tls_3)s</TD>
  <TD class="minical_day_hdr">%(tls_4)s</TD>
  <TD class="minical_day_hdr">%(tls_5)s</TD>
  <TD class="minical_hday_hdr">%(tls_6)s</TD>
  <TD class="minical_hday_hdr">%(tls_7)s</TD>
</TR>""" % locals())

    for week in data.calendar:
        output.append(u"""<TR bgcolor="#FFFFFF">""")
        for i in range(7):
            day = week[i]
            if day == data.day:
                ms = ' background-color: #7BC300;'
            else:
                ms = ''
            if data.year == today.year and data.month == today.month and day == today.day:
                bs = ' background-color: #B2F63D;'
            else:
                bs = ''
            if day == 0:
                output.append(u"""<TD>&nbsp;</TD>""" )
            elif i == 5 or i == 6:
                data_year = data.year
                data_month = data.month
                output.append(u"""<TD class="minical_day" style="%(ms)s%(bs)s"><A style=" color: red;" href="%(BASE_CALENDAR_URL)s%(cal_link)s?date=%(data_year)04d-%(data_month)02d-%(day)02d">%(day)d</A></TD>""" % locals())
            else:
                data_year = data.year
                data_month = data.month
                output.append(u"""<TD class="minical_day" style="%(ms)s%(bs)s"><A style=" color: black;" href="%(BASE_CALENDAR_URL)s%(cal_link)s?date=%(data_year)04d-%(data_month)02d-%(day)02d">%(day)d</A></TD>""" % locals())
        output.append(u"""</TR>""")
    output.append(u"""</TABLE></CENTER>""")

    if type==1:
        output.append(u"""\
    <TABLE border=0 align=center>
    <FORM action="%sday.py" method="POST">
    <INPUT type="hidden" name="date" value="%04d-%02d-%02d">
      <TR>
        <TD align=center><BR><B>%s</B>:""" % (_Conf.BASE_CALENDAR_URL, data.year, data.month, data.day, REQUEST.TLS('cal_users')))
        if show_users or show_resources:
            output.append("""\
          <IMG src="%sspacer.gif" width=1 height=4 border=0 alt=""><br>
          <IMG src="%sspacer.gif" width=1 height=4 border=0 alt=""><br>
          <INPUT TYPE="submit" class="input1" name="show_users" value="%s"><BR>
          <IMG src="%sspacer.gif" width=1 height=2 border=0 alt=""><br>""" % (_Conf.BASE_ICON_URL, _Conf.BASE_ICON_URL, REQUEST.TLS('cal_onlymine'), _Conf.BASE_ICON_URL))
        else:
            output.append(u"""<br>""")  
        output.append(u"""<INPUT TYPE="submit" class="input1" name="show_users_list" value="%s">
        </TD>
      </TR>
    </FORM>
    </TABLE>""" % REQUEST.TLS('cal_selusers'))
        

        BASE_ICON_URL=_Conf.BASE_ICON_URL
        tls_legend = REQUEST.TLS('cal_legend')
        tls_myevent = REQUEST.TLS('cal_myevent')
        tls_relatedevent = REQUEST.TLS('cal_related_event')
        tls_otherevent = REQUEST.TLS('cal_other_event')
        tls_groupevent = REQUEST.TLS('cal_group_event')
        tls_resourceevent = REQUEST.TLS('cal_resource_event')
        output.append(u"""\
    &nbsp;<BR>
    <TABLE border=0 cellpadding=0 cellspacing=4 width="100%%" style="border: 2px dashed #AAAAAA">
      <TR>
        <TD colspan=2><IMG src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
      </TR>
      <TR>
        <TD colspan=2><b>%(tls_legend)s:</b></TD>
      </TR>
      <TR>
        <TD colspan=2><IMG src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
      </TR>
      <TR>
        <TD colspan=2 width="100%%" class="week_my" align="center">%(tls_myevent)s</TD>
      </TR>
      <TR>
        <TD colspan=2 width="100%%" class="week_rel" align="center">%(tls_relatedevent)s</TD>
      </TR>
      <TR>
        <TD colspan=2 width="100%%" class="week_notrel" align="center">%(tls_otherevent)s</TD>
      </TR>
      <TR>
        <TD colspan=2 width="100%%" class="week_group" align="center">%(tls_groupevent)s</TD>
      </TR>
      <TR>
        <TD colspan=2 width="100%%" class="week_res" align="center">%(tls_resourceevent)s</TD>
      </TR>
      <TR>
        <TD colspan=2><IMG src="%(BASE_ICON_URL)sspacer.gif" width=1 height=1 border=0 alt=""></TD>
      </TR>
    </TABLE>
    """ % locals())
        right_param = _Access.select_param(REQUEST.USER.get_id(), _Access.ACCESS_READ, [_InitTypes.ITEM_TYPE_CONTACT])
        if right_param:
            right_param = " AND " + right_param
        SQL = """select c.first_name || ' ' || c.last_name as name, c.birth_date from contacts c, items i where c.contact_id=i.item_id and extract(month from age(birth_date))::int = 11 and extract(day from age(birth_date))::int >= 20 %s order by date_part('month', birth_date) asc, date_part('day', birth_date) asc, contact_id""" % right_param
        REQUEST.db.execute(SQL.encode('UTF8'))
        dbres = REQUEST.db.dictfetchall()
        if dbres:
            if int(str(random.random())[2])>4:
                n = 2
            else:
                n = 1
            output.append(u"""
&nbsp;<BR>
<TABLE border="0" cellpadding="0" cellspacing="0" width="100%%" class="text11" style="border: 2px dashed #2BA10B;">
  <TR>
    <TD colspan="2" align="left" class="pad2" style="line-height: 18px;"><img src="%(BASE_ICON_URL)sico_birthday%(n)s.gif" width="18" height="18" border="0" alt="" style="vertical-align: bottom">&nbsp;&nbsp;<b>%(tls_birthdays)s:</b></TD>
  </TR>""" % locals())
            for row in dbres:
                name = row['name'].decode('UTF8')
                day = row['birth_date'].day
                mon = REQUEST.TLS('month_name_%02d' % row['birth_date'].month)
                output.append(u"""
  <TR>
    <TD style="padding: 2px;" nowrap>%(day)s. %(mon)s</TD>
    <TD width="100%%" style="padding: 3px;" align="left">%(name)s</TD>
  </TR>""" % locals())
        output.append(u"""</TD><TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width=2 height=1 border=0 alt=""></TD>""" % locals())
    return "\n".join(output)
