# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

import base64, poplib, imaplib, email, email.Iterators, email.Errors, email.MIMEMultipart, email.Header, email.MIMEText, email.Utils, MIMEFile, md5
import mx.DateTime, smtplib, urllib, uu
from cStringIO import StringIO
import _Conf, _InitTypes, _Email, _Utils, standard_html, _Efolder, _Eaccount, _RootObject
from Menus import get_email_menu
import libsms, _Event, cPickle, re

def message_from_string(data):
    obj = email.message_from_string(data)
    rebuild_msg_uudecode(obj)
    return obj

def rebuild_msg_uudecode(obj, parent=None, parentofparent=None, level=0):
    payload = obj.get_payload()
    if isinstance(payload, list):
        for child in payload:
            rebuild_msg_uudecode(child, obj, parent, level+1)
    elif obj.get_content_type() == 'text/plain':
        uu_check(parent, obj, parentofparent)
    else:
        return

def uu_check(parent, child, parentofparent):
    if child.get_content_type() <> 'text/plain' or parent is None:
        return
    if child.get_payload(decode=1) is None:
        return
    START = child.get_payload(decode=1).find('begin 666')
    if START <> -1:
        END = child.get_payload(decode=1).find('end', START) + 3
        if END <> -1:
            N = child.get_payload(decode=1)[START:END]
            fp1 = StringIO(N)
            fp1.seek(0)
            fp2 = StringIO()
            F = uu.decode(fp1, fp2)
            fp1.close()
            fp2.seek(0)
            newchild = MIMEFile.MIMEFile(fp2.read(), N[:N.find('\n')][10:])
            fp2.close()
            if parent.get_content_maintype() == 'multipart': # Simply add a new attachment
                parent.attach(newchild)
            if parent.get_content_type() == 'message/rfc822': # Create multipart under parent
                container = email.MIMEMultipart.MIMEMultipart()
                container.set_payload(parent.get_payload())
                container.attach(newchild)
                parent.set_payload([container])
            elif parentofparent: # Create multipart under paretnt
                container = email.MIMEMultipart.MIMEMultipart()
                container.set_payload(parentofparent.get_payload())
                container.attach(newchild)
                parentofparent.set_payload([container])
            else: # no other way, do a hack
                parent.attach(newchild)
            child.set_payload(child.get_payload(decode=1)[:START] + child.get_payload(decode=1)[END:])
   

def parse_quoted_string(message, subject):
    if isinstance(subject, unicode):
        return subject

    subject_parts = email.Header.decode_header(subject)
    subject_result = []

    for part in subject_parts:
        if part[1] is None and message.get_content_charset(): # No specific charset, but message has one.
            try:
                subject_result.append(part[0].decode(parse_charset(message.get_content_charset())))
            except LookupError:
                subject_result.append(part[0].decode(_Conf.FALLBACK_ENCODING)) # FIXME
            except UnicodeError:
                subject_result.append(part[0].decode(_Conf.FALLBACK_ENCODING)) # FIXME
        elif part[1] is None: # No charset and message has none either, assume us-ascii
            try:
                subject_result.append(part[0].decode('us-ascii'))
            except LookupError:
                subject_result.append(part[0].decode(_Conf.FALLBACK_ENCODING)) # FIXME
            except UnicodeError:
                subject_result.append(part[0].decode(_Conf.FALLBACK_ENCODING)) # FIXME
        else: # Part has a charset
            try:
                subject_result.append(part[0].decode(parse_charset(part[1])))
            except LookupError:
                subject_result.append(part[0].decode(_Conf.FALLBACK_ENCODING)) # FIXME
            except UnicodeError:
                subject_result.append(part[0].decode(_Conf.FALLBACK_ENCODING)) # FIXME
    return " ".join(subject_result)

    if subject.find('=?') == -1:
        if isinstance(subject, str) and message.get_content_charset():
            try:
                return subject.decode(parse_charset(message.get_content_charset()))
            except LookupError:
               return subject.decode(_Conf.FALLBACK_ENCODING) # FIXME
            except UnicodeError:
               return subject.decode(_Conf.FALLBACK_ENCODING) # FIXME
        elif isinstance(subject, str):
            try:
                return unicode(subject)
            except UnicodeError: # check for message with buggy encoding set
                return subject.decode(_Conf.FALLBACK_ENCODING)
        else:
            return subject

#    raise RuntimeError, REQUEST.TLS('email_invalidsubject') % (subject, msg)  FIXME
    return subject

def parse_charset(charset):
    if not charset.strip():
        return 'us-ascii'
    if charset.lower() in ['iso-7102-5', 'iso-1372-4']: # spamfix
        return 'us-ascii'
    if charset.lower() == 'standard':
        return 'us-ascii'
    if charset.lower() == 'unknown_parameter_value':
        return 'us-ascii'
    if charset.lower() == 'utf-8':
        return 'utf8'
    if charset.lower() == 'unicode-1-1-utf-7':
        return 'utf7'
    if charset.lower() == 'x-unknown':
        return _Conf.FALLBACK_ENCODING
    if charset.lower() == 'unknown-8bit':
        return _Conf.FALLBACK_ENCODING
    if charset[:2].upper() == '3D': # fix problems with charsets in html being escaped
        charset = charset[2:]
    if charset[:8] == 'windows-':    
        charset = "cp%s" % charset[8:]
    if charset == 'ks_c_5601-1987':
        charset = 'euc_kr'
    if charset.lower() == 'big-5': 
        charset = 'big5'
    try:
        tmp = ''.decode(charset)
    except LookupError: # catch unknown charsets
        charset = 'us-ascii'
    except: # ingore other errors, they must be raised in proper context
        pass
    return charset

def getpart(REQUEST):
    if not REQUEST.form.has_key('mail_id') or not REQUEST.form['mail_id'].value or not REQUEST.form.has_key('part') or not REQUEST.form['part'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    mail_id = int(REQUEST.form['mail_id'].value)
    parts = map(int, REQUEST.form['part'].value.decode('UTF8').split('.'))[1:]

    msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, mail_id)
    message = message_from_string(base64.decodestring(msg.get('email_contents')))

    for part_ndx in parts:
        message = message.get_payload()[part_ndx]

    fn = parse_quoted_string(message, (message.get_filename() or get_alt_name(message) or 'noname.bin'))
    if REQUEST.browser == 'IE':
        try:
            fn = fn.encode(_Conf.FALLBACK_ENCODING)
        except:
            fn = fn.encode('UTF8')
    else:
        fn = str(email.Header.Header(fn))
    content_disp = "attachment; filename=\"%s\"" % fn
    del REQUEST.mod_req.headers_out["Pragma"]
    if isinstance(content_disp, unicode): # mod_python tables do not like unicode strings. But then again, IE doesn't like unicode filenames :(
        content_disp = content_disp.encode("UTF8")
    REQUEST.mod_req.headers_out["Content-Disposition"] = content_disp
    REQUEST.mod_req.content_type = '%s; charset="UTF8"' % (message.get_content_type() or "application/binary")
    output = message.get_payload(decode=1)
    if message.get_content_type() == 'text/plain' and REQUEST.browser == 'IE' and output.find('\r\n') == -1: # FIXME, a hack for windows-based stuff.
        output = output.replace('\n','\r\n')
    return output

def getpart_inline(REQUEST):
    if not REQUEST.form.has_key('mail_id') or not REQUEST.form['mail_id'].value or not REQUEST.form.has_key('part') or not REQUEST.form['part'].value:
        raise RuntimeError, REQUEST.TLS('required_parameters_missing')

    mail_id = int(REQUEST.form['mail_id'].value)
    parts = map(int, REQUEST.form['part'].value.decode('UTF8').split('.'))[1:]

    msg = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_ID, mail_id)
    message = message_from_string(base64.decodestring(msg.get('email_contents')))

    for part_ndx in parts:
        message = message.get_payload()[part_ndx]

    del REQUEST.mod_req.headers_out["Pragma"]
    content_disp = "inline; filename=\"%s\"" % (parse_quoted_string(message, (message.get_filename() or get_alt_name(message) or 'noname.bin')))
    if isinstance(content_disp, unicode): # mod_python tables do not like unicode strings. But then again, IE doesn't like unicode filenames :(
        content_disp = content_disp.encode("UTF8")
    REQUEST.mod_req.headers_out["Content-Disposition"] = content_disp
    REQUEST.mod_req.content_type = '%s; charset="UTF8"' % (message.get_content_type() or "application/binary")
    output = message.get_payload(decode=1)
    if message.get_content_type() == 'text/plain' and REQUEST.browser == 'IE' and output.find('\r\n') == -1: # FIXME, a hack for windows-based stuff.
        output = output.replace('\n','\r\n')
    return output

def full_parse_message(REQUEST, topmessage, message, ndx, levelstring="0"):
    try:
      date = REQUEST.iso2userdatetime(REQUEST, mx.DateTime.DateTimeFrom(message['date']))
    except:
      date = message['date']
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    BASE_WEB_URL = _Conf.BASE_WEB_URL
    tls_added = REQUEST.TLS('email_contactadded')
    tls_print = REQUEST.TLS('tls_print')
    output = []
    output.append(u"""<script type="text/javascript" src="%(BASE_WEB_URL)sreq.js"></script><script type="text/javascript">if (document.images){ im1= new Image(3,3); im1.src="%(BASE_ICON_URL)sco_crn1.gif"; im2= new Image(3,3); im2.src="%(BASE_ICON_URL)sco_crn2.gif"; im3= new Image(3,3); im3.src="%(BASE_ICON_URL)sco_crn3.gif"; im4= new Image(3,3); im4.src="%(BASE_ICON_URL)sco_crn4.gif"; } function write_c(){ var co = document.getElementById('contactadddiv'); co.innerHTML='<table border="0" cellpadding="0" cellspacing="0"><tr>  <td><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></td>  <td bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sco_crn1.gif" width="3" height="3" border="0" alt=""></td>  <td bgcolor="#B5EDBC"><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></td>  <td bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sco_crn3.gif" width="3" height="3" border="0" alt=""></td></tr><tr>  <td><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></td>  <td bgcolor="#B5EDBC"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></td>  <td bgcolor="#B5EDBC">&nbsp;<b>%(tls_added)s</b>&nbsp;</td>  <td bgcolor="#B5EDBC"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></td></tr><tr>  <td><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></td>  <td bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sco_crn2.gif" width="3" height="3" border="0" alt=""></td>  <td bgcolor="#B5EDBC"><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></td>  <td bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sco_crn4.gif" width="3" height="3" border="0" alt=""></td></tr><tr><td colspan="4"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="2" border="0" alt=""></td></td></tr></table>';}</script>""" % locals())
    output.append(u"""<div id='contactadddiv'></div><TABLE align="center" border="0" width="99%%" cellpadding="0" cellspacing="0" style="border: 1px solid #999999;">""")
    name = email.Utils.parseaddr(parse_quoted_string(message, message['from'] or '-- no sender --'))

    formstring = REQUEST.get_formstring(['qs'])
    if name[0] and len(name[0].split(" "))>1:
        contact_link = """&nbsp;<span class="em_contact" onclick="SendRequest('%scontactadd.py/quickadd?name=%s&email=%s');write_c();">%s</span>""" % (_Conf.BASE_CONTACT_URL, urllib.quote(name[0].encode('UTF8')), urllib.quote(name[1].encode('UTF8')), REQUEST.TLS('email_tocontacts'))
    else:
        contact_link = ""
    output.append(u"""<TR>\n  <TD width="50%%" class="email_read2"><B>%s:</B> %s%s</TD>""" % (REQUEST.TLS('email_from'), _Utils.html_quote(parse_quoted_string(message, message['from'] or '-- no sender --')), contact_link))
    output.append(u"""  <TD  width="50%%" class="email_read2"><B>%s:</B> %s""" % (REQUEST.TLS('email_to'), _Utils.html_quote(parse_quoted_string(message, message['to'] or '-- no to --'))))
    if message['Cc']:
        output.append(u"""  <B>%s:</B> %s""" % (REQUEST.TLS('email_cc'), _Utils.html_quote(parse_quoted_string(message, message['cc']))))
    if levelstring == "0": # only for toplevel
        output.append(u"""  </TD>\n  <TD width="1%%" class="email_read2" style="border-bottom: 1px solid #999999;" rowspan="2"><input type="button" class="input7" onclick="window.print()" value="%s"></TD>\n</TR>\n<TR>\n  <TD class="email_read2" style="border-bottom: 1px solid #999999;"><B>%s:</B> %s</TD><TD class="email_read2" style="border-bottom: 1px solid #999999;"><B>%s:</B> %s</TD>\n</TR>""" % (tls_print, REQUEST.TLS('tls_subject'), _Utils.html_quote(parse_quoted_string(message, message['subject'] or '-- no subject --')), REQUEST.TLS('email_sent'), date))
    else:
        output.append(u"""  </TD>\n  <TD width="1%%" class="email_read2" style="border-bottom: 1px solid #999999;" rowspan="2">&nbsp;</TD>\n</TR>\n<TR>\n  <TD class="email_read2" style="border-bottom: 1px solid #999999;"><B>%s:</B> %s</TD><TD class="email_read2" style="border-bottom: 1px solid #999999;"><B>%s:</B> %s</TD>\n</TR>""" % (REQUEST.TLS('tls_subject'), _Utils.html_quote(parse_quoted_string(message, message['subject'] or '-- no subject --')), REQUEST.TLS('email_sent'), date))
    output.append(u"""<TR>\n  <TD colspan="3" class="email_read3">""")
    output.append(parse_message(REQUEST, topmessage, message, ndx, levelstring))
    output.append(u"""  </TD>\n</TR>""")
    if levelstring == "0":
        try:
            tmp = email.Utils.getaddresses([message['to']])
            tolist = []
            for i in tmp:
                if i[0] or i[1]: tolist.append(i)
        except:
            tolist = []
        if message['cc'] or len(tolist) >= 2:
            replyallbutton = """\n    <INPUT type="button" name="email_replyall" class="input6" value="%s" onclick="document.emailreadform.email_type.value='4'; document.emailreadform.submit();">""" % REQUEST.TLS('email_replyallmessage')
        else:
            replyallbutton = ""
        output.append(u"""
<TR>
  <TD colspan="3" nowrap class="email_read2" style="border-top: 1px solid #999999;">
    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
    <INPUT type="submit" class="input6" name="email_delete" value="%s" onClick="if (confirm('%s')) { document.emailreadform.email_type.value='1'; document.emailreadform.submit(); }">
    <INPUT type="submit" class="input6" name="email_forward" value="%s" onclick="document.emailreadform.email_type.value='2'; document.emailreadform.submit();"> 
    <INPUT type="submit" class="input6" name="email_forward2" value="%s" onclick="document.emailreadform.email_type.value='5'; document.emailreadform.submit();">
    <INPUT type="submit" class="input6" name="email_reply" value="%s" onclick="document.emailreadform.email_type.value='3'; document.emailreadform.submit();">%s
  </TD>
</TR>""" % (REQUEST.TLS('tls_delete'), REQUEST.TLS('email_confirm_del'), REQUEST.TLS('email_forward'), REQUEST.TLS('email_forwardwhole'), REQUEST.TLS('email_reply'), replyallbutton))
    output.append(u"</TABLE>")
    if levelstring=="0":
        output.append(u"""
<FORM action="%scompose.py" method="POST" target="topcontents" name="emailreadform">
<INPUT type="hidden" name="email_type" value="">
<INPUT type="hidden" name="read_mail_id" value="%s">
</FORM>""" % (_Conf.BASE_EMAIL_URL, ndx))
    return '\n'.join(output)

def parse_message(REQUEST, topmessage, message, top_ndx, levelstring):
    if REQUEST.form.has_key('view_inline') and REQUEST.form['view_inline'].value == "1":
        view_inline = 1
    else:
        view_inline = 0
    if message.get_content_type() == 'message/rfc822':
        output = [full_parse_message(REQUEST, topmessage, message.get_payload()[0], top_ndx, levelstring + ".0")]
        if isinstance(message.get_payload(), list) and len(message.get_payload()) > 1:
            for i in range(len(message.get_payload())-1):
                output.append(parse_message(REQUEST, topmessage, message.get_payload()[i+1], top_ndx, levelstring + ".%d"%(i+1)))
        return "\n".join(output)
    if message.get_content_type() == 'text/calendar':
        cs = message.get_content_charset()
        if cs:
            cs = parse_charset(cs)
            try:
                event = get_dict_from_ical(REQUEST, message.get_payload().decode(cs))
            except:
                event = get_dict_from_ical(REQUEST, message.get_payload().decode(_Conf.FALLBACK_ENCODING))
        else:
            event = get_dict_from_ical(REQUEST, message.get_payload())
        if event:
            return ical(REQUEST, event)
        else:
            return " "
    if message.get_content_type() == 'text/x-vcard':
        cs = message.get_content_charset()
        if cs:
            cs = parse_charset(cs)
            try:
                event = get_dict_from_vcard(REQUEST, message.get_payload().decode(cs))
            except:
                event = get_dict_from_vcard(REQUEST, message.get_payload().decode(_Conf.FALLBACK_ENCODING))
        else:
            event = get_dict_from_vcard(REQUEST, message.get_payload())
        if event:
            return vcard(REQUEST, event)
        else:
            return " "

    if message.get_content_maintype() == 'multipart' and message.get_content_subtype() in ['mixed','related','signed','appledouble','digest','report']:
        output = [u"""<TABLE border=0>"""]
        children = message.get_payload()
        has_inline_files = 0
        ndx = 0
        for child in children:
            try:
                fname = (child.get_filename() or get_alt_name(child)).split(".")
                if fname and fname[-1] and fname[-1].lower() in _Conf.EMAIL_INLINE and not view_inline:
                    has_inline_files = 1
            except:
                pass
            locallevel = levelstring + ".%d" % ndx 
            output.append(u"""<TR><TD>%s</TD></TR>""" % parse_message(REQUEST, topmessage, child, top_ndx, locallevel))
            ndx += 1
        if has_inline_files and REQUEST.form.has_key('headers'):
            output.append(u"""<TR><TD><A href="%sread.py?mail_id=%d&headers=%s&view_inline=1">%s</A></TD></TR>""" % (_Conf.BASE_EMAIL_URL, top_ndx, REQUEST.form['headers'].value, REQUEST.TLS('email_inline')))
        elif has_inline_files and not REQUEST.form.has_key('headers'):
            output.append(u"""<TR><TD><A href="%sread.py?mail_id=%d&view_inline=1">%s</A></TD></TR>""" % (_Conf.BASE_EMAIL_URL, top_ndx, REQUEST.TLS('email_inline')))
        output.append(u"""</TABLE>""")
        return "\n".join(output)

    elif message.get_content_maintype() == 'multipart' and message.get_content_subtype() == 'alternative':
        children = message.get_payload()


        if not isinstance(children, str):
            locallevel = levelstring + ".1"
            if len(children) >= 2:
                return parse_message(REQUEST, topmessage, children[1], top_ndx, locallevel) # FIXME index
            elif len(children) == 1:
                return parse_message(REQUEST, topmessage, children[0], top_ndx, locallevel) # FIXME index
            else:
                return u""
        else:
            contents = message.get_payload(decode=1)
            if message.get_content_charset() and isinstance(contents, str):
                try:
                    contents = contents.decode(parse_charset(message.get_content_charset()))
                except UnicodeError: # FIXME, checking for bastards who claim one charset and use another!
                    contents = contents.decode(_Conf.FALLBACK_ENCODING)

            if message.get_content_type() == 'text/plain':
                contents = _Utils.newline2br(parse_urls(_Utils.html_quote(contents)))
            elif message.get_content_type() == 'text/html':
                contents = replace_css_with_include(REQUEST, topmessage, top_ndx, contents)

            if isinstance(contents, str):
                try: # Since we already check for charset a few lines above, we have to assume
                     # this is a ascii message. However, not all are :(, so we try to work around
                     # with FALLBACK_ENCODING when an error occurs
                    contents = unicode(contents)
                except UnicodeError:
                    contents = contents.decode(_Conf.FALLBACK_ENCODING)
            return contents
    else:
        if message.get_filename() or get_alt_name(message): # FIXME
            ns = {}
            ns['BASE_EMAIL_URL'] = _Conf.BASE_EMAIL_URL
            ns['tls_attachment'] = REQUEST.TLS('email_attachment')
            ns['mail_id'] = top_ndx
            ns['part'] = levelstring
            ns['filename'] = parse_quoted_string(message, (message.get_filename() or get_alt_name(message) or '-- no filename --'))
            ns['tls_size'] = REQUEST.TLS('size')
            ns['tls_save'] = REQUEST.TLS('tls_save')
            ns['real_size'] = _Utils.str_size(len(str(message.get_payload(decode=1))))
            access_str = _Utils.get_module_access(REQUEST)
            types_menus = {_InitTypes.ITEM_TYPE_DOCUMENT: _Conf.MODULES_DOCUMENTS}
            fname = (message.get_filename() or get_alt_name(message)).split(".")
            if fname and fname[-1] and fname[-1].lower() in _Conf.EMAIL_INLINE and view_inline:
                return u""" <img src="%(BASE_EMAIL_URL)sread.py/getpart_inline?mail_id=%(mail_id)d&part=%(part)s">""" % ns
            else:
                return u"""%(tls_attachment)s: <A HREF="%(BASE_EMAIL_URL)sread.py/getpart?mail_id=%(mail_id)d&part=%(part)s">%(filename)s</A> (%(tls_size)s %(real_size)s)""" % ns
        elif message.get_content_maintype() <> 'text':
            # Non-text message part with no filename:
            # since we do not know how to deal with these,
            # we shall ignore them
            return u''

        contents = message.get_payload(decode=1)
        if message.get_content_charset() and isinstance(contents, str):
            try:
                contents = contents.decode(parse_charset(message.get_content_charset()))
            except UnicodeError: # FIXME, checking for bastards who claim one charset and use another!
                contents = contents.decode(_Conf.FALLBACK_ENCODING)

        if message.get_content_type() == 'text/plain':
            contents = _Utils.newline2br(parse_urls(_Utils.html_quote(contents)))
        elif message.get_content_type() == 'text/html':
            contents = replace_css_with_include(REQUEST, topmessage, top_ndx, contents)

        if isinstance(contents, str):
            try: # Since we already check for charset a few lines above, we have to assume
                 # this is a ascii message. However, not all are :(, so we try to work around
                 # with FALLBACK_ENCODING when an error occurs
                contents = unicode(contents)
            except UnicodeError:
                contents = contents.decode(_Conf.FALLBACK_ENCODING)
        return contents

def find_first_urlstart(text, startndx):
    http = text.find('http://', startndx)
    https = text.find('https://', startndx)
    ftp = text.find('ftp://', startndx)
    if http == -1 and https == -1 and ftp == -1:
        return -1
    elif http <> -1 and https <> -1 and ftp <> -1:
        return min(http, https, ftp)
    elif http <> -1 and https <> -1:
        return min(http, https)
    elif http <> -1 and ftp <> -1:
        return min(http, ftp)
    elif https <> -1 and ftp <> -1:
        return min(https, ftp)
    elif http <> -1:
        return http
    elif https <> -1:
        return https
    elif ftp <> -1:
        return ftp
    else:
        return -1

def parse_urls(text):
    text = text.replace('\r','')
    output = ''
    startndx = 0
    while 1:
        x = find_first_urlstart(text, startndx)
        if x == -1:
            output += text[startndx:]
            break
        output += text[startndx:x]
        delimiters = [' ', '\n', '&quot;']
        positions = []
        for delim in delimiters:
           positions.append(text.find(delim, x))
        positions = filter(lambda x:x<>-1, positions)
        if positions:
           tmp = min(positions)
        else:
            output += """<A target="_blank" href="%s">%s</A>""" % (text[x:], text[x:])
            break
        if text[tmp-1] in ['.',',','!','?']:
            tmp -= 1
        output += """<A target="_blank" href="%s">%s</A>""" % (text[x:tmp], text[x:tmp])
        startndx = tmp
    return output

def has_attachment(REQUEST, message, level=0):
    payload = message.get_payload()
    if isinstance(payload, list):
        for child in payload:
            if has_attachment(REQUEST, child, level+1):
                return 1
        return 0
    elif level == 0: # If level 0 and no children
        return 0
    elif message.get_filename() or get_alt_name(message):
        return 1
    else:
        return 0

def get_attachments_2(REQUEST, message, level=0):
    children = []
    payload = message.get_payload()
    if isinstance(payload, list):
        for child in payload:
            children += get_attachments(REQUEST, child, level+1)
        return children
    elif level == 0: # If level 0 and no children
        return []
    elif message.get_filename() or get_alt_name(message):
        return [message]
    else:
        return []

def get_attachments(REQUEST, message, show_messages=0, level=0, ident="0"):
    children = []
    payload = message.get_payload()
    if show_messages and level and message.get_content_type() == 'message/rfc822':
        message['conflux-ident'] = ident
        return [message]
    elif isinstance(payload, list):
        ndx = 0
        for child in payload:
            children += get_attachments(REQUEST, child, show_messages, level+1, "%s.%d" % (ident, ndx))
            ndx += 1
        return children
#    elif level == 0: # If level 0 and no children
#        return []
    elif message.get_filename() or get_alt_name(message):
        message['conflux-ident'] = ident
        return [message]
    else:
        return []

def find_by_contentid(REQUEST, message, cid, level=0, ident="0"):
    payload = message.get_payload()
    if message['content-id'] == "<%s>" % cid:
        return ident
    elif isinstance(payload, list):
        ndx = 0
        for child in payload:
            result = find_by_contentid(REQUEST, child, cid, level+1, "%s.%d" % (ident, ndx))
            if result is not None:
                return result
            ndx += 1
        return None
    else:
        return None

def indexify_message(REQUEST, message):
    output = []
    parts = email.Iterators.typed_subpart_iterator(message, 'text', 'plain')
    for part in parts:
        if part.get_filename() or get_alt_name(message): # FIXME
            continue
        payload = part.get_payload(decode=1)
        if part.get_content_charset() and isinstance(payload, str):
            try:
                payload = payload.decode(parse_charset(part.get_content_charset()))
            except UnicodeError: # FIXME, checking for bastards who claim one charset and use another!
                payload = payload.decode(_Conf.FALLBACK_ENCODING)
        else:
            try:
                payload = unicode(payload)
            except UnicodeError: # FIXME, checking for bastards who claim one charset and use another!
                payload = payload.decode(_Conf.FALLBACK_ENCODING)
        output.append(payload)
    return "\n".join(output)

def reply_message(REQUEST, message):
    parts = email.Iterators.typed_subpart_iterator(message, 'text') # , 'plain') FIXME
    for part in parts:
        if part.get_content_type() == 'text/plain':
            payload = part.get_payload(decode=1)
            if part.get_content_charset() and isinstance(payload, str):
                try:
                    payload = payload.decode(parse_charset(part.get_content_charset()))
                except UnicodeError: # FIXME, checking for bastards who claim one charset and use another!
                    payload = payload.decode(_Conf.FALLBACK_ENCODING)
            else:
                try:
                    payload = unicode(payload)
                except UnicodeError: # FIXME, checking for bastards who claim one charset and use another!
                    payload = payload.decode(_Conf.FALLBACK_ENCODING)
            payload = payload.replace('\r\n','\n')
            payload = payload.split('\n')
            result = []
            for row in payload:
                if len(row) > 70:
                    for row2 in _Utils.split_text_plain(row, 70):
                        result.append(row2.replace('\n',''))
                else:
                    result.append(row)
            if result:
                return "\n".join(result)
        if part.get_content_type() == 'text/html':
            payload = part.get_payload(decode=1)
            if part.get_content_charset() and isinstance(payload, str):
                try:
                    payload = payload.decode(parse_charset(part.get_content_charset()))
                except UnicodeError: # FIXME, checking for bastards who claim one charset and use another!
                    payload = payload.decode(_Conf.FALLBACK_ENCODING)
            else:
                try:
                    payload = unicode(payload)
                except:
                    payload = payload.decode(_Conf.FALLBACK_ENCODING)
            payload = payload.replace('<br>','\n')
            payload = payload.replace('<BR>','\n')
            payload = _Utils.strip_html(payload,valid_tags=[]) # FIXME
            payload = payload.replace('\r\n','\n')
            payload = payload.split('\n')
            return "\n".join(payload)
    return ""

def send_reminder(event, REQUEST):
    if (event['remind_type'] ==1 and not event['e_mail'].decode('UTF8').strip()):
        return
    if (event['remind_type'] ==2 and not event['phone_cell'].decode('UTF8').strip()):
        return

    users = {event['creator_id']:1}
    if (event['event_flags'] & _Event.EVENT_REMINDER_OTHERS):
        if event['related_persons'] <> '{}':
            for i in _Utils.sql_parse_array(REQUEST, event['related_persons']):
                users[i] = 1
        if event['related_groups'] <> '{}':
            REQUEST.db.execute("""SELECT members FROM calendar_groups WHERE group_id in (%s)""" % ",".join(map(str, _Utils.sql_parse_array(REQUEST, event['related_groups']))))
            tmp = REQUEST.db.dictfetchall()
            for i in tmp:
                i = _Utils.sql_parse_array(REQUEST, i['members'])
                for n in i:
                    users[n] = 1
    users = ",".join(map(str, users.keys()))
    if event['remind_type'] == 1:
        REQUEST.db.execute("""SELECT e_mail, person_id FROM persons WHERE person_id in (%s)""" % users)
        try: server = smtplib.SMTP(_Conf.SMTPSERVER)
        except: pass
    else:
        REQUEST.db.execute("""SELECT phone_cell, person_id FROM persons WHERE person_id in (%s)""" % users)
    res = REQUEST.db.fetchall()
    res = filter(lambda x:x[0], res)

    for data in res:
        REQUEST.su_by_id(data[1])
        subject = REQUEST.TLS('reminder_subject') % event['event_name'].decode('UTF8')
        message = REQUEST.TLS('reminder_message') % (event['event_name'].decode('UTF8'), REQUEST.iso2usertime(REQUEST, event['start_stamp']), event['description'].decode('UTF8'))
        REQUEST.unsu()

        msg = email.MIMEMultipart.MIMEMultipart()
        msg['From'] = str(email.Header.Header(u'%s <%s@%s>' % (_Conf.APP_NAME, _Conf.APP_EMAIL_NAME, _Conf.SMTPSERVER)))
        msg['To'] = str(email.Header.Header(data[0].decode('UTF8')))
        msg['Subject'] = str(email.Header.Header(subject))
        if isinstance(message, unicode):
            message = message.encode('UTF8')
        submsg = email.MIMEText.MIMEText(message)
        del submsg['Content-Type']
        submsg['Content-Type'] = 'text/plain; charset="utf-8"'
        msg.attach(submsg)

        if event['remind_type'] == 1:
            to = str(msg['to'])
            try: server.sendmail(str(msg['from']), to, msg.as_string())
            except: pass
        elif event['remind_type'] == 2:
            libsms.send_sms([data[0]], str(msg['subject']), message)
    if event['remind_type'] == 1:
        try: server.quit()
        except: pass

def send_invitation(REQUEST, event, etype=1):
    users = {}
    if event.get('related_persons') <> '{}':
        for i in _Utils.sql_parse_array(REQUEST, event.get('related_persons')):
            users[i] = 1
    if etype==1 and event.get('related_groups') <> '{}':
        REQUEST.db.execute("""SELECT members FROM calendar_groups WHERE group_id in (%s)""" % ",".join(map(str, _Utils.sql_parse_array(REQUEST, event.get('related_groups')))))
        tmp = REQUEST.db.dictfetchall()
        for i in tmp:
            i = _Utils.sql_parse_array(REQUEST, i['members'])
            for n in i:
                users[n] = 1
    users = ",".join(map(str, users.keys()))
    if users:
        REQUEST.db.execute("""SELECT e_mail, person_id, first_name FROM persons WHERE person_id in (%s) and e_mail<>'' and e_mail is not null and email_notify=1""" % users)
        res = REQUEST.db.fetchall()
    else:
        res = []
    
    if etype==1:
      url = '%seditevent.py?event_id=%s' % (_Conf.BASE_CALENDAR_URL, event.get_id())
    elif etype==2:
      url = '%stodoedit.py?todo_id=%s' % (_Conf.BASE_TODO_URL, event.get_id())
    if REQUEST.mod_req.connection.local_addr[1] == 443:
        url = 'https://%s%sindex.py?ext_link=%s' % (REQUEST.mod_req.server.server_hostname, _Conf.BASE_URL, urllib.quote(url))
    else:
        url = 'http://%s%sindex.py?ext_link=%s' % (REQUEST.mod_req.server.server_hostname, _Conf.BASE_URL, urllib.quote(url))
    
    creator_id = event.get('creator_id')
    try:
        creator = _RootObject.dispatch_item(REQUEST, creator_id)
    except:
        raise RuntimeError, creator_id
    creator_name = creator.get('item_name')
    creator_email = creator.get('e_mail') or ('%s@%s' % (_Conf.APP_EMAIL_NAME, _Conf.SMTPSERVER))
    if res:
        try: server = smtplib.SMTP(_Conf.SMTPSERVER)
        except: pass
    
    for row in res:
        REQUEST.su_by_id(row[1])
        msg = email.MIMEMultipart.MIMEMultipart()
        subject = event.get('item_name')
        if etype==1:
            message = REQUEST.TLS('invite_message') % (row[2].decode('UTF8'), creator_name, event.get('event_name'), REQUEST.iso2userdatetime(REQUEST, event.get('start_stamp')), event.get('description'), url)
        elif etype==2:
            if event.get('due_time'):
              message = REQUEST.TLS('assign_message') % (row[2].decode('UTF8'), creator_name, event.get('title'), REQUEST.iso2userdate(event.get('due_time')), event.get('description'), url)
            else:
              message = REQUEST.TLS('assign_message') % (row[2].decode('UTF8'), creator_name, event.get('title'), 'N/A', event.get('description'), url)
        msg['From'] = str(email.Header.Header(u'%s <%s>' % (creator_name, creator_email)))
        msg['To'] = str(email.Header.Header(row[0].decode('UTF8')))
        msg['Subject'] = str(email.Header.Header(subject))
        if isinstance(message, unicode):
            message = message.encode('UTF8')
        submsg = email.MIMEText.MIMEText(message)
        del submsg['Content-Type']
        submsg['Content-Type'] = 'text/plain; charset="utf-8"'
        msg.attach(submsg)
        to = str(msg['to'])
        try: server.sendmail(str(msg['from']), to, msg.as_string())
        except: pass
        REQUEST.unsu()
    if res:
        try: server.quit()
        except: pass

def send_invitation_update(REQUEST, event, etype=1):
    users = {}
    if event.get('related_persons') <> '{}':
        for i in _Utils.sql_parse_array(REQUEST, event.get('related_persons')):
            users[i] = 1
    if event.get('related_groups') <> '{}':
        REQUEST.db.execute("""SELECT members FROM calendar_groups WHERE group_id in (%s)""" % ",".join(map(str, _Utils.sql_parse_array(REQUEST, event.get('related_groups')))))
        tmp = REQUEST.db.dictfetchall()
        for i in tmp:
            i = _Utils.sql_parse_array(REQUEST, i['members'])
            for n in i:
                users[n] = 1
    users = ",".join(map(str, users.keys()))
    if users:
        REQUEST.db.execute("""SELECT e_mail, person_id, first_name FROM persons WHERE person_id in (%s) and e_mail<>'' and e_mail is not null and email_notify=1""" % users)
        res = REQUEST.db.fetchall()
    else:
        res = []
    
    if etype==1:
      url = '%seditevent.py?event_id=%s' % (_Conf.BASE_CALENDAR_URL, event.get_id())
    elif etype==2:
      url = '%stodoedit.py?todo_id=%s' % (_Conf.BASE_TODO_URL, event.get_id())
    if REQUEST.mod_req.connection.local_addr[1] == 443:
        url = 'https://%s%sindex.py?ext_link=%s' % (REQUEST.mod_req.server.server_hostname, _Conf.BASE_URL, urllib.quote(url))
    else:
        url = 'http://%s%sindex.py?ext_link=%s' % (REQUEST.mod_req.server.server_hostname, _Conf.BASE_URL, urllib.quote(url))
    
    creator_id = event.get('creator_id')
    try:
        creator = _RootObject.dispatch_item(REQUEST, creator_id)
    except:
        raise RuntimeError, creator_id
    creator_name = creator.get('item_name')
    creator_email = creator.get('e_mail') or ('%s@%s' % (_Conf.APP_EMAIL_NAME, _Conf.SMTPSERVER))
    if res:
        try: server = smtplib.SMTP(_Conf.SMTPSERVER)
        except: pass
    
    for row in res:
        REQUEST.su_by_id(row[1])
        msg = email.MIMEMultipart.MIMEMultipart()
        if etype==1:
            subject = REQUEST.TLS('invite_subject_update') % event.get('item_name')
            message = REQUEST.TLS('invite_message_update') % (row[2].decode('UTF8'), event.get('event_name'), REQUEST.iso2userdatetime(REQUEST, event.get('start_stamp')), event.get('description'), url)
        elif etype==2:
            subject = REQUEST.TLS('invite_subject_delete') % event.get('item_name')
            message = REQUEST.TLS('invite_message_delete') % (row[2].decode('UTF8'), event.get('event_name'), REQUEST.USER.get_name())

        msg['From'] = str(email.Header.Header(u'%s <%s>' % (creator_name, creator_email)))
        msg['To'] = str(email.Header.Header(row[0].decode('UTF8')))
        msg['Subject'] = str(email.Header.Header(subject))
        if isinstance(message, unicode):
            message = message.encode('UTF8')
        submsg = email.MIMEText.MIMEText(message)
        del submsg['Content-Type']
        submsg['Content-Type'] = 'text/plain; charset="utf-8"'
        msg.attach(submsg)
        to = str(msg['to'])
        try: server.sendmail(str(msg['from']), to, msg.as_string())
        except: pass
        REQUEST.unsu()
    if res:
        try: server.quit()
        except: pass

def send_invitation_notify(REQUEST, event, etype=1):
    creator_id = event.get('creator_id')
    try:
        creator = _RootObject.dispatch_item(REQUEST, creator_id)
    except:
        raise RuntimeError, creator_id
    creator_name = creator.get('item_name')
    creator_email = creator.get('e_mail')
    if creator_email and creator_name:
        person_name = REQUEST.USER.get_name()
        REQUEST.su_by_id(event.get('creator_id'))
        try: server = smtplib.SMTP(_Conf.SMTPSERVER)
        except: pass
        msg = email.MIMEMultipart.MIMEMultipart()
        if etype==1:
            subject = REQUEST.TLS('invite_subject_accept') % {'event_name':event.get('item_name'), 'person_name':person_name}
            message = ""
        elif etype==2:
            subject = REQUEST.TLS('invite_subject_reject') % {'event_name':event.get('item_name'), 'person_name':person_name}
            message = ""

        msg['From'] = str(email.Header.Header(u'%s <%s@%s>' % (_Conf.APP_NAME, _Conf.APP_EMAIL_NAME, _Conf.SMTPSERVER)))
        msg['To'] = str(email.Header.Header(creator_email))
        msg['Subject'] = str(email.Header.Header(subject))
        if isinstance(message, unicode):
            message = message.encode('UTF8')
        submsg = email.MIMEText.MIMEText(message)
        del submsg['Content-Type']
        submsg['Content-Type'] = 'text/plain; charset="utf-8"'
        msg.attach(submsg)
        to = str(msg['to'])
        try: server.sendmail(str(msg['from']), to, msg.as_string())
        except: pass
        REQUEST.unsu()
    if creator_email and creator_name:
        try: server.quit()
        except: pass

def replace_css_with_include(REQUEST, message, top_ndx, htmltext):
    while 1: # A dummy while
        # Reload our CSS after html css to avoid design problems
        stylesheet_ndx = htmltext.find('rel="stylesheet"')
        if stylesheet_ndx == -1:
            break
        ndx = stylesheet_ndx
        tagstart = -1
        while ndx >= 0:
            ndx -= 1
            if htmltext[ndx] == '>':
                break
            elif htmltext[ndx] == '<':
                tagstart = ndx
                break
        if tagstart == -1:
            break
        tmp1 = htmltext.find('<', stylesheet_ndx+1)
        tagend = htmltext.find('>', stylesheet_ndx+1)
        if tagend == -1 or tmp1 < tagend:
            break
        htmltext = htmltext[:tagend+1]+("""\n<STYLE>\n@import url(%s);\n</STYLE>\n""" % (_Conf.BASE_WEB_URL + 'lothelle.css'))+   \
        htmltext[tagend+1:]
        break
    # FIXME REMOVE
    start_pos = 0
    while 1: # A little less dummy while
        # Replace all cid:'s with valid links
        cid_start = htmltext.find('cid:', start_pos)
        if cid_start == -1:
            break
        tmp1 = htmltext.find(' ', cid_start+5)
        tmp2 = htmltext.find("'", cid_start+5)
        tmp3 = htmltext.find('"', cid_start+5)
        tmp4 = htmltext.find('>', cid_start+5)
        if tmp1 == -1:
            tmp1 = 999999999 # FIXME
        if tmp2 == -1:
            tmp2 = 999999999 # FIXME
        if tmp3 == -1:
            tmp3 = 999999999 # FIXME
        if tmp4 == -1:
            tmp4 = 999999999 # FIXME
        cid_end = min([tmp1, tmp2, tmp3, tmp4])
        if cid_end in [-1, 999999999]: # FIXME
            break
        cid = htmltext[cid_start+4:cid_end].strip()
        if cid[0] in ['"', '"']:
            cid = cid[1:]
        cidresult = find_by_contentid(REQUEST, message, cid)
        if cidresult:
            quotespacerstart = 0
            quotespacerend = 0
            if htmltext[cid_end] in '"':
                quotespacerend = 1
            elif htmltext[cid_end] == "'":
                quotespacerend = 1
            if htmltext[cid_start-1] in '"':
                quotespacerstart = 1
            elif htmltext[cid_start-1] == "'":
                quotespacerstart = 1
            htmltext = htmltext[:cid_start-quotespacerstart] + "'%sread.py/getpart?mail_id=%s&part=%s'" % (_Conf.BASE_EMAIL_URL, top_ndx, cidresult) + htmltext[cid_end+quotespacerend:]
        start_pos = cid_end
    return htmltext



###
# Classes for fetching mail
###

class IMAP4Mailbox(object):
    def __init__(self):
        self.__con = None

    def open(self, REQUEST, account):
        try:
            self.__con = imaplib.IMAP4(account.get('eaccount_name'))
            self.__con.login(account.get('eaccount_user'), account.get('eaccount_password'))
        except:
            if self.__con and self.__con.sock:
                self.__con.sock.close()
            raise # FIXME

    def close(self):
        if self.__con is not None:
            self.__con.close() # Close folder
            self.__con.logout() # Log out
            self.__con = None

    def __len__(self):
        if self.__con is None:
            return 0
        resp, data = self.__con.SELECT("INBOX",1)
        return int(data[0])


    def get(self, ndx, fp):
        self.__con.SELECT("INBOX",1)
        resp, data = self.__con.FETCH(ndx, '(RFC822)')
        fp.seek(0)
        fp.truncate()
        fp.write(data[0][1])
        fp.seek(0)
        try:
            return email.message_from_file(fp)
        except email.Errors.BoundaryError, message:
            boundary = None
            res = data[0][1].split('\n')
            for row in res:
                if row[:12].lower() == 'content-type':
                    try:
                        boundary = row.split(';')[-1].split('=')[-1].replace('"', '')
                    except:
                        raise email.Errors.BoundaryError, message
                    break
            if boundary is None:
                raise email.Errors.BoundaryError, message
#            res.append('--%s--\n' % boundary)
            fp.seek(0)
            fp.truncate()
            fp.write("\n".join(res))
            fp.seek(0)
            try:
                return email.message_from_file(fp)
            except email.Errors.MessageError, msg:
                # The parser failed to figure out whats's going on here
                # To prevent us from resyncing until the email is gone
                # we import it as an invalid email
                fp.seek(0)
                message = email.MIMEMultipart.MIMEMultipart()
                del message['from']
                del message['subject']
                message['from'] = _Conf.APP_NAME
                message['subject'] = 'Error message from %s' % _Conf.APP_NAME
               
                submsg = email.MIMEText.MIMEText('%s was unable to process the following message:\n%s' % (_Conf.APP_NAME, str(msg)))
                del submsg['content-type']
                submsg['Content-Type'] = 'text/plain; charset="utf-8"'
                message.attach(submsg)
                
                submsg = MIMEFile.MIMEFile(fp.read(), 'failed_message.bin')
                message.attach(submsg)
        
                return message

    def getfast(self, ndx, fp):
        self.__con.SELECT("INBOX",1)
        resp, data = self.__con.FETCH(ndx, '(RFC822.HEADER)')
        fp.seek(0)
        fp.truncate()
        fp.write(data[0][1])
        fp.seek(0)
        return email.message_from_file(fp) 

    def delete(self, ndx):
        self.__con.SELECT("INBOX")
        self.__con.STORE(ndx, "+flags", "\Deleted")

    def get_new_items(self):
        self.__con.SELECT("INBOX",1)  
        resp, data = self.__con.SEARCH(None, "UNSEEN")
        entries = data[0].split(" ")
        if entries:
            return map(int, entries)
        else:
            return []

class POP3Mailbox(object):
    def __init__(self):
        self.__con = None
        self.__uids = None

    def open(self, REQUEST, account):
        try:
            self.__con = poplib.POP3(account.get('eaccount_name'))
            self.__con.user(account.get('eaccount_user'))
            self.__con.pass_(account.get('eaccount_password'))
        except:
            if self.__con:
                self.__con.quit()
            raise # FIXME

    def loaduids(self):
        if self.__uids is None:
            self.__uids = {}
            response = self.__con.uidl()[1]
            for item in response:
                uid, uidl = item.split(' ')
                self.__uids[int(uid)] = uidl

    def getuid(self, ndx):
        return self.__uids[ndx]

    def getuids(self):
        return self.__uids

    def close(self):
        if self.__con is not None:
            self.__con.quit()
            self.__con = None

    def __len__(self):
        if self.__con is None:
            return 0
        return self.__con.stat()[0]

    def get(self, ndx, fp):
        res = self.__con.retr(ndx)[1]
        fp.seek(0)
        fp.truncate()
        fp.write("\n".join(res))
        fp.seek(0)
        try:
            return email.message_from_file(fp)
        except email.Errors.BoundaryError, message:
            boundary = None
            for row in res:
                if row[:12].lower() == 'content-type':
                    try:
                        boundary = row.split(';')[-1].split('=')[-1].replace('"', '')
                    except:
                        raise email.Errors.BoundaryError, message
                    break
            if boundary is None:
                raise email.Errors.BoundaryError, message
            res.append('--%s--\n' % boundary)
            fp.seek(0)
            fp.truncate()
            fp.write("\n".join(res))
            fp.seek(0)
            try:
                return email.message_from_file(fp)
            except email.Errors.MessageError, msg:
                # The parser failed to figure out whats's going on here
                # To prevent us from resyncing until the email is gone
                # we import it as an invalid email
                fp.seek(0)
                message = email.MIMEMultipart.MIMEMultipart()
                del message['from']
                del message['subject']
                message['from'] = _Conf.APP_NAME
                message['subject'] = 'Error message from %s' % _Conf.APP_NAME
               
                submsg = email.MIMEText.MIMEText('%s was unable to process the following message:\n%s' % (_Conf.APP_NAME, str(msg)))
                del submsg['content-type']
                submsg['Content-Type'] = 'text/plain; charset="utf-8"'
                message.attach(submsg)
                
                submsg = MIMEFile.MIMEFile(fp.read(), 'failed_message.bin')
                message.attach(submsg)
        
                return message
            except TypeError, msg:
                # The parser failed to figure out whats's going on here
                # To prevent us from resyncing until the email is gone
                # we import it as an invalid email
                fp.seek(0)
                message = email.MIMEMultipart.MIMEMultipart()
                del message['from']
                del message['subject']
                message['from'] = _Conf.APP_NAME
                message['subject'] = 'Error message from %s' % _Conf.APP_NAME
               
                submsg = email.MIMEText.MIMEText('%s was unable to process the following message:\n%s' % (_Conf.APP_NAME, str(msg)))
                del submsg['content-type']
                submsg['Content-Type'] = 'text/plain; charset="utf-8"'
                message.attach(submsg)
                
                submsg = MIMEFile.MIMEFile(fp.read(), 'failed_message.bin')
                message.attach(submsg)
        
                return message

    def getfast(self, ndx, fp):
        fp.seek(0)
        fp.truncate()
        fp.write("\n".join(self.__con.top(ndx,0)[1]))
        fp.seek(0)
        return email.message_from_file(fp)

    def delete(self, ndx):
        self.__con.dele(ndx)

    def get_new_items(self):
        raise RuntimeError, 'pop3 does not support this'


def sync(REQUEST, autocheck=0):
    output = []
    output.append(standard_html.html_header(REQUEST))
    output.append(get_email_menu(REQUEST, 4))

    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_no_accounts = REQUEST.TLS('email_no_accounts')
    SQL = u"""SELECT e.parent_id, e.email_message_id, e.email_pop3_uid, e.email_account FROM emails_received e WHERE e.parent_id=%d""" % REQUEST.USER.get_id()
    REQUEST.db.execute(SQL.encode('UTF8'))
    result = REQUEST.db.dictfetchall()
    message_ids = {}
    message_uids = {}
    for res in result:
        if res['email_message_id']: message_ids[res['email_message_id']] = 1 # IMAP
        if res['email_pop3_uid'] is None:
            continue
        if message_uids.has_key(res['email_account']): # POP3
            message_uids[res['email_account']][res['email_pop3_uid']] = 1
        else:
            message_uids[res['email_account']] = {res['email_pop3_uid']: 1}

    # Start efolder stuff here
    REQUEST.db.execute("""SELECT e.*, i.* FROM items i, efolders e WHERE e.efolder_id=i.item_id AND i.parent_id=%d AND (e.efolder_flags & %d) <> 0""" % (REQUEST.USER.get_id(), _Efolder.EFOLDER_SYSTEM))
    result = REQUEST.db.dictfetchall()
    if not result: # The user does not have folders yet, tell the system to make them
        _Efolder.create_default_folders(REQUEST)

    SQL = u"""SELECT e.efolder_id FROM items i, efolders e WHERE e.efolder_id=i.item_id AND i.parent_id=%d AND (e.efolder_flags & %d) <> 0""" % (REQUEST.USER.get_id(), _Efolder.EFOLDER_INBOX)
    REQUEST.db.execute(SQL.encode('UTF8'))
    result = REQUEST.db.dictfetchone()
    if not result:
        raise RuntimeError, REQUEST.TLS('email_noinboxfolder')
    else:
        inbox_id = result['efolder_id']

    SQL = u"""SELECT e.efolder_id FROM items i, efolders e WHERE e.efolder_id=i.item_id AND i.parent_id=%d AND (e.efolder_flags & %d) <> 0""" % (REQUEST.USER.get_id(), _Efolder.EFOLDER_DELETED)
    REQUEST.db.execute(SQL.encode('UTF8'))
    result = REQUEST.db.dictfetchone()
    if not result:
        raise RuntimeError, REQUEST.TLS('email_noinboxfolder')
    else:
        del_fold_id = result['efolder_id']

    SQL = u"""SELECT e.* FROM eaccounts e, items i WHERE e.eaccount_id=i.item_id AND i.parent_id=%d AND (e.eaccount_flags & %d) <> 0""" % (REQUEST.USER.get_id(), _Eaccount.EACCOUNT_ACTIVE)
    REQUEST.db.execute(SQL.encode('UTF8'))
    accounts = REQUEST.db.dictfetchall()

    SQL = """SELECT * from email_filters, items where item_id=filter_id and creator_id=%s and item_type_id=%s order by priority desc, condition_id asc""" % (REQUEST.USER.get_id(), _InitTypes.ITEM_TYPE_EFILTER)
    REQUEST.db.execute(SQL)
    filters = REQUEST.db.dictfetchall()
    fp = StringIO()
    index = 0
    fout = ""
    total_messages = 0
    account_messages = 0 # There seems to be a problem with this and returning it in the end of the function, as it'll only 
                         # return the number for the last account
    for account in accounts:
        d_count = []
        m_count = []
        p_count = []
        fout = ""
        index = index + 1
        total_messages += account_messages
        account_messages = 0
        account_obj = _Eaccount.Eaccount(REQUEST, _InitTypes.INIT_TYPE_ID, account['eaccount_id'])
        try:
            if account['eaccount_flags'] & _Eaccount.EACCOUNT_IMAP4:
                mailbox = IMAP4Mailbox()
                mailbox.open(REQUEST, account_obj)
                del_ndx = []
                for ndx in range(len(mailbox)):
                    message = mailbox.getfast(ndx+1, fp)

                    if message['message-id'] in message_ids: # FIXME
                        continue
                    else:
                        account_messages += 1
                        message = mailbox.get(ndx+1, fp)

                    if message['message-id'] is None:
                        md5sum = md5.md5(message.as_string()).hexdigest()
                        if md5sum in message_ids: # FIXME
                            account_messages -= 1
                            continue

                    email_obj = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_NEW)
                    email_obj.set('parent_id', inbox_id)
                    email_obj.set('is_private', 1)

                    x_orig = email.Utils.parseaddr(parse_quoted_string(message, message['to'] or ''))
                    y_orig = email.Utils.parseaddr(parse_quoted_string(message, message['from'] or ''))
                    x = x_orig[0] or x_orig[1] or '-- no to --'
                    y = y_orig[0] or y_orig[1] or '-- no from --'
                    email_obj.set('email_to', _Utils.html_quote(x))
                    email_obj.set('email_from', _Utils.html_quote(y))
                    email_obj.set('email_from_addr', y_orig[1])
                    email_obj.set('email_subject', parse_quoted_string(message, message['subject'] or '-- no subject --'))
                    try:
                        dt = mx.DateTime.DateTimeFrom(message['date'])
                    except:
                        dt = _Utils.utc_now_mx()
                    email_obj.set('email_date', "%04d-%02d-%02d %02d:%02d" % (dt.year, dt.month, dt.day, dt.hour, dt.minute))
                    email_obj.set('email_size', len(message.as_string()))

                    if message['message-id'] is not None:
                        try:
                            msg_txt_id = message['message-id'].decode('UTF8')
                        except:
                            msg_txt_id = message['message-id'].decode(_Conf.FALLBACK_ENCODING)
                        email_obj.set('email_message_id', msg_txt_id)

                    flags = 0
                    if message['x-status'] and 'A' in message['x-status']:
                        flags |= _Email.EMAIL_ANSWERED
                    if message['status'] and 'R' in message['status']:
                        flags |= _Email.EMAIL_READ
                    if has_attachment(REQUEST, message):
                        flags |= _Email.EMAIL_ATTACH
                    email_obj.set('email_flags', flags)

                    email_obj.set('email_contents', base64.encodestring(message.as_string())) # Can't use this as simple string due charset problems
                    email_obj.set('email_account', account_obj.get('eaccount_name'))
                    email_obj.set('index_this_item', 1)
                    nosave = 0
                    thismessage2 = re.sub(" {2,}", " ", reply_message(REQUEST, message).replace("\r", "").replace("\n", " ").replace(">", ""))
                    thismessage = thismessage2.lower()
                    for filter in filters:
                        ftype = filter['condition_id']
                        if not filter['use_case']:
                            if isinstance(filter['keywords'], unicode):
                                filter['keywords']=filter['keywords'].lower()
                            else:
                                filter['keywords']=filter['keywords'].decode('UTF8').lower()
                            if ftype==1:
                                if parse_quoted_string(message, message['from']).lower().find(filter['keywords'])<>-1 or \
                                   parse_quoted_string(message, message['to']).lower().find(filter['keywords'])<>-1 or \
                                   parse_quoted_string(message, message['subject']).lower().find(filter['keywords'])<>-1 or \
                                   thismessage.find(filter['keywords'])<>-1:
                                  act = 1
                                else:
                                  act = 0
                            elif ftype==2:
                                if parse_quoted_string(message, message['from']).lower().find(filter['keywords'])<>-1 or \
                                   parse_quoted_string(message, message['to']).lower().find(filter['keywords'])<>-1:
                                  act=1
                                else:
                                  act = 0
                            elif ftype==3:
                                if parse_quoted_string(message, message['subject']).lower().find(filter['keywords'])<>-1 or \
                                   reply_message(REQUEST, message).lower().find(filter['keywords'])<>-1:
                                  act=1
                                else:
                                  act=0
                            elif ftype==4:
                                 if parse_quoted_string(message, message['from']).lower().find(filter['keywords'])<>-1:
                                   act = 1
                                 else:
                                   act = 0
                            elif ftype==5:
                                  if parse_quoted_string(message, message['to']).lower().find(filter['keywords'])<>-1:
                                    act = 1
                                  else:
                                    act = 0
                            elif ftype==6:
                                  if parse_quoted_string(message, message['subject']).lower().find(filter['keywords'])<>-1:
                                    act = 1
                                  else:
                                    act = 0
                            elif ftype==7:
                                  if thismessage.find(filter['keywords'])<>-1:
                                    act = 1
                                  else:
                                    act = 0
                            else:
                                  pass
                        else:
                            if ftype==1:
                                if parse_quoted_string(message, message['from']).find(filter['keywords'])<>-1 or \
                                   parse_quoted_string(message, message['to']).find(filter['keywords'])<>-1 or \
                                   parse_quoted_string(message, message['subject']).find(filter['keywords'])<>-1 or \
                                   thismessage2.find(filter['keywords'])<>-1:
                                  act = 1
                                else:
                                  act = 0
                            elif ftype==2:
                                if parse_quoted_string(message, message['from']).find(filter['keywords'])<>-1 or \
                                   parse_quoted_string(message, message['to']).find(filter['keywords'])<>-1:
                                  act=1
                                else:
                                  act = 0
                            elif ftype==3:
                                if parse_quoted_string(message, message['subject']).find(filter['keywords'])<>-1 or \
                                   reply_message(REQUEST, message).find(filter['keywords'])<>-1:
                                  act=1
                                else:
                                  act=0
                            elif ftype==4:
                                 if parse_quoted_string(message, message['from']).find(filter['keywords'])<>-1:
                                   act = 1
                                 else:
                                   act = 0
                            elif ftype==5:
                                  if parse_quoted_string(message, message['to']).find(filter['keywords'])<>-1:
                                    act = 1
                                  else:
                                    act = 0
                            elif ftype==6:
                                  if parse_quoted_string(message, message['subject']).find(filter['keywords'])<>-1:
                                    act = 1
                                  else:
                                    act = 0
                            elif ftype==7:
                                  if thismessage2.find(filter['keywords'])<>-1:
                                    act = 1
                                  else:
                                    act = 0
                        if act == 1:
                             action = filter['action_id']
                             if action == 1: # move
                               email_obj.set('parent_id', filter['folder_id'])
                               m_count.append("1")
                               break;
                             elif action == 2: # delete
                               email_obj.save_received()
                               email_obj.set('parent_id', del_fold_id)
                               d_count.append("1")
                               break;
                             elif action == 3: # mark
                               flags |= _Email.EMAIL_PRIORITY
                               email_obj.set('email_flags', flags)
                               p_count.append("1")
                               break;
                    email_obj.save()
                    del_ndx.append(ndx+1)
                if (account_obj.get('eaccount_flags') & _Eaccount.EACCOUNT_DELETE_MESSAGES) <> 0:
                    del_ndx.sort()
                    del_ndx.reverse()
                    for del_id in del_ndx:
                        mailbox.delete(del_id)
                mailbox.close()
            elif account['eaccount_flags'] & _Eaccount.EACCOUNT_POP3:
                mailbox = POP3Mailbox()
                mailbox.open(REQUEST, account_obj)
                mailbox.loaduids()
                del_ndx = []
                for (ndx, uid) in mailbox.getuids().items():
                    load_message = 0
                    if account_obj.get('eaccount_name') not in message_uids: # check for server key
                        load_message = 1
                    elif mailbox.getuid(ndx) not in message_uids[account_obj.get('eaccount_name')]: # check for message from active server
                        load_message = 1

                    if not load_message:
                        continue

                    message = mailbox.getfast(ndx, fp)
                    if message['message-id'] in message_ids: # FIXME
                        continue

                    account_messages += 1
                    message = mailbox.get(ndx, fp)

                    if message['message-id'] is None:
                        md5sum = md5.md5(message.as_string()).hexdigest()
                        if md5sum in message_ids: # FIXME
                            account_messages -= 1
                            continue

                    email_obj = _Email.Email(REQUEST, _InitTypes.INIT_TYPE_NEW)
                    email_obj.set('parent_id', inbox_id)
                    email_obj.set('is_private', 1)

                    x_orig = email.Utils.parseaddr(parse_quoted_string(message, message['to'] or ''))
                    y_orig = email.Utils.parseaddr(parse_quoted_string(message, message['from'] or ''))
                    x = x_orig[0] or x_orig[1] or '-- no to --'
                    y = y_orig[0] or y_orig[1] or '-- no from --'
                    email_obj.set('email_to', _Utils.html_quote(x))
                    email_obj.set('email_from', _Utils.html_quote(y))
                    email_obj.set('email_from_addr', y_orig[1])
                    email_obj.set('email_subject', parse_quoted_string(message, message['subject'] or '-- no subject --'))
                    try:
                        dt = mx.DateTime.DateTimeFrom(message['date'])
                    except:
                        dt = _Utils.utc_now_mx()
                    email_obj.set('email_date', "%04d-%02d-%02d %02d:%02d" % (dt.year, dt.month, dt.day, dt.hour, dt.minute))
                    email_obj.set('email_size', len(message.as_string()))

                    if message['message-id'] is not None:
                        try:
                            msg_txt_id = message['message-id'].decode('UTF8')
                        except:
                            msg_txt_id = message['message-id'].decode(_Conf.FALLBACK_ENCODING)
                        email_obj.set('email_message_id', msg_txt_id)

                    flags = 0
                    if message['x-status'] and 'A' in message['x-status']:
                        flags |= _Email.EMAIL_ANSWERED
                    if message['status'] and 'R' in message['status']:
                        flags |= _Email.EMAIL_READ
                    if has_attachment(REQUEST, message):
                        flags |= _Email.EMAIL_ATTACH
                    email_obj.set('email_flags', flags)
                    email_obj.set('email_contents', base64.encodestring(message.as_string())) # Can't use this as simple string due charset problems
                    email_obj.set('email_pop3_uid', mailbox.getuid(ndx))
                    email_obj.set('email_account', account_obj.get('eaccount_name'))
                    email_obj.set('index_this_item', 1)
                    nosave = 0
                    thismessage2 = re.sub(" {2,}", " ", reply_message(REQUEST, message).replace("\r", "").replace("\n", " ").replace(">", ""))
                    thismessage = thismessage2.lower()
                    for filter in filters:
                        ftype = filter['condition_id']
                        if not filter['use_case']:
                            if isinstance(filter['keywords'], unicode):
                                filter['keywords']=filter['keywords'].lower()
                            else:   
                                filter['keywords']=filter['keywords'].decode('UTF8').lower()
                            if ftype==1:
                                if parse_quoted_string(message, message['from']).lower().find(filter['keywords'])<>-1 or \
                                   parse_quoted_string(message, message['to']).lower().find(filter['keywords'])<>-1 or \
                                   parse_quoted_string(message, message['subject']).lower().find(filter['keywords'])<>-1 or \
                                   thismessage.find(filter['keywords'])<>-1:
                                  act = 1
                                else:
                                  act = 0
                            elif ftype==2:
                                if parse_quoted_string(message, message['from']).lower().find(filter['keywords'])<>-1 or \
                                   parse_quoted_string(message, message['to']).lower().find(filter['keywords'])<>-1:
                                  act=1
                                else:
                                  act = 0
                            elif ftype==3:
                                if parse_quoted_string(message, message['subject']).lower().find(filter['keywords'])<>-1 or \
                                   reply_message(REQUEST, message).lower().find(filter['keywords'])<>-1:
                                  act=1
                                else:
                                  act=0
                            elif ftype==4:
                                 if parse_quoted_string(message, message['from']).lower().find(filter['keywords'])<>-1:
                                   act = 1
                                 else:
                                   act = 0
                            elif ftype==5:
                                  if parse_quoted_string(message, message['to']).lower().find(filter['keywords'])<>-1:
                                    act = 1
                                  else:
                                    act = 0
                            elif ftype==6:
                                  if parse_quoted_string(message, message['subject']).lower().find(filter['keywords'])<>-1:
                                    act = 1
                                  else:
                                    act = 0
                            elif ftype==7:
                                  if thismessage.find(filter['keywords'])<>-1:
                                    act = 1
                                  else:
                                    act = 0
                            else:
                                  pass
                        else:
                            if isinstance(filter['keywords'], unicode):
                                filter['keywords']=filter['keywords']
                            else:   
                                filter['keywords']=filter['keywords'].decode('UTF8')
                            if ftype==1:
                                if parse_quoted_string(message, message['from']).find(filter['keywords'])<>-1 or \
                                   parse_quoted_string(message, message['to']).find(filter['keywords'])<>-1 or \
                                   parse_quoted_string(message, message['subject']).find(filter['keywords'])<>-1 or \
                                   thismessage2.find(filter['keywords'])<>-1:
                                  act = 1
                                else:
                                  act = 0
                            elif ftype==2:
                                if parse_quoted_string(message, message['from']).find(filter['keywords'])<>-1 or \
                                   parse_quoted_string(message, message['to']).find(filter['keywords'])<>-1:
                                  act=1
                                else:
                                  act = 0
                            elif ftype==3:
                                if parse_quoted_string(message, message['subject']).find(filter['keywords'])<>-1 or \
                                   reply_message(REQUEST, message).find(filter['keywords'])<>-1:
                                  act=1
                                else:
                                  act=0
                            elif ftype==4:
                                 if parse_quoted_string(message, message['from']).find(filter['keywords'])<>-1:
                                   act = 1
                                 else:
                                   act = 0
                            elif ftype==5:
                                  if parse_quoted_string(message, message['to']).find(filter['keywords'])<>-1:
                                    act = 1
                                  else:
                                    act = 0
                            elif ftype==6:
                                  if parse_quoted_string(message, message['subject']).find(filter['keywords'])<>-1:
                                    act = 1
                                  else:
                                    act = 0
                            elif ftype==7:
                                  if thismessage2.find(filter['keywords'])<>-1:
                                    act = 1
                                  else:
                                    act = 0
                        if act == 1:
                             action = filter['action_id']
                             if action == 1: # move
                               email_obj.set('parent_id', filter['folder_id'])
                               m_count.append("1")
                               break
                             elif action == 2: # delete
                               email_obj.save_received()
                               email_obj.set('parent_id', del_fold_id)
                               d_count.append("1")
                               break
                             elif action == 3: # mark
                               flags |= _Email.EMAIL_PRIORITY
                               email_obj.set('email_flags', flags)
                               p_count.append("1")
                               break
                    email_obj.save()
                    del_ndx.append(ndx)
                if (account_obj.get('eaccount_flags') & _Eaccount.EACCOUNT_DELETE_MESSAGES) <> 0:
                    del_ndx.sort()
                    del_ndx.reverse()
                    for del_id in del_ndx:
                        mailbox.delete(del_id)
                mailbox.close()
            else:
                continue # FIXME
        except:
            output.append(u"""\
        <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
          <TR>
            <TD colspan=3><IMG src="%sspacer.gif" width=1 height=15 border=0 alt=""></TD>
          </TR>
          <TR>
            <TD><IMG src="%sspacer.gif" width=15 height=1 border=0 alt=""></TD>
            <TD>""" % (_Conf.BASE_ICON_URL, _Conf.BASE_ICON_URL))
            output.append(REQUEST.TLS('email_failedsyncrostring') % (account_obj.get('eaccount_name'), account_obj.get('eaccount_user')))
            output.append(u"""\
            </TD>
            <TD><IMG src="%sspacer.gif" width=15 height=1 border=0 alt=""></TD>
          </TR>
        </TABLE>""" % _Conf.BASE_ICON_URL)
            raise
            continue
        output.append(u"""\
        <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
          <TR>
            <TD colspan=3><IMG src="%sspacer.gif" width=1 height=15 border=0 alt=""></TD>
          </TR>
          <TR>
            <TD><IMG src="%sspacer.gif" width=15 height=1 border=0 alt=""></TD>
            <TD width="100%%">""" % (_Conf.BASE_ICON_URL, _Conf.BASE_ICON_URL))
        output.append(REQUEST.TLS('email_syncrostring') % (account_messages, account_obj.get('eaccount_name'), account_obj.get('eaccount_user')))
        output.append(u"""\
            </TD>
            <TD><IMG src="%sspacer.gif" width=15 height=1 border=0 alt=""></TD>
          </TR>
        </TABLE>""" % _Conf.BASE_ICON_URL)
        total_messages = total_messages + account_messages
        fout = ""
        if len(m_count)>0 or len(d_count)>0 or len(p_count)>0:
            tls_filters = REQUEST.TLS('compmenu_email_filters')
            tls_moved = REQUEST.TLS('email_filter_moved')
            tls_del = REQUEST.TLS('email_filter_del')
            tls_pri = REQUEST.TLS('email_filter_pri')
            BASE_ICON_URL = _Conf.BASE_ICON_URL
            mc = len(m_count)
            dc = len(d_count)
            pc = len(p_count)
            output.append("""
        <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
          <TR>
            <TD colspan=3><IMG src="%(BASE_ICON_URL)sspacer.gif" width=1 height=15 border=0 alt=""></TD>
          </TR>
          <TR>
            <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width=15 height=1 border=0 alt=""></TD>
            <TD width="100%%">
              <B>%(tls_filters)s:</B><BR>
              %(tls_moved)s: %(mc)d<BR>
              %(tls_del)s: %(dc)d<BR>
              %(tls_pri)s: %(pc)d<BR>
            </TD>
            <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width=15 height=1 border=0 alt=""></TD>
          </TR>
        </TABLE>""" % locals())
            fout = """
        <TABLE border=0 width="100%%" cellpadding=5 cellspacing=0>
          <TR>
            <TD>
              <B>%(tls_filters)s:</B><BR>
              %(tls_moved)s: %(mc)d<BR>
              %(tls_del)s: %(dc)d<BR>
              %(tls_pri)s: %(pc)d<BR>
            </TD>
          </TR>
        </TABLE>""" % locals()

    fp.close()
    
    if(index==0):
        output.append(u"""\
        <TABLE border=0 width="100%%" cellpadding=0 cellspacing=0>
          <TR>
            <TD colspan=3><IMG src="%(BASE_ICON_URL)sspacer.gif" width=1 height=15 border=0 alt=""></TD>
          </TR>
          <TR>
          <TR>
            <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width=15 height=1 border=0 alt=""></TD>
            <TD>%(tls_no_accounts)s</TD>
            <TD><IMG src="%(BASE_ICON_URL)sspacer.gif" width=15 height=1 border=0 alt=""></TD>
          </TR>
        </TABLE>""" % locals())
    del fp

    output.append(standard_html.html_footer(REQUEST))
    if autocheck:
      return (fout, total_messages)
#      return (fout, account_messages)
    else:
      return '\n'.join(output)

def get_alt_name(message):
    try:
       if message['content-type'].find('name=') <> -1:
           name = message['content-type'].split('name=')[-1]
           if name[0] == '"' and name[-1] == '"':
               name = name[1:-1]
           elif name[0] == "'" and name[-1] == "'":
               name = message[1:-1]
           return parse_quoted_string(message, name)
       else:
           return None
    except:
       return None

def get_dict_from_ical(REQUEST, ical):
    ical_contents = filter(None, ical.split("\r\n"))
    event = {}
    in_event = 0
    in_standard = 0
    n = 0
    while n<len(ical_contents):
        line = ical_contents[n]
        o = n
        while 1:
            o = o + 1
            try:
                line2 = ical_contents[o]
                if line2[0]==" ":
                    line = line + line2
                else:
                    break
            except:
                break
        
        if in_event and len(line)>6 and line[0:6] == "BEGIN:":
            in_event = 0
        if line.strip() == "BEGIN:VEVENT":
            in_event = 1
        if line.strip() == "BEGIN:STANDARD":
            in_standard = 1
        if line.strip() == "END:STANDARD":
            in_standard = 0
        if in_standard and len(line)>=11 and line[0:11] == "TZOFFSETTO:":
            event['tz_op'] = line[11:12]
            event['tz_offset'] = line[12:16]
        if in_event and len(line)>8 and line[0:8] == "SUMMARY:":
            event['title']=line[8:].replace("\\", "")
        if in_event and len(line)>9 and line[0:9] == "ORGANIZER":
            event['creator'] = line[10:].replace("MAILTO:", "").replace("CN=", "").replace(":", " ")
        if in_event and len(line)>12 and line[0:12] == "DESCRIPTION:":
            event['description'] = line[12:].replace("\\n", "<BR>").replace("\\", "")
        if in_event and len(line)>8 and line[0:8] == "ATTENDEE":
            tmp = line.split(";")
            found = 0
            thisname = ""
            thisaction = ""
            for a in tmp:
                if a[0:3]=="CN=":
                    thisname = a.replace("CN=", "").replace('"', "")
                if a[0:9]=="PARTSTAT=":
                    thisaction = "|"+a.replace("PARTSTAT=", "").split(":")[0]
            if thisname:
                event['attendees'] = event.get('attendees', '') + "###" + thisname + thisaction
        if in_event and len(line)>8 and line[0:8] == "LOCATION":
            event['location'] = line[8:].replace("\\", "")
        if in_event and len(line)>7 and line[0:7] == "DTSTART":
            lines = line.split(":")
            lines = filter(None, lines)
            if len(lines)>=2 and len(lines[1])>=13 and lines[1][0:4].isdigit():
                line = lines[1]
                date = line[0:8]
                time = line[9:13]
                event['start_stamp'] = "%s-%s-%s %s:%s" % (date[0:4], date[4:6], date[6:8], time[0:2], time[2:4])
            elif len(lines)>=2 and len(lines[1])>=8 and (lines[1][0:2]=="20" or lines[1][0:2]==20 or lines[1][0:2]=="19" or lines[1][0:2]==19):
                line = lines[1]
                date = line[0:8]
                event['start_stamp'] = "%s-%s-%s" % (date[0:4], date[4:6], date[6:8])
            else:
                n = n + 1
                line = ical_contents[n].strip()
                date = line[0:8]
                time = line[9:13]
                event['start_stamp'] = "%s-%s-%s %s:%s" % (date[0:4], date[4:6], date[6:8], time[0:2], time[2:4])
        if in_event and len(line)>5 and line[0:5] == "DTEND":
            lines = line.split(":")
            lines = filter(None, lines)
            if len(lines)>=2 and len(lines[1])>=13 and lines[1][0:4].isdigit():
                line = lines[1]
                date = line[0:8]
                time = line[9:13]
                event['end_stamp'] = "%s-%s-%s %s:%s" % (date[0:4], date[4:6], date[6:8], time[0:2], time[2:4])
            elif len(lines)>=2 and len(lines[1])>=8 and (lines[1][0:2]=="20" or lines[1][0:2]==20 or lines[1][0:2]=="19" or lines[1][0:2]==19):
                line = lines[1]
                date = line[0:8]
                event['end_stamp'] = "%s-%s-%s" % (date[0:4], date[4:6], date[6:8])
            else:
                n = n + 1
                line = ical_contents[n].strip()
                date = line[0:8]
                time = line[9:13]
                event['end_stamp'] = "%s-%s-%s %s:%s" % (date[0:4], date[4:6], date[6:8], time[0:2], time[2:4])
        n = n + 1
    return event

def ical(REQUEST, event):
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    title = REQUEST.TLS('log_event_id') + ": " + event.get('title')
    output = []
    output.append(u"""
<div id="icaldiv"></div>
<BR>
<TABLE border=0 cellpadding=0 cellspacing=0>
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn221.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="7" height="7" border="0" alt=""></TD>
  <TD style="color: #FFFFFF; font-weight: bold; padding: 4px;" bgcolor="#0068C6" nowrap><b>%(title)s</b></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn222.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="7" height="7" border="0" alt=""></TD>
</TR>""" % locals())
    creator = event.get('creator')
    if creator:
        line = "<b>" + REQUEST.TLS('tls_creator') + ":</b> " + creator
        output.append(u"""
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn28.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD class="note_td" align="left" bgcolor="#3F97E1" style="color: #CBFFFF">%(line)s</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn26.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>""" % locals())
    start_stamp = event.get('start_stamp')
    if start_stamp:
        if len(start_stamp)>10:
            date, time = start_stamp.split(" ")
            year, month, day = map(int, date.split("-"))
            hour, minute = map(int, time.split(":"))
            start_stamp = mx.DateTime.DateTime(year, month, day, hour, minute)
            if event.get('tz_op') and event.get('tz_offset'):
                delta_stamp = mx.DateTime.DateTimeDelta(0, int(event.get('tz_offset')[0:2]), int(event.get('tz_offset')[2:4]))
                if event.get('tz_op')=="+":
                    start_stamp = start_stamp - delta_stamp
                else:
                    start_stamp = start_stamp + delta_stamp
            start_stamp = REQUEST.iso2userdatetime(REQUEST, start_stamp)
        else:
            year, month, day = map(int, start_stamp.split("-"))
            start_stamp = mx.DateTime.DateTime(year, month, day)
            start_stamp = REQUEST.iso2userdate(start_stamp)
        line = "<b>" + REQUEST.TLS('cal_start') + ":</b> " + start_stamp
        output.append(u"""
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn28.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD class="note_td" align="left" bgcolor="#3F97E1" style="color: #CBFFFF">%(line)s</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn26.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>""" % locals())
    end_stamp = event.get('end_stamp')
    if end_stamp:
        if len(end_stamp)>10:
            date, time = end_stamp.split(" ")
            year, month, day = map(int, date.split("-"))
            hour, minute = map(int, time.split(":"))
            end_stamp = mx.DateTime.DateTime(year, month, day, hour, minute)
            if event.get('tz_op') and event.get('tz_offset'):
                delta_stamp = mx.DateTime.DateTimeDelta(0, int(event.get('tz_offset')[0:2]), int(event.get('tz_offset')[2:4]))
                if event.get('tz_op')=="+":
                    end_stamp = end_stamp - delta_stamp
                else:
                    end_stamp = end_stamp + delta_stamp
            end_stamp = REQUEST.iso2userdatetime(REQUEST, end_stamp)
        else:
            year, month, day = map(int, end_stamp.split("-"))
            end_stamp = mx.DateTime.DateTime(year, month, day)
            end_stamp = REQUEST.iso2userdate(end_stamp)
        line = "<b>" + REQUEST.TLS('cal_end') + ":</b> " + end_stamp
        output.append(u"""
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn28.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD class="note_td" align="left" bgcolor="#3F97E1" style="color: #CBFFFF">%(line)s</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn26.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>""" % locals())
    location = event.get('location')
    if location:
        line = u"<b>" + REQUEST.TLS('tls_description') + u":</b> " + location
        output.append(u"""
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn28.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD class="note_td" align="left" bgcolor="#3F97E1" style="color: #CBFFFF">%(line)s</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn26.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>""" % locals())
    description = event.get('description')
    if description:
        line = u"<b>" + REQUEST.TLS('tls_location') + u":</b> " + _Utils.newline2br(description)
        output.append(u"""
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn28.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD class="note_td" align="left" bgcolor="#3F97E1" style="color: #CBFFFF">%(line)s</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn26.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>""" % locals())
    attendees = event.get('attendees')
    if attendees:
        attendees = attendees.split('###')
        attendees = filter(None, attendees)
        line = u"<b>" + REQUEST.TLS('tls_attendees') + u":</b> "
        output.append(u"""
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn28.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD class="note_td" align="left" bgcolor="#3F97E1" style="color: #CBFFFF">%(line)s</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn26.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>""" % locals())
        for attendee in attendees:
            attendee = attendee.split("|")
            status = ""
            if len(attendee)>1:
               if attendee[1].lower() in ('accepted', 'declined','tentative'):
                   if attendee[1].lower()=='accepted':
                       status = " <b><font color='green'>[%s]</FONT></B>" % REQUEST.TLS('email_accepted')
                   elif attendee[1].lower()=='tentative':
                       status = " <b><font color='yellow'>[%s]</FONT></B>" % REQUEST.TLS('email_tentative')
                   elif attendee[1].lower()=='declined':
                       status = " <b><font color='red'>[%s]</FONT></B>" % REQUEST.TLS('email_declined')
            line = "&nbsp;&nbsp;&nbsp;&nbsp;%s%s" % (attendee[0], status)
            output.append(u"""
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn28.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD class="note_td" align="left" bgcolor="#3F97E1" style="color: #CBFFFF">%(line)s</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn26.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>""" % locals())
    output.append(u"""
<TR>
  <TD style="background-image: url('%(BASE_ICON_URL)sn28.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD class="note_td" align="left" bgcolor="#3F97E1" style="color: #CBFFFF;text-align: center;"><a href="javascript:void(0);" onclick="add_event();" style="color: black; text-decoration: underline;font-weight:bold">Lisa kalendrisse</A></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn26.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>""" % locals())
    
    BASE_CALENDAR_URL = _Conf.BASE_CALENDAR_URL
    tmp = cPickle.dumps(event)
    tmp = base64.encodestring(tmp).replace("\n", "")
    content = urllib.urlencode({'content':tmp})
    host_name = REQUEST.mod_req.server.server_hostname
    tls_added2 = REQUEST.TLS('email_eventadded')
    if REQUEST.is_https:
        protocol = "https://"
    else:
        protocol = "http://"
    output.append(u"""
<TR valign="top">
  <TD><img src="%(BASE_ICON_URL)sn23.gif" width="7" height="7" border="0" alt=""></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn27.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="400" height="1" border="0" alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sn24.gif" width="7" height="7" border="0" alt=""></TD>
</TR>
</TABLE>
<BR>
<script type="text/javascript">
function add_event(){ txt = PostRequest('%(protocol)s%(host_name)s%(BASE_CALENDAR_URL)saddevent.py/quickadd', '%(content)s'); write_e();}
function write_e(){ var co = document.getElementById('icaldiv'); co.innerHTML='<table border="0" cellpadding="0" cellspacing="0"><tr>  <td><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></td>  <td bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sco_crn1.gif" width="3" height="3" border="0" alt=""></td>  <td bgcolor="#B5EDBC"><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></td>  <td bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sco_crn3.gif" width="3" height="3" border="0" alt=""></td></tr><tr>  <td><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></td>  <td bgcolor="#B5EDBC"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></td>  <td bgcolor="#B5EDBC">&nbsp;<b>%(tls_added2)s</b>&nbsp;</td>  <td bgcolor="#B5EDBC"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></td></tr><tr>  <td><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></td>  <td bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sco_crn2.gif" width="3" height="3" border="0" alt=""></td>  <td bgcolor="#B5EDBC"><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></td>  <td bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sco_crn4.gif" width="3" height="3" border="0" alt=""></td></tr><tr><td colspan="4"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="2" border="0" alt=""></td></td></tr></table>';}
</script>
""" % locals())
    return "\n".join(output)


def get_dict_from_vcard(REQUEST, vcard):
    vcard_contents = filter(None, vcard.split("\r\n"))
    event = {}
    in_event = 0
    n = 0
    while n<len(vcard_contents):
        line = vcard_contents[n]
        o = n
        while 1:
            o = o + 1
            line2 = vcard_contents[0]
            if line2 and len(line2)>0 and line2[0]==" ":
                line = line + line2
            else:
                break
        if len(line)>=11 and line[0:11] == "BEGIN:VCARD":
          in_event = 1
        if len(line)>=9 and line[0:9]=="END:VCARD":
          in_event = 0
        if in_event and len(line)>=2 and line[0:2]=="N:":
            name = line[2:].split(";")
            if len(name)>=2:
                event['last_name'] = name[0]
                event['first_name'] = name[1]
        if in_event and len(line)>=4 and line[0:4]=="ORG:":
            org = line[4:]
            org = org.split(";")
            if len(org)>=1:
                event['company']=org[0]
            if len(org)>=2:
                event['department']=org[1]
        if in_event and len(line)>=6 and line[0:6]=="TITLE:":
            event['jobtitle'] = line[6:]
        if in_event and len(line)>=15 and line[0:15]=="TEL;WORK;VOICE:":
            event['phone_work'] = line[15:]
        if in_event and len(line)>=13 and line[0:13]=="TEL;WORK;FAX:":
            event['phone_fax'] = line[13:]
        if in_event and len(line)>=15 and line[0:15]=="TEL;CELL;VOICE:":
            event['phone_cell'] = line[15:]
        if in_event and len(line)>=15 and line[0:15]=="TEL;HOME;VOICE:":
            event['phone_home'] = line[15:]
        if in_event and len(line)>=9 and line[0:9]=="ADR;WORK:":
            adr = line[9:].split(";")
            if len(adr)>=7:
                event['mailing_address'] = adr[0] + adr[1] + adr[2] + "\n" + adr[3] + "\n" + adr[4] + "\n" + adr[5] + "\n" + adr[6]
        if in_event and len(line)>=9 and line[0:9]=="URL;WORK:":
            event['homepage'] = line[9:]
        if in_event and len(line)>=20 and line[0:20]=="EMAIL;PREF;INTERNET:":
            event['e_mail'] = line[20:]
        n = n + 1
    if event.get('first_name') and event.get('last_name'):
        return event
    return ""


def vcard(REQUEST, event):
    BASE_ICON_URL = _Conf.BASE_ICON_URL
    tls_add_to_contacts = REQUEST.TLS('email_tocontacts')
    title = event.get('first_name') + " " + event.get('last_name')
    output = []
    output.append(u"""
<div id="icaldiv"></div>
<BR>
<TABLE border=0 cellpadding=0 cellspacing=0>
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn221.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="7" height="7" border="0" alt=""></TD>
  <TD style="color: #FFFFFF; font-weight: bold; padding: 4px;" bgcolor="#0068C6" nowrap><b>%(title)s</b></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn222.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="7" height="7" border="0" alt=""></TD>
</TR>""" % locals())
    company = event.get('company')
    if company:
        line = "<b>" + REQUEST.TLS('contact_company') + ":</b> " + company
        output.append(u"""
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn28.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD class="note_td" align="left" bgcolor="#3F97E1" style="color: #CBFFFF">%(line)s</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn26.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>""" % locals())
    department = event.get('department')
    if department:
        line = "<b>" + REQUEST.TLS('contact_department') + ":</b> " + department
        output.append(u"""
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn28.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD class="note_td" align="left" bgcolor="#3F97E1" style="color: #CBFFFF">%(line)s</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn26.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>""" % locals())
    jobtitle = event.get('jobtitle')
    if jobtitle:
        line = "<b>" + REQUEST.TLS('contact_job') + ":</b> " + jobtitle
        output.append(u"""
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn28.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD class="note_td" align="left" bgcolor="#3F97E1" style="color: #CBFFFF">%(line)s</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn26.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>""" % locals())
    phone_work = event.get('phone_work')
    if phone_work:
        line = "<b>" + REQUEST.TLS('tls_phone_work') + ":</b> " + phone_work
        output.append(u"""
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn28.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD class="note_td" align="left" bgcolor="#3F97E1" style="color: #CBFFFF">%(line)s</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn26.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>""" % locals())
    phone_fax = event.get('phone_fax')
    if phone_fax:
        line = "<b>" + REQUEST.TLS('tls_phone_fax') + ":</b> " + phone_fax
        output.append(u"""
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn28.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD class="note_td" align="left" bgcolor="#3F97E1" style="color: #CBFFFF">%(line)s</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn26.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>""" % locals())
    phone_cell = event.get('phone_cell')
    if phone_fax:
        line = "<b>" + REQUEST.TLS('tls_phone_cell') + ":</b> " + phone_cell
        output.append(u"""
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn28.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD class="note_td" align="left" bgcolor="#3F97E1" style="color: #CBFFFF">%(line)s</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn26.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>""" % locals())
    phone_home = event.get('phone_home')
    if phone_home:
        line = "<b>" + REQUEST.TLS('tls_phone_home') + ":</b> " + phone_home
        output.append(u"""
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn28.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD class="note_td" align="left" bgcolor="#3F97E1" style="color: #CBFFFF">%(line)s</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn26.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>""" % locals())
    mailing_address = event.get('mailing_address')
    if phone_home:
        line = "<b>" + REQUEST.TLS('contact_address') + ":</b> " + mailing_address
        output.append(u"""
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn28.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD class="note_td" align="left" bgcolor="#3F97E1" style="color: #CBFFFF">%(line)s</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn26.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>""" % locals())
    homepage = event.get('homepage')
    if homepage:
        line = "<b>" + REQUEST.TLS('contact_homepage') + ":</b> " + homepage
        output.append(u"""
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn28.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD class="note_td" align="left" bgcolor="#3F97E1" style="color: #CBFFFF">%(line)s</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn26.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>""" % locals())
    e_mail = event.get('e_mail')
    if e_mail:
        line = "<b>" + REQUEST.TLS('tls_email') + ":</b> " + e_mail
        output.append(u"""
<TR valign="top">
  <TD style="background-image: url('%(BASE_ICON_URL)sn28.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD class="note_td" align="left" bgcolor="#3F97E1" style="color: #CBFFFF">%(line)s</TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn26.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>""" % locals())
    
    output.append(u"""
<TR>
  <TD style="background-image: url('%(BASE_ICON_URL)sn28.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
  <TD class="note_td" align="left" bgcolor="#3F97E1" style="color: #CBFFFF;text-align: center;"><a href="javascript:void(0);" onclick="add_event();" style="color: black; text-decoration: underline;font-weight:bold">%(tls_add_to_contacts)s</A></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn26.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></TD>
</TR>""" % locals())
    
    BASE_CONTACT_URL = _Conf.BASE_CONTACT_URL
    tmp = cPickle.dumps(event)
    tmp = base64.encodestring(tmp).replace("\n", "")
    content = urllib.urlencode({'content':tmp})
    host_name = REQUEST.mod_req.server.server_hostname
    tls_added2 = REQUEST.TLS('email_contactadded')
    if REQUEST.is_https:
        protocol = "https://"
    else:
        protocol = "http://"
    output.append(u"""
<TR valign="top">
  <TD><img src="%(BASE_ICON_URL)sn23.gif" width="7" height="7" border="0" alt=""></TD>
  <TD style="background-image: url('%(BASE_ICON_URL)sn27.gif');"><img src="%(BASE_ICON_URL)sspacer.gif" width="400" height="1" border="0" alt=""></TD>
  <TD><img src="%(BASE_ICON_URL)sn24.gif" width="7" height="7" border="0" alt=""></TD>
</TR>
</TABLE>
<BR>
<script type="text/javascript">
function add_event(){ txt = PostRequest('%(protocol)s%(host_name)s%(BASE_CONTACT_URL)scontactadd.py/quickadd2', '%(content)s'); write_e();}
function write_e(){ var co = document.getElementById('icaldiv'); co.innerHTML='<table border="0" cellpadding="0" cellspacing="0"><tr>  <td><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></td>  <td bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sco_crn1.gif" width="3" height="3" border="0" alt=""></td>  <td bgcolor="#B5EDBC"><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></td>  <td bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sco_crn3.gif" width="3" height="3" border="0" alt=""></td></tr><tr>  <td><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></td>  <td bgcolor="#B5EDBC"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></td>  <td bgcolor="#B5EDBC">&nbsp;<b>%(tls_added2)s</b>&nbsp;</td>  <td bgcolor="#B5EDBC"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="1" border="0" alt=""></td></tr><tr>  <td><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></td>  <td bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sco_crn2.gif" width="3" height="3" border="0" alt=""></td>  <td bgcolor="#B5EDBC"><img src="%(BASE_ICON_URL)sspacer.gif" width="20" height="1" border="0" alt=""></td>  <td bgcolor="#FFFFFF"><img src="%(BASE_ICON_URL)sco_crn4.gif" width="3" height="3" border="0" alt=""></td></tr><tr><td colspan="4"><img src="%(BASE_ICON_URL)sspacer.gif" width="1" height="2" border="0" alt=""></td></td></tr></table>';}
</script>
""" % locals())
    return "\n".join(output)
