# Copyright (C) 2003-2005 Inversion Software Ltd. <inversion@inversion.ee>
# http://www.conflux.ee/
#
# This file is part of Conflux Lite
#
# Conflux Lite is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2,
# or (at your option) any later version.
#
# Conflux Lite is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Conflux Lite; if not, write to the Free Software
# Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
######################################################################

####
# C header includes
####
cdef extern from "stdlib.h":
    int RAND_MAX
    int rand()
    int srand(int)

cdef extern from "time.h":
    int time(int *)

####
# C functions
####
cdef int randnum():
    cdef int j
    j = <int> (62.0*rand()/(RAND_MAX+1.0))
    return j

####
# Exported python functions
####

def init_random():
    """
Initializes the random generator with new seed.
    """
    cdef int i
    i = time(NULL)
    srand(i)

def new_session_key():
    """
Args:
Return: string

Generates a random 16-byte session identifier.
"""
    cdef int i
    cdef int j
    letters = "DKhP6Z9y5orjGdQOIiVXqSU2tB0AJu7lYTmHbe8wNs3fcCva4WnzR1LEMgkFxp"
    key = ""
    for i from 0 <= i < 16:
        j = randnum()
        key = key + letters[j]
    return key

def get_salt():
    """
Args:
Return: string

Generates a random 2-byte crypt salt.
"""
    cdef int i
    cdef int j
    letters = "DKhP6Z9y5orjGdQOIiVXqSU2tB0AJu7lYTmHbe8wNs3fcCva4WnzR1LEMgkFxp"
    key = ""
    for i from 0 <= i < 2:
        j = randnum()
        key = key + letters[j]
    return key

